[![CI](https://github.com/JuliaCollections/LRUCache.jl/actions/workflows/ci.yml/badge.svg)](https://github.com/JuliaCollections/LRUCache.jl/actions/workflows/ci.yml)
[![Test Coverage](https://coveralls.io/repos/github/JuliaCollections/DataStructures.jl/badge.svg?branch=master)](https://coveralls.io/github/JuliaCollections/DataStructures.jl?branch=master)
[![Test Coverage](https://codecov.io/github/JuliaCollections/DataStructures.jl/coverage.svg?branch=master)](https://codecov.io/github/JuliaCollections/DataStructures.jl?branch=master)
[![Stable Documentation](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliacollections.github.io/DataStructures.jl/stable)
[![Dev Documentation](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliacollections.github.io/DataStructures.jl/dev)
[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor's%20Guide-blueviolet)](https://github.com/SciML/ColPrac)

DataStructures.jl
=================

This package implements a variety of data structures, including

-   Deque (implemented with an [unrolled linked list](https://en.wikipedia.org/wiki/Unrolled_linked_list))
-   CircularBuffer
-   CircularDeque (based on a circular buffer)
-   Stack
-   Queue
-   Priority Queue
-   Fenwick Tree
-   Accumulators and Counters (i.e. Multisets / Bags)
-   Disjoint-Sets
-   Binary Heap
-   Mutable Binary Heap
-   Ordered Dicts and Sets
-   RobinDict (implemented with [Robin Hood Hashing](https://cs.uwaterloo.ca/research/tr/1986/CS-86-14.pdf))
-   SwissDict (inspired from [SwissTables](https://abseil.io/blog/20180927-swisstables))
-   Dictionaries with Defaults
-   Trie
-   Linked List and Mutable Linked List
-   Sorted Dict, Sorted Multi-Dict and Sorted Set
-   DataStructures.IntSet
-   SparseIntSet
-   DiBitVector (in which each element can store two bits)
-   Red Black Tree
-   AVL Tree
-   Splay Tree

Resources
---------

-   **Documentation**: https://juliacollections.github.io/DataStructures.jl/stable/

## Notes on regression testing with PkgBenchmark

### To troubleshoot benchmark script locally:
```
julia --project=benchmark -e '
    using Pkg; Pkg.instantiate();
    include("benchmark/runbenchmarks.jl");'
```

### To compare against baseline locally:

Note, must have a `baseline` branch, which will be the refrence point against the currently active branch. A common use case is to point the baseline to the previous commit.

This can be accomplished with
```
git branch baseline HEAD~
```

If there are errors preventing branch creation (likely due to earlier local benchmarking), may force a repoint with
```
git branch -f baseline HEAD~
```

Then run this command:
```
julia --project=benchmark -e '
    using Pkg; Pkg.instantiate();
    include("benchmark/runjudge.jl");
    include("benchmark/pprintjudge.jl");'
```

### To compare against baseline locally (without re-running baseline):

Running the above baseline comparison produces a `benchmark/result-baseline.json` file which is
used as a refrence for new changes.
If the baseline remains unchanged during development, then it is unnecessary to regenerate this file,
and the following command may be used to save benchmarking time.
```
julia --project=benchmark -e '
    using Pkg; Pkg.instantiate();
    include("benchmark/incrementalrunjudge.jl");
    include("benchmark/pprintjudge.jl");'
```

using Pkg
tempdir = mktempdir()
Pkg.activate(tempdir)
Pkg.develop(PackageSpec(path=joinpath(@__DIR__, "..")))
Pkg.add(["BenchmarkTools", "PkgBenchmark", "Random"])
Pkg.resolve()

using DataStructures
using BenchmarkTools

const SUITE = BenchmarkGroup()

SUITE["heap"] = include("bench_heap.jl")
SUITE["SparseIntSet"] = include("bench_sparse_int_set.jl")

# This file was copied from Transducers.jl
# which is available under an MIT license (see LICENSE).
using PkgBenchmark
benchmarkpkg(
    dirname(@__DIR__),
    BenchmarkConfig(
        env = Dict(
            "JULIA_NUM_THREADS" => "1",
        ),
    ),
    resultfile = joinpath(@__DIR__, "result.json"),
)

# 0.18 deprecations. Remove before releasing 0.19
@deprecate path(t::Trie, str::AbstractString) partial_path(t::Trie, str::AbstractString)
@deprecate find_root find_root!
@deprecate top first
@deprecate reverse_iter Iterators.reverse
# Deprecations from #700
Base.@deprecate_binding DisjointSets DisjointSet
Base.@deprecate_binding IntDisjointSets IntDisjointSet
# We won't want to make this `@deprecate DisjointSets(xs...) DisjointSet(xs)`
# because then loading this package will trigger a deprecation warning when we
# evaluate the deprecated DisjointSets binding. This breaks any package that
# tries to load DataStructures with --depwarn=error
@deprecate DisjointSet(xs...) DisjointSet(xs)
# Enqueue and dequeue deprecations
@deprecate enqueue!(q::Queue, x) Base.push!(q, x)
@deprecate enqueue!(q::PriorityQueue, x) Base.push!(q, x)
@deprecate enqueue!(q::PriorityQueue, k, v) Base.push!(q, k=>v)
@deprecate dequeue!(q::Queue) Base.popfirst!(q)
@deprecate dequeue!(q::PriorityQueue) Base.popfirst!(q).first # maybe better: `val, _ = popfirst!(pq)`
@deprecate dequeue!(q::PriorityQueue, x) popat!(q, x).first
@deprecate dequeue_pair!(q::PriorityQueue) Base.popfirst!(q)
@deprecate dequeue_pair!(q::PriorityQueue, key) popat!(q, key)

@deprecate startof(m::SortedContainer) firstindex(m::SortedContainer)
@deprecate endof(m::SortedContainer) lastindex(m::SortedContainer)
@deprecate insert!(m::SortedSet, k) push_return_semitoken!(m::SortedSet, k)
@deprecate insert!(m::SortedDict, k, d) push_return_semitoken!(m::SortedDict, k=>d)
@deprecate insert!(m::SortedMultiDict, k, d) (push_return_semitoken!(m::SortedMultiDict, k=>d))[2]

function Base.peek(q::PriorityQueue)
    Expr(:meta, :noinline)
    Base.depwarn("`peek(q::PriorityQueue)` is deprecated, use `first(q)` instead.", :peek)
    first(q)
end

const SWISS_DICT_LOAD_FACTOR = 0.97
const _u8x16 = NTuple{16, VecElement{UInt8}}

"""
    SwissDict([itr])

`SwissDict{K,V}()` constructs a hash table with keys of type `K` and values of type `V`.
Keys are compared with [`isequal`](@ref) and hashed with [`hash`](@ref).
Given a single iterable argument, constructs a [`SwissDict`](@ref) whose key-value pairs
are taken from 2-tuples `(key,value)` generated by the argument.

# Examples
```jldoctest
julia> SwissDict([("A", 1), ("B", 2)])
SwissDict{String, Int64} with 2 entries:
  "A" => 1
  "B" => 2
```

Alternatively, a sequence of pair arguments may be passed.

```jldoctest
julia> SwissDict("A"=>1, "B"=>2)
SwissDict{String, Int64} with 2 entries:
  "A" => 1
  "B" => 2
```
"""
mutable struct SwissDict{K,V} <: AbstractDict{K,V}
    slots::Vector{_u8x16}
    keys::Vector{K}
    vals::Vector{V}
    nbfull::Int
    count::Int
    age::UInt
    idxfloor::Int  # an index <= the indices of all used slots

    function SwissDict{K,V}() where {K, V}
        new(fill(_expand16(0x00),1), Vector{K}(undef, 16), Vector{V}(undef, 16), 0, 0, 0, 1)
    end
    function SwissDict{K,V}(d::SwissDict{K,V}) where {K, V}
        new(copy(d.slots), copy(d.keys), copy(d.vals), d.nbfull, d.count, d.age,
            d.idxfloor)
    end
    function SwissDict{K, V}(slots, keys, vals, nbfull, count, age, idxfloor) where {K, V}
        new(slots, keys, vals, nbfull, count, age, idxfloor)
    end
end
function SwissDict{K,V}(kv) where {K, V}
    h = SwissDict{K,V}()
    for (k,v) in kv
        h[k] = v
    end
    return h
end
SwissDict{K,V}(p::Pair) where {K,V} = setindex!(SwissDict{K,V}(), p.second, p.first)
function SwissDict{K,V}(ps::Pair...) where {K, V}
    h = SwissDict{K,V}()
    sizehint!(h, length(ps))
    for p in ps
        h[p.first] = p.second
    end
    return h
end
SwissDict() = SwissDict{Any,Any}()
SwissDict(kv::Tuple{}) = SwissDict()
Base.copy(d::SwissDict) = SwissDict(d)
Base.empty(d::SwissDict, ::Type{K}, ::Type{V}) where {K, V} = SwissDict{K, V}()

SwissDict(ps::Pair{K,V}...) where {K,V} = SwissDict{K,V}(ps)
SwissDict(ps::Pair...)                  = SwissDict(ps)

function SwissDict(kv)
    try
        dict_with_eltype((K, V) -> SwissDict{K, V}, kv, eltype(kv))
    catch e
        if !isiterable(typeof(kv)) || !all(x->isa(x,Union{Tuple,Pair}),kv)
            throw(ArgumentError("SwissDict(kv): kv needs to be an iterator of tuples or pairs"))
        else
            rethrow(e)
        end
    end
end

# SIMD utilities
@inline _expand16(u::UInt8) = ntuple(i->VecElement(u), Val(16))
_blsr(i::UInt32)= i & (i-Int32(1))

@inline _vcmp_eq(u::_u8x16, v::_u8x16) = Core.Intrinsics.llvmcall(("""
%cmp = icmp eq <16 x i8> %0, %1
%cmp16 = bitcast <16 x i1> %cmp to i16
%res = zext i16 %cmp16 to i32
ret i32 %res
"""), UInt32, Tuple{_u8x16,_u8x16}, u, v)

@inline _vcmp_le(u::_u8x16, v::_u8x16) = Core.Intrinsics.llvmcall(("""
%cmp = icmp ule <16 x i8> %0, %1
%cmp16 = bitcast <16 x i1> %cmp to i16
%res = zext i16 %cmp16 to i32
ret i32 %res
"""), UInt32, Tuple{_u8x16,_u8x16}, u, v)

@inline function _prefetchr(p::Ptr)
    ccall("llvm.prefetch", llvmcall, Cvoid, (Ref{Int8}, Int32, Int32, Int32), Ptr{Int8}(p), 0, 3, 1)
end

@inline function _prefetchw(p::Ptr)
    ccall("llvm.prefetch", llvmcall, Cvoid, (Ref{Int8}, Int32, Int32, Int32), Ptr{Int8}(p), 1, 3, 1)
end

@inline function _hashtag(u::Unsigned)
    #extracts tag between 0x02 and 0xff from lower bits, rotates tag bits to front
    u = u % UInt
    tag = u % UInt8
    if UInt === UInt64
        hi = ((u>>8) | (u<<56)) % Int
    else
        hi = ((u>>8) | (u<<24)) % Int
    end
    tag = tag > 1 ? tag : tag+0x02
    return (hi, tag)
end

Base.@propagate_inbounds function _slotget(slots::Vector{_u8x16}, i::Int)
    @boundscheck 0 < i <= length(slots)*16 || throw(BoundsError(slots, 1 + (i-1)>>4))
    GC.@preserve slots begin
        return unsafe_load(convert(Ptr{UInt8}, pointer(slots)), i)
    end
end

Base.@propagate_inbounds function _slotset!(slots::Vector{_u8x16},  v::UInt8, i::Int)
   @boundscheck 0 < i <= length(slots)*16 || throw(BoundsError(slots, 1 + (i-1)>>4))
    GC.@preserve slots begin
        return unsafe_store!(convert(Ptr{UInt8}, pointer(slots)), v, i)
    end
end

@inline function _find_candidates(v::_u8x16, tag::UInt8)
    match = _vcmp_eq(v, _expand16(tag))
    return (match, v[16].value === 0x00)
end

@inline _find_free(v::_u8x16) = _vcmp_le(v, _expand16(UInt8(1)))

# Basic operations

# get the index where a key is stored, or -1 if not present
ht_keyindex(h::SwissDict, key) = ht_keyindex(h::SwissDict, key, _hashtag(hash(key))...)
function ht_keyindex(h::SwissDict, key, i0, tag)
    slots = h.slots
    keys = h.keys
    sz = length(slots)
    i = i0 & (sz-1)
    _prefetchr(pointer(h.keys, i*16+1))
    _prefetchr(pointer(h.vals, i*16+1))
    #Todo/discuss: _prefetchr(pointer(h.keys, i*16+9))?
    @inbounds while true
        msk = slots[i+1]
        cands, done = _find_candidates(msk, tag)
        while cands != 0
            off = trailing_zeros(cands)
            idx = i*16 + off + 1
            isequal(keys[idx], key) && return idx
            cands = _blsr(cands)
        end
        done && break
        i = (i+1) & (sz-1)
    end
    return -1
end

# get the index where a key is stored, or -pos if not present
# and the key would be inserted at pos
# This version is for use by setindex! and get!. It never rehashes.
ht_keyindex2!(h::SwissDict, key) = ht_keyindex2!(h, key, _hashtag(hash(key))...)
@inline function ht_keyindex2!(h::SwissDict, key, i0, tag)
    slots = h.slots
    keys = h.keys
    sz = length(slots)
    i = i0 & (sz-1)
    _prefetchw(pointer(h.keys, i*16+1))
    _prefetchw(pointer(h.vals, i*16+1))
    #Todo/discuss: _prefetchr(pointer(h.keys, i*16+9))?
    @inbounds while true
        msk = slots[i+1]
        cands, done = _find_candidates(msk, tag)
        while cands != 0
            off = trailing_zeros(cands)
            idx = i*16 + off + 1
            isequal(keys[idx], key) && return idx, tag
            cands = _blsr(cands)
        end
        done && break
        i = (i+1) & (sz-1)
    end
    i = i0 & (sz-1)
    @inbounds while true
        msk = slots[i+1]
        cands = _find_free(msk)
        if cands != 0
            off = trailing_zeros(cands)
            idx = i*16 + off + 1
            return -idx, tag
        end
        i = (i+1) & (sz-1)
    end
end

function _setindex!(h::SwissDict, v, key, index, tag)
    @inbounds h.keys[index] = key
    @inbounds h.vals[index] = v
    h.count += 1
    h.age += 1
    so =  _slotget(h.slots, index)
    h.nbfull += (iszero(index & 0x0f) & (so==0x00))
    _slotset!(h.slots, tag, index)
    if index < h.idxfloor
        h.idxfloor = index
    end
    maybe_rehash_grow!(h)
end

function _delete!(h::SwissDict{K,V}, index) where {K,V}
    # Caller is responsible for maybe shrinking the SwissDict after the deletion.
    isbitstype(K) || isbitsunion(K) || ccall(:jl_arrayunset, Cvoid, (Any, UInt), h.keys, index-1)
    isbitstype(V) || isbitsunion(V) || ccall(:jl_arrayunset, Cvoid, (Any, UInt), h.vals, index-1)
    isboundary = iszero(index & 0x0f) #boundaries: 16, 32, ...
    @inbounds _slotset!(h.slots, ifelse(isboundary, 0x01, 0x00), index)
    h.count -= 1
    h.age += 1
    maybe_rehash_shrink!(h)
end


# fast iteration over active slots.
function _iterslots(h::SwissDict, start::Int)
    i0 = ((start-1) & (length(h.keys)-1))>>4 + 1
    off = (start-1) & 0x0f
    @inbounds sl = _find_free(h.slots[i0>>4 + 1])
    sl = ((~sl & 0xffff)>>off) << off
    return _iterslots(h, (i0, sl))
end

function _iterslots(h::SwissDict, state)
    i, sl = state
    while iszero(sl)
        i += 1
        i <= length(h.slots) || return nothing
        @inbounds msk = h.slots[i]
        sl = _find_free(msk)
        sl = (~sl & 0xffff)
    end
    return ((i-1)*16 + trailing_zeros(sl) + 1, (i, _blsr(sl)))
end

# Dictionary resize logic:
# Guarantee 40% of buckets and 15% of entries free, and at least 25% of entries filled
# growth when > 85% entries full or > 60% buckets full, shrink when <25% entries full.
# >60% bucket full should be super rare outside of very bad hash collisions or
# super long-lived Dictionaries (expected 0.85^16 = 7% buckets full at 85% entries full).
# worst-case hysteresis: shrink at 25% vs grow at 30% if all hashes collide.
# expected hysteresis is 25% to 42.5%.
function maybe_rehash_grow!(h::SwissDict)
        sz = length(h.keys)
        if h.count > sz * SWISS_DICT_LOAD_FACTOR || (h.nbfull-1) * 10 > sz * 6
            rehash!(h, sz<<2)
        end
    end

function maybe_rehash_shrink!(h::SwissDict)
   sz = length(h.keys)
   if h.count*4 < sz && sz > 16
       rehash!(h, sz>>1)
   end
end

function Base.sizehint!(d::SwissDict, newsz::Integer)
    newsz = _tablesz(newsz*2)  # *2 for keys and values in same array
    oldsz = length(d.keys)
    # grow at least 25%
    if newsz < (oldsz*5)>>2
        return d
    end
    rehash!(d, newsz)
end

function rehash!(h::SwissDict{K,V}, newsz = length(h.keys)) where {K, V}
    olds = h.slots
    oldk = h.keys
    oldv = h.vals
    sz = length(oldk)
    newsz = _tablesz(newsz)
    (newsz*SWISS_DICT_LOAD_FACTOR) > h.count || (newsz <<= 1)
    h.age += 1
    h.idxfloor = 1
    if h.count == 0
        resize!(h.slots, newsz>>4)
        fill!(h.slots, _expand16(0x00))
        resize!(h.keys, newsz)
        resize!(h.vals, newsz)
        h.nbfull = 0
        return h
    end
    nssz = newsz>>4
    slots = fill(_expand16(0x00), nssz)
    keys = Vector{K}(undef, newsz)
    vals = Vector{V}(undef, newsz)
    age0 = h.age
    nbfull = 0
    is = _iterslots(h, 1)
    count = 0
    @inbounds while is !== nothing
        i, s = is
        k = oldk[i]
        v = oldv[i]
        i0, t = _hashtag(hash(k))
        i = i0 & (nssz-1)
        idx = 0
        while true
            msk = slots[i + 1]
            cands = _find_free(msk)
            if cands != 0
                off = trailing_zeros(cands)
                idx = i*16 + off + 1
                break
            end
            i = (i+1) & (nssz-1)
        end
        _slotset!(slots, t, idx)
        keys[idx] = k
        vals[idx] = v
        nbfull += iszero(idx & 0x0f)
        count += 1
        if h.age != age0
            return rehash!(h, newsz)
        end
        is = _iterslots(h, s)
    end
    h.slots = slots
    h.keys = keys
    h.vals = vals
    h.nbfull = nbfull
    @assert h.age == age0
    @assert h.count == count
    return h
end

Base.isempty(t::SwissDict) = (t.count == 0)
Base.length(t::SwissDict) = t.count

"""
    empty!(collection) -> collection

Remove all elements from a `collection`.

# Examples
```jldoctest
julia> A = SwissDict("a" => 1, "b" => 2)
SwissDict{String, Int64} with 2 entries:
  "a" => 1
  "b" => 2

julia> empty!(A);


julia> A
SwissDict{String, Int64}()
```
"""
function Base.empty!(h::SwissDict{K,V}) where {K, V}
    fill!(h.slots, _expand16(0x00))
    sz = length(h.keys)
    empty!(h.keys)
    empty!(h.vals)
    resize!(h.keys, sz)
    resize!(h.vals, sz)
    h.nbfull = 0
    h.count = 0
    h.age += 1
    h.idxfloor = 1
    return h
end

function Base.setindex!(h::SwissDict{K,V}, v0, key0) where {K, V}
    key = convert(K, key0)
    _setindex!(h, v0, key)
end

function _setindex!(h::SwissDict{K,V}, v0, key::K) where {K, V}
    v = convert(V, v0)
    index, tag = ht_keyindex2!(h, key)

    if index > 0
        h.age += 1
        @inbounds h.keys[index] = key
        @inbounds h.vals[index] = v
    else
        _setindex!(h, v, key, -index, tag)
    end

    return h
end

"""
    get!(collection, key, default)

Return the value stored for the given key, or if no mapping for the key is present, store
`key => default`, and return `default`.

# Examples
```jldoctest
julia> d = SwissDict("a"=>1, "b"=>2, "c"=>3);

julia> get!(d, "a", 5)
1

julia> get!(d, "d", 4)
4

julia> d
SwissDict{String, Int64} with 4 entries:
  "a" => 1
  "b" => 2
  "c" => 3
  "d" => 4
```
"""
Base.get!(h::SwissDict{K,V}, key0, default) where {K,V} = get!(()->default, h, key0)

"""
    get!(f::Function, collection, key)

Return the value stored for the given key, or if no mapping for the key is present, store
`key => f()`, and return `f()`.

This is intended to be called using `do` block syntax:
```julia
get!(dict, key) do
    # default value calculated here
    time()
end
```
"""
function Base.get!(default::Callable, h::SwissDict{K,V}, key0) where {K, V}
    key = convert(K, key0)
    return _get!(default, h, key)
end

function _get!(default::Callable, h::SwissDict{K,V}, key::K) where {K, V}
    index, tag = ht_keyindex2!(h, key)

    index > 0 && return @inbounds h.vals[index]

    age0 = h.age
    v = convert(V, default())
    if h.age != age0
        index, tag = ht_keyindex2!(h, key)
    end
    if index > 0
        h.age += 1
        @inbounds h.keys[index] = key
        @inbounds h.vals[index] = v
    else
        _setindex!(h, v, key, -index, tag)
    end
    return v
end

function Base.getindex(h::SwissDict{K,V}, key) where {K, V}
    index = ht_keyindex(h, key)
    @inbounds return (index < 0) ? throw(KeyError(key)) : h.vals[index]::V
end

"""
    get(collection, key, default)

Return the value stored for the given key, or the given default value if no mapping for the
key is present.

# Examples
```jldoctest
julia> d = SwissDict("a"=>1, "b"=>2);


julia> get(d, "a", 3)
1

julia> get(d, "c", 3)
3
```
"""
function Base.get(h::SwissDict{K,V}, key, default) where {K, V}
    index = ht_keyindex(h, key)
    @inbounds return (index < 0) ? default : h.vals[index]::V
end

"""
    get(f::Function, collection, key)

Return the value stored for the given key, or if no mapping for the key is present, return
`f()`.  Use [`get!`](@ref) to also store the default value in the dictionary.

This is intended to be called using `do` block syntax

```julia
get(dict, key) do
    # default value calculated here
    time()
end
```
"""
function Base.get(default::Callable, h::SwissDict{K,V}, key) where {K, V}
    index = ht_keyindex(h, key)
    @inbounds return (index < 0) ? default() : h.vals[index]::V
end

"""
    haskey(collection, key) -> Bool

Determine whether a collection has a mapping for a given `key`.

# Examples
```jldoctest
julia> D = SwissDict('a'=>2, 'b'=>3)
SwissDict{Char, Int64} with 2 entries:
  'a' => 2
  'b' => 3

julia> haskey(D, 'a')
true

julia> haskey(D, 'c')
false
```
"""
Base.haskey(h::SwissDict, key) = (ht_keyindex(h, key) > 0)
Base.in(key, v::KeySet{<:Any, <:SwissDict}) = (ht_keyindex(v.dict, key) > 0)

"""
    getkey(collection, key, default)

Return the key matching argument `key` if one exists in `collection`, otherwise return `default`.

# Examples
```jldoctest
julia> D = SwissDict('a'=>2, 'b'=>3)
SwissDict{Char, Int64} with 2 entries:
  'a' => 2
  'b' => 3

julia> getkey(D, 'a', 1)
'a': ASCII/Unicode U+0061 (category Ll: Letter, lowercase)

julia> getkey(D, 'd', 'a')
'a': ASCII/Unicode U+0061 (category Ll: Letter, lowercase)
```
"""
function Base.getkey(h::SwissDict{K,V}, key, default) where {K, V}
    index = ht_keyindex(h, key)
    @inbounds return (index<0) ? default : h.keys[index]::K
end

function _pop!(h::SwissDict, index)
    @inbounds val = h.vals[index]
    _delete!(h, index)
    maybe_rehash_shrink!(h)
    return val
end

"""
    pop!(collection, key[, default])

Delete and return the mapping for `key` if it exists in `collection`, otherwise return
`default`, or throw an error if `default` is not specified.

# Examples
```jldoctest
julia> d = SwissDict("a"=>1, "b"=>2, "c"=>3);

julia> pop!(d, "a")
1

julia> pop!(d, "d")
ERROR: KeyError: key "d" not found
[...]

julia> pop!(d, "e", 4)
4
```
"""
function Base.pop!(h::SwissDict, key)
    index = ht_keyindex(h, key)
    return index > 0 ? _pop!(h, index) : throw(KeyError(key))
end

function Base.pop!(h::SwissDict, key, default)
    index = ht_keyindex(h, key)
    return index > 0 ? _pop!(h, index) : default
end

function Base.pop!(h::SwissDict)
    isempty(h) && throw(ArgumentError("SwissDict must be non-empty"))
    is = _iterslots(h, h.idxfloor)
    @assert is !== nothing
    idx, s = is
    @inbounds key = h.keys[idx]
    @inbounds val = h.vals[idx]
    _delete!(h, idx)
    h.idxfloor = idx
    return key => val
end

"""
    delete!(collection, key)

Delete the mapping for the given key in a collection, and return the collection.

# Examples
```jldoctest
julia> d = SwissDict("a"=>1, "b"=>2)
SwissDict{String, Int64} with 2 entries:
  "a" => 1
  "b" => 2

julia> delete!(d, "b")
SwissDict{String, Int64} with 1 entry:
  "a" => 1
```
"""
function Base.delete!(h::SwissDict, key)
    index = ht_keyindex(h, key)
    if index > 0
        _delete!(h, index)
    end
    maybe_rehash_shrink!(h)
    return h
end

Base.@propagate_inbounds function Base.iterate(h::SwissDict{K,V}, state = h.idxfloor) where {K,V}
    is = _iterslots(h, state)
    is === nothing && return nothing
    i, s = is
    @inbounds p = Pair{K,V}(h.keys[i], h.vals[i])
    return (p, s)
end

Base.@propagate_inbounds function Base.iterate(v::Union{KeySet{<:Any, <:SwissDict}, Base.ValueIterator{<:SwissDict}}, state=v.dict.idxfloor)
    is = _iterslots(v.dict, state)
    is === nothing && return nothing
    i, s = is
    return (v isa KeySet ? v.dict.keys[i] : v.dict.vals[i], s)
end

# Benchmark on disjoint set forests

using DataStructures

# do 10^6 random unions over 10^6 element set

const n =  2 * (10^6)
const T0 = 10
const T = 10^6

function batch_union!(s::IntDisjointSet, x::Vector{Int}, y::Vector{Int})
    for i = 1 : length(x)
        @inbounds union!(s, x[i], y[i])
    end
end

s = IntDisjointSet(n)

# warming

x0 = rand(1:n, T0)
y0 = rand(1:n, T0)

batch_union!(s, x0, y0)

# measure

x = rand(1:n, T)
y = rand(1:n, T)

@time batch_union!(s, x, y)

# support functions

function not_iterator_of_pairs(kv::T) where T
    # if the object is not iterable, return true, else check the eltype of the iteration
    Base.isiterable(T) || return true 
    # else, check if we can check `eltype`:
    if Base.IteratorEltype(kv) isa Base.HasEltype
        typ = eltype(kv)
        if !(typ == Any)
            return !(typ <: Union{<: Tuple, <: Pair})
        end
    end
    # we can't check eltype, or eltype is not useful, 
    # so brute force it.
    return any(x->!isa(x, Union{Tuple,Pair}), kv)
end

@testset "Stacks" begin

    @testset "Constructors" begin
        s = Stack{Int}()
        @test isa(s, Stack{Int})

        s = Stack{Int}(5)
        @test isa(s, Stack{Int})
    end

    @testset "Core Functionality" begin
        s = Stack{Int}(5)
        n = 100

        @test isa(s, Stack{Int})
        @test length(s) == 0
        @test isempty(s)
        @test eltype(s) == Int
        @test eltype(typeof(s)) == Int
        @test_throws ArgumentError first(s)
        @test_throws ArgumentError pop!(s)

        for i = 1 : n
            push!(s, i)
            @test first(s) == i
            @test !isempty(s)
            @test length(s) == i
        end

        for i = 1 : n
            x = pop!(s)
            @test x == n - i + 1
            if i < n
                @test first(s) == n - i
            else
                @test_throws ArgumentError first(s)
            end
            @test isempty(s) == (i == n)
            @test length(s) == n - i
        end
    end

    @testset "==" begin
        s = Stack{Int}()
        t = Stack{Int}()

        @test s == t
        push!(s, 10)
        @test s != t
        push!(t, 10)
        @test s == t
        push!(t, 20)
        @test s != t

        @testset "different types" begin
            r = Stack{Float32}()
            push!(r, 10)
            @test s == r
        end
    end

    @testset "empty!" begin
        s = Stack{Int}(1)
        push!(s, 10)
        @test length(empty!(s)) == 0
    end

    @testset "iter should return a LIFO collection" begin
        stk = Stack{Int}(10)
        #an array to check iteration sequence against
        arr = Int64[]

        n = 100

        for i = 1:n
            push!(stk, i)
            push!(arr, i)
        end

        @testset "iterator" begin
            index = length(arr)
            for i in stk
                @test(arr[index] == i)
                index -= 1
            end
        end

        @testset "reverse iterator" begin
            index = 1
            for i in Iterators.reverse(stk)
                @test(arr[index] == i)
                index += 1
            end
        end

        @test arr == [i for i in Iterators.reverse(stk)]
        @test reverse(arr) == [i for i in stk]
        @test first(Iterators.reverse(stk)) === last(stk)
        @test last(Iterators.reverse(stk)) === first(stk)
        @test length(Iterators.reverse(stk)) === length(stk)
    end

end # @testset Stack

# by JMW

function unquote(e::Expr)
    @assert e.head == :quote
    return e.args[1]
end

function unquote(e::QuoteNode)
    return e.value
end

macro delegate(source::Expr, targets::Expr)
    typename = esc(source.args[1])
    fieldname = unquote(source.args[2])
    funcnames = targets.args
    n = length(funcnames)
    fdefs = Vector{Any}(undef, n)
    for i in 1:n
        funcname = esc(funcnames[i])
        fdefs[i] = quote
                     ($funcname)(a::($typename), args...) =
                       ($funcname)(a.$fieldname, args...)
                   end
    end
    return Expr(:block, fdefs...)
end

macro delegate_return_parent(source::Expr, targets::Expr)
    typename = esc(source.args[1])
    fieldname = unquote(source.args[2])
    funcnames = targets.args
    n = length(funcnames)
    fdefs = Vector{Any}(undef, n)
    for i in 1:n
        funcname = esc(funcnames[i])
        fdefs[i] = quote
                     ($funcname)(a::($typename), args...) =
                       (($funcname)(a.$fieldname, args...); a)
                   end
    end
    return Expr(:block, fdefs...)
end

abstract type LinkedList{T} end

Base.eltype(::Type{<:LinkedList{T}}) where T = T

mutable struct Nil{T} <: LinkedList{T}
end

mutable struct Cons{T} <: LinkedList{T}
    head::T
    tail::LinkedList{T}
end

cons(h, t::LinkedList{T}) where {T} = Cons{T}(h, t)

nil(T) = Nil{T}()
nil() = nil(Any)

head(x::Cons) = x.head
tail(x::Cons) = x.tail

Base.:(==)(x::Nil, y::Nil) = true
Base.:(==)(x::Cons, y::Cons) = (x.head == y.head) && (x.tail == y.tail)

function Base.show(io::IO, l::LinkedList{T}) where T
    if isa(l,Nil)
        if T === Any
            print(io, "nil()")
        else
            print(io, "nil(", T, ")")
        end
    else
        print(io, "list(")
        show(io, head(l))
        for t in tail(l)
            print(io, ", ")
            show(io, t)
        end
        print(io, ")")
    end
end

list() = nil()

function list(elts...)
    l = nil()
    for i=length(elts):-1:1
        l = cons(elts[i],l)
    end
    return l
end

function list(elts::T...) where T
    l = nil(T)
    for i=length(elts):-1:1
        l = cons(elts[i],l)
    end
    return l
end

Base.length(l::Nil) = 0

function Base.length(l::Cons)
    n = 0
    for i in l
        n += 1
    end
    return n
end

Base.map(f::Base.Callable, l::Nil) = l

function Base.map(f::Base.Callable, l::Cons{T}) where T
    first = f(l.head)
    l2 = cons(first, nil(typeof(first) <: T ? T : typeof(first)))
    for h in l.tail
        l2 = cons(f(h), l2)
    end
    reverse(l2)
end

function Base.filter(f::Function, l::LinkedList{T}) where T
    l2 = nil(T)
    for h in l
        if f(h)
            l2 = cons(h, l2)
        end
    end
    reverse(l2)
end

function Base.reverse(l::LinkedList{T}) where T
    l2 = nil(T)
    for h in l
        l2 = cons(h, l2)
    end
    return l2
end

Base.copy(l::Nil) = l

function Base.copy(l::Cons)
    l2 = reverse(reverse(l))
end

Base.cat(lst::LinkedList) = lst

function Base.cat(lst::LinkedList, lsts::LinkedList...)
    T = typeof(lst).parameters[1]
    n = length(lsts)
    for i = 1:n
        T2 = typeof(lsts[i]).parameters[1]
        T = typejoin(T, T2)
    end

    l2 = nil(T)
    for h in lst
        l2 = cons(h, l2)
    end

    for i = 1:n
        for h in lsts[i]
            l2 = cons(h, l2)
        end
    end

    reverse(l2)
end

Base.iterate(l::LinkedList, ::Nil) = nothing
function Base.iterate(l::LinkedList, state::Cons = l)
    state.head, state.tail
end

@testset "Trie" begin
    @testset "Core Functionality" begin
        t = Trie{Char,Int}()
        t["amy"] = 56
        t["ann"] = 15
        t["emma"] = 30
        t["rob"] = 27
        t["roger"] = 52
        t["kevin"] = Int8(11)

        @test haskey(t, "roger")
        @test get(t,"rob",nothing) == 27
        @test sort(keys(t)) == ["amy", "ann", "emma", "kevin", "rob", "roger"]
        @test t["rob"] == 27
        @test sort(keys_with_prefix(t,"ro")) == ["rob", "roger"]
    end

    @testset "Constructors" begin
        ks = ["amy", "ann", "emma", "rob", "roger"]
        vs = [56, 15, 30, 27, 52]
        kvs = collect(zip(ks, vs))
        @test isa(Trie(ks, vs), Trie{Char,Int})
        @test isa(Trie(kvs), Trie{Char,Int})
        @test isa(Trie(Dict(kvs)), Trie{Char,Int})
        @test isa(Trie(ks), Trie{Char,Nothing})
    end

    @testset "partial_path iterator" begin
        t = Trie{Char,Int}()
        t["rob"] = 27
        t["roger"] = 52
        t["kevin"] = Int8(11)
        t0 = t
        t1 = t0.children['r']
        t2 = t1.children['o']
        t3 = t2.children['b']
        @test collect(partial_path(t, "b")) == [t0]
        @test collect(partial_path(t, "rob")) == [t0, t1, t2, t3]
        @test collect(partial_path(t, "robb")) == [t0, t1, t2, t3]
        @test collect(partial_path(t, "ro")) == [t0, t1, t2]
        @test collect(partial_path(t, "roa")) == [t0, t1, t2]
    end

    @testset "partial_path iterator non-ascii" begin
        t = Trie(["東京都"])
        t0 = t
        t1 = t0.children['東']
        t2 = t1.children['京']
        t3 = t2.children['都']
        @test collect(partial_path(t, "西")) == [t0]
        @test collect(partial_path(t, "東京都")) == [t0, t1, t2, t3]
        @test collect(partial_path(t, "東京都渋谷区")) == [t0, t1, t2, t3]
        @test collect(partial_path(t, "東京")) == [t0, t1, t2]
        @test collect(partial_path(t, "東京スカイツリー")) == [t0, t1, t2]
    end

    @testset "find_prefixes" begin
        t = Trie(["A", "ABC", "ABD", "BCD"])
        prefixes = find_prefixes(t, "ABCDE")
        @test prefixes == ["A", "ABC"]
    end

    @testset "find_prefixes non-ascii" begin
        t = Trie(["東京都", "東京都渋谷区", "東京都新宿区"])
        prefixes = find_prefixes(t, "東京都渋谷区東")
        @test prefixes == ["東京都", "東京都渋谷区"]
    end

    @testset "non-string indexing" begin
        t = Trie{Int,Int}()
        t[[1,2,3,4]] = 1
        t[[1,2]] = 2
        @test haskey(t, [1,2])
        @test get(t, [1,2], nothing) == 2
        st = subtrie(t, [1,2,3])
        @test keys(st) == [[4]]
        @test st[[4]] == 1
        @test find_prefixes(t, [1,2,3,5]) == [[1,2]]
        @test find_prefixes(t, 1:3) == [1:2]
    end
end # @testset Trie

# This file was copied from Transducers.jl
# which is available under an MIT license (see LICENSE).
using PkgBenchmark
include("pprinthelper.jl")
group_target = PkgBenchmark.readresults(joinpath(@__DIR__, "result-target.json"))
group_baseline = PkgBenchmark.readresults(joinpath(@__DIR__, "result-baseline.json"))
judgement = judge(group_target, group_baseline)

displayresult(judgement)

printnewsection("Target result")
displayresult(group_target)

printnewsection("Baseline result")
displayresult(group_baseline)

# Binary heap

struct MutableBinaryHeapNode{T}
    value::T
    handle::Int
end

#################################################
#
#   core implementation
#
#################################################

function _heap_bubble_up!(ord::Ordering,
    nodes::Vector{MutableBinaryHeapNode{T}}, nodemap::Vector{Int}, nd_id::Int) where T

    @inbounds nd = nodes[nd_id]
    v::T = nd.value

    swapped = true  # whether swap happens at last step
    i = nd_id

    while swapped && i > 1  # nd is not root
        p = i >> 1
        @inbounds nd_p = nodes[p]

        if Base.lt(ord, v, nd_p.value)
            # move parent downward
            @inbounds nodes[i] = nd_p
            @inbounds nodemap[nd_p.handle] = i
            i = p
        else
            swapped = false
        end
    end

    if i != nd_id
        nodes[i] = nd
        nodemap[nd.handle] = i
    end
end

function _heap_bubble_down!(ord::Ordering,
    nodes::Vector{MutableBinaryHeapNode{T}}, nodemap::Vector{Int}, nd_id::Int) where T

    @inbounds nd = nodes[nd_id]
    v::T = nd.value

    n = length(nodes)
    last_parent = n >> 1

    swapped = true
    i = nd_id

    while swapped && i <= last_parent
        il = i << 1

        if il < n   # contains both left and right children
            ir = il + 1

            # determine the better child
            @inbounds nd_l = nodes[il]
            @inbounds nd_r = nodes[ir]

            if Base.lt(ord, nd_r.value, nd_l.value)
                # consider right child
                if Base.lt(ord, nd_r.value, v)
                    @inbounds nodes[i] = nd_r
                    @inbounds nodemap[nd_r.handle] = i
                    i = ir
                else
                    swapped = false
                end
            else
                # consider left child
                if Base.lt(ord, nd_l.value, v)
                    @inbounds nodes[i] = nd_l
                    @inbounds nodemap[nd_l.handle] = i
                    i = il
                else
                    swapped = false
                end
            end

        else  # contains only left child
            nd_l = nodes[il]
            if Base.lt(ord, nd_l.value, v)
                @inbounds nodes[i] = nd_l
                @inbounds nodemap[nd_l.handle] = i
                i = il
            else
                swapped = false
            end
        end
    end

    if i != nd_id
        @inbounds nodes[i] = nd
        @inbounds nodemap[nd.handle] = i
    end
end

function _binary_heap_pop!(ord::Ordering,
    nodes::Vector{MutableBinaryHeapNode{T}}, nodemap::Vector{Int}, nd_id::Int=1) where T

    # extract node
    rt = nodes[nd_id]
    v = rt.value
    @inbounds nodemap[rt.handle] = 0

    # if node-to-remove is at end, we can just pop it
    # the same applies to 1-element heaps that are empty after removing the last element
    if nd_id == lastindex(nodes)
        pop!(nodes)
    else
        # move the last node to the position of the node-to-remove
        @inbounds nodes[nd_id] = new_rt = nodes[end]
        pop!(nodes)
        @inbounds nodemap[new_rt.handle] = nd_id

        if length(nodes) > 1
            if Base.lt(ord, new_rt.value, v)
                _heap_bubble_up!(ord, nodes, nodemap, nd_id)
            else
                _heap_bubble_down!(ord, nodes, nodemap, nd_id)
            end
        end
    end
    return v
end

function _make_mutable_binary_heap(ord::Ordering, ty::Type{T}, values) where T
    # make a static binary index tree from a list of values

    n = length(values)
    nodes = Vector{MutableBinaryHeapNode{T}}(undef, n)
    nodemap = Vector{Int}(undef, n)

    i::Int = 0
    for v in values
        i += 1
        @inbounds nodes[i] = MutableBinaryHeapNode{T}(v, i)
        @inbounds nodemap[i] = i
    end

    for i = 1 : n
        _heap_bubble_up!(ord, nodes, nodemap, i)
    end
    return nodes, nodemap
end


#################################################
#
#   Binary Heap type and constructors
#
#################################################

mutable struct MutableBinaryHeap{T, O <: Base.Ordering} <: AbstractMutableHeap{T, Int}
    ordering::O
    nodes::Vector{MutableBinaryHeapNode{T}}
    node_map::Vector{Int}

    function MutableBinaryHeap{T}(ordering::Base.Ordering) where T
        nodes = Vector{MutableBinaryHeapNode{T}}()
        node_map = Vector{Int}()
        new{T, typeof(ordering)}(ordering, nodes, node_map)
    end

    function MutableBinaryHeap{T}(ordering::Base.Ordering, xs::AbstractVector) where T
        nodes, node_map = _make_mutable_binary_heap(ordering, T, xs)
        new{T, typeof(ordering)}(ordering, nodes, node_map)
    end
end

MutableBinaryHeap(ordering::Base.Ordering, xs::AbstractVector{T}) where T = MutableBinaryHeap{T}(ordering, xs)

# Constructors using singleton order types as type parameters rather than arguments
MutableBinaryHeap{T, O}() where {T, O<:Base.Ordering} = MutableBinaryHeap{T}(O())
MutableBinaryHeap{T, O}(xs::AbstractVector) where {T, O<:Base.Ordering} = MutableBinaryHeap{T}(O(), xs)

# These constructors needed for BinaryMaxHeap, until we have https://github.com/JuliaLang/julia/pull/37822
MutableBinaryHeap{T, DefaultReverseOrdering}() where {T} = MutableBinaryHeap{T}(Base.Reverse)
MutableBinaryHeap{T, DefaultReverseOrdering}(xs::AbstractVector) where {T} = MutableBinaryHeap{T}(Base.Reverse, xs)

# Forward/reverse ordering type aliases
const MutableBinaryMinHeap{T} = MutableBinaryHeap{T, Base.ForwardOrdering}
const MutableBinaryMaxHeap{T} = MutableBinaryHeap{T, DefaultReverseOrdering}

MutableBinaryMinHeap(xs::AbstractVector{T}) where T = MutableBinaryMinHeap{T}(xs)
MutableBinaryMaxHeap(xs::AbstractVector{T}) where T = MutableBinaryMaxHeap{T}(xs)


function Base.show(io::IO, h::MutableBinaryHeap)
    print(io, "MutableBinaryHeap(")
    nodes = h.nodes
    n = length(nodes)
    if n > 0
        print(io, string(nodes[1].value))
        for i = 2 : n
            print(io, ", $(nodes[i].value)")
        end
    end
    print(io, ")")
end


#################################################
#
#   interfaces
#
#################################################

Base.length(h::MutableBinaryHeap) = length(h.nodes)

Base.isempty(h::MutableBinaryHeap) = isempty(h.nodes)

function Base.push!(h::MutableBinaryHeap{T}, v) where T
    nodes = h.nodes
    nodemap = h.node_map
    i = length(nodemap) + 1
    nd_id = length(nodes) + 1
    push!(nodes, MutableBinaryHeapNode{T}(convert(T, v), i))
    push!(nodemap, nd_id)
    _heap_bubble_up!(h.ordering, nodes, nodemap, nd_id)
    return i
end

function Base.empty!(h::MutableBinaryHeap)
    empty!(h.nodes)
    empty!(h.node_map)
    return h
end

function Base.sizehint!(h::MutableBinaryHeap, s::Integer)
    sizehint!(h.nodes, s)
    sizehint!(h.node_map, s)
    return h
end

@inline Base.first(h::MutableBinaryHeap) = h.nodes[1].value

"""
    top_with_handle(h::MutableBinaryHeap)

Returns the element at the top of the heap `h` and its handle.
"""
function top_with_handle(h::MutableBinaryHeap)
    el = h.nodes[1]
    return el.value, el.handle
end

Base.pop!(h::MutableBinaryHeap{T}) where {T} = _binary_heap_pop!(h.ordering, h.nodes, h.node_map)

"""
    update!{T}(h::MutableBinaryHeap{T}, i::Int, v::T)

Replace the element at index `i` in heap `h` with `v`.
This is equivalent to `h[i]=v`.
"""
function update!(h::MutableBinaryHeap{T}, i::Int, v) where T
    nodes = h.nodes
    nodemap = h.node_map
    ordering = h.ordering

    nd_id = nodemap[i]
    v0 = nodes[nd_id].value
    x = convert(T, v)
    nodes[nd_id] = MutableBinaryHeapNode{T}(x, i)
    if Base.lt(ordering, x, v0)
        _heap_bubble_up!(ordering, nodes, nodemap, nd_id)
    else
        _heap_bubble_down!(ordering, nodes, nodemap, nd_id)
    end
end

"""
    delete!{T}(h::MutableBinaryHeap{T}, i::Int)

Deletes the element with handle `i` from heap `h` .
"""
function Base.delete!(h::MutableBinaryHeap{T}, i::Int) where T
     nd_id = h.node_map[i]
    _binary_heap_pop!(h.ordering, h.nodes, h.node_map, nd_id)
    return h
end

Base.setindex!(h::MutableBinaryHeap, v, i::Int) = update!(h, i, v)
Base.getindex(h::MutableBinaryHeap, i::Int) = h.nodes[h.node_map[i]].value

################################################
#
# minmax heap type and constructors
#
################################################

mutable struct BinaryMinMaxHeap{T} <: AbstractMinMaxHeap{T}
    valtree::Vector{T}

    BinaryMinMaxHeap{T}() where {T} = new{T}(Vector{T}())

    function BinaryMinMaxHeap{T}(xs::AbstractVector{T}) where {T}
        valtree = _make_binary_minmax_heap(xs)
        new{T}(valtree)
    end
end

BinaryMinMaxHeap(xs::AbstractVector{T}) where T = BinaryMinMaxHeap{T}(xs)

################################################
#
# core implementation
#
################################################

function _make_binary_minmax_heap(xs)
    valtree = copy(xs)
    for i in length(xs):-1:1
        @inbounds _minmax_heap_trickle_down!(valtree, i)
    end
    return valtree
end

Base.@propagate_inbounds function _minmax_heap_bubble_up!(A::AbstractVector, i::Integer)
    if on_minlevel(i)
        if i > 1 && A[i] > A[hparent(i)]
            # swap to parent and bubble up max
            tmp = A[i]
            A[i] = A[hparent(i)]
            A[hparent(i)] = tmp
            _minmax_heap_bubble_up!(A, hparent(i), Reverse)
        else
            # bubble up min
            _minmax_heap_bubble_up!(A, i, Forward)
        end

    else
        # max level
        if i > 1 && A[i] < A[hparent(i)]
            # swap to parent and bubble up min
            tmp = A[i]
            A[i] = A[hparent(i)]
            A[hparent(i)] = tmp
            _minmax_heap_bubble_up!(A, hparent(i), Forward)
        else
            # bubble up max
            _minmax_heap_bubble_up!(A, i, Reverse)
        end
    end
end

Base.@propagate_inbounds function _minmax_heap_bubble_up!(A::AbstractVector, i::Integer, o::Ordering, x=A[i])
    if hasgrandparent(i)
        gparent = hparent(hparent(i))
        if lt(o, x, A[gparent])
            A[i] = A[gparent]
            A[gparent] = x
            _minmax_heap_bubble_up!(A, gparent, o)
        end
    end
end

Base.@propagate_inbounds function _minmax_heap_trickle_down!(A::AbstractVector, i::Integer)
    if on_minlevel(i)
        _minmax_heap_trickle_down!(A, i, Forward)
    else
        _minmax_heap_trickle_down!(A, i, Reverse)
    end
end

Base.@propagate_inbounds function _minmax_heap_trickle_down!(A::AbstractVector, i::Integer, o::Ordering, x=A[i])

    if haschildren(i, A)
        # get the index of the extremum (min or max) descendant
        extremum = o === Forward ? minimum : maximum
        _, m = extremum((A[j], j) for j in children_and_grandchildren(length(A), i))

        if isgrandchild(m, i)
            if lt(o, A[m], A[i])
                A[i] = A[m]
                A[m] = x
                if lt(o, A[hparent(m)], A[m])
                    t = A[m]
                    A[m] = A[hparent(m)]
                    A[hparent(m)] = t
                end
                _minmax_heap_trickle_down!(A, m, o)
            end
        else
            if lt(o, A[m], A[i])
                A[i] = A[m]
                A[m] = x
            end
        end
    end
end

################################################
#
# utilities
#
################################################

@inline level(i) = floor(Int, log2(i))
@inline lchild(i) = 2*i
@inline rchild(i) = 2*i+1
@inline children(i) = (lchild(i), rchild(i))
@inline hparent(i) = i ÷ 2
@inline on_minlevel(i) = level(i) % 2 == 0
@inline haschildren(i, A) = lchild(i) ≤ length(A)
@inline isgrandchild(j, i) = j > rchild(i)
@inline hasgrandparent(i) = i ≥ 4

"""
    children_and_grandchildren(maxlen, i)

Return the indices of all children and grandchildren of
position `i`.
"""
function children_and_grandchildren(maxlen::T, i::T) where {T <: Integer}
    left, right = children(i)
    _children_and_grandchildren = (left, children(left)..., right, children(right)...)
    return Iterators.filter(<=(maxlen), _children_and_grandchildren)
end

"""
    is_minmax_heap(h::AbstractVector) -> Bool

Return `true` if `A` is a min-max heap. A min-max heap is a
heap where the minimum element is the root and the maximum
element is a child of the root.
"""
function is_minmax_heap(A::AbstractVector)

    for i in 1:length(A)
        if on_minlevel(i)
            # check that A[i] < children A[i]
            #    and grandchildren A[i]
            for j in children_and_grandchildren(length(A), i)
                A[i] ≤ A[j] || return false
            end
        else
            # max layer
            for j in children_and_grandchildren(length(A), i)
                A[i] ≥ A[j] || return false
            end
        end
    end
    return true
end

################################################
#
# interfaces
#
################################################

Base.length(h::BinaryMinMaxHeap) = length(h.valtree)

Base.isempty(h::BinaryMinMaxHeap) = isempty(h.valtree)

"""
    pop!(h::BinaryMinMaxHeap) = popmin!(h)
"""
@inline Base.pop!(h::BinaryMinMaxHeap) = popmin!(h)

function Base.sizehint!(h::BinaryMinMaxHeap, s::Integer)
    sizehint!(h.valtree, s)
    return h
end

"""
    popmin!(h::BinaryMinMaxHeap) -> min

Remove the minimum value from the heap.
"""
function popmin!(h::BinaryMinMaxHeap)
    valtree = h.valtree
    !isempty(valtree) || throw(ArgumentError("heap must be non-empty"))
    @inbounds x = valtree[1]
    y = pop!(valtree)
    if !isempty(valtree)
        @inbounds valtree[1] = y
        @inbounds _minmax_heap_trickle_down!(valtree, 1)
    end
    return x
end


"""
    popmin!(h::BinaryMinMaxHeap, k::Integer) -> vals

Remove up to the `k` smallest values from the heap.
"""
@inline function popmin!(h::BinaryMinMaxHeap, k::Integer)
    return [popmin!(h) for _ in 1:min(length(h), k)]
end

"""
    popmax!(h::BinaryMinMaxHeap) -> max

Remove the maximum value from the heap.
"""
function popmax!(h::BinaryMinMaxHeap)
    valtree = h.valtree
    !isempty(valtree) || throw(ArgumentError("heap must be non-empty"))
    @inbounds x, i = maximum(((valtree[j], j) for j in 1:min(length(valtree), 3)))
    y = pop!(valtree)
    if !isempty(valtree) && i <= length(valtree)
        @inbounds valtree[i] = y
        @inbounds _minmax_heap_trickle_down!(valtree, i)
    end
    return x
end

"""
    popmax!(h::BinaryMinMaxHeap, k::Integer) -> vals

Remove up to the `k` largest values from the heap.
"""
@inline function popmax!(h::BinaryMinMaxHeap, k::Integer)
    return [popmax!(h) for _ in 1:min(length(h), k)]
end


function Base.push!(h::BinaryMinMaxHeap, v)
    valtree = h.valtree
    push!(valtree, v)
    @inbounds _minmax_heap_bubble_up!(valtree, length(valtree))
end

"""
    first(h::BinaryMinMaxHeap)

Get the first (minimum) of the heap.
"""
@inline Base.first(h::BinaryMinMaxHeap) = minimum(h)

@inline function Base.minimum(h::BinaryMinMaxHeap)
    valtree = h.valtree
    !isempty(h) || throw(ArgumentError("heap must be non-empty"))
    return @inbounds h.valtree[1]
end

@inline function Base.maximum(h::BinaryMinMaxHeap)
    valtree = h.valtree
    !isempty(h) || throw(ArgumentError("heap must be non-empty"))
    return @inbounds maximum(@views(valtree[1:min(end, 3)]))
end

Base.empty!(h::BinaryMinMaxHeap) = (empty!(h.valtree); h)


"""
    popall!(h::BinaryMinMaxHeap, ::Ordering = Forward)

Remove and return all the elements of `h` according to
the given ordering. Default is `Forward` (smallest to
largest).
"""
popall!(h::BinaryMinMaxHeap) = popall!(h, Forward)
popall!(h::BinaryMinMaxHeap, ::ForwardOrdering) = popmin!(h, length(h))
popall!(h::BinaryMinMaxHeap, ::ReverseOrdering) = popmax!(h, length(h))

const ALLOWABLE_USELESS_GROWTH = 0.25

"""
    OrderedRobinDict([itr])

`OrderedRobinDict{K,V}()` constructs a ordered dictionary with keys of type `K` and values of type `V`.
It takes advantage of `RobinDict` in maintaining the order of the keys.
Given a single iterable argument, constructs a [`OrderedRobinDict`](@ref) whose key-value pairs
are taken from 2-tuples `(key,value)` generated by the argument.


# Examples
```jldoctest
julia> OrderedRobinDict([("A", 1), ("B", 2)])
OrderedRobinDict{String, Int64} with 2 entries:
  "A" => 1
  "B" => 2
```

Alternatively, a sequence of pair arguments may be passed.

```jldoctest
julia> OrderedRobinDict("A"=>1, "B"=>2)
OrderedRobinDict{String, Int64} with 2 entries:
  "A" => 1
  "B" => 2
```
"""
mutable struct OrderedRobinDict{K,V} <: AbstractDict{K,V}
    dict::RobinDict{K, Int32}
    keys::Vector{K}
    vals::Vector{V}
    count::Int32

    function OrderedRobinDict{K, V}() where {K, V}
        new{K, V}(RobinDict{K, Int32}(), Vector{K}(), Vector{V}(), 0)
    end

    function OrderedRobinDict{K, V}(d::OrderedRobinDict{K, V}) where {K, V}
        new{K, V}(copy(d.dict), copy(d.keys), copy(d.vals), d.count)
    end

    function OrderedRobinDict{K,V}(kv) where {K, V}
        h = OrderedRobinDict{K,V}()
        for (k,v) in kv
            h[k] = v
        end
        return h
    end
    OrderedRobinDict{K,V}(p::Pair) where {K,V} = setindex!(OrderedRobinDict{K,V}(), p.second, p.first)
    function OrderedRobinDict{K,V}(ps::Pair...) where V where K
        h = OrderedRobinDict{K,V}()
        sizehint!(h, length(ps))
        for p in ps
            h[p.first] = p.second
        end
        return h
    end
end

OrderedRobinDict() = OrderedRobinDict{Any,Any}()
OrderedRobinDict(kv::Tuple{}) = OrderedRobinDict()
Base.copy(d::OrderedRobinDict) = OrderedRobinDict(d)
Base.empty(d::OrderedRobinDict, ::Type{K}, ::Type{V}) where {K, V} = OrderedRobinDict{K, V}()

OrderedRobinDict(ps::Pair{K,V}...) where {K,V} = OrderedRobinDict{K,V}(ps)
OrderedRobinDict(ps::Pair...)                  = OrderedRobinDict(ps)

OrderedRobinDict(d::AbstractDict{K, V}) where {K, V} = OrderedRobinDict{K, V}(d)

function OrderedRobinDict(kv)
    try
        return dict_with_eltype((K, V) -> OrderedRobinDict{K, V}, kv, eltype(kv))
    catch e
        if !isiterable(typeof(kv)) || !all(x -> isa(x, Union{Tuple,Pair}), kv)
            !all(x->isa(x,Union{Tuple,Pair}),kv)
            throw(ArgumentError("OrderedRobinDict(kv): kv needs to be an iterator of tuples or pairs"))
        else
            rethrow(e)
        end
    end
end

Base.empty(d::OrderedRobinDict{K,V}) where {K,V} = OrderedRobinDict{K,V}()

Base.length(d::Union{RobinDict, OrderedRobinDict}) = d.count
Base.isempty(d::Union{RobinDict, OrderedRobinDict}) = (length(d) == 0)

"""
    empty!(collection) -> collection

Remove all elements from a `collection`.

# Examples
```jldoctest
julia> A = OrderedRobinDict("a" => 1, "b" => 2)
OrderedRobinDict{String, Int64} with 2 entries:
  "a" => 1
  "b" => 2

julia> empty!(A);


julia> A
OrderedRobinDict{String, Int64}()
```
"""
function Base.empty!(h::OrderedRobinDict{K,V}) where {K, V}
    empty!(h.dict)
    empty!(h.keys)
    empty!(h.vals)
    h.count = 0
    return h
end

function _setindex!(h::OrderedRobinDict, v, key)
    hk, hv = h.keys, h.vals
    push!(hk, key)
    push!(hv, v)
    nk = length(hk)
    @inbounds h.dict[key] = Int32(nk)
    h.count += 1
end

function Base.setindex!(h::OrderedRobinDict{K, V}, v0, key0) where {K,V}
    key = convert(K, key0)
    v = convert(V, v0)
    index = get(h.dict, key, -2)

    if index < 0
        _setindex!(h, v0, key0)
    else
        @assert haskey(h, key0)
        @inbounds orig_v = h.vals[index]
        !isequal(orig_v, v0) && (@inbounds h.vals[index] = v0)
    end

    check_for_rehash(h) && rehash!(h)

    return h
end

# rehash when there are ALLOWABLE_USELESS_GROWTH %
# tombstones, or non-mirrored entries in the dictionary
function check_for_rehash(h::OrderedRobinDict)
    keysl = length(h.keys)
    dictl = length(h)
    return (keysl > (1 + ALLOWABLE_USELESS_GROWTH)*dictl)
end

function rehash!(h::OrderedRobinDict{K, V}) where {K, V}
    keys = h.keys
    vals = h.vals
    hk = Vector{K}()
    hv = Vector{V}()

    for (idx, (k, v)) in enumerate(zip(keys, vals))
        if get(h.dict, k, -1) == idx
            push!(hk, k)
            push!(hv, v)
        end
    end

    h.keys = hk
    h.vals = hv

    for (idx, k) in enumerate(h.keys)
        h.dict[k] = idx
    end
    return h
end

function Base.sizehint!(d::OrderedRobinDict, newsz::Integer)
    oldsz = length(d)
    # grow at least 25%
    if newsz < (oldsz*5)>>2
        return d
    end
    sizehint!(d.keys, newsz)
    sizehint!(d.vals, newsz)
    sizehint!(d.dict, newsz)
    return d
end

"""
    get!(collection, key, default)

Return the value stored for the given key, or if no mapping for the key is present, store
`key => default`, and return `default`.

# Examples
```jldoctest
julia> d = OrderedRobinDict("a"=>1, "b"=>2, "c"=>3);


julia> get!(d, "a", 5)
1

julia> get!(d, "d", 4)
4

julia> d
OrderedRobinDict{String, Int64} with 4 entries:
  "a" => 1
  "b" => 2
  "c" => 3
  "d" => 4
```
"""
function Base.get!(h::OrderedRobinDict{K,V}, key0, default) where {K,V}
    index = get(h.dict, key0, -2)
    index > 0 && return h.vals[index]
    v = convert(V, default)
    setindex!(h, v, key0)
    return v
end

"""
    get!(f::Function, collection, key)

Return the value stored for the given key, or if no mapping for the key is present, store
`key => f()`, and return `f()`.

This is intended to be called using `do` block syntax:
```julia
get!(dict, key) do
    # default value calculated here
    time()
end
```
"""
function Base.get!(default::Base.Callable, h::OrderedRobinDict{K,V}, key0) where {K,V}
    index = get(h.dict, key0, -2)
    index > 0 && return @inbounds h.vals[index]

    v = convert(V, default())
    setindex!(h, v, key0)
    return v
end

function Base.getindex(h::OrderedRobinDict{K,V}, key) where {K,V}
    index = get(h.dict, key, -1)
    return (index < 0) ? throw(KeyError(key)) : @inbounds h.vals[index]::V
end

"""
    get(collection, key, default)

Return the value stored for the given key, or the given default value if no mapping for the
key is present.

# Examples
```jldoctest
julia> d = OrderedRobinDict("a"=>1, "b"=>2);


julia> get(d, "a", 3)
1

julia> get(d, "c", 3)
3
```
"""
function Base.get(h::OrderedRobinDict{K,V}, key, default) where {K,V}
    index = get(h.dict, key, -1)
    return (index < 0) ? default : @inbounds h.vals[index]::V
end

"""
    get(f::Function, collection, key)

Return the value stored for the given key, or if no mapping for the key is present, return
`f()`.  Use [`get!`](@ref) to also store the default value in the dictionary.

This is intended to be called using `do` block syntax

```julia
get(dict, key) do
    # default value calculated here
    time()
end
```
"""
function Base.get(default::Base.Callable, h::OrderedRobinDict{K,V}, key) where {K,V}
    index = get(h.dict, key, -1)
    return (index < 0) ? default() : @inbounds h.vals[index]::V
end

"""
    haskey(collection, key) -> Bool

Determine whether a collection has a mapping for a given `key`.

# Examples
```jldoctest
julia> D = OrderedRobinDict('a'=>2, 'b'=>3)
OrderedRobinDict{Char, Int64} with 2 entries:
  'a' => 2
  'b' => 3

julia> haskey(D, 'a')
true

julia> haskey(D, 'c')
false
```
"""
Base.haskey(h::OrderedRobinDict, key) = (get(h.dict, key, -1) > 0)
Base.in(key, v::Base.KeySet{K,T}) where {K,T<:OrderedRobinDict{K}} = (get(v.dict.dict, key, -1) >= 0)

"""
    getkey(collection, key, default)

Return the key matching argument `key` if one exists in `collection`, otherwise return `default`.

# Examples
```jldoctest
julia> D = OrderedRobinDict('a'=>2, 'b'=>3)
OrderedRobinDict{Char, Int64} with 2 entries:
  'a' => 2
  'b' => 3

julia> getkey(D, 'a', 1)
'a': ASCII/Unicode U+0061 (category Ll: Letter, lowercase)

julia> getkey(D, 'd', 'a')
'a': ASCII/Unicode U+0061 (category Ll: Letter, lowercase)
```
"""
function Base.getkey(h::OrderedRobinDict{K,V}, key, default) where {K,V}
    index = get(h.dict, key, -1)
    return (index < 0) ? default : h.keys[index]::K
end

Base.@propagate_inbounds isslotfilled(h::OrderedRobinDict, index) = (h.dict[h.keys[index]] == index)

function _pop!(h::OrderedRobinDict, index)
    @inbounds val = h.vals[index]
    _delete!(h, index)
    return val
end

function Base.pop!(h::OrderedRobinDict)
    check_for_rehash(h) && rehash!(h)
    index = length(h.keys)
    while (index > 0)
        isslotfilled(h, index) && break
        index -= 1
    end
    index == 0 && rehash!(h)
    @inbounds key = h.keys[index]
    return key => _pop!(h, index)
end

function Base.pop!(h::OrderedRobinDict, key)
    index = get(h.dict, key, -1)
    (index > 0) ? _pop!(h, index) : throw(KeyError(key))
end

"""
    pop!(collection, key[, default])

Delete and return the mapping for `key` if it exists in `collection`, otherwise return
`default`, or throw an error if `default` is not specified.

# Examples
```jldoctest
julia> d = OrderedRobinDict("a"=>1, "b"=>2, "c"=>3);


julia> pop!(d, "a")
1

julia> pop!(d, "d")
ERROR: KeyError: key "d" not found
Stacktrace:
[...]

julia> pop!(d, "e", 4)
4
```
"""
function Base.pop!(h::OrderedRobinDict, key, default)
    index = get(h.dict, key, -1)
    (index > 0) ? _pop!(h, index) : default
end

"""
    delete!(collection, key)

Delete the mapping for the given key in a collection, and return the collection.

# Examples
```jldoctest
julia> d = OrderedRobinDict("a"=>1, "b"=>2)
OrderedRobinDict{String, Int64} with 2 entries:
  "a" => 1
  "b" => 2

julia> delete!(d, "b")
OrderedRobinDict{String, Int64} with 1 entry:
  "a" => 1
```
"""
function Base.delete!(h::OrderedRobinDict, key)
    pop!(h, key)
    return h
end

function _delete!(h::OrderedRobinDict, index)
    @inbounds h.dict[h.keys[index]] = -1
    h.count -= 1
    check_for_rehash(h) ? rehash!(h) : h
end

function get_first_filled_index(h::OrderedRobinDict)
    index = 1
    while (true)
        isslotfilled(h, index) && return index
        index += 1
    end
end

function get_next_filled_index(h::OrderedRobinDict, index)
    # get the next filled slot, including index and beyond
    while (index <= length(h.keys))
        isslotfilled(h, index) && return index
        index += 1
    end
    return -1
end

Base.@propagate_inbounds function Base.iterate(h::OrderedRobinDict{K,V}) where {K,V}
    isempty(h) && return nothing
    check_for_rehash(h) && rehash!(h)
    index = get_first_filled_index(h)
    @inbounds return (Pair{K,V}(h.keys[index], h.vals[index]), index+1)
end

Base.@propagate_inbounds function Base.iterate(h::OrderedRobinDict{K,V}, i) where {K,V}
    length(h.keys) < i && return nothing
    index = get_next_filled_index(h, i)
    (index < 0) && return nothing
    @inbounds return (Pair{K,V}(h.keys[index], h.vals[index]), index+1)
end

Base.filter!(f, d::Union{RobinDict, OrderedRobinDict}) = Base.filter_in_one_pass!(f, d)

function Base.merge(d::OrderedRobinDict, others::AbstractDict...)
    K,V = _merge_kvtypes(d, others...)
    merge!(OrderedRobinDict{K,V}(), d, others...)
end

function Base.merge(combine::Function, d::OrderedRobinDict, others::AbstractDict...)
    K,V = _merge_kvtypes(d, others...)
    merge!(combine, OrderedRobinDict{K,V}(), d, others...)
end

OrderedCollections.isordered(::Type{T}) where {T <: OrderedRobinDict} = true

@testset "CircularDeque" begin

    @testset "Core Functionality" begin
        D = CircularDeque{Int}(5)
        @test eltype(D) == Int
        @test eltype(typeof(D)) == Int
        @test capacity(D) == 5
        @test length(D) == 0
        @test isempty(D)
        @test_throws BoundsError first(D)
        @test_throws BoundsError last(D)
        push!(D, 1)
        @test first(D) === last(D) === 1
        push!(D, 2)
        @test first(D) === 1
        @test last(D)  === 2
        @test length(D) == 2
        for i = 3:5
            push!(D, i)
        end
        @test_throws BoundsError push!(D, 6)
        @test popfirst!(D) === 1
        @test first(D) === 2
        @test last(D) === 5
        io = IOBuffer()
        print(io, Int)
        intstr = String(take!(io))
        print(io, D)
        @test String(take!(io)) == "CircularDeque{$intstr}([2,3,4,5])"
        push!(D, 6)
        @test first(D) === 2
        @test last(D) === 6
        @test pop!(D) === 6
        @test first(D) === 2
        @test last(D) === 5
        pushfirst!(D, 7)
        @test first(D) === 7
        @test last(D) === 5
        @test_throws BoundsError pushfirst!(D, 8)
        @test popfirst!(D) === 7
        @test popfirst!(D) === 2
        @test pop!(D) === 5
        @test popfirst!(D) === 3
        @test pop!(D) === 4
        @test_throws BoundsError pop!(D)
        @test_throws BoundsError popfirst!(D)
        @test isempty(D)
        push!(D, 10)
        @test !isempty(D)
        empty!(D)
        @test isempty(D)
        @test_throws BoundsError first(D)
        push!(D, 20)
        @test first(D) == last(D) == 20
        empty!(D)
        for i = 1:5
            push!(D, i)
        end
        @test popfirst!(D) == 1
        push!(D, 6)
        for i = 2:6
            @test last(D) === 6
            @test D[1] === i
            @test D[7-i] === 6
            @test popfirst!(D) === i
        end
    end

    @testset "pushfirst! works on an empty deque" begin
        # Test that pushfirst! works on an empty deque, and that first/last give the right answer
        D = CircularDeque{Int}(5)
        pushfirst!(D, 30)
        @test first(D) == last(D) == 30
        empty!(D)
        pushfirst!(D, 40)
        @test first(D) == last(D) == 40
    end

    @testset "iteration over loop" begin
        D = CircularDeque{Int}(5)
        for i in 1:5 push!(D, i) end
        @test collect([i for i in D]) == collect(1:5)
    end

    VERSION >= v"1.3" && @testset "pop! and popfirst! do not leak" begin
        D = CircularDeque{String}(5)

        @testset "pop! doesn't leak" begin
            push!(D,"foo")
            push!(D,"bar")
            ss2 = Base.summarysize(D)
            pop!(D)
            GC.gc(true)
            ss1 = Base.summarysize(D)
            @test ss1 < ss2
        end
        @testset "popfirst! doesn't leak" begin
            push!(D,"baz")
            push!(D,"bug")
            ss2 = Base.summarysize(D)
            popfirst!(D)
            GC.gc(true)
            ss1 = Base.summarysize(D)
            @test ss1 < ss2
        end
    end
end

nothing

## A SortedSet is a wrapper around balancedTree with
## methods similar to those of the julia Set.

mutable struct SortedSet{K, Ord <: Ordering}  <: AbstractSet{K}
    bt::BalancedTree23{K,Nothing,Ord}
end


"""
    SortedSet{K,Ord}(o::Ord=Forward) where {K, Ord<:Ordering}
    SortedSet{K,Ord}(o::Ord, iter) where {K, Ord<:Ordering}

Construct a SortedSet of eltype `K`using from elements
produced by  iterable `iter` (e.g., an
array) and ordering object `o`.  Running time: O(*cn* log *n*)
where *n* is the length of iterable.
"""
SortedSet{K,Ord}(o::Ord=Forward) where{K,Ord<:Ordering} =
    SortedSet{K,Ord}(BalancedTree23{K,Nothing,Ord}(o))

function SortedSet{K,Ord}(o::Ord, iter) where {K,Ord<:Ordering}
    sorted_set = SortedSet{K,Ord}(BalancedTree23{K,Nothing,Ord}(o))
    for item in iter
        push!(sorted_set, item)
    end
    return sorted_set
end


"""
    SortedSet(o::Ord=Forward) where {Ord <: Ordering}
    SortedSet{K}(o::Ord=Forward) where {K, Ord<:Ordering}


Construct an empty `SortedSet` with `Forward` ordering.  The first form
assumes element type of `Any`.  Time: O(1).

**Note that an element type of `Any` or any other abstract type will lead
to slow performance.**
"""
SortedSet(o::Ord=Forward) where {Ord<:Ordering} = SortedSet{Any,Ord}(o)
SortedSet{K}(o::Ord=Forward) where {K,Ord <: Ordering} =
    SortedSet{K,Ord}(o)


"""
    SortedSet(o::Ordering, iter)
    SortedSet(iter, o::Ordering=Forward)
    SortedSet{K}(o::Ordering, iter)
    SortedSet{K}(iter, o::Ordering=Forward)

Construct a sorted set from an iterable `iter` using order o.   In
the first two forms, the element type is inferred from the
iterable, which requires copying the data twice.  Therefore,
the second two forms (specifying `K` explicitly) are more efficient.
Time: O(*cn* log *n*)
"""
function SortedSet(o::Ordering, iter)
    c = collect(iter)
    SortedSet{eltype(c),typeof(o)}(o, c)
end
SortedSet(iter, o::Ordering=Forward) = SortedSet(o, iter)
SortedSet{K}(o::Ordering, iter) where {K} = SortedSet{K,typeof(o)}(o, iter)
SortedSet{K}(iter, o::Ordering=Forward) where {K} = SortedSet{K}(o, iter)



"""
    SortedSet{K}(::Val{true}, iterable) where {K}
    SortedSet{K}(::Val{true}, iterable, ord::Ord) where {K, Ord <: Ordering}

Construct a `SortedSet` from an iterable whose entries
have type `K` and that is already in sorted ordered. No duplicates
allowed.  The first form assumes Forward ordering.
Time: O(*cn*).
"""
SortedSet{K}(::Val{true}, iterable) where {K} =
    SortedSet{K}(Val(true), iterable, Forward)
function SortedSet{K}(::Val{true},
                      iterable,
                      ord::Ord) where {K, Ord <: Ordering}
    SortedSet{K, Ord}(BalancedTree23{K,Nothing,Ord}(Val(true),
                                                    ((k,nothing) for k in iterable),
                                                    ord,
                                                    false))
end

# The following is needed to resolve ambiguities

SortedSet{K}(::Val{true}, ::Ordering) where {K} =
    throw(ArgumentError("Not a valid SortedSet constructor"))
SortedSet(::Ordering, ::Ordering) =
    throw(ArgumentError("Not a valid SortedSet constructor"))
SortedSet{K}(::Ordering,::Ordering) where {K} =
    throw(ArgumentError("Not a valid SortedSet constructor"))


const SetSemiToken = IntSemiToken


"""
    findkey(m::SortedSet, k)

Return the semitoken of the element `k` in sorted set `m`.
If the element is not present in `m`, then the past-end semitoken
is returned.  Time: O(*c* log *n*)
"""
@inline function findkey(m::SortedSet, k_)
    ll, exactfound = findkey(m.bt, convert(keytype(m),k_))
    IntSemiToken(exactfound ? ll : 2)
end


"""
    DataStructures.push_return_semitoken!(ss::SortedSet, k)

Insert the element `k`
into the SortedSet `sc`.
If `k` is already present, this overwrites
the old value. (This is not necessarily a no-op; see remarks about the 
customizing the sort order.) Unlike `push!`,
the return value is a
pair whose first entry is boolean and indicates whether the
insertion was new (i.e., the key was not previously present) and the
second entry is the semitoken of the new entry.   This function
replaces the deprecated `insert!`.
Time: O(*c* log *n*)
"""
@inline function push_return_semitoken!(m::SortedSet, k_)
    b, i = insert!(m.bt, convert(keytype(m),k_), nothing, false)
    return b, IntSemiToken(i)
end


"""
    Base.push!(ss::SortedSet, k)

Insert the element `k` into the sorted set `ss`.
If the `k` is already present, this overwrites
the old value. (This is not necessarily a no-op; see remarks about the 
customizing the sort order.) 
See also [`push_return_semitoken!(ss::SortedSet, k)`](@ref).
The return value is
`ss`. Time: O(*c* log *n*)
"""
@inline function Base.push!(m::SortedSet, k_)
    b, i = insert!(m.bt, convert(keytype(m),k_), nothing, false)
    return m
end



"""
    Base.in(k,m::SortedSet)

Return `true` iff
element `k` is in sorted set `m` is a sorted set.
Unlike the `in` function for
`Set`, this routine will thrown an error if `k` is not 
convertible to `eltype(m)`.  Time: O(*c* log *n*)
"""
@inline function Base.in(k_, m::SortedSet)
    i, exactfound = findkey(m.bt, convert(keytype(m),k_))
    return exactfound
end

@inline Base.keytype(m::SortedSet{K,Ord}) where {K,Ord <: Ordering} = K
@inline Base.keytype(::Type{SortedSet{K,Ord}}) where {K,Ord <: Ordering} = K



"""
    Base.delete!(ss::SortedSet, k)

Delete element `k` from `sc`.  After this operation
is complete, a token addressing the deleted item is invalid.
Returns `sc`.  if `k` is not present, this operation is a no-op.
Time: O(*c* log *n*)
"""
@inline function Base.delete!(m::SortedSet, k_)
    i, exactfound = findkey(m.bt,convert(keytype(m),k_))
    if exactfound
        delete!(m.bt, i)
    end
    return m
end


"""
    Base.pop!(ss::SortedSet, k)
    Base.pop!(ss::SortedSet, k, default)

Delete the item with key `k` in `ss` and
return the item that compares equal to `k` according to the
sort order (which is not necessarily `k`, since equality in the
sort-order does not necessarily imply hash-equality). If `k` is not found,
return `default`, or throw a `KeyError` if `default` is not specified.
Time: O(*c* log *n*)
"""
@inline function Base.pop!(m::SortedSet, k_)
    k = convert(keytype(m),k_)
    i, exactfound = findkey(m.bt, k)
    !exactfound && throw(KeyError(k_))
    k2 = m.bt.data[i].k
    delete!(m.bt, i)
    return k2
end

@inline function Base.pop!(m::SortedSet, k_, default)
    k = convert(keytype(m),k_)
    i, exactfound = findkey(m.bt, k)
    !exactfound && return default
    delete!(m.bt, i)
    return k
end

"""
    Base.popfirst!(ss::SortedSet)

Delete the item with first key in SortedSet `ss` and returns the
key.  This function was named `pop!` in a previous version of the package.
 A `BoundsError` results if `ss` is empty. Time: O(log *n*)
"""
@inline function Base.popfirst!(m::SortedSet)
    i = beginloc(m.bt)
    i == 2 && throw(BoundsError())
    k = m.bt.data[i].k
    delete!(m.bt, i)
    return k
end

Base.pop!(m::SortedSet) = error("pop!(::SortedSet) is disabled in this version; refer to popfirst! and `poplast! in the docs")



"""
    poplast!(ss::SortedSet)

Delete the item with last key in SortedSet `ss` and returns the
key. A `BoundsError` results if `ss` is empty.   This function will
be renamed `Base.pop!` in a future version of the package.
Time: O(log *n*)
"""
@inline function poplast!(m::SortedSet)
    i = endloc(m.bt)
    i == 2 && throw(BoundsError())
    k = m.bt.data[i].k
    delete!(m.bt, i)
    return k
end



## Check if two SortedSets are equal in the sense of containing
## the same K entries.  This sense of equality does not mean
## that semitokens valid for one are also valid for the other.
"""
    Base.isequal(ss1::SortedSet{K,Ord}, ss2::SortedSet{K,Ord}) where {K,Ord <: Ordering}
    Base.issetequal(ss1::SortedSet{K,Ord}, ss2::SortedSet{K,Ord}) where {K,Ord <: Ordering}

Check if two sorted sets are equal in the sense that they contain
the same items.
Note that `isequal` in this sense does not imply correspondence
between semitokens for items in `sc1` with those for `sc2`.  Time:
O(*cn*) where n is the size of the smaller container. 
If the two sorted sets have `K`, different `Ord`, or 
different order objects, then a
fallback routine `isequal(::AbstractSet, ::AbstractSet)` is invoked.
"""
function Base.isequal(m1::SortedSet{K, Ord}, m2::SortedSet{K, Ord}) where {K, Ord <: Ordering}
    ord = orderobject(m1)
    if ord != orderobject(m2)
        return invoke(issetequal, Tuple{AbstractSet, AbstractSet}, m1, m2)
    end
    p1 = firstindex(m1)
    p2 = firstindex(m2)
    while true
        p1 == pastendsemitoken(m1) && return p2 == pastendsemitoken(m2)
        p2 == pastendsemitoken(m2) && return false
        @inbounds k1 = deref((m1,p1))
        @inbounds k2 = deref((m2,p2))
        !eq(ord,k1,k2) && return false
        @inbounds p1 = advance((m1,p1))
        @inbounds p2 = advance((m2,p2))
    end
end


Base.issetequal(m1::SortedSet, m2::SortedSet) = isequal(m1, m2)


"""
    Base.union!(ss::SortedSet, iterable...)

Insert each item among the second and following
arguments  (which must be
iterable) into the SortedSet `ss`. The items must be convertible to
the key-type of `ss`. Time: O(*cN* log *N*) where *N* is the total number
of items in the iterable arguments.  
"""
function Base.union!(m1::SortedSet, iterable...)
    for iter in iterable
        for k in iter
            push!(m1,convert(eltype(m1),k))
        end
    end
    return m1
end

struct UnionManySortedSets{K, Ord <: Ordering}
    vec::Vector{SortedSet{K, Ord}}
end

function Base.iterate(ss::UnionManySortedSets{K, Ord},
                      state = [firstindex(ss.vec[k]) for k=1:length(ss.vec)]) where
{K, Ord <: Ordering}
    ord = orderobject(ss.vec[1])
    N = length(ss.vec)
    firsti = 0
    for i = 1 : N
        if state[i] != pastendsemitoken(ss.vec[i])
            firsti = i
            break
        end
    end
    firsti == 0 && return nothing
    foundi = firsti
    @inbounds firstk = deref((ss.vec[firsti], state[firsti]))
    for i = firsti + 1 : N
        if state[i] != pastendsemitoken(ss.vec[i])
            @inbounds k2 = deref((ss.vec[i], state[i]))
            if !lt(ord, firstk, k2)
                foundi = i
                firstk = k2
            end
        end
    end
    for i = firsti : N
        if state[i] != pastendsemitoken(ss.vec[i]) &&
            @inbounds eq(ord, deref((ss.vec[i], state[i])), firstk)
            @inbounds state[i] = advance((ss.vec[i], state[i]))
        end
    end
    (firstk, state)
end



"""
    Base.union(ss::SortedSet, iterable...)

Compute and return
the union of a sorted set and one or more iterables.  They must have the same
keytype.  If they are all sorted sets with the same order object, then the
required time is O(*cn*), where *n* is the total size.  If not,
then the fallback routine requires time O(*cn* log *n*).

"""
function Base.union(m1::SortedSet, others...)
    mr = packcopy(m1)
    for m2 in others
        union!(mr, m2)
    end
    return mr
end

function Base.union(s1::SortedSet{K,Ord}, others::SortedSet{K,Ord}...) where
{K, Ord <: Ordering}
    ss = UnionManySortedSets{K, Ord}(SortedSet{K,Ord}[s1])
    for s in others
        if orderobject(s) != orderobject(s1)
            return invoke(union,
                          Tuple{SortedSet, Vararg{Any}},
                          s1, others...)
        end
        push!(ss.vec, s)
    end
    SortedSet{K}(Val(true), ss, orderobject(s1))
end





struct IntersectTwoSortedSets{K, Ord <: Ordering}
    m1::SortedSet{K,Ord}
    m2::SortedSet{K,Ord}
end

struct TwoSortedSets_State
    p1::IntSemiToken
    p2::IntSemiToken
end

function Base.iterate(twoss::IntersectTwoSortedSets,
                      state = TwoSortedSets_State(firstindex(twoss.m1),
                                                  firstindex(twoss.m2)))
    m1 = twoss.m1
    m2 = twoss.m2
    ord = orderobject(m1)
    p1 = state.p1
    p2 = state.p2
    while p1 != pastendsemitoken(m1) && p2 != pastendsemitoken(m2)
        @inbounds k1 = deref((m1, p1))
        @inbounds k2 = deref((m2, p2))
        if lt(ord, k1, k2)
            @inbounds p1 = advance((m1, p1))
            continue
        end
        if lt(ord, k2, k1)
            @inbounds p2 = advance((m2, p2))
            continue
        end
        @inbounds return (k1, TwoSortedSets_State(advance((m1, p1)),
                                                  advance((m2, p2))))
    end
    return nothing
end


function intersect2(m1::SortedSet{K, Ord}, m2::SortedSet{K, Ord}) where {K, Ord <: Ordering}
    if orderobject(m1) != orderobject(m2)
        return invoke(intersect2, Tuple{SortedSet{K, Ord}, Any}, m1, m2)
    end
    SortedSet{K}(Val(true),
                 IntersectTwoSortedSets(m1, m2),
                 orderobject(m1))
end


function intersect2(m1::SortedSet{K,Ord}, iterable) where {K, Ord <: Ordering}
    mi = SortedSet{K, Ord}(orderobject(m1))
    for k_ in iterable
        k = convert(K,k_)
        k in m1 && push!(mi, k)
    end
    mi
end
        



"""
    Base.intersect(ss::SortedSet, others...)

Intersect SortedSets with other SortedSets or other iterables and return
the intersection as a new SortedSet.
Time: O(*cn*), where *n* is the
total number of items in all the arguments if all the arguments are
SortedSets of the same type and same order object.  Otherwise, the
time is O(*cn* log *n*)

"""
function Base.intersect(m1::SortedSet{K,Ord}, others...) where {K, Ord <: Ordering}
    if length(others) == 0
        return packcopy(m1)
    end
    mi = intersect2(m1, others[1])
    for s2 = others[2:end]
        mi = intersect2(mi, s2)
    end
    mi
end


struct SymdiffTwoSortedSets{K,Ord <: Ordering}
    m1::SortedSet{K,Ord}
    m2::SortedSet{K,Ord}
end

function Base.iterate(twoss::SymdiffTwoSortedSets,
                      state = TwoSortedSets_State(firstindex(twoss.m1),
                                                  firstindex(twoss.m2)))
    m1 = twoss.m1
    m2 = twoss.m2
    ord = orderobject(m1)
    p1 = state.p1
    p2 = state.p2
    while true
        m1end = p1 == pastendsemitoken(m1)
        m2end = p2 == pastendsemitoken(m2)
        if m1end && m2end
            return nothing
        end
        if m1end
            @inbounds return (deref((m2, p2)),
                              TwoSortedSets_State(p1, advance((m2,p2))))
        end
        if m2end
            @inbounds return (deref((m1, p1)),
                              TwoSortedSets_State(advance((m1,p1)), p2))
        end
        @inbounds k1 = deref((m1, p1))
        @inbounds k2 = deref((m2, p2))
        if lt(ord, k1, k2)
            @inbounds return (k1, TwoSortedSets_State(advance((m1,p1)), p2))
        end
        if lt(ord, k2, k1)
            @inbounds return (k2, TwoSortedSets_State(p1, advance((m2,p2))))
        end
        @inbounds p1 = advance((m1,p1))
        @inbounds p2 = advance((m2,p2))
    end
end

"""
    Base.symdiff(ss1::SortedSet, iterable)

Compute and
return the symmetric difference of `ss1` and `iterable`, i.e., a sorted set
containing entries that are in one of `ss1` or `iterable` but not both.
Time: O(*cn*), where *n* is the total size of the two
containers if both are sorted sets with the same key and order objects.
Otherwise, the time is O(*cn* log *n*)
"""
function Base.symdiff(m1::SortedSet{K,Ord}, iterable) where {K, Ord <: Ordering}
    ms = SortedSet{K,Ord}(orderobject(m1))
    m1seen = SortedSet{K,Ord}(orderobject(m1))
    for k_ in iterable
        k = convert(K,k_)
        if k in m1
            push!(m1seen, k)
        else
            push!(ms, k)
        end
    end
    for k in m1
        if !(k in m1seen)
            push!(ms, k)
        end
    end
    ms
end

function Base.symdiff(m1::SortedSet{K,Ord}, m2::SortedSet{K,Ord}) where {K, Ord <: Ordering}
    ord = orderobject(m1)
    if ord != orderobject(m2)
        return invoke(symdiff, Tuple{SortedSet{K,Ord}, Any}, m1, m2)
    end
    SortedSet{K}(Val(true), SymdiffTwoSortedSets(m1, m2), ord)
end


struct SetdiffTwoSortedSets{K, Ord <: Ordering}
    m1::SortedSet{K,Ord}
    m2::SortedSet{K,Ord}
end

function Base.iterate(twoss::SetdiffTwoSortedSets,
                      state = TwoSortedSets_State(firstindex(twoss.m1),
                                                  firstindex(twoss.m2)))
    m1 = twoss.m1
    m2 = twoss.m2
    ord = orderobject(m1)
    p1 = state.p1
    p2 = state.p2
    while true
        m1end = p1 == pastendsemitoken(m1)
        m2end = p2 == pastendsemitoken(m2)
        if m1end
            return nothing
        end
        if m2end
            @inbounds return (deref((m1, p1)), TwoSortedSets_State(advance((m1,p1)), p2))
        end
        @inbounds k1 = deref((m1, p1))
        @inbounds k2 = deref((m2, p2))
        if lt(ord, k1, k2)
            @inbounds return (k1, TwoSortedSets_State(advance((m1,p1)), p2))
        end
        if !lt(ord, k2, k1)
            @inbounds p1 = advance((m1,p1))
        end
        @inbounds p2 = advance((m2, p2))
    end
end

        
"""
    Base.setdiff(ss1::SortedSet{K,Ord}, ss2::SortedSet{K,Ord}) where {K, Ord<:Ordering}
    Base.setdiff(ss1::SortedSet, others...)

Return the set difference, i.e., a sorted set containing entries in `ss1` but not
in `ss2` or successive arguments.   Time for the first form: O(*cn*)
where *n* is the total size of both sets provided that they are both
sorted sets of the same type and order object.  
The second form computes the set difference
between `ss1` and all the others, which are all iterables.  The second
form requires O(*cn* log *n*) time.
"""
function Base.setdiff(m1::SortedSet{K,Ord}, m2::SortedSet{K,Ord}) where {K, Ord <: Ordering}
    ord = orderobject(m1)
    if ord != orderobject(m2)
        return invoke(setdiff, Tuple{SortedSet{K,Ord}, Vararg{Any}}, m1, m2)
    end
    SortedSet{K}(Val(true), SetdiffTwoSortedSets(m1,m2), ord)
end


function Base.setdiff(m1::SortedSet{K,Ord}, others...) where {K, Ord <: Ordering}
    ms = packcopy(m1)
    setdiff!(ms, others...)
    ms
end


"""
    Base.setdiff!(ss::SortedSet, iterable..)

Delete items in `ss` that appear in any of the
iterables. The arguments after the first  must be iterables each
of whose entries must  convertible to the key type of m1. 
Time: O(*cm* log *n*), where *n* is the size of `ss` and *m* is the 
total number of items in iterable.
"""
function Base.setdiff!(m1::SortedSet, others...)
    for iterable in others
        for p in iterable
            i = findkey(m1, convert(eltype(m1), p))
            i != pastendsemitoken(m1) &&  delete!((m1,i))
        end
    end
end


# TODO: implement a jump-forward method so that issubset runs in time
# O(*m* log (*n*/*m*)) when both sets are sorted sets.

"""
    Base.issubset(iterable, ss::SortedSet)

Check whether each item of the first argument is an
element of  `ss`. The entries must be convertible to
the key-type of `ss`. Time: O(*cm* log *n*), where *n* is the size
of `ss` and *m* is the number of items in `iterable`.  If both are
sorted sets of the same keytype and order object and if *m* > *n* / log *n*,
then an algorithm whose running time is O(*c*(*m*+*n*)) is used.
"""
function Base.issubset(iterable, m2::SortedSet)
    for k in iterable
        if !(k in m2)
            return false
        end
    end
    return true
end

function Base.issubset(m1::SortedSet{K,Ord}, m2::SortedSet{K,Ord}) where {K, Ord <: Ordering}
    ord = orderobject(m1)
    if ord != orderobject(m2) ||
        length(m1) < length(m2) / log2(length(m2) + 2)
        return invoke(issubset, Tuple{Any, SortedSet}, m1, m2)
    end
    p1 = firstindex(m1)
    p2 = firstindex(m2)
    while p1 != pastendsemitoken(m1)
        p2 == pastendsemitoken(m2) && return false
        @inbounds k1 = deref((m1, p1))
        @inbounds k2 = deref((m2, p2))
        if eq(ord, k1, k2)
            @inbounds p1 = advance((m1,p1))
            @inbounds p2 = advance((m2,p2))
        elseif lt(ord, k1,k2)
            return false
        else
            @inbounds p2 = advance((m2,p2))
        end
    end
    return true
end
            
# Standard copy functions use packcopy - that is, they retain elements but not
# the identical structure.
Base.copymutable(m::SortedSet) = packcopy(m)
Base.copy(m::SortedSet) = packcopy(m)

"""
    copy(sc::SortedSet)
    copy(sc::SortedDict)
    copy(sc::SortedMultiDict)
    packcopy(sc::SortedSet)
    packcopy(sc::SortedDict)
    packcopy(sc::SortedMultiDict)

Return a copy of `sc`, where `sc` is a sorted
container, in which the data is packed. When
deletions take place, the previously allocated memory is not
returned. This function can be used to reclaim memory after many
deletions. Time: O(*cn*)

Note that the semitokens valid for the original container are no
longer valid for the copy because the indexing structure is rebuilt
by these copies.  If an exact copy is needed in which semitokens
remain valid, use `Base.deepcopy`.
"""
function packcopy(m::SortedSet{K,Ord}) where {K,Ord <: Ordering}
    SortedSet{K}(Val(true), m, orderobject(m))
end


"""
    packdeepcopy(sc::SortedSet)
    packdeepcopy(sc::SortedDict)
    packdeepcopy(sc::SorteMultiDict)

Return a packed copy of `sc`, where `sc` is a sorted
container in which the keys and values are
deep-copied. This function can be used to reclaim memory after many
deletions. Time: O(*cn*)
"""
packdeepcopy(m::SortedSet{K,Ord}) where {K, Ord <: Ordering} =
    SortedSet{K}(Val(true), deepcopy(m), orderobject(m))


"""
    Base.empty(sc)

Return a new `SortedDict`, `SortedMultiDict`, or `SortedSet` of the same
type and with the same ordering as `sc` but with no entries (i.e.,
empty). Time: O(1)
"""
function Base.empty(m::SortedSet{K,Ord}, ::Type{U}=K) where {K,Ord<:Ordering,U}
    return Base.emptymutable(m, U)
end
function Base.emptymutable(m::SortedSet{K,Ord}, ::Type{U}=K) where {K,Ord<:Ordering,U}
    return SortedSet{U,Ord}(orderobject(m))
end

using Documenter
using DataStructures

DocMeta.setdocmeta!(DataStructures, :DocTestSetup, :(using DataStructures); recursive=true)

makedocs(
    sitename = "DataStructures.jl",
    warnonly = true,  # FIXME: address all warnings and resolve them
    doctest = true,
    pages = [
        "index.md",
        "deque.md",
        "circ_buffer.md",
        "circ_deque.md",
        "stack.md",
        "queue.md",
        "priority-queue.md",
        "fenwick.md",
        "accumulators.md",
        "disjoint_sets.md",
        "heaps.md",
        "ordered_containers.md",
        "default_dict.md",
        "robin_dict.md",
        "swiss_dict.md",
        "trie.md",
        "linked_list.md",
        "mutable_linked_list.md",
        "intset.md",
        "sorted_containers.md",
        "dibit_vector.md",
        "red_black_tree.md",
        "avl_tree.md",
        "splay_tree.md",
    ],
    modules = [DataStructures],
    format = Documenter.HTML()
)

deploydocs(
    repo = "github.com/JuliaCollections/DataStructures.jl.git",
)

# Binary heap (non-mutable)

include("arrays_as_heaps.jl")

#################################################
#
#   heap type and constructors
#
#################################################

"""
    FasterForward()

FasterForward enables 2x faster float comparison versus Base.ForwardOrdering,
but ordering is undefined if the data contains NaN values.
Enable this higher-performance option by calling the BinaryHeap
constructor instead of the BinaryMinHeap helper constructor.
"""
struct FasterForward <: Base.Ordering end
Base.lt(o::FasterForward, a, b) = a < b

"""
    FasterReverse()

FasterReverse enables 2x faster float comparison versus Base.ReverseOrdering,
but ordering is undefined if the data contains NaN values.
Enable this higher-performance option by calling the BinaryHeap
constructor instead of the BinaryMaxHeap helper constructor.
"""
struct FasterReverse <: Base.Ordering end
Base.lt(o::FasterReverse, a, b) = a > b

mutable struct BinaryHeap{T, O <: Base.Ordering} <: AbstractHeap{T}
    ordering::O
    valtree::Vector{T}

    function BinaryHeap{T}(ordering::Base.Ordering) where T
        new{T, typeof(ordering)}(ordering, Vector{T}())
    end

    function BinaryHeap{T}(ordering::Base.Ordering, xs::AbstractVector) where T
        valtree = heapify(xs, ordering)
        new{T, typeof(ordering)}(ordering, valtree)
    end
end

BinaryHeap(ordering::Base.Ordering, xs::AbstractVector{T}) where T = BinaryHeap{T}(ordering, xs)

# Constructors using singleton order types as type parameters rather than arguments
BinaryHeap{T, O}() where {T, O<:Base.Ordering} = BinaryHeap{T}(O())
BinaryHeap{T, O}(xs::AbstractVector) where {T, O<:Base.Ordering} = BinaryHeap{T}(O(), xs)

# These constructors needed for BinaryMaxHeap, until we have https://github.com/JuliaLang/julia/pull/37822
BinaryHeap{T, DefaultReverseOrdering}() where {T} = BinaryHeap{T}(Base.Reverse)
BinaryHeap{T, DefaultReverseOrdering}(xs::AbstractVector) where {T} = BinaryHeap{T}(Base.Reverse, xs)

# Forward/reverse ordering type aliases
const BinaryMinHeap{T} = BinaryHeap{T, Base.ForwardOrdering}
const BinaryMaxHeap{T} = BinaryHeap{T, DefaultReverseOrdering}

BinaryMinHeap(xs::AbstractVector{T}) where T = BinaryMinHeap{T}(xs)
BinaryMaxHeap(xs::AbstractVector{T}) where T = BinaryMaxHeap{T}(xs)


#################################################
#
#   interfaces
#
#################################################

"""
    length(h::BinaryHeap)

Returns the number of elements in heap `h`.
"""
Base.length(h::BinaryHeap) = length(h.valtree)

"""
    isempty(h::BinaryHeap)

Returns whether the heap `h` is empty.
"""
Base.isempty(h::BinaryHeap) = isempty(h.valtree)

"""
    push!(h::BinaryHeap, value)

Adds the `value` element to the heap `h`.
"""
@inline function Base.push!(h::BinaryHeap, v)
    heappush!(h.valtree, v, h.ordering)
    return h
end

"""
    first(h::BinaryHeap)

Returns the element at the top of the heap `h`.
"""
@inline Base.first(h::BinaryHeap) = h.valtree[1]

"""
    pop!(h::BinaryHeap)

Removes and returns the element at the top of the heap `h`.
"""
Base.pop!(h::BinaryHeap) = heappop!(h.valtree, h.ordering)

function Base.empty!(h::BinaryHeap)
    empty!(h.valtree)
    return h
end

# Suggest that heap `h` reserve capacity for at least `n` elements. This can improve performance.
function Base.sizehint!(h::BinaryHeap, n::Integer)
    sizehint!(h.valtree, n)
    return h
end

# A SortedMultiDict is a wrapper around balancedTree.
## Unlike SortedDict, a key in SortedMultiDict can
## refer to multiple data entries.

mutable struct SortedMultiDict{K, D, Ord <: Ordering}
    bt::BalancedTree23{K,D,Ord}
end

"""
    SortedMultiDict{K,V,Ord}(o::Ord=Forward) where {K, V, Ord <: Ordering}
    SortedMultiDict{K,V,Ord}(o::Ord, iterable) where {K, V, Ord <: Ordering}

Construct a sorted multidict in which type parameters are
explicitly listed; ordering object is explicitly specified. 
Time: O(*cn* log *n*)
"""
SortedMultiDict{K,D,Ord}(o::Ord=Forward) where {K,D,Ord<:Ordering} =
    SortedMultiDict{K,D,Ord}(BalancedTree23{K,D,Ord}(o))

function SortedMultiDict{K,D,Ord}(o::Ord, kv) where {K,D,Ord<:Ordering}
    smd = SortedMultiDict{K,D,Ord}(BalancedTree23{K,D,Ord}(o))
    for (k,v) in kv
        push_return_semitoken!(smd, k=>v)
    end
    return smd
end


"""
    SortedMultiDict(o::Ord=Forward) where {Ord <: Ordering}
    SortedMultiDict{K,V}(o::Ordering=Forward) where {K,V}

Construct an empty `SortedMultiDict` with key type `K` and value type
`V` with `o` ordering (default to `Forward` ordering).  If
`K` and `V` are not specified as in the
first form, then they are assumed to both be `Any`.
Time: O(1).

**Note that a key type of `Any` or any other abstract type will lead
to slow performance, as the values are stored boxed (i.e., as
pointers), and insertion will require a run-time lookup of the
appropriate comparison function. It is recommended to always specify
a concrete key type, or to use one of the constructors in
which the key type is inferred.**
"""
SortedMultiDict(o::Ord=Forward) where {Ord <: Ordering} = 
    SortedMultiDict{Any,Any,typeof(o)}(o)
SortedMultiDict{K,D}(o::Ordering=Forward) where {K, D} =
    SortedMultiDict{K,D,typeof(o)}(o)

# Construction from Pairs
"""
    SortedMultiDict(ps::Pair...)
    SortedMultiDict(o, ps::Pair...)
    SortedMultiDict{K,V}(ps::Pair...)
    SortedMultiDict{K,V}(o, ps::Pair...)

Construct a `SortedMultiDict` from the given key-value pairs. 
The key type and value type are inferred from the
given key-value pairs in the first two form.
The ordering is assumed to be `Forward`
ordering in the first and third forms.  
The first two forms involve copying the data three times to
infer the types and so are less efficient than the third and fourth
form where `{K,V}` are specified explicitly.  Time: O(*cn* log *n*)
"""
SortedMultiDict(ps::Pair...) = SortedMultiDict(Forward, ps)
SortedMultiDict{K,D}(ps::Pair...) where {K,D} = SortedMultiDict{K,D,ForwardOrdering}(Forward, ps)
SortedMultiDict(o::Ordering, ps::Pair...) = SortedMultiDict(o, ps)
SortedMultiDict{K,D}(o::Ord, ps::Pair...) where {K,D,Ord<:Ordering} = SortedMultiDict{K,D,Ord}(o, ps)


"""
    SortedMultiDict(iter, o::Ord=Forward) where {Ord <: Ordering}
    SortedMultiDict(o::Ordering, iter)
    SortedMultiDict{K,V}(iter, o::Ordering=Forward) where {K, V}
    SortedMultiDict{K,V}(o::Ordering, iter) where {K, V}

Construct a `SortedMultiDict` from an arbitrary iterable object of
`key=>value` pairs or (key,value) tuples with order object `o`. The key type
and value type are inferred from the given iterable in the
first two forms.  The first two forms copy the
data three times, so
it is more efficient to explicitly specify `K` and `V` as in the
second two forms.  Time: O(*cn* log *n*)

"""
SortedMultiDict(kv, o::Ord=Forward) where {Ord <: Ordering} =
    SortedMultiDict(o, kv)
SortedMultiDict{K,D}(kv, o::Ordering=Forward) where {K,D} =
    SortedMultiDict{K,D, typeof(o)}(o, kv)
SortedMultiDict{K,D}(o::Ordering, kv) where {K,D} =
    SortedMultiDict{K,D, typeof(o)}(o, kv)

# TODO: figure out how to infer type without three copies
function SortedMultiDict(o::Ordering, kv)
    c = collect(kv)
    if eltype(c) <: Pair
        c2 = collect((t.first, t.second) for t in c)
    elseif eltype(c) <: Tuple
        c2 = collect((t[1], t[2]) for t in c)
    else
        throw(ArgumentError("In SortedMultiDict(o,kv), kv should contain either pairs or 2-tuples"))
    end
    SortedMultiDict{eltype(c2).parameters[1], eltype(c2).parameters[2], typeof(o)}(o, c2)
end


"""
    SortedMultiDict{K,V}(::Val{true}, iterable) where {K,V}
    SortedMultiDict{K,V}(::Val{true}, iterable, ord::Ord) where {K,V,Ord<:Ordering}

Construct a `SortedMultiDict` from an iterable whose eltype is
Tuple{K,V} or Pair{K,V} and that is already in sorted ordered. 
The first form assumes Forward ordering.
Duplicate keys
allowed. Time: O(*cn*).
"""
SortedMultiDict{K,D}(::Val{true},iterable) where {K, D} =
    SortedMultiDict{K,D}(Val(true), iterable, Forward)

function SortedMultiDict{K,D}(::Val{true},
                              iterable,
                              ord::Ord) where {K, D, Ord<:Ordering}
    SortedMultiDict{K, D, Ord}(BalancedTree23{K, D, Ord}(Val(true),
                                                         iterable,
                                                         ord,
                                                         true))
end


## The following is needed to resolve ambiguities

SortedMultiDict(::Ordering, ::Ordering) =
    throw(ArgumentError("Not a valid SortedMultiDict constructor"))
SortedMultiDict{K,D}(::Ordering, ::Ordering) where {K,D} =
    throw(ArgumentError("Not a valid SortedMultiDict constructor"))
SortedMultiDict(::Val{true}, ::Ordering) =
    throw(ArgumentError("Not a valid SortedMultiDict constructor"))
SortedMultiDict{K,D}(::Val{true}, ::Ordering) where {K,D}=
throw(ArgumentError("Not a valid SortedMultiDict constructor"))




const SMDSemiToken = IntSemiToken

const SMDToken = Tuple{SortedMultiDict, IntSemiToken}


"""
    DataStructures.push_return_semitoken!(smd::SortedMultiDict, pr::Pair)

Insert the key-value pair `pr`, i.e., `k=>v`, into `smd`.  
If `k` already appears as a key
in `smd`, then `k=>v` is inserted in the rightmost position after existing
items with key `k`.  Unlike `push!`, 
the
return value is a 2-tuple whose first entry is boolean
always equal to `true` and whose second entry is the semitoken of the new entry.
(The reason for returning a bool whose value is always `true` is for consistency
with `push_return_semitoken!` for SortedDict and SortedSet.)
This function replaces
the deprecated `insert!`.
Time: O(*c* log *n*)
"""
@inline function push_return_semitoken!(m::SortedMultiDict, pr::Pair)
    b, i = insert!(m.bt, convert(keytype(m),pr.first), convert(valtype(m),pr.second), true)
    b, IntSemiToken(i)
end


"""
    Base.push!(smd::SortedMultiDict, p::Pair)

Insert the pair `p`, i.e., a `k=>v` into `smd`.
If `k` already appears as a key
in `smd`, then `k=>v` is inserted in the rightmost position after existing
items with key `k`.  Returns the container.
See also [`push_return_semitoken!(smd::SortedMultiDict, p::Pair)`](@ref).
Time: O(*c* log *n*)
"""
@inline function Base.push!(m::SortedMultiDict{K,D}, pr::Pair) where {K,D}
    insert!(m.bt, convert(K,pr[1]), convert(D,pr[2]), true)
    return m
end


"""
    DataStructures.searchequalrange(smd::SortedMultiDict, k)

Return two semitokens that correspond to the first and last
items in the SortedMultiDict that have key exactly equal
to `k`.  If `k` is not found, then it returns 
(pastendsemitoken(smd), beforestartsemitoken(smd)).
Time: O(*c* log *n*)
"""
function searchequalrange(m::SortedMultiDict, k_)
    k = convert(keytype(m),k_)
    i1 = findkeyless(m.bt, k)
    i2, exactfound = findkey(m.bt, k)
    if exactfound
        i1a = nextloc0(m.bt, i1)
        return IntSemiToken(i1a), IntSemiToken(i2)
    else
        return IntSemiToken(2), IntSemiToken(1)
    end
end


"""
    Base.eltype(sc)

Returns the (key,value) type (a 2-entry pair, i.e., `Pair{K,V}`) for
SortedDict and SortedMultiDict. Returns the key type for SortedSet.
This function may also be applied to the type itself. Time: O(1)
"""
@inline Base.eltype(m::SortedMultiDict{K,D,Ord}) where {K,D,Ord <: Ordering} =  Pair{K,D}
@inline Base.eltype(::Type{SortedMultiDict{K,D,Ord}}) where {K,D,Ord <: Ordering} =  Pair{K,D}


function in_(k_, d_, m::SortedMultiDict)
    k = convert(keytype(m), k_)
    d = convert(valtype(m), d_)
    i1 = findkeyless(m.bt, k)
    i2,exactfound = findkey(m.bt,k)
    !exactfound && return false
    ord = m.bt.ord
    while true
        i1 = nextloc0(m.bt, i1)
        @invariant eq(ord, m.bt.data[i1].k, k)
        m.bt.data[i1].d == d && return true
        i1 == i2 && return false
    end
end


"""
    Base.in(p::Pair, smd::SortedMultiDict)

Return true if `p` is in `smd`. Here, `p` is a key=>value pair. In the
The time is
is O(*c* log *n* + *dl*) where *d* is the time
to compare two values and  *l* stands for the number of entries
that have the key of the given pair. (So therefore this call is
inefficient if the same key addresses a large number of values, and
an alternative should be considered.)
"""
@inline Base.in(pr::Pair, m::SortedMultiDict) =
    in_(pr[1], pr[2], m)

@inline Base.keytype(m::SortedMultiDict{K,D,Ord}) where {K,D,Ord <: Ordering} = K
@inline Base.keytype(::Type{SortedMultiDict{K,D,Ord}}) where {K,D,Ord <: Ordering} = K
@inline Base.valtype(m::SortedMultiDict{K,D,Ord}) where {K,D,Ord <: Ordering} = D
@inline Base.valtype(::Type{SortedMultiDict{K,D,Ord}}) where {K,D,Ord <: Ordering} = D


"""
    Base.isequal(smd1::SortedMultiDict{K,V,Ord}, smd2::SortedMultiDict{K,V,Ord}) where {K, V, Ord <: Ordering}
           

Check if two SortedMultiDicts are equal in the sense that they contain
the same items in the same order (that is, the same insertion order).
They must have the same order object, else they compare unequal.
The keys are compared using the `eq` method, while
the values are compared with the `isequal` function.
Note that `isequal` in this sense does not imply any correspondence
between semitokens for items in `smd1` with those for `smd2`. 
Time: O(*cn*)
"""
function Base.isequal(m1::SortedMultiDict{K, D, Ord},
                      m2::SortedMultiDict{K, D, Ord}) where {K, D, Ord <: Ordering}
    ord = orderobject(m1)
    if ord != orderobject(m2)
        return false
    end
    p1 = firstindex(m1)
    p2 = firstindex(m2)
    while true
        if p1 == pastendsemitoken(m1)
            return p2 == pastendsemitoken(m2)
        end
        if p2 == pastendsemitoken(m2)
            return false
        end
        @inbounds k1,d1 = deref((m1,p1))
        @inbounds k2,d2 = deref((m2,p2))
        (!eq(ord,k1,k2) || !isequal(d1,d2)) && return false
        @inbounds p1 = advance((m1,p1))
        @inbounds p2 = advance((m2,p2))
    end
end


function mergetwo!(m::SortedMultiDict{K,D,Ord}, iterable) where {K,D,Ord <: Ordering}
    for (k,v) in iterable
        insert!(m.bt, convert(K,k), convert(D,v), true)
    end
end

Base.copymutable(m::SortedMultiDict) = packcopy(m)
Base.copy(m::SortedMultiDict) = packcopy(m)


# See sorted_set.jl for the docstrings on packcopy and packdeepcopy
function packcopy(m::SortedMultiDict{K,D,Ord}) where {K,D,Ord <: Ordering}
    SortedMultiDict{K, D}(Val(true), m, orderobject(m))
end

function packdeepcopy(m::SortedMultiDict{K,D,Ord}) where {K,D,Ord <: Ordering}
    SortedMultiDict{K, D}(Val(true), deepcopy(m), orderobject(m))
end


struct MergeManySortedMultiDicts{K, D, Ord <: Ordering}
    vec::Vector{SortedMultiDict{K,D,Ord}}
end

function Base.iterate(sds::MergeManySortedMultiDicts{K, D, Ord},
                      state = [firstindex(sds.vec[k]) for k=1:length(sds.vec)]) where
{K, D, Ord <: Ordering}
    ord = orderobject(sds.vec[1])
    firsti = 0
    N = length(sds.vec)
    for i = 1 : N
        if state[i] != pastendsemitoken(sds.vec[i])
            firsti = i
            break
        end
    end
    firsti == 0 && return nothing
    foundi = firsti
    @inbounds firstk = deref_key((sds.vec[firsti], state[firsti]))
    for i = firsti + 1 : N
        if state[i] != pastendsemitoken(sds.vec[i])
            @inbounds k2 = deref_key((sds.vec[i], state[i]))
            if lt(ord, k2, firstk)
                foundi = i
                firstk = k2
            end
        end
    end
    foundsemitoken = state[foundi]
    @inbounds state[foundi] = advance((sds.vec[foundi], foundsemitoken))
    @inbounds return (deref((sds.vec[foundi], foundsemitoken)), state)
end

"""
    Base.merge!(smd::SortedMultiDict, iter...)

Merge one or more iterables `iter`, etc. into `smd`.
These must all must have the same key-value types.
Items with equal keys are stored
with left-to-right ordering.  Time: O(*cN* log *N*), where *N*
is the total size of all the arguments.
"""
function Base.merge!(m::SortedMultiDict{K,D,Ord},
                     others...) where {K,D,Ord <: Ordering}
    for o in others
        mergetwo!(m,o)
    end
end


"""
    Base.merge(smd::SortedMultiDict, iter...)

Merge `smd` and one or more iterables and return
the resulting new SortedMultiDict.
The iterables must have
the same key-value type as `smd`.
Items with equal keys are stored
with left-to-right ordering.  
Time: O(*cN* log
*N*), where *N* is the total size of all the arguments.  If all
the arguments are SortedMultiDicts with the same
key, value, and order object, then the time is O(*cN*).
"""
function Base.merge(m::SortedMultiDict{K,D,Ord},
                    others...) where {K,D,Ord <: Ordering}
    result = packcopy(m)
    merge!(result, others...)
    return result
end

function Base.merge(m::SortedMultiDict{K,D,Ord},
                    others::SortedMultiDict{K,D,Ord}...) where {K, D, Ord <: Ordering}
    sds = MergeManySortedMultiDicts{K, D, Ord}(SortedMultiDict{K,D,Ord}[m])
    for sd in others
        if orderobject(sd) != orderobject(m)
            return invoke(merge, Tuple{SortedMultiDict, Vararg{Any}},
            m, others...)
        end
        push!(sds.vec, sd)
    end
    SortedMultiDict{K, D}(Val(true), sds, orderobject(m))
end

function Base.show(io::IO, m::SortedMultiDict{K,D,Ord}) where {K,D,Ord <: Ordering}
    print(io, "SortedMultiDict{", K,
          ",\n                ", D,
          ",\n                ", Ord, "}(")
    print(io, orderobject(m), ",\n")
    print(io, collect(m))
    print(io, ")")
end

"""
    Base.empty(sc)

Returns a new `SortedDict`, `SortedMultiDict`, or `SortedSet` of the same
type and with the same ordering as `sc` but with no entries (i.e.,
empty). Time: O(1)
"""
Base.empty(m::SortedMultiDict{K,D,Ord}) where {K,D,Ord<:Ordering} =
   SortedMultiDict{K,D}(orderobject(m))

OrderedCollections.isordered(::Type{T}) where {T<:SortedMultiDict} = true

"""
    DiBitVector(n::Integer, v::Integer)

Create a `DiBitVector` with `n` elements preinitialized to a value `v`
from `0` to `3`, inclusive.

A `DiBitVector` is a vector whose elements are two bits wide, allowing
storage of integer values between 0 and 3. This structure is optimized for
performance and memory savings for large numbers of elements.
"""
mutable struct DiBitVector <: AbstractVector{UInt8}
    data::Vector{UInt64}
    len::UInt

    function DiBitVector(n::Integer, v::Integer)
        if Int(n) < 0
            throw(ArgumentError("n ($n) must be greater than or equal to zero"))
        end
        if !(Int(v) in 0:3)
            throw(ArgumentError("v ($v) must be in 0:3"))
        end
        fv = (0x0000000000000000, 0x5555555555555555,
        0xaaaaaaaaaaaaaaaa, 0xffffffffffffffff)[v + 1]
        vec = Vector{UInt64}(undef, cld(n, 32))
        fill!(vec, fv)
        return new(vec, n % UInt64)
    end
end

@inline Base.checkbounds(D::DiBitVector, n::Integer) =  0 < n ≤ length(D.data) << 5 || throw(BoundsError(D, n))

"""
    DiBitVector(n::Integer)

Create a [`DiBitVector`](@ref) with `n` elements set to `0`.
"""
DiBitVector(n::Integer) = DiBitVector(n, 0)
DiBitVector() = DiBitVector(0, 0)

@inline Base.length(x::DiBitVector) = x.len % Int
@inline Base.size(x::DiBitVector) = (length(x),)

@inline index(n::Integer) = ((n-1) >>> 5) + 1
@inline offset(n::Integer) = ((UInt64(n)-1) << 1) & 63

@inline function Base.getindex(x::DiBitVector, i::Int)
    @boundscheck checkbounds(x, i)
    return UInt8((@inbounds x.data[index(i)] >>> offset(i)) & 3)
end

@inline function Base.unsafe_setindex!(x::DiBitVector, v::UInt64, i::Int)
    bits = @inbounds x.data[index(i)]
    bits &= ~(UInt64(3) << offset(i))
    bits |= convert(UInt64, v) << offset(i)
    @inbounds x.data[index(i)] = bits
end

@inline function Base.setindex!(x::DiBitVector, v::Integer, i::Int)
    v & 3 == v || throw(DomainError("Can only contain 0:3 (tried $v)"))
    @boundscheck checkbounds(x, i)
    unsafe_setindex!(x, convert(UInt64, v), i)
end

@inline function Base.push!(x::DiBitVector, v::Integer)
    len = length(x)
    len == UInt64(length(x.data)) << 5 && push!(x.data, zero(UInt64))
    x.len = (len + 1) % UInt64
    x[len+1] = convert(UInt64, v)
    return x
end

@inline function Base.pop!(x::DiBitVector)
    x.len == 0 && throw(ArgumentError("array must be non-empty"))
    v = x[end]
    x.len = (x.len - 1) % UInt64
    x.len == UInt64((length(x.data) -1)) << 5 && pop!(x.data)
    return v
end

@inline Base.zero(x::DiBitVector) = DiBitVector(x.len, 0)

# This contains code that was formerly a part of Julia. License is MIT: http://julialang.org/license

using Base.Order: Forward, Ordering, lt

const DefaultReverseOrdering = Base.ReverseOrdering{Base.ForwardOrdering}

# Heap operations on flat arrays
# ------------------------------


# Binary heap indexing
heapleft(i::Integer) = 2i
heapright(i::Integer) = 2i + 1
heapparent(i::Integer) = div(i, 2)


# Binary min-heap percolate down.
function percolate_down!(xs::AbstractArray, i::Integer, x=xs[i], o::Ordering=Forward, len::Integer=length(xs))
    @inbounds while (l = heapleft(i)) <= len
        r = heapright(i)
        j = r > len || lt(o, xs[l], xs[r]) ? l : r
        if lt(o, xs[j], x)
            xs[i] = xs[j]
            i = j
        else
            break
        end
    end
    xs[i] = x
end

percolate_down!(xs::AbstractArray, i::Integer, o::Ordering, len::Integer=length(xs)) = percolate_down!(xs, i, xs[i], o, len)


# Binary min-heap percolate up.
function percolate_up!(xs::AbstractArray, i::Integer, x=xs[i], o::Ordering=Forward)
    @inbounds while (j = heapparent(i)) >= 1
        if lt(o, x, xs[j])
            xs[i] = xs[j]
            i = j
        else
            break
        end
    end
    xs[i] = x
end

@inline percolate_up!(xs::AbstractArray, i::Integer, o::Ordering) = percolate_up!(xs, i, xs[i], o)

"""
    heappop!(v, [ord])

Given a binary heap-ordered array, remove and return the lowest ordered element.
For efficiency, this function does not check that the array is indeed heap-ordered.
"""
function heappop!(xs::AbstractArray, o::Ordering=Forward)
    x = xs[1]
    y = pop!(xs)
    if !isempty(xs)
        percolate_down!(xs, 1, y, o)
    end
    return x
end

"""
    heappush!(v, x, [ord])

Given a binary heap-ordered array, push a new element `x`, preserving the heap property.
For efficiency, this function does not check that the array is indeed heap-ordered.
"""
@inline function heappush!(xs::AbstractArray, x, o::Ordering=Forward)
    push!(xs, x)
    percolate_up!(xs, length(xs), o)
    return xs
end


# Turn an arbitrary array into a binary min-heap (by default) in linear time.
"""
    heapify!(v, ord::Ordering=Forward)

In-place [`heapify`](@ref).
"""
@inline function heapify!(xs::AbstractArray, o::Ordering=Forward)
    for i in heapparent(length(xs)):-1:1
        percolate_down!(xs, i, o)
    end
    return xs
end

"""
    heapify(v, ord::Ordering=Forward)

Returns a new vector in binary heap order, optionally using the given ordering.
```jldoctest
julia> a = [1,3,4,5,2];

julia> heapify(a)
5-element Array{Int64,1}:
 1
 2
 4
 5
 3

julia> heapify(a, Base.Order.Reverse)
5-element Array{Int64,1}:
 5
 3
 4
 1
 2
```
"""
# Todo, benchmarking shows copy(xs) outperforms copyto!(similar(xs), xs) for 10^6 Float64
heapify(xs::AbstractArray, o::Ordering=Forward) = heapify!(copyto!(similar(xs), xs), o)

"""
    isheap(v, ord::Ordering=Forward)

Return `true` if an array is heap-ordered according to the given order.

```jldoctest
julia> a = [1,2,3]
3-element Vector{Int64}:
 1
 2
 3

julia> isheap(a,Base.Order.Forward)
true

julia> isheap(a,Base.Order.Reverse)
false
```
"""
function isheap(xs::AbstractArray, o::Ordering=Forward)
    for i in 1:div(length(xs), 2)
        if lt(o, xs[heapleft(i)], xs[i]) ||
           (heapright(i) <= length(xs) && lt(o, xs[heapright(i)], xs[i]))
            return false
        end
    end
    return true
end

using DataStructures: IntSemiToken

# These are the tests for deprecated features, they should be deleted along with them

@testset "Trie: path iterator" begin
    t = Trie{Char,Int}()
    t["rob"] = 27
    t["roger"] = 52
    t["kevin"] = Int8(11)
    t0 = t
    t1 = t0.children['r']
    t2 = t1.children['o']
    t3 = t2.children['b']
    @test collect(path(t, "b")) == [t0]
    @test collect(path(t, "rob")) == [t0, t1, t2, t3]
    @test collect(path(t, "robb")) == [t0, t1, t2, t3]
    @test collect(path(t, "ro")) == [t0, t1, t2]
    @test collect(path(t, "roa")) == [t0, t1, t2]
end

@testset "top" begin
    hh = BinaryMinHeap{Float64}([1,2,3])
    @test top(hh) == 1
end

function test_reverse_iter(it::T) where T
    arr = [i for i in it]
    index = length(arr)
    for i in reverse_iter(it)
        @test arr[index] == i
        index -= 1
    end

    @test reverse(arr) == [i for i in reverse_iter(it)]
end
@testset "reverse_iter" begin
    @testset "Queue" begin
        q = Queue{Int}(); push!(q, 1); push!(q, 2)
        test_reverse_iter(q)
    end
    @testset "Stack" begin
        s = Stack{Int}(); push!(s, 1); push!(s, 2)
        test_reverse_iter(s)
    end
end

@testset "Queue enqueue! dequeue!" begin
    s = Queue{Int}(5)
    n = 100

    @test length(s) == 0
    @test eltype(s) == Int
    @test eltype(typeof(s)) == Int
    @test isempty(s)
    @test_throws ArgumentError first(s)
    @test_throws ArgumentError last(s)
    @test_throws ArgumentError dequeue!(s)

    for i = 1 : n
        enqueue!(s, i)
        @test first(s) == 1
        @test last(s) == i
        @test !isempty(s)
        @test length(s) == i
    end

    for i = 1 : n
        x = dequeue!(s)
        @test x == i
        if i < n
            @test first(s) == i + 1
            @test last(s) == n
        else
            @test_throws ArgumentError first(s)
            @test_throws ArgumentError last(s)
        end
        @test isempty(s) == (i == n)
        @test length(s) == n - i
    end
end

@testset "PriorityQueue enqueue! dequeue!" begin
    s = PriorityQueue{Int,Int}()
    n = 100

    @test length(s) == 0
    @test isempty(s)
    @test_throws BoundsError first(s)
    @test_throws BoundsError dequeue!(s)

    for i = 1 : n
        enqueue!(s, i=>i)
        @test first(s) == (1=>1)
        @test !isempty(s)
        @test length(s) == i
    end

    for i = 1 : n
        x = dequeue!(s)
        @test x == i
        if i < n
            @test first(s) == (i+1 => i+1)
        else
            @test_throws BoundsError first(s)
        end
        @test isempty(s) == (i == n)
        @test length(s) == n - i
    end
end

@testset "peek" begin
    pq = PriorityQueue{Int,Int}()
    push!(pq, 1 => 1)
    push!(pq, 2 => 2)
    @test peek(pq) == (1=>1)
    pq = PriorityQueue{Int,Int}()
    push!(pq, 2 => 2)
    push!(pq, 1 => 1)
    @test peek(pq) == (1=>1)
end

@testset "insert!" begin
    # issues 479 and 767: deprecate insert! (in favor of push_return_semitoken!)
    # deprecate startof in favor of firstindex
    # deprecate endof in favor of lastindex
    s = SortedDict{Int,String}();
    @test isa(insert!(s, 5, "hello"), Tuple{Bool, IntSemiToken})
    s2 = SortedMultiDict{Int,String}();
    @test isa(insert!(s2, 5, "hello"), IntSemiToken)
    s3 = SortedSet{Int}()
    @test isa(insert!(s3, 5), Tuple{Bool, IntSemiToken})
    s4 = SortedDict{Int,String}(3=>"o", 4=>"p")
    @test deref_key((s4,startof(s4))) == 3
    @test deref_key((s4,endof(s4))) == 4
end

const INT_PER_PAGE = div(ccall(:jl_getpagesize, Clong, ()), sizeof(Int))
# we use this to mark pages not in use, it must never be written to.
const NULL_INT_PAGE = Vector{Int}()

mutable struct SparseIntSet
    packed ::Vector{Int}
    reverse::Vector{Vector{Int}}
    counters::Vector{Int}  # counts the number of real elements in each page of reverse.
end

SparseIntSet() = SparseIntSet(Int[], Vector{Int}[], Int[])

SparseIntSet(indices) = union!(SparseIntSet(), indices)

Base.eltype(::Type{SparseIntSet}) = Int

Base.empty(::SparseIntSet) = SparseIntSet()

function Base.empty!(s::SparseIntSet)
    empty!(s.packed)
    empty!(s.reverse)
    empty!(s.counters)
    return s
end

Base.isempty(s::SparseIntSet) = isempty(s.packed)

Base.copy(s::SparseIntSet) = copy!(SparseIntSet(), s)

function Base.copy!(to::SparseIntSet, from::SparseIntSet)
    to.packed = copy(from.packed)
    #we want to keep the null pages === NULL_INT_PAGE
    resize!(to.reverse, length(from.reverse))
    for i in eachindex(from.reverse)
        page = from.reverse[i]
        if page === NULL_INT_PAGE
            to.reverse[i] = NULL_INT_PAGE
        else
            to.reverse[i] = copy(from.reverse[i])
        end
    end
    to.counters = copy(from.counters)
    return to
end

function pageid_offset(s::SparseIntSet, i)
    pageid = div(i - 1, INT_PER_PAGE) + 1
    return pageid, (i - 1) & (INT_PER_PAGE - 1) + 1
end

function Base.in(i, s::SparseIntSet)
    pageid, offset = pageid_offset(s, i)
    if pageid > length(s.reverse)
        return false
    else
        page = @inbounds s.reverse[pageid]
        return page !== NULL_INT_PAGE &&  @inbounds page[offset] != 0
    end
end

Base.length(s::SparseIntSet) = length(s.packed)

@inline function Base.push!(s::SparseIntSet, i::Integer)
    i <= 0 && throw(DomainError("Only positive Ints allowed."))

    pageid, offset = pageid_offset(s, i)
    pages = s.reverse
    plen = length(pages)

    if pageid > plen
        # Create new null pages up to pageid and fresh (zero-filled) one at pageid
        sizehint!(pages, pageid)
        sizehint!(s.counters, pageid)
        for i in 1:pageid - plen - 1
            push!(pages, NULL_INT_PAGE)
            push!(s.counters, 0)
        end
        push!(pages, zeros(Int, INT_PER_PAGE))
        push!(s.counters, 0)
    elseif pages[pageid] === NULL_INT_PAGE
        #assign a page to previous null page
        pages[pageid] = zeros(Int, INT_PER_PAGE)
    end
    page = pages[pageid]
    if page[offset] == 0
        @inbounds page[offset] = length(s) + 1
        @inbounds s.counters[pageid] += 1
        push!(s.packed, i)
        return s
    end
    return s
end

@inline function Base.push!(s::SparseIntSet, is::Integer...)
    for i in is
        push!(s, i)
    end
    return s
end

@inline Base.@propagate_inbounds function Base.pop!(s::SparseIntSet)
    if isempty(s)
        throw(ArgumentError("Cannot pop an empty set."))
    end
    id = pop!(s.packed)
    pageid, offset = pageid_offset(s, id)
    @inbounds s.reverse[pageid][offset] = 0
    @inbounds s.counters[pageid] -= 1
    cleanup!(s, pageid)
    return id
end

@inline Base.@propagate_inbounds function Base.pop!(s::SparseIntSet, id::Integer)
    id < 0 && throw(ArgumentError("Int to pop needs to be positive."))

    @boundscheck if !in(id, s)
        throw(BoundsError(s, id))
    end
    @inbounds begin
        packed_endid = s.packed[end]
        from_page, from_offset = pageid_offset(s, id)
        to_page, to_offset = pageid_offset(s, packed_endid)

        packed_id = s.reverse[from_page][from_offset]
        s.packed[packed_id] = packed_endid
        s.reverse[to_page][to_offset] = s.reverse[from_page][from_offset]
        s.reverse[from_page][from_offset] = 0
        s.counters[from_page] -= 1
        pop!(s.packed)
    end
    cleanup!(s, from_page)
    return id
end

@inline function cleanup!(s::SparseIntSet, pageid::Int)
    if s.counters[pageid] == 0
        s.reverse[pageid] = NULL_INT_PAGE
    end
end

@inline function Base.pop!(s::SparseIntSet, id::Integer, default)
    id < 0 && throw(ArgumentError("Int to pop needs to be positive."))
    return in(id, s) ? (@inbounds pop!(s, id)) : default
end
Base.popfirst!(s::SparseIntSet) = pop!(s, first(s))

@inline Base.iterate(set::SparseIntSet, args...) = iterate(set.packed, args...)

Base.last(s::SparseIntSet) = isempty(s) ? throw(ArgumentError("Empty set has no last element.")) : last(s.packed)

Base.union(s::SparseIntSet, ns) = union!(copy(s), ns)
function Base.union!(s::SparseIntSet, ns)
    for n in ns
        push!(s, n)
    end
    return s
end

Base.intersect(s1::SparseIntSet) = copy(s1)
Base.intersect(s1::SparseIntSet, ss...) = intersect(s1, intersect(ss...))
function Base.intersect(s1::SparseIntSet, ns)
    s = SparseIntSet()
    for n in ns
        n in s1 && push!(s, n)
    end
    return s
end

Base.intersect!(s1::SparseIntSet, ss...) = intersect!(s1, intersect(ss...))

#Is there a more performant way to do this?
Base.intersect!(s1::SparseIntSet, ns) = copy!(s1, intersect(s1, ns))

Base.setdiff(s::SparseIntSet, ns) = setdiff!(copy(s), ns)
function Base.setdiff!(s::SparseIntSet, ns)
    for n in ns
        pop!(s, n, nothing)
    end
    return s
end

function Base.:(==)(s1::SparseIntSet, s2::SparseIntSet)
    length(s1) != length(s2) && return false
    return all(in(s1), s2)
end

Base.issubset(a::SparseIntSet, b::SparseIntSet) = isequal(a, intersect(a, b))

Base.:(<)(a::SparseIntSet, b::SparseIntSet) = ( a<=b ) && !isequal(a, b)
Base.:(<=)(a::SparseIntSet, b::SparseIntSet) = issubset(a, b)

function findfirst_packed_id(i, s::SparseIntSet)
    pageid, offset = pageid_offset(s, i)
    if pageid > length(s.counters) || s.counters[pageid] == 0
        return 0
    end
    @inbounds id = s.reverse[pageid][offset]
    return id
end

Base.collect(s::SparseIntSet) = copy(s.packed)

struct ZippedSparseIntSetIterator{VT,IT}
    valid_sets::VT
    shortest_set::SparseIntSet
    excluded_sets::IT
    function ZippedSparseIntSetIterator(valid_sets::SparseIntSet...; exclude::NTuple{N, SparseIntSet}=()) where{N}
        shortest = valid_sets[findmin(map(length, valid_sets))[2]]
        new{typeof(valid_sets), NTuple{N, SparseIntSet}}(valid_sets, shortest, exclude)
    end
end

function Base.zip(s0::SparseIntSet, s::SparseIntSet...; kwargs...)
    return ZippedSparseIntSetIterator(s0, s...; kwargs...)
end

Base.length(it::ZippedSparseIntSetIterator) = length(it.shortest_set)

# we know it is not in_excluded, as there are no excluded
@inline in_excluded(id, it::ZippedSparseIntSetIterator{VT,Tuple{}}) where {VT} = false

@inline function in_excluded(id, it)
    for e in it.excluded_sets
        if id in e
            return true
        end
    end
    return false
end

@inline function in_valid(id, it)
    for e in it.valid_sets
        if !in(id, e)
            return false
        end
    end
    return true
end

@inline function Base.iterate(it::ZippedSparseIntSetIterator, state=1)
    iterator_length = length(it)
    if state > iterator_length
        return nothing
    end
    for i in state:iterator_length
        @inbounds id = it.shortest_set.packed[i]
        if in_valid(id, it) && !in_excluded(id, it)
            return map(x->findfirst_packed_id(id, x), it.valid_sets), i + 1
        end
    end
    return nothing
end

using DataStructures
using OrderedCollections
using BenchmarkTools
using Random

suite = BenchmarkGroup()

dicttypes = [Dict, RobinDict, SwissDict]
KVtypes = [Int, Float64]
aexps = [4]
for dt in dicttypes
    for aexp in aexps
        for K in KVtypes
            V = K
            Random.seed!(0)
            sample = rand(K, 10^aexp, 2)
            entries = [sample[i, 1]=>sample[i, 2] for i in 1:size(sample, 1)]
            sample_str = string(" 10^$aexp elem $K")
            
            dict = (dt == Dict) ? string("base-Dict") : string(dt)

            # dict_el_type: {Any, Any}
            suite["make "*dict*"()"*sample_str] = @benchmarkable $(dt)($entries)
            suite["pop! "*dict*"()"*sample_str] = @benchmarkable pop!(h) setup=(h=$(dt)($entries))
            suite["empty! "*dict*"()"*sample_str] = @benchmarkable empty!(h) setup=(h=$(dt)($entries))
            suite["find-success "*dict*"()"*sample_str] = @benchmarkable get(h, e, -1) setup=(h=$(dt)($entries); e=($entries)[1, 1])
            suite["find-failure "*dict*"()"*sample_str] = @benchmarkable get(h, e, -1) setup=(h=$(dt)($entries); e=first(pop!(h)))
            # dict_el_type: {K, V}
            suite["make "*dict*"{$K,$V}()"*sample_str] = @benchmarkable $(dt){$K,$V}($entries)
            suite["pop! "*dict*"{$K,$V}()"*sample_str] = @benchmarkable pop!(h) setup=(h=$(dt){$K,$V}($entries))
            suite["empty! "*dict*"{$K,$V}()"*sample_str] = @benchmarkable empty!(h) setup=(h=$(dt){$K,$V}($entries))
            suite["find-success "*dict*"{$K,$V}()"*sample_str] = @benchmarkable get(h, e, -1) setup=(h=$(dt){$K,$V}($entries); e=($entries)[1, 1])
            suite["find-failure "*dict*"{$K,$V}()"*sample_str] = @benchmarkable get(h, e, -1) setup=(h=$(dt){$K,$V}($entries); e=first(pop!(h)))
        end
    end
end 

results = run(suite, verbose=true);

function filter_result(results, op, dt, apow=4)
    dict = (dt == Dict) ? string("base-Dict") : string(dt)
    for tr in keys(filter(k->(occursin(op, first(k)) && occursin(dict, first(k))
                                 && occursin("10^$apow", first(k))) , results))
           println(tr, " memory ", memory(results[tr])/1024, " kB")
           println(tr, " minimum time ", minimum(results[tr]))
       end
end

# it has unique keys
# leftChild has keys which are less than the node
# rightChild has keys which are greater than the node
# height stores the height of the subtree.
mutable struct AVLTreeNode{K}
    height::Int8
    leftChild::Union{AVLTreeNode{K}, Nothing}
    rightChild::Union{AVLTreeNode{K}, Nothing}
    subsize::Int32
    data::K

    AVLTreeNode{K}(d::K) where K = new{K}(1, nothing, nothing, 1, d)
end

AVLTreeNode(d) = AVLTreeNode{Any}(d)

AVLTreeNode_or_null{T} = Union{AVLTreeNode{T}, Nothing}

mutable struct AVLTree{T}
    root::AVLTreeNode_or_null{T}
    count::Int

    AVLTree{T}() where T = new{T}(nothing, 0)
end

AVLTree() = AVLTree{Any}()

Base.length(tree::AVLTree) = tree.count

get_height(node::Union{AVLTreeNode, Nothing}) = (node == nothing) ? 0 : node.height

# balance is the difference of height between leftChild and rightChild of a node.
function get_balance(node::Union{AVLTreeNode, Nothing})
    if node == nothing
        return 0
    else
        return get_height(node.leftChild) - get_height(node.rightChild)
    end
end

# computes the height of the subtree, which basically is
# one added the maximum of the height of the left subtree and right subtree
compute_height(node::AVLTreeNode) = 1 + max(get_height(node.leftChild), get_height(node.rightChild))

get_subsize(node::AVLTreeNode_or_null) = (node == nothing) ? 0 : node.subsize

# compute the subtree size
function compute_subtree_size(node::AVLTreeNode_or_null)
    if node == nothing
        return 0
    else
        L = get_subsize(node.leftChild)
        R = get_subsize(node.rightChild)
        return (L + R + 1)
    end
end

"""
    left_rotate(node_x::AVLTreeNode)

Performs a left-rotation on `node_x`, updates height of the nodes, and returns the rotated node. 
"""
function left_rotate(z::AVLTreeNode)
    y = z.rightChild
    α = y.leftChild
    y.leftChild = z
    z.rightChild = α
    z.height = compute_height(z)
    y.height = compute_height(y)
    z.subsize = compute_subtree_size(z)
    y.subsize = compute_subtree_size(y)
    return y
end

"""
    right_rotate(node_x::AVLTreeNode)

Performs a right-rotation on `node_x`, updates height of the nodes, and returns the rotated node. 
"""
function right_rotate(z::AVLTreeNode)
    y = z.leftChild
    α = y.rightChild
    y.rightChild = z
    z.leftChild = α
    z.height = compute_height(z)
    y.height = compute_height(y)
    z.subsize = compute_subtree_size(z)
    y.subsize = compute_subtree_size(y)
    return y
end

"""
   minimum_node(tree::AVLTree, node::AVLTreeNode) 

Returns the AVLTreeNode with minimum value in subtree of `node`. 
"""
function minimum_node(node::Union{AVLTreeNode, Nothing})
    while node != nothing && node.leftChild != nothing
        node = node.leftChild
    end
    return node
end

function search_node(tree::AVLTree{K}, d::K) where K
    prev = nothing
    node = tree.root
    while node != nothing && node.data != nothing && node.data != d

        prev = node
        if d < node.data 
            node = node.leftChild
        else
            node = node.rightChild
        end
    end
    
    return (node == nothing) ? prev : node
end

function Base.haskey(tree::AVLTree{K}, d::K) where K 
    (tree.root == nothing) && return false
    node = search_node(tree, d)
    return (node.data == d)
end

Base.in(key, tree::AVLTree) = haskey(tree, key)

function Base.insert!(tree::AVLTree{K}, d::K) where K

    function insert_node(node::Union{AVLTreeNode, Nothing}, key)
        if node == nothing
            return AVLTreeNode{K}(key)
        elseif key < node.data
            node.leftChild = insert_node(node.leftChild, key)
        else
            node.rightChild = insert_node(node.rightChild, key)
        end
        
        node.subsize = compute_subtree_size(node)
        node.height = compute_height(node)
        balance = get_balance(node)
        
        if balance > 1
            if key < node.leftChild.data
                return right_rotate(node)
            else
                node.leftChild = left_rotate(node.leftChild)
                return right_rotate(node)
            end
        end

        if balance < -1
            if key > node.rightChild.data
                return left_rotate(node)
            else
                node.rightChild = right_rotate(node.rightChild)
                return left_rotate(node)
            end
        end

        return node
    end

    haskey(tree, d) && return tree

    tree.root = insert_node(tree.root, d)
    tree.count += 1
    return tree
end

function Base.push!(tree::AVLTree{K}, key0) where K
    key = convert(K, key0)
    insert!(tree, key)
end

function Base.delete!(tree::AVLTree{K}, d::K) where K

    function delete_node!(node::Union{AVLTreeNode, Nothing}, key)
        if key < node.data
            node.leftChild = delete_node!(node.leftChild, key)
        elseif key > node.data
            node.rightChild = delete_node!(node.rightChild, key)
        else
            if node.leftChild == nothing
                result = node.rightChild
                return result
            elseif node.rightChild == nothing
                result = node.leftChild
                return result
            else 
                result = minimum_node(node.rightChild)
                node.data = result.data
                node.rightChild = delete_node!(node.rightChild, result.data)
            end 
        end
        
        node.subsize = compute_subtree_size(node)
        node.height = compute_height(node)
        balance = get_balance(node)

        if balance > 1
            if get_balance(node.leftChild) >= 0
                return right_rotate(node)
            else
                node.leftChild = left_rotate(node.leftChild)
                return right_rotate(node)
            end
        end

        if balance < -1
            if get_balance(node.rightChild) <= 0
                return left_rotate(node)
            else
                node.rightChild = right_rotate(node.rightChild)
                return left_rotate(node)
            end
        end 
        
        return node
    end

    # if the key is not in the tree, do nothing and return the tree
    !haskey(tree, d) && return tree
    
    # if the key is present, delete it from the tree
    tree.root = delete_node!(tree.root, d)
    tree.count -= 1
    return tree
end

"""
    sorted_rank(tree::AVLTree, key)

Returns the rank of `key` present in the `tree`, if it present. A KeyError is thrown if `key` is not present.
"""
function sorted_rank(tree::AVLTree{K}, key::K) where K
    !haskey(tree, key) && throw(KeyError(key))
    node = tree.root
    rank = 0
    while node.data != key
        if (node.data < key)
            rank += (1 + get_subsize(node.leftChild))
            node = node.rightChild
        else
            node = node.leftChild
        end
    end 
    rank += (1 + get_subsize(node.leftChild))
    return rank
end

function Base.getindex(tree::AVLTree{K}, ind::Integer) where K 
    @boundscheck (1 <= ind <= tree.count) || throw(BoundsError("$ind should be in between 1 and $(tree.count)"))
    function traverse_tree(node::AVLTreeNode_or_null, idx)
        if (node != nothing)
            L = get_subsize(node.leftChild)
            if idx <= L
                return traverse_tree(node.leftChild, idx)
            elseif idx == L + 1
                return node.data
            else
                return traverse_tree(node.rightChild, idx - L - 1)
            end
        end
    end
    value = traverse_tree(tree.root, ind) 
    return value
end

mutable struct ListNode{T}
    data::T
    prev::ListNode{T}
    next::ListNode{T}
    function ListNode{T}() where T
        node = new{T}()
        node.next = node
        node.prev = node
        return node
    end
    function ListNode{T}(data) where T
        node = new{T}(data)
        return node
    end
end

mutable struct MutableLinkedList{T}
    len::Int
    node::ListNode{T}
    function MutableLinkedList{T}() where T
        l = new{T}()
        l.len = 0
        l.node = ListNode{T}()
        l.node.next = l.node
        l.node.prev = l.node
        return l
    end
end

MutableLinkedList() = MutableLinkedList{Any}()

function MutableLinkedList{T}(elts...) where T
    l = MutableLinkedList{T}()
    for elt in elts
        push!(l, elt)
    end
    return l
end

Base.iterate(l::MutableLinkedList) = l.len == 0 ? nothing : (l.node.next.data, l.node.next.next)
Base.iterate(l::MutableLinkedList, n::ListNode) = n === l.node ? nothing : (n.data, n.next)

Base.isempty(l::MutableLinkedList) = l.len == 0
Base.length(l::MutableLinkedList) = l.len
Base.collect(l::MutableLinkedList{T}) where T = T[x for x in l]
Base.eltype(::Type{<:MutableLinkedList{T}}) where T = T
Base.lastindex(l::MutableLinkedList) = l.len

function Base.first(l::MutableLinkedList)
    isempty(l) && throw(ArgumentError("List is empty"))
    return l.node.next.data
end

function Base.last(l::MutableLinkedList)
    isempty(l) && throw(ArgumentError("List is empty"))
    return l.node.prev.data
end

Base.:(==)(l1::MutableLinkedList{T}, l2::MutableLinkedList{S}) where {T,S} = false

function Base.:(==)(l1::MutableLinkedList{T}, l2::MutableLinkedList{T}) where T
    length(l1) == length(l2) || return false
    for (i, j) in zip(l1, l2)
        i == j || return false
    end
    return true
end

function Base.map(f::Base.Callable, l::MutableLinkedList{T}) where T
    if isempty(l) && f isa Function
        S = Core.Compiler.return_type(f, Tuple{T})
        return MutableLinkedList{S}()
    elseif isempty(l) && f isa Type
        return MutableLinkedList{f}()
    else
        S = typeof(f(first(l)))
        l2 = MutableLinkedList{S}()
        for h in l
            el = f(h)
            if el isa S
                push!(l2, el)
            else
                R = typejoin(S, typeof(el))
                l2 = MutableLinkedList{R}(collect(l2)...)
                push!(l2, el)
            end
        end
        return l2
    end
end

function Base.filter(f::Function, l::MutableLinkedList{T}) where T
    l2 = MutableLinkedList{T}()
    for h in l
        if f(h)
            push!(l2, h)
        end
    end
    return l2
end

function Base.reverse(l::MutableLinkedList{T}) where T
    l2 = MutableLinkedList{T}()
    for h in l
        pushfirst!(l2, h)
    end
    return l2
end

function Base.copy(l::MutableLinkedList{T}) where T
    l2 = MutableLinkedList{T}()
    for h in l
        push!(l2, h)
    end
    return l2
end

function Base.getindex(l::MutableLinkedList, idx::Int)
    @boundscheck 0 < idx <= l.len || throw(BoundsError(l, idx))
    node = l.node
    for i in 1:idx
        node = node.next
    end
    return node.data
end

function Base.getindex(l::MutableLinkedList{T}, r::UnitRange) where T
    @boundscheck 0 < first(r) < last(r) <= l.len || throw(BoundsError(l, r))
    l2 = MutableLinkedList{T}()
    node = l.node
    for i in 1:first(r)
        node = node.next
    end
    len = length(r)
    for j in 1:len
        push!(l2, node.data)
        node = node.next
    end
    l2.len = len
    return l2
end

function Base.setindex!(l::MutableLinkedList{T}, data, idx::Int) where T
    @boundscheck 0 < idx <= l.len || throw(BoundsError(l, idx))
    node = l.node
    for i in 1:idx
        node = node.next
    end
    node.data = convert(T, data)
    return l
end

function Base.append!(l1::MutableLinkedList{T}, l2::MutableLinkedList{T}) where T
    l1.node.prev.next = l2.node.next
    l2.node.next.prev = l1.node.prev
    l1.len += length(l2)
    return l1
end

function Base.append!(l::MutableLinkedList, elts...)
    for elt in elts
        push!(l, elt)
    end
    return l
end

function Base.delete!(l::MutableLinkedList, idx::Int)
    @boundscheck 0 < idx <= l.len || throw(BoundsError(l, idx))
    node = l.node
    for i = 1:idx
        node = node.next
    end
    prev = node.prev
    next = node.next
    prev.next = next
    next.prev = prev
    l.len -= 1
    return l
end

function Base.delete!(l::MutableLinkedList, r::UnitRange)
    @boundscheck 0 < first(r) < last(r) <= l.len || throw(BoundsError(l, r))
    node = l.node
    for i in 1:first(r)
        node = node.next
    end
    prev = node.prev
    len = length(r)
    for j in 1:len
        node = node.next
    end
    next = node
    prev.next = next
    next.prev = prev
    l.len -= len
    return l
end

function Base.push!(l::MutableLinkedList{T}, data) where T
    oldlast = l.node.prev
    node = ListNode{T}(data)
    node.next = l.node
    node.prev = oldlast
    l.node.prev = node
    oldlast.next = node
    l.len += 1
    return l
end

function Base.pushfirst!(l::MutableLinkedList{T}, data) where T
    oldfirst = l.node.next
    node = ListNode{T}(data)
    node.prev = l.node
    node.next = oldfirst
    l.node.next = node
    oldfirst.prev = node
    l.len += 1
    return l
end

function Base.pop!(l::MutableLinkedList)
    isempty(l) && throw(ArgumentError("List must be non-empty"))
    last = l.node.prev.prev
    data = l.node.prev.data
    last.next = l.node
    l.node.prev = last
    l.len -= 1
    return data
end

function Base.popfirst!(l::MutableLinkedList)
    isempty(l) && throw(ArgumentError("List must be non-empty"))
    first = l.node.next.next
    data = l.node.next.data
    first.prev = l.node
    l.node.next = first
    l.len -= 1
    return data
end

function Base.show(io::IO, node::ListNode)
    x = node.data
    print(io, "$(typeof(node))($x)")
end

function Base.show(io::IO, l::MutableLinkedList)
    print(io, typeof(l), '(')
    join(io, l, ", ")
    print(io, ')')
end

@testset "DictionarySorting" begin
    @testset "Core Functionality" begin
        forward = OrderedDict(zip('a':'z', 26:-1:1))
        rev = OrderedDict(zip(reverse('a':'z'), 1:26))

        @testset "sort" begin
            d = copy(rev)
            @test d == rev
            @test sort(d) == forward
        end

        @testset "sort!" begin
            d = copy(rev)
            sort!(d)
            @test d == forward
            @test sort(d; rev=true) == rev

            sort!(d; rev=true)
            @test d == rev
            @test sort(d; byvalue=true) == rev
            @test sort(d; byvalue=true, rev=true) == forward

            sort!(d; byvalue=true, rev=true)
            @test d == forward
            @test sort(d; byvalue=true) == rev
            @test sort(d; byvalue=true, rev=true) == forward

            sort!(d; byvalue=true)
            @test d == rev
        end

    end

    @testset "Bug DataStructures.jl/#394" begin
        @test sort(OrderedDict(k=>string(k) for k in 1:3))[1] == "1"
    end
end

# This file was copied from Transducers.jl
# which is available under an MIT license (see LICENSE).
using PkgBenchmark

mkconfig(; kwargs...) =
    BenchmarkConfig(
        env = Dict(
            "JULIA_NUM_THREADS" => "1",
        );
        kwargs...
    )

group_target = benchmarkpkg(
    dirname(@__DIR__),
    mkconfig(),
    resultfile = joinpath(@__DIR__, "result-target.json"),
)

group_baseline = benchmarkpkg(
    dirname(@__DIR__),
    mkconfig(id = "baseline"),
    resultfile = joinpath(@__DIR__, "result-baseline.json"),
)

judgement = judge(group_target, group_baseline)

# Various heap implementation

###########################################################
#
#   Heap interface specification
#
#   Each heap is associated with a handle type (H), and
#   a value type v.
#
#   Here, the value type must be comparable, and a handle
#   is an object through which one can refer to a specific
#   node of the heap and thus update its value.
#
#   Each heap type must implement all of the following
#   functions. Here, let h be a heap, i be a handle,
#   v be a value and s be a size.
#
#   - length(h)           returns the number of elements
#
#   - isempty(h)          returns whether the heap is
#                         empty
#
#   - empty!(h)           reset the heap
#
#   - push!(h, v)         add a value to the heap
#
#   - sizehint!(h, s)     set size hint to a heap
#
#   - first(h)            return the first (top) value of a heap
#
#   - pop!(h)             removes the first (top) value, and
#                         returns it
#
#  For mutable heaps, it should also support
#
#   - push!(h, v)         adds a value to the heap and
#                         returns a handle to v
#
#   - update!(h, i, v)    updates the value of an element
#                         (referred to by the handle i)
#
#   - delete!(h, i)       deletes the node with
#                         handle i from the heap
#
#   - top_with_handle(h)  return the top value of a heap
#                         and its handle
#
#
###########################################################

# HT: handle type
# VT: value type

abstract type AbstractHeap{VT} end

abstract type AbstractMutableHeap{VT,HT} <: AbstractHeap{VT} end

abstract type AbstractMinMaxHeap{VT} <: AbstractHeap{VT} end

# heap implementations

include("heaps/binary_heap.jl")
include("heaps/mutable_binary_heap.jl")
include("heaps/minmax_heap.jl")

# generic functions

Base.eltype(::Type{<:AbstractHeap{T}}) where T = T

"""
    extract_all!(h)

Return an array of heap elements in sorted order (heap head at first index).

Note that for simple heaps (not mutable or minmax)
sorting the internal array of elements in-place is faster.
"""
function extract_all!(h::AbstractHeap{VT}) where VT
    n = length(h)
    r = Vector{VT}(undef, n)
    for i in 1 : n
        r[i] = pop!(h)
    end
    return r
end

"""
    extract_all_rev!(h)

Return an array of heap elements in reverse sorted order (heap head at last index).

Note that for simple heaps (not mutable or minmax)
sorting the internal array of elements in-place is faster.
"""
function extract_all_rev!(h::AbstractHeap{VT}) where VT
    n = length(h)
    r = Vector{VT}(undef, n)
    for i in 1 : n
        r[n + 1 - i] = pop!(h)
    end
    return r
end

# Array functions using heaps

"""
    nextreme(ord, n, arr)

return an array of the first `n` values of `arr` sorted by `ord`.
"""
function nextreme(ord::Base.Ordering, n::Int, arr::AbstractVector{T}) where T
    Base.require_one_based_indexing(arr)
    if n <= 0
        return T[] # sort(arr)[1:n] returns [] for n <= 0
    elseif n >= length(arr)
        return sort(arr, order = ord)
    end

    rev = Base.ReverseOrdering(ord)

    buffer = heapify!(arr[1:n], rev)

    @inbounds for i = n + 1 : length(arr)
        xi = arr[i]
        if Base.lt(rev, buffer[1], xi)
            buffer[1] = xi
            percolate_down!(buffer, 1, rev)
        end
    end

    return sort!(buffer, order = ord)
end

"""
    nlargest(n, arr; kw...)

Return the `n` largest elements of the array `arr`.

Equivalent to:
    sort(arr, kw..., rev=true)[1:min(n, end)]

Note that if `arr` contains floats and is free of NaN values,
then the following alternative may be used to achieve 2x performance:

    DataStructures.nextreme(DataStructures.FasterReverse(), n, arr)

This faster version is equivalent to:

    sort(arr, lt = >)[1:min(n, end)]
"""
function nlargest(n::Int, arr::AbstractVector; lt=isless, by=identity)
    order = Base.ReverseOrdering(Base.ord(lt, by, nothing))
    return nextreme(order, n, arr)
end

"""
    nsmallest(n, arr; kw...)

Return the `n` smallest elements of the array `arr`.

Equivalent to:
    sort(arr; kw...)[1:min(n, end)]

Note that if `arr` contains floats and is free of NaN values,
then the following alternative may be used to achieve 2x performance:

    DataStructures.nextreme(DataStructures.FasterForward(), n, arr)

This faster version is equivalent to:

    sort(arr, lt = <)[1:min(n, end)]
"""
function nsmallest(n::Int, arr::AbstractVector; lt=isless, by=identity)
    order = Base.ord(lt, by, nothing)
    return nextreme(order, n, arr)
end

# Test of accumulators

@testset "Accumulators" begin

    ct = counter(String)

    @testset "Core Functionality" begin
        @assert isa(ct, Accumulator{String,Int})

        @test ct["abc"] == 0
        @test !haskey(ct, "abc")
        @test isempty(collect(keys(ct)))
    end

    @testset "Test setindex!" begin
        ct["b"] = 2
        @test ct["b"] == 2
        ct["b"] = 0
        @test ct["b"] == 0
    end

    @testset "Test inc!" begin
        inc!(ct, "a")
        @test haskey(ct, "a")
        @test ct["a"] == 1

        inc!(ct, "b", 2)
        @test haskey(ct, "b")
        @test ct["b"] == 2
    end

    @testset "Test dec!" begin
        dec!(ct, "b")
        @test ct["b"] == 1
        dec!(ct, "b", 16)
        @test ct["b"] == -15
        ct["b"] = 2
    end

    @testset "Test convert" begin
        inc!(ct, "b", 0x3)
        @test ct["b"] == 5

        @test !haskey(ct, "abc")
        @test ct["abc"] == 0

        @test length(ct) == 2
        @test length(collect(ct)) == 2
        @test length(collect(keys(ct))) == 2
        @test length(collect(values(ct))) == 2
        @test sum(ct) == 6
    end

    @testset "From Pairs" begin
        acc = Accumulator("a" => 2, "b" => 3, "c" => 1)
        @test isa(acc,Accumulator{String,Int})
        @test haskey(acc,"a")
        @test haskey(acc,"b")
        @test haskey(acc,"c")
        @test acc["a"] == 2
        @test acc["b"] == 3
        @test acc["c"] == 1
    end

    @testset "From Pairs with repeats" begin
        acc = Accumulator("a" => 2, "b" => 3, "b" => 1)
        @test isa(acc,Accumulator{String,Int})
        @test haskey(acc,"a")
        @test haskey(acc,"b")
        @test acc["a"] == 2
        @test acc["b"] == 4
    end

    @testset "From Vector" begin
        ct2 = counter(["a", "a", "b", "b", "a", "c", "c"])
        @test isa(ct2, Accumulator{String,Int})
        @test haskey(ct2, "a")
        @test haskey(ct2, "b")
        @test haskey(ct2, "c")
        @test ct2["a"] == 3
        @test ct2["b"] == 2
        @test ct2["c"] == 2

        merge!(ct, ct2)
        @test ct["a"] == 4
        @test ct["b"] == 7
        @test ct["c"] == 2
    end

    @testset "From Dict" begin
        ct3 = counter(Dict([("a",10), ("b",20)]))
        @test isa(ct3, Accumulator{String,Int})
        @test haskey(ct3, "a")
        @test haskey(ct3, "b")
        @test ct3["a"] == 10
        @test ct3["b"] == 20

        ct2 = counter(["a", "a", "b", "b", "a", "c", "c"])
        ctm = merge(ct2, ct3)
        @test isa(ctm, Accumulator{String,Int})
        @test haskey(ctm, "a")
        @test haskey(ctm, "b")
        @test haskey(ctm, "c")
        @test ctm["a"] == 13
        @test ctm["b"] == 22
        @test ctm["c"] == 2

        @test reset!(ctm, "b") == 22
        @test !haskey(ctm, "b")
        @test ctm["b"] == 0
    end

    @testset "From AbstractDict" begin
        kv = (:a => 1, :b => 2)
        for f in (Accumulator, counter)
            ct_odict = f(OrderedDict(kv))
            ct_dict = f(Dict(kv))
            @test ct_odict isa Accumulator{Symbol, Int}
            @test ct_odict == ct_dict
        end
    end

    @testset "From Pair" begin
        ct4 = counter(Pair{Int,Int})
        @test isa(ct4, Accumulator{Pair{Int,Int}})
        @test push!(ct4, 1=>2) == 1
        @test push!(ct4, 1=>2) == 2
    end

    @testset "From Dict / merge / merge!" begin
        ct5 = counter(Dict([("a",10), ("b",20)]))
        @test merge(ct5)==ct5
        @test merge!(ct5)===ct5
        @test merge(ct5,ct5,ct5)==counter(Dict([("a",30), ("b",60)]))
    end

    @testset "Counter equality/inequality" begin
        @test counter([2,3,4,4]) == counter([4,2,3,4])
        @test counter([2,3,4,4]) != counter([4,2,3,4,4])
    end

    @testset "Array{SubString{String},1}" begin
        ct5 = counter(split("a b b c c c"))
        @test ct5["a"] == 1
        @test ct5["b"] == 2
        @test ct5["c"] == 3
    end

    @testset "ct6" begin
        ct6 = counter(["a", "b" , "b", "c", "c", "c"])
        for ii in split("a b c")
            inc!(ct6, ii)
        end
        @test ct6["a"] == 2
        @test ct6["b"] == 3
        @test ct6["c"] == 4
        for ii in split("a b")
            reset!(ct6, ii)
        end
        @test ct6["a"] == 0
        @test ct6["b"] == 0
        @test ct6["c"] == 4
    end

    @testset "Generators" begin
        s = ["y", "el", "sol", "se", "fue"]
        @test counter(length(x) for x in s) == counter(map(length, s))
    end

    @testset "non-integer uses" begin
        acc = Accumulator{Symbol, Float16}()
        acc[:a] = 1.5
        @test acc[:a] ≈ 1.5
        push!(acc, :a, 2.5)
        @test acc[:a] ≈ 4.0
        dec!(acc, :a)
        @test acc[:a] ≈ 3.0
    end

    @testset "ambiguity resolution" begin
        ct7 = counter(Int)
        @test_throws MethodError push!(ct7, 1=>2)
    end

    @testset "nlargest" begin
        @test nlargest(counter("abbbcddddda")) == ['d'=>5, 'b'=>3, 'a'=>2, 'c'=>1]
        @test nlargest(counter("abbbccddddda"),2) == ['d'=>5, 'b'=>3]
        @test nlargest(counter("a")) == ['a'=>1]

        @test nlargest(counter("aaabbcc")) ∈ (['a'=>3,'b'=>2, 'c'=>2], ['a'=>3,'c'=>2, 'b'=>2])


        @test_throws BoundsError nlargest(counter("a"),2)
    end

    @testset "nsmallest" begin
        acc = counter("aabbbcccc")
        @test nsmallest(acc) == ['a'=>2, 'b'=>3, 'c'=>4]
        @test nsmallest(acc,2) == ['a'=>2, 'b'=>3]
        acc['d']=0
        @test nsmallest(acc,2) == ['d'=>0, 'a'=>2]

        @test nsmallest(counter("aaabbcc")) ∈ (['b'=>2, 'c'=>2, 'a'=>3], ['c'=>2, 'b'=>2, 'a'=>3])

        @test_throws BoundsError nsmallest(counter("a"),2)
    end

    @testset "reset!" begin
        ct = counter("abbbcddddda") # ['d'=>5, 'b'=>3, 'a'=>2, 'c'=>1]
        @test reset!(ct, 'b') == 3
        @test ct == counter("acddddda")

        @test reset!(ct, 'x') == 0
    end

    @testset "copy" begin
        orig = counter("aabbbcccc")
        dup = copy(orig)
        @test orig == dup

        # Modifying copy should not modify original
        inc!(orig, 'a')
        @test orig != dup
    end

    @testset "Multiset" begin
        @testset "issubset" begin
            @test issubset(counter([1,2,3]), counter([1,2,3]))
            @test !issubset(counter([1,2,3,4]), counter([1,2,3]))
            @test issubset(counter([1,2]), counter([1,2,3]))

            @test issubset(counter([1,2,3]), counter([1,2,3,3]))
            @test !issubset(counter([1,2,3,3]), counter([1,2,3]))
        end

        @testset "setdiff" begin
            @test setdiff(counter([1,2,3]), counter([2, 4])) == counter([3, 1])
            @test setdiff(counter([1,2,3]), counter([2,2,4])) == counter([3, 1])
            @test setdiff(counter([1,2,2,2,3]), counter([2,2,4])) == counter([1,2,3])

            nonmultiset = counter(Dict([('a',-10), ('b',20)]))
            @test_throws DataStructures.MultiplicityException setdiff(counter("aabbcc"), nonmultiset)
        end

        @testset "union" begin
            @test ∪(counter([1,2,3]), counter([1,2,3])) == counter([1,2,3])
            @test ∪(counter([1,2,3]), counter([1,2,2,3])) == counter([1,2,2,3])
            @test ∪(counter([1,3]), counter([2,2])) == counter([1,2,2,3])
            @test ∪(counter([1,2,3]), counter(Int[])) == counter([1,2,3])

            nonmultiset = counter(Dict([('a',-10), ('b',20)]))
            @test_throws DataStructures.MultiplicityException (counter("aabbcc") ∪ nonmultiset)
            @test_throws DataStructures.MultiplicityException (nonmultiset ∪ counter("aabbcc"))
        end

        @testset "intersect" begin
            @test ∩(counter([1,2,3]), counter([1,2,3])) == counter([1,2,3])
            @test ∩(counter([1,2,3]), counter([1,2,2,3])) == counter([1,2,3])
            @test ∩(counter([1,3]), counter([2,2])) == counter(Int[])
            @test ∩(counter([1,2,3]), counter(Int[])) == counter(Int[])


            nonmultiset = counter(Dict([('a',-10), ('b',20)]))
            @test_throws DataStructures.MultiplicityException (counter("aabbcc") ∩ nonmultiset)
            @test_throws DataStructures.MultiplicityException (nonmultiset ∩ counter("aabbcc"))
        end

        @testset "show" begin
            @test sprint(show,Accumulator(1 => 3)) == "Accumulator(1 => 3)"
            @test sprint(show,Accumulator(1 => 3, 3 => 4)) == "Accumulator(3 => 4, 1 => 3)"
        end


    end

end # @testset Accumulators

@testset "Constructors" begin
    h1 = RobinDict()
    @test length(h1) == 0
    @test isempty(h1) == true
    @test h1.idxfloor == 0
    @test length(h1.keys) == 16
    @test length(h1.vals) == 16
    @test length(h1.hashes) == 16
    @test eltype(h1) == Pair{Any, Any}
    @test keytype(h1) == Any
    @test valtype(h1) == Any
end

@testset "RobinDict" begin
    h = RobinDict()
    for i=1:10000
        h[i] = i+1
    end
    for i=1:10000
        @test (h[i] == i+1)
    end
    for i=1:2:10000
        delete!(h, i)
    end
    for i=1:2:10000
        h[i] = i+1
    end
    for i=1:10000
        @test (h[i] == i+1)
    end
    for i=1:10000
        delete!(h, i)
    end
    @test isempty(h)
    h[77] = 100
    @test h[77] == 100
    for i=1:10000
        h[i] = i+1
    end
    for i=1:2:10000
        delete!(h, i)
    end
    for i=10001:20000
        h[i] = i+1
    end
    for i=2:2:10000
        @test h[i] == i+1
    end
    for i=10000:20000
        @test h[i] == i+1
    end
    h = RobinDict{Any,Any}("a" => 3)
    @test h["a"] == 3
    h["a","b"] = 4
    @test h["a","b"] == h[("a","b")] == 4
    h["a","b","c"] = 4
    @test h["a","b","c"] == h[("a","b","c")] == 4

    @testset "eltype, keytype and valtype" begin
        @test eltype(h) == Pair{Any,Any}
        @test keytype(h) == Any
        @test valtype(h) == Any

        td = RobinDict{AbstractString,Float64}()
        @test eltype(td) == Pair{AbstractString,Float64}
        @test keytype(td) == AbstractString
        @test valtype(td) == Float64
        @test keytype(Dict{AbstractString,Float64}) === AbstractString
        @test valtype(Dict{AbstractString,Float64}) === Float64
    end
    # test rethrow of error in ctor
    @test_throws DomainError RobinDict((sqrt(p[1]), sqrt(p[2])) for p in zip(-1:2, -1:2))
end

@testset "RobinDict on pairs" begin
	let x = RobinDict(3=>3, 5=>5, 8=>8, 6=>6)
	    pop!(x, 5)
	    for k in keys(x)
	        RobinDict{Int,Int}(x)
	        @test k in [3, 8, 6]
	    end
	end

    let y = RobinDict{Any, Int}(3=>3, 5=>5, "8"=>8, 6=>6)
        pop!(y, "8")
        for k in keys(y)
            RobinDict{Int,Int}(y)
            @test k in [3, 5, 6]
        end
    end

    d = @inferred RobinDict(Pair(1,1), Pair(2,2), Pair(3,3))
    @test isa(d, RobinDict)
    @test d == RobinDict(1=>1, 2=>2, 3=>3)
    @test eltype(d) == Pair{Int,Int}
end

@testset "KeyError" begin
    let z = RobinDict()
        get_KeyError = false
        try
            z["a"]
        catch _e123_
            get_KeyError = isa(_e123_,KeyError)
        end
        @test get_KeyError
    end

    h = RobinDict{Char, Int}()
    @test_throws KeyError h[0.01] 
end

@testset "Filter function" begin
    _d = RobinDict("a"=>0)
    @test isa([k for k in filter(x->length(x)==1, collect(keys(_d)))], Vector{String})

    h = RobinDict{Int, Int}()
    for i in 1:100
        h[i] = i
    end
    filter!(x->isodd(x.first), h)
    for i in 1:2:100
        @test h[i] == i
    end
end

@testset "typeof" begin
    d = RobinDict(((1, 2), (3, 4)))
    @test d[1] === 2
    @test d[3] === 4
    d2 = RobinDict(1 => 2, 3 => 4)
    d3 = RobinDict((1 => 2, 3 => 4))
    @test d == d2 == d3
    @test typeof(d) == typeof(d2) == typeof(d3) == RobinDict{Int,Int}

    d = RobinDict(((1, 2), (3, "b")))
    @test d[1] === 2
    @test d[3] == "b"
    d2 = RobinDict(1 => 2, 3 => "b")
    d3 = RobinDict((1 => 2, 3 => "b"))
    @test d == d2 == d3
    @test typeof(d) == typeof(d2) == typeof(d3) == RobinDict{Int,Any}

    d = RobinDict(((1, 2), ("a", 4)))
    @test d[1] === 2
    @test d["a"] === 4
    d2 = RobinDict(1 => 2, "a" => 4)
    d3 = RobinDict((1 => 2, "a" => 4))
    @test d == d2 == d3
    @test typeof(d) == typeof(d2) == typeof(d3) == RobinDict{Any,Int}

    d = RobinDict(((1, 2), ("a", "b")))
    @test d[1] === 2
    @test d["a"] == "b"
    d2 = RobinDict(1 => 2, "a" => "b")
    d3 = RobinDict((1 => 2, "a" => "b"))
    @test d == d2 == d3
    @test typeof(d) == typeof(d2) == typeof(d3) == RobinDict{Any,Any}
end

@testset "type of RobinDict constructed from varargs of Pairs" begin
    @test RobinDict(1=>1, 2=>2.0) isa RobinDict{Int,Real}
    @test RobinDict(1=>1, 2.0=>2) isa RobinDict{Real,Int}
    @test RobinDict(1=>1.0, 2.0=>2) isa RobinDict{Real,Real}

    for T in (Nothing, Missing)
        @test RobinDict(1=>1, 2=>T()) isa RobinDict{Int,Union{Int,T}}
        @test RobinDict(1=>T(), 2=>2) isa RobinDict{Int,Union{Int,T}}
        @test RobinDict(1=>1, T()=>2) isa RobinDict{Union{Int,T},Int}
        @test RobinDict(T()=>1, 2=>2) isa RobinDict{Union{Int,T},Int}
    end
end

@testset "equality" for eq in (isequal, ==)
    @test  eq(RobinDict(), RobinDict())
    @test  eq(RobinDict(1 => 1), RobinDict(1 => 1))
    @test !eq(RobinDict(1 => 1), RobinDict())
    @test !eq(RobinDict(1 => 1), RobinDict(1 => 2))
    @test !eq(RobinDict(1 => 1), RobinDict(2 => 1))

    # Generate some data to populate dicts to be compared
    data_in = [ (rand(1:1000), randstring(2)) for _ in 1:1001 ]

    # Populate the first dict
    d1 = RobinDict{Int, AbstractString}()
    for (k, v) in data_in
        d1[k] = v
    end
    data_in = collect(d1)
    # shuffle the data
    for i in 1:length(data_in)
        j = rand(1:length(data_in))
        data_in[i], data_in[j] = data_in[j], data_in[i]
    end
    # Inserting data in different (shuffled) order should result in
    # equivalent dict.
    d2 = RobinDict{Int, AbstractString}()
    for (k, v) in data_in
        d2[k] = v
    end

    @test eq(d1, d2)
    d3 = copy(d2)
    d4 = copy(d2)
    # Removing an item gives different dict
    delete!(d1, data_in[rand(1:length(data_in))][1])
    @test !eq(d1, d2)
    # Changing a value gives different dict
    d3[data_in[rand(1:length(data_in))][1]] = randstring(3)
    !eq(d1, d3)
    # Adding a pair gives different dict
    d4[1001] = randstring(3)
    @test !eq(d1, d4)

    @test eq(RobinDict(), sizehint!(RobinDict(),96))

    # Dictionaries of different types
    @test !eq(RobinDict(1 => 2), RobinDict("dog" => "bone"))
    @test eq(RobinDict{Int,Int}(), RobinDict{AbstractString,AbstractString}())
end

@testset "equality special cases" begin
    @test RobinDict(1=>0.0) == RobinDict(1=>-0.0)
    @test !isequal(RobinDict(1=>0.0), RobinDict(1=>-0.0))

    @test RobinDict(0.0=>1) != RobinDict(-0.0=>1)
    @test !isequal(RobinDict(0.0=>1), RobinDict(-0.0=>1))

    @test RobinDict(1=>NaN) != RobinDict(1=>NaN)
    @test isequal(RobinDict(1=>NaN), RobinDict(1=>NaN))

    @test RobinDict(NaN=>1) == RobinDict(NaN=>1)
    @test isequal(RobinDict(NaN=>1), RobinDict(NaN=>1))

    @test ismissing(RobinDict(1=>missing) == RobinDict(1=>missing))
    @test isequal(RobinDict(1=>missing), RobinDict(1=>missing))

    @test RobinDict(missing=>1) == RobinDict(missing=>1)
    @test isequal(RobinDict(missing=>1), RobinDict(missing=>1))
end

@testset "get!" begin
    f(x) = x^2
    d = RobinDict(8=>19)
    @test get!(d, 8, 5) == 19
    @test get!(d, 19, 2) == 2

    @test get!(d, 42) do  # d is updated with f(2)
        f(2)
    end == 4

    @test get!(d, 42) do  # d is not updated
        f(200)
    end == 4

    @test get(d, 13) do   # d is not updated
        f(4)
    end == 16

    @test d == RobinDict(8=>19, 19=>2, 42=>4)
end

@testset "push!" begin
    d = RobinDict()
    @test push!(d, 'a' => 1) === d
    @test d['a'] == 1
    @test push!(d, 'b' => 2, 'c' => 3) === d
    @test d['b'] == 2
    @test d['c'] == 3
    @test push!(d, 'd' => 4, 'e' => 5, 'f' => 6) === d
    @test d['d'] == 4
    @test d['e'] == 5
    @test d['f'] == 6
    @test length(d) == 6
end

@testset "pop!" begin
    d = RobinDict(1=>2, 3=>4)
    @test pop!(d, 1) == 2
    @test_throws KeyError pop!(d, 1)
    @test pop!(d, 1, 0) == 0
    @test pop!(d) == (3=>4)
    @test_throws ArgumentError pop!(d)
end

@testset "keys as a set" begin
    d = RobinDict(1=>2, 3=>4)
    @test keys(d) isa AbstractSet
    @test empty(keys(d)) isa AbstractSet
    let i = keys(d) ∩ Set([1,2])
        @test i isa AbstractSet
        @test i == Set([1])
    end
    @test Set(string(k) for k in keys(d)) == Set(["1","3"])
end

@testset "find" begin
    @test findall(isequal(1), RobinDict(:a=>1, :b=>2)) == [:a]
    @test sort(findall(isequal(1), RobinDict(:a=>1, :b=>1))) == [:a, :b]
    @test isempty(findall(isequal(1), RobinDict()))
    @test isempty(findall(isequal(1), RobinDict(:a=>2, :b=>3)))

    @test findfirst(isequal(1), RobinDict(:a=>1, :b=>2)) == :a
    @test findfirst(isequal(1), RobinDict(:a=>1, :b=>1, :c=>3)) in (:a, :b)
    @test findfirst(isequal(1), RobinDict()) === nothing
    @test findfirst(isequal(1), RobinDict(:a=>2, :b=>3)) === nothing
end

@testset "haskey" begin
    h = RobinDict(1=>2, 2=>3)
    @test haskey(h, 1) == true
    @test haskey(h, 2) == true
    @test haskey(h, 3) == false
    @test haskey(h, "1") == false
end

@testset "getkey" begin
    h = RobinDict(1=>2, 3 => 6, 5=>10)
    @test getkey(h, 1, 7) == 1
    @test getkey(h, 4, 6) == 6
    @test getkey(h, "1", 8) == 8
end

@testset "empty" begin
    h = RobinDict()
    for i=1:1000
        h[i] = i+1
    end
    length0 = length(h.hashes)
    empty!(h)
    @test h.count == 0
    @test h.idxfloor == 0
    @test length(h.hashes) == length(h.keys) == length(h.vals) == length0
    for i=-1000:1000
      @test !haskey(h, i)
    end
end

@testset "ArgumentError" begin
    @test_throws ArgumentError RobinDict(0)
    @test_throws ArgumentError RobinDict([1])
    @test_throws ArgumentError RobinDict([(1,2),0])
end

@testset "empty tuple" begin
    h = RobinDict(())
    @test length(h) == 0
end

@testset "merge" begin
    h1 = RobinDict("a" => 1, "b" => 2)
    h2 = RobinDict("c" => 3, "d" => 4)
    d = merge(h1, h2)
    @test isa(d, RobinDict{String, Int})
    @test length(d) == 4
    @test d["a"] == 1
    @test d["b"] == 2
    @test d["c"] == 3
    @test d["d"] == 4
end

@testset "merge with combine function" begin
    h1 = RobinDict("a" => 1, "b" => 2)
    h2 = RobinDict("b" => 3, "c" => 4)
    d = merge(+, h1, h2)
    @test isa(d, RobinDict{String, Int})
    @test d["b"] == 5
    @test d["a"] == 1
    @test d["c"] == 4
end

@testset "invariants" begin
    # Functions which are not exported, but are required for checking invariants
    hash_key(key) = (hash(key)%UInt32) | 0x80000000
    desired_index(hash, sz) = (hash & (sz - 1)) + 1
    isslotfilled(h::RobinDict, index) = (h.hashes[index] != 0)
    isslotempty(h::RobinDict, index) = (h.hashes[index] == 0)
    
    function calculate_distance(h::RobinDict{K, V}, index) where {K, V}
        @assert isslotfilled(h, index)
        sz = length(h.keys)
        @inbounds index_init = desired_index(h.hashes[index], sz)
        return (index - index_init + sz) & (sz - 1)
    end

    function get_idxfloor(h::RobinDict)
        @inbounds for i = 1:length(h.keys)
            if isslotfilled(h, i)
                return i
            end
        end
        return 0
    end

    h1 = RobinDict{Int, Int}()
    for i in 1:300
        h1[i] = i
    end

    for i in 1:length(h1.keys)
        if isslotfilled(h1, i)
            @test hash_key(h1.keys[i]) == h1.hashes[i]
        end
    end

    h2 = RobinDict{Float64, Float64}()
    for i in 1:300
        h2[rand()] = rand()
    end

    for i in 1:length(h2.keys)
        if isslotfilled(h2, i)
            @test hash_key(h2.keys[i]) == h2.hashes[i]
        end
    end

    h3 = RobinDict{String, Int}()
    for i in 1:300
        h3[randstring()] = i
    end

    for i in 1:length(h3.keys)
        if isslotfilled(h3, i)
            @test hash_key(h3.keys[i]) == h3.hashes[i]
        end
    end

    max_disp = 0
    function check_invariants(h::RobinDict)
        cnt = 0
        min_idx = 0
        sz = length(h.keys)
        for i=1:length(h.keys)
            isslotfilled(h, i) || continue
            (min_idx == 0) && (min_idx = i)
            @assert hash_key(h.keys[i]) == h.hashes[i]
            @assert (h.hashes[i] & 0x80000000) != 0
            cnt += 1
            @assert typeof(h.hashes[i]) == UInt32
            des_ind = desired_index(h.hashes[i], sz)
            pos_diff = 0
            if (i >= des_ind)
                pos_diff = i - des_ind
            else
                pos_diff = sz - des_ind + i
            end
            dist = calculate_distance(h, i)
            @assert dist == pos_diff
            max_disp = max(max_disp, dist)
            distlast = (i != 1) ? isslotfilled(h, i-1) ? calculate_distance(h, i-1) : 0 : isslotfilled(h, sz) ? calculate_distance(h, sz) : 0
            @assert dist <= distlast + 1
        end
        @assert h.idxfloor == min_idx
        @assert cnt == length(h)
    end

    h = RobinDict()
    for i = 1:10000
        h[i] = i+1
    end
    check_invariants(h)

    @testset "get_idxfloor" begin
        h = RobinDict()
        @test get_idxfloor(h) == 0

        h["a"] = 1
        h[2] = "b"
        @test h.idxfloor == get_idxfloor(h)
        pop!(h)
        @test h.idxfloor == get_idxfloor(h)
        pop!(h)
        @test h.idxfloor == get_idxfloor(h) == 0
    end
end

mutable struct Trie{K,V}
    value::V
    children::Dict{K,Trie{K,V}}
    is_key::Bool

    function Trie{K,V}() where {K,V}
        self = new{K,V}()
        self.children = Dict{K,Trie{K,V}}()
        self.is_key = false
        return self
    end

    function Trie{K,V}(ks, vs) where {K,V}
        return Trie{K,V}(zip(ks, vs))
    end

    function Trie{K,V}(kv) where {K,V}
        t = Trie{K,V}()
        for (k,v) in kv
            t[k] = v
        end
        return t
    end
end

Trie() = Trie{Any,Any}()
Trie(ks::AbstractVector{K}, vs::AbstractVector{V}) where {K,V} = Trie{eltype(K),V}(ks, vs)
Trie(kv::AbstractVector{Tuple{K,V}}) where {K,V} = Trie{eltype(K),V}(kv)
Trie(kv::AbstractDict{K,V}) where {K,V} = Trie{eltype(K),V}(kv)
Trie(ks::AbstractVector{K}) where {K} = Trie{eltype(K),Nothing}(ks, similar(ks, Nothing))

function Base.setindex!(t::Trie{K,V}, val, key) where {K,V}
    value = convert(V, val) # we don't want to iterate before finding out it fails
    node = t
    for char in key
        node = get!(Trie{K,V}, node.children, char)
    end
    node.is_key = true
    node.value = value
end

function Base.getindex(t::Trie, key)
    node = subtrie(t, key)
    if node != nothing && node.is_key
        return node.value
    end
    throw(KeyError("key not found: $key"))
end

function subtrie(t::Trie, prefix)
    node = t
    for char in prefix
        node = get(node.children, char, nothing)
        isnothing(node) && return nothing
    end
    return node
end

function Base.haskey(t::Trie, key)
    node = subtrie(t, key)
    node != nothing && node.is_key
end

function Base.get(t::Trie, key, notfound)
    node = subtrie(t, key)
    if node != nothing && node.is_key
        return node.value
    end
    return notfound
end

_concat(prefix::String, char::Char) = string(prefix, char)
_concat(prefix::Vector{T}, char::T) where {T} = vcat(prefix, char)

_empty_prefix(::Trie{Char,V}) where {V} = ""
_empty_prefix(::Trie{K,V}) where {K,V} = K[]

function Base.keys(t::Trie{K,V},
                   prefix=_empty_prefix(t),
                   found=Vector{typeof(prefix)}()) where {K,V}
    if t.is_key
        push!(found, prefix)
    end
    for (char,child) in t.children
        keys(child, _concat(prefix, char), found)
    end
    return found
end

function keys_with_prefix(t::Trie, prefix)
    st = subtrie(t, prefix)
    st != nothing ? keys(st,prefix) : []
end

# The state of a TrieIterator is a pair (t::Trie, i::Int),
# where t is the Trie which was the output of the previous iteration
# and i is the index of the current character of the string.
# The indexing is potentially confusing;
# see the comments and implementation below for details.
struct TrieIterator
    t::Trie
    str
end

# At the start, there is no previous iteration,
# so the first element of the state is undefined.
# We use a "dummy value" of it.t to keep the type of the state stable.
# The second element is 0
# since the root of the trie corresponds to a length 0 prefix of str.
function Base.iterate(it::TrieIterator, (t, i) = (it.t, 0))
    if i == 0
        return it.t, (it.t, firstindex(it.str))
    elseif i > lastindex(it.str) || !(it.str[i] in keys(t.children))
        return nothing
    else
        t = t.children[it.str[i]]
        return (t, (t, nextind(it.str, i)))
    end
end

partial_path(t::Trie, str) = TrieIterator(t, str)
Base.IteratorSize(::Type{TrieIterator}) = Base.SizeUnknown()

"""
    find_prefixes(t::Trie, str)

Find all keys from the `Trie` that are prefix of the given string

# Examples
```julia-repl
julia> t = Trie(["A", "ABC", "ABCD", "BCE"])

julia> find_prefixes(t, "ABCDE")
3-element Vector{AbstractString}:
 "A"
 "ABC"
 "ABCD"

julia> t′ = Trie([1:1, 1:3, 1:4, 2:4]);

julia> find_prefixes(t′, 1:5)
3-element Vector{UnitRange{Int64}}:
 1:1
 1:3
 1:4

julia> find_prefixes(t′, [1,2,3,4,5])
3-element Vector{Vector{Int64}}:
 [1]
 [1, 2, 3]
 [1, 2, 3, 4]
```
"""
function find_prefixes(t::Trie, str::T) where {T}
    prefixes = T[]
    it = partial_path(t, str)
    idx = 0
    for t in it
        if t.is_key
            push!(prefixes, str[firstindex(str):idx])
        end
        idx = nextind(str, idx)
    end
    return prefixes
end

# This file was copied from Transducers.jl
# which is available under an MIT license (see LICENSE).
using PkgBenchmark
using Markdown

function displayresult(result)
    md = sprint(export_markdown, result)
    md = replace(md, ":x:" => "❌")
    md = replace(md, ":white_check_mark:" => "✅")
    display(Markdown.parse(md))
end

function printnewsection(name)
    println()
    println()
    println()
    printstyled("▃" ^ displaysize(stdout)[2]; color=:blue)
    println()
    printstyled(name; bold=true)
    println()
    println()
end

# This file was a part of Julia. License is MIT: http://julialang.org/license

mutable struct IntSet
    bits::BitVector
    inverse::Bool
    IntSet() = new(falses(256), false)
end
IntSet(itr) = union!(IntSet(), itr)

Base.empty(s::IntSet) = IntSet()
Base.copy(s1::IntSet) = copy!(IntSet(), s1)
function Base.copy!(to::IntSet, from::IntSet)
    resize!(to.bits, length(from.bits))
    copyto!(to.bits, from.bits)
    to.inverse = from.inverse
    return to
end
Base.eltype(::Type{IntSet}) = Int
Base.sizehint!(s::IntSet, n::Integer) = (_resize0!(s.bits, n+1); s)

# An internal function for setting the inclusion bit for a given integer n >= 0
@inline function _setint!(s::IntSet, n::Integer, b::Bool)
    idx = n+1
    if idx > length(s.bits)
        !b && return s # setting a bit to zero outside the set's bits is a no-op
        newlen = idx + idx>>1 # This operation may overflow; we want saturation
        _resize0!(s.bits, ifelse(newlen<0, typemax(Int), newlen))
    end
    unsafe_setindex!(s.bits, b, idx) # Use @inbounds once available
    return s
end

# An internal function to resize a bitarray and ensure the newly allocated
# elements are zeroed (will become unnecessary if this behavior changes)
@inline function _resize0!(b::BitVector, newlen::Integer)
    len = length(b)
    resize!(b, newlen)
    len < newlen && @inbounds(b[len+1:newlen] .= false) # resize! gives dirty memory
    return b
end

# An internal function that resizes a bitarray so it matches the length newlen
# Returns a bitvector of the removed elements (empty if none were removed)
function _matchlength!(b::BitArray, newlen::Integer)
    len = length(b)
    len > newlen && return splice!(b, newlen+1:len)
    len < newlen && _resize0!(b, newlen)
    return BitVector()
end

const _intset_bounds_err_msg = "elements of IntSet must be between 0 and typemax(Int)-1"

function Base.push!(s::IntSet, n::Integer)
    0 <= n < typemax(Int) || throw(ArgumentError(_intset_bounds_err_msg))
    _setint!(s, n, !s.inverse)
end
Base.push!(s::IntSet, ns::Integer...) = (for n in ns; push!(s, n); end; s)

function Base.pop!(s::IntSet)
    s.inverse && throw(ArgumentError("cannot pop the last element of complement IntSet"))
    pop!(s, last(s))
end
function Base.pop!(s::IntSet, n::Integer)
    0 <= n < typemax(Int) || throw(ArgumentError(_intset_bounds_err_msg))
    n in s ? (_delete!(s, n); n) : throw(KeyError(n))
end
function Base.pop!(s::IntSet, n::Integer, default)
    0 <= n < typemax(Int) || throw(ArgumentError(_intset_bounds_err_msg))
    n in s ? (_delete!(s, n); n) : default
end
function Base.pop!(f::Function, s::IntSet, n::Integer)
    0 <= n < typemax(Int) || throw(ArgumentError(_intset_bounds_err_msg))
    n in s ? (_delete!(s, n); n) : f()
end
_delete!(s::IntSet, n::Integer) = _setint!(s, n, s.inverse)
Base.delete!(s::IntSet, n::Integer) = n < 0 ? s : _delete!(s, n)
Base.popfirst!(s::IntSet) = pop!(s, first(s))

Base.empty!(s::IntSet) = (fill!(s.bits, false); s.inverse = false; s)
Base.isempty(s::IntSet) = s.inverse ? length(s.bits) == typemax(Int) && all(s.bits) : !any(s.bits)

# Mathematical set functions: union!, intersect!, setdiff!, symdiff!
# When applied to two intsets, these all have a similar form:
# - Reshape s1 to match s2, occasionally grabbing the bits that were removed
# - Use map to apply some bitwise operation across the entire bitvector
#   - These operations use functors to work on the bitvector chunks, so are
#     very efficient... but a little untraditional. E.g., (p > q) => (p & ~q)
# - If needed, append the removed bits back to s1 or invert the array

Base.union(s::IntSet, ns) = union!(copy(s), ns)
Base.union!(s::IntSet, ns) = (for n in ns; push!(s, n); end; s)
function Base.union!(s1::IntSet, s2::IntSet)
    l = length(s2.bits)
    if     !s1.inverse & !s2.inverse;  e = _matchlength!(s1.bits, l); map!(|, s1.bits, s1.bits, s2.bits); append!(s1.bits, e)
    elseif  s1.inverse & !s2.inverse;  e = _matchlength!(s1.bits, l); map!(>, s1.bits, s1.bits, s2.bits); append!(s1.bits, e)
    elseif !s1.inverse &  s2.inverse;  _resize0!(s1.bits, l);         map!(<, s1.bits, s1.bits, s2.bits); s1.inverse = true
    else #= s1.inverse &  s2.inverse=# _resize0!(s1.bits, l);         map!(&, s1.bits, s1.bits, s2.bits)
    end
    s1
end

Base.intersect(s1::IntSet) = copy(s1)
Base.intersect(s1::IntSet, ss...) = intersect(s1, intersect(ss...))
function Base.intersect(s1::IntSet, ns)
    s = IntSet()
    for n in ns
        n in s1 && push!(s, n)
    end
    return s
end
Base.intersect(s1::IntSet, s2::IntSet) = intersect!(copy(s1), s2)
function Base.intersect!(s1::IntSet, s2::IntSet)
    l = length(s2.bits)
    if     !s1.inverse & !s2.inverse;  _resize0!(s1.bits, l);         map!(&, s1.bits, s1.bits, s2.bits)
    elseif  s1.inverse & !s2.inverse;  _resize0!(s1.bits, l);         map!(<, s1.bits, s1.bits, s2.bits); s1.inverse = false
    elseif !s1.inverse &  s2.inverse;  e = _matchlength!(s1.bits, l); map!(>, s1.bits, s1.bits, s2.bits); append!(s1.bits, e)
    else #= s1.inverse &  s2.inverse=# e = _matchlength!(s1.bits, l); map!(|, s1.bits, s1.bits, s2.bits); append!(s1.bits, e)
    end
    return s1
end

Base.setdiff(s::IntSet, ns) = setdiff!(copy(s), ns)
Base.setdiff!(s::IntSet, ns) = (for n in ns; _delete!(s, n); end; s)
function Base.setdiff!(s1::IntSet, s2::IntSet)
    l = length(s2.bits)
    if     !s1.inverse & !s2.inverse;  e = _matchlength!(s1.bits, l); map!(>, s1.bits, s1.bits, s2.bits); append!(s1.bits, e)
    elseif  s1.inverse & !s2.inverse;  e = _matchlength!(s1.bits, l); map!(|, s1.bits, s1.bits, s2.bits); append!(s1.bits, e)
    elseif !s1.inverse &  s2.inverse;  _resize0!(s1.bits, l);         map!(&, s1.bits, s1.bits, s2.bits)
    else #= s1.inverse &  s2.inverse=# _resize0!(s1.bits, l);         map!(<, s1.bits, s1.bits, s2.bits); s1.inverse = false
    end
    return s1
end

Base.symdiff(s::IntSet, ns) = symdiff!(copy(s), ns)
Base.symdiff!(s::IntSet, ns) = (for n in ns; symdiff!(s, n); end; s)
function Base.symdiff!(s::IntSet, n::Integer)
    0 <= n < typemax(Int) || throw(ArgumentError(_intset_bounds_err_msg))
    val = (n in s) ⊻ !s.inverse
    _setint!(s, n, val)
    return s
end
function Base.symdiff!(s1::IntSet, s2::IntSet)
    e = _matchlength!(s1.bits, length(s2.bits))
    map!(⊻, s1.bits, s1.bits, s2.bits)
    s2.inverse && (s1.inverse = !s1.inverse)
    append!(s1.bits, e)
    return s1
end

function Base.in(n::Integer, s::IntSet)
    idx = n+1
    if 1 <= idx <= length(s.bits)
        unsafe_getindex(s.bits, idx) != s.inverse
    else
        ifelse((idx <= 0) | (idx > typemax(Int)), false, s.inverse)
    end
end

function findnextidx(s::IntSet, i::Int, invert=false)
    if s.inverse ⊻ invert
        # i+1 could rollover causing a BoundsError in findnext/findnextnot
        nextidx = i == typemax(Int) ? 0 : something(findnextnot(s.bits, i+1), 0)
        # Extend indices beyond the length of the bits since it is inverted
        nextidx = nextidx == 0 ? max(i, length(s.bits))+1 : nextidx
    else
        nextidx = i == typemax(Int) ? 0 : something(findnext(s.bits, i+1), 0)
    end
    return nextidx
end

Base.iterate(s::IntSet) = iterate(s, findnextidx(s, 0))

function Base.iterate(s::IntSet, i::Int, invert=false)
    i <= 0 && return nothing
    return (i-1, findnextidx(s, i, invert))
end

# Nextnot iterates through elements *not* in the set
nextnot(s::IntSet, i) = iterate(s, i, true)

function Base.last(s::IntSet)
    l = length(s.bits)
    if s.inverse
        idx = l < typemax(Int) ? typemax(Int) : something(findprevnot(s.bits, l), 0)
    else
        idx = something(findprev(s.bits, l), 0)
    end
    idx == 0 ? throw(ArgumentError("collection must be non-empty")) : idx - 1
end

Base.length(s::IntSet) = (n = sum(s.bits); ifelse(s.inverse, typemax(Int) - n, n))

complement(s::IntSet) = complement!(copy(s))
complement!(s::IntSet) = (s.inverse = !s.inverse; s)

function Base.show(io::IO, s::IntSet)
    print(io, "IntSet([")
    first = true
    for n in s
        if s.inverse && n > 2
            state = nextnot(s, n - 3)
            if state !== nothing && state[2] <= 0
                print(io, ", ..., ", typemax(Int)-1)
                break
            end
         end
        !first && print(io, ", ")
        print(io, n)
        first = false
    end
    print(io, "])")
end

function Base.:(==)(s1::IntSet, s2::IntSet)
    l1 = length(s1.bits)
    l2 = length(s2.bits)
    l1 < l2 && return ==(s2, s1) # Swap so s1 is always equal-length or longer

    # Try to do this without allocating memory or checking bit-by-bit
    if s1.inverse == s2.inverse
        # If the lengths are the same, simply punt to bitarray comparison
        l1 == l2 && return s1.bits == s2.bits
        # Otherwise check the last bit. If equal, we only need to check up to l2
        return findprev(s1.bits, l1) == findprev(s2.bits, l2) &&
               unsafe_getindex(s1.bits, 1:l2) == s2.bits
    else
        # one complement, one not. Could feasibly be true on 32 bit machines
        # Only if all non-overlapping bits are set and overlaps are inverted
        return l1 == typemax(Int) &&
               map!(!, unsafe_getindex(s1.bits, 1:l2)) == s2.bits &&
               (l1 == l2 || all(unsafe_getindex(s1.bits, l2+1:l1)))
    end
end

const hashis_seed = UInt === UInt64 ? 0x88989f1fc7dea67d : 0xc7dea67d
function Base.hash(s::IntSet, h::UInt)
    # Only hash the bits array up to the last-set bit to prevent extra empty
    # bits from changing the hash result
    l = findprev(s.bits, length(s.bits))
    return hash(unsafe_getindex(s.bits, 1:l), h) ⊻ hash(s.inverse) ⊻ hashis_seed
end

Base.issubset(a::IntSet, b::IntSet) = isequal(a, intersect(a,b))
Base.:(<)(a::IntSet, b::IntSet) = (a<=b) && !isequal(a,b)
Base.:(<=)(a::IntSet, b::IntSet) = issubset(a, b)

## These functions define the possible iterations for the
## sorted containers.
## The prefix SDM is for SortedDict and SortedMultiDict
## The prefix SS is for SortedSet.  The prefix SA
## is for all sorted containers.
## The following two definitions now appear in tokens2.jl

# const SDMContainer = Union{SortedDict, SortedMultiDict}
# const SAContainer = Union{SDMContainer, SortedSet}

extractcontainer(s::SAContainer) = s
getrangeobj(s::SAContainer) = s


## This holds an object describing an exclude-last
## iteration.


abstract type AbstractExcludeLast{ContainerType <: SAContainer} end

struct SDMExcludeLast{ContainerType <: SDMContainer} <:
                              AbstractExcludeLast{ContainerType}
    m::ContainerType
    first::Int
    pastlast::Int
end

Base.keytype(::SDMExcludeLast{T}) where {T <: SAContainer} = keytype(T)
Base.keytype(::Type{SDMExcludeLast{T}}) where {T <: SAContainer} = keytype(T)
Base.valtype(::SDMExcludeLast{T}) where {T <: SAContainer} = valtype(T)
Base.valtype(::Type{SDMExcludeLast{T}}) where {T <: SAContainer} = valtype(T)
Base.eltype(::SDMExcludeLast{T}) where {T <: SAContainer} = eltype(T)
Base.eltype(::Type{SDMExcludeLast{T}}) where {T <: SAContainer} = eltype(T)


struct SSExcludeLast{ContainerType <: SortedSet} <:
                              AbstractExcludeLast{ContainerType}
    m::ContainerType
    first::Int
    pastlast::Int
end

Base.eltype(::SSExcludeLast{T}) where {T <: SortedSet} = eltype(T)
Base.eltype(::Type{SSExcludeLast{T}}) where {T <: SortedSet} = eltype(T)


extractcontainer(s::AbstractExcludeLast) = s.m
getrangeobj(s::AbstractExcludeLast) = s

## This holds an object describing an include-last
## iteration.

abstract type AbstractIncludeLast{ContainerType <: SAContainer} end


struct SDMIncludeLast{ContainerType <: SDMContainer} <:
                               AbstractIncludeLast{ContainerType}
    m::ContainerType
    first::Int
    last::Int
end

Base.keytype(::SDMIncludeLast{T}) where {T <: SAContainer} = keytype(T)
Base.keytype(::Type{SDMIncludeLast{T}}) where {T <: SAContainer} = keytype(T)
Base.valtype(::SDMIncludeLast{T}) where {T <: SAContainer} = valtype(T)
Base.valtype(::Type{SDMIncludeLast{T}}) where {T <: SAContainer} = valtype(T)
Base.eltype(::SDMIncludeLast{T}) where {T <: SAContainer} = eltype(T)
Base.eltype(::Type{SDMIncludeLast{T}}) where {T <: SAContainer} = eltype(T)


struct SSIncludeLast{ContainerType <: SortedSet} <:
                               AbstractIncludeLast{ContainerType}
    m::ContainerType
    first::Int
    last::Int
end

Base.eltype(::SSIncludeLast{T}) where {T <: SortedSet} = eltype(T)
Base.eltype(::Type{SSIncludeLast{T}}) where {T <: SortedSet} = eltype(T)


extractcontainer(s::AbstractIncludeLast) = s.m
getrangeobj(s::AbstractIncludeLast) = s


Base.IteratorSize(::Type{T} where {T <: SAContainer}) = HasLength()
Base.IteratorSize(::Type{T} where {T <: AbstractExcludeLast}) = SizeUnknown()
Base.IteratorSize(::Type{T} where {T <: AbstractIncludeLast}) = SizeUnknown()


## The basic iterations are either over the whole sorted container, an
## exclude-last object or include-last object.

const SDMIterableTypesBase = Union{SDMContainer,
                                   SDMExcludeLast,
                                   SDMIncludeLast}

const SSIterableTypesBase = Union{SortedSet,
                                  SSExcludeLast,
                                  SSIncludeLast}


const SAIterableTypesBase = Union{SAContainer,
                                  AbstractExcludeLast,
                                  AbstractIncludeLast}


## The compound iterations are obtained by applying keys(..) or values(..)
## to the basic iterations of the SDM.. type.
## Furthermore, semitokens(..) can be applied
## to either a basic iteration or a keys/values iteration.

struct SDMKeyIteration{T <: SDMIterableTypesBase}
    base::T
end

Base.eltype(::Type{SDMKeyIteration{T}}) where {T} = keytype(T)
Base.eltype(s::SDMKeyIteration) = keytype(extractcontainer(s.base))
Base.length(s::SDMKeyIteration{T} where T <: SDMContainer) = length(extractcontainer(s.base))


struct SDMValIteration{T <: SDMIterableTypesBase}
    base::T
end

Base.eltype(::Type{SDMValIteration{T}}) where {T} = valtype(T)
Base.eltype(s::SDMValIteration) = valtype(extractcontainer(s.base))
Base.length(s::SDMValIteration{T} where T <: SDMContainer) = length(extractcontainer(s.base))


struct SDMSemiTokenIteration{T <: SDMIterableTypesBase}
    base::T
end

Base.eltype(::Type{SDMSemiTokenIteration{T}}) where {T} =
    Tuple{IntSemiToken, keytype(T), valtype(T)}
Base.eltype(s::SDMSemiTokenIteration) = Tuple{IntSemiToken,
                                         keytype(extractcontainer(s.base)),
                                         valtype(extractcontainer(s.base))}
Base.length(s::SDMSemiTokenIteration{T} where T <: SDMContainer) = length(s.base)


struct SSSemiTokenIteration{T <: SSIterableTypesBase}
    base::T
end

Base.eltype(::Type{SSSemiTokenIteration{T}}) where {T} =
    Tuple{IntSemiToken, eltype(T)}
Base.eltype(s::SSSemiTokenIteration) = Tuple{IntSemiToken,
                                        eltype(extractcontainer(s.base))}
Base.length(s::SSSemiTokenIteration{T} where T <: SortedSet) = length(s.base)


struct SDMSemiTokenKeyIteration{T <: SDMIterableTypesBase}
    base::T
end

Base.eltype(::Type{SDMSemiTokenKeyIteration{T}}) where {T} =
    Tuple{IntSemiToken,
          keytype(T)}
Base.eltype(s::SDMSemiTokenKeyIteration) = Tuple{IntSemiToken,
                                            keytype(extractcontainer(s.base))}
Base.length(s::SDMSemiTokenKeyIteration{T} where T <: SDMContainer) = length(s.base)

struct SAOnlySemiTokensIteration{T <: SAIterableTypesBase}
    base::T
end

Base.eltype(::Type{SAOnlySemiTokensIteration{T}} where {T}) = IntSemiToken
Base.eltype(::SAOnlySemiTokensIteration) = IntSemiToken
Base.length(s::SAOnlySemiTokensIteration{T} where T <: SAContainer) = length(s.base)

struct SDMSemiTokenValIteration{T <: SDMIterableTypesBase}
    base::T
end

Base.eltype(::Type{SDMSemiTokenValIteration{T}}) where {T} =
    Tuple{IntSemiToken, valtype(T)}
Base.eltype(s::SDMSemiTokenValIteration) = Tuple{IntSemiToken,
                                            valtype(extractcontainer(s.base))}
Base.length(s::SDMSemiTokenValIteration{T} where T <: SDMContainer) = length(s.base)

const SACompoundIterable = Union{SDMKeyIteration,
                                 SDMValIteration,
                                 SDMSemiTokenIteration,
                                 SSSemiTokenIteration,
                                 SDMSemiTokenKeyIteration,
                                 SDMSemiTokenValIteration,
                                 SAOnlySemiTokensIteration}

extractcontainer(s::SACompoundIterable) = extractcontainer(s.base)
getrangeobj(s::SACompoundIterable) = getrangeobj(s.base)

const SAIterable = Union{SAIterableTypesBase, SACompoundIterable}


Base.IteratorEltype(::Type{T} where {T <: SAIterable}) = HasEltype()
Base.IteratorSize(::Type{SDMKeyIteration{T}}) where {T} = IteratorSize(T)
Base.IteratorSize(::Type{SDMValIteration{T}}) where {T} = IteratorSize(T)
Base.IteratorSize(::Type{SDMSemiTokenIteration{T}}) where {T} = IteratorSize(T)
Base.IteratorSize(::Type{SSSemiTokenIteration{T}}) where {T} = IteratorSize(T)
Base.IteratorSize(::Type{SDMSemiTokenKeyIteration{T}}) where {T} = IteratorSize(T)
Base.IteratorSize(::Type{SDMSemiTokenValIteration{T}}) where {T} = IteratorSize(T)
Base.IteratorSize(::Type{SAOnlySemiTokensIteration{T}}) where {T} = IteratorSize(T)


## All the loops maintain a state which is an object of the
## following type.

struct SAIterationState
    next::Int
    final::Int
end


exclusive(m::SDMContainer, ii::Tuple{IntSemiToken,IntSemiToken}) =
    SDMExcludeLast(m, ii[1].address, ii[2].address)
exclusive(m::SortedSet, ii::Tuple{IntSemiToken,IntSemiToken}) =
    SSExcludeLast(m, ii[1].address, ii[2].address)
exclusive(m::SAContainer, i1::IntSemiToken, i2::IntSemiToken) =
    exclusive(m, (i1, i2))

inclusive(m::SDMContainer, ii::Tuple{IntSemiToken,IntSemiToken}) =
    SDMIncludeLast(m, ii[1].address, ii[2].address)
inclusive(m::SortedSet, ii::Tuple{IntSemiToken,IntSemiToken}) =
    SSIncludeLast(m, ii[1].address, ii[2].address)
inclusive(m::SAContainer, i1::IntSemiToken, i2::IntSemiToken) =
    inclusive(m, (i1, i2))


# Next definition needed to break ambiguity with keys(AbstractDict) from Dict.jl

Base.keys(ba::SortedDict) = SDMKeyIteration(ba)
Base.keys(ba::SDMIterableTypesBase) = SDMKeyIteration(ba)


Base.in(k, keyit::SDMKeyIteration{SortedDict{K,D,Ord}} where {K,D,Ord}) =
    haskey(extractcontainer(keyit.base), k)

Base.in(k, keyit::SDMKeyIteration{SortedMultiDict{K,D,Ord}} where {K,D,Ord}) =
    haskey(extractcontainer(keyit.base), k)


# Next definition needed to break ambiguity with values(AbstractDict) from Dict.jl
Base.values(ba::SortedDict) = SDMValIteration(ba)
Base.values(ba::SDMIterableTypesBase) = SDMValIteration(ba)
semitokens(ba::SDMIterableTypesBase) = SDMSemiTokenIteration(ba)
semitokens(ba::SSIterableTypesBase) = SSSemiTokenIteration(ba)
semitokens(ki::SDMKeyIteration) = SDMSemiTokenKeyIteration(ki.base)
semitokens(vi::SDMValIteration) = SDMSemiTokenValIteration(vi.base)
onlysemitokens(ba::SAIterableTypesBase) = SAOnlySemiTokensIteration(ba)


function nexthelper(c::SAContainer, state::SAIterationState)
    sn = state.next
    (sn < 3 || !(sn in c.bt.useddatacells)) && throw(BoundsError())
    SAIterationState(nextloc0(c.bt, sn), state.final)
end


getitem(::SDMIterableTypesBase, dt, sn) = dt.k => dt.d
getitem(::SSIterableTypesBase, dt, sn) = dt.k
getitem(::SDMKeyIteration, dt, sn) = dt.k
getitem(::SDMValIteration, dt, sn) = dt.d
getitem(::SDMSemiTokenIteration, dt, sn) = (IntSemiToken(sn), dt.k, dt.d)
getitem(::SSSemiTokenIteration, dt, sn) = (IntSemiToken(sn), dt.k)
getitem(::SDMSemiTokenKeyIteration, dt, sn) = (IntSemiToken(sn), dt.k)
getitem(::SDMSemiTokenValIteration, dt, sn) = (IntSemiToken(sn), dt.d)
getitem(::SAOnlySemiTokensIteration, dt, sn) = IntSemiToken(sn)


function get_init_state(e::AbstractExcludeLast)
    (!(e.first in e.m.bt.useddatacells) || e.first == 1 ||
     !(e.pastlast in e.m.bt.useddatacells)) &&
     throw(BoundsError())
    if compareInd(e.m.bt, e.first, e.pastlast) < 0
        return SAIterationState(e.first, e.pastlast)
    else
        return SAIterationState(2, 2)
    end
end

function get_init_state(e::AbstractIncludeLast)
    (!(e.first in e.m.bt.useddatacells) || e.first == 1 ||
     !(e.last in e.m.bt.useddatacells) || e.last == 2) &&
     throw(BoundsError())
    if compareInd(e.m.bt, e.first, e.last) <= 0
        return SAIterationState(e.first, nextloc0(e.m.bt, e.last))
    else
        return SAIterationState(2, 2)
    end
end

get_init_state(m::SAContainer) = SAIterationState(beginloc(m.bt), 2)

function Base.iterate(s::SAIterable, state = get_init_state(getrangeobj(s)))
    if state.next == state.final
        return nothing
    else
        c = extractcontainer(s)
        dt = isa(s, SAOnlySemiTokensIteration) ? nothing : c.bt.data[state.next]
        return (getitem(s, dt, state.next),
                nexthelper(c, state))
    end
end


Base.eachindex(sd::SortedDict) = keys(sd)
Base.eachindex(sdm::SortedMultiDict) = onlysemitokens(sdm)
Base.eachindex(ss::SortedSet) = onlysemitokens(ss)
Base.eachindex(sd::SDMExcludeLast{SortedDict{K,D,Ord}} where {K,D,Ord <: Ordering}) = keys(sd)
Base.eachindex(smd::SDMExcludeLast{SortedMultiDict{K,D,Ord}} where {K,D,Ord <: Ordering}) =
     onlysemitokens(smd)
Base.eachindex(ss::SSExcludeLast) = onlysemitokens(ss)
Base.eachindex(sd::SDMIncludeLast{SortedDict{K,D,Ord}} where {K,D,Ord <: Ordering}) = keys(sd)
Base.eachindex(smd::SDMIncludeLast{SortedMultiDict{K,D,Ord}} where {K,D,Ord <: Ordering}) =
     onlysemitokens(smd)
Base.eachindex(ss::SSIncludeLast) = onlysemitokens(ss)


Base.empty!(m::SAContainer) =  empty!(m.bt)
Base.length(m::SAContainer) = length(m.bt.data) - length(m.bt.freedatainds) - 2
Base.isempty(m::SAContainer) = length(m) == 0

## Token interface to a container.  A token is the address
## of an item in a container.  The token has two parts: the
## container and the item's address.  The address is of type
## AbstractSemiToken.


module Tokens

abstract type AbstractSemiToken end

struct IntSemiToken <: AbstractSemiToken
    address::Int
end

end

import DataStructures: DefaultDictBase

@testset "DefaultDict" begin

    @testset "DefaultDictBase" begin
        #construction
        @test_throws ArgumentError DefaultDictBase()
        @test isa(DefaultDictBase(0.0), DefaultDictBase{Any, Any, Float64, Dict{Any, Any}})
        @test isa(DefaultDictBase(0.0, 1 => 1.0), DefaultDictBase{Int, Float64, Float64, Dict{Int, Float64}})
        @test isa(DefaultDictBase(0.0, [(1, 1.0)]), DefaultDictBase{Int, Float64, Float64, Dict{Int, Float64}})
        #@test isa(DefaultDictBase(0.0, Dict()), DefaultDictBase{Any, Any, Float64, Dict{Any, Any}}))

        ddb = DefaultDictBase{Int, Float64}(0.0)
        @test isa(ddb, DefaultDictBase{Int, Float64, Float64, Dict{Int,Float64}})
        @test isa(DefaultDictBase(1.0, ddb), DefaultDictBase{Int, Float64, Float64, Dict{Int,Float64}})

        @test isa(DefaultDictBase{Int, String}(String), DefaultDictBase{Int, String, typeof(String), Dict{Int, String}})
        @test isa(DefaultDictBase{Int, String}(String; passkey=true), DefaultDictBase{Int, String, typeof(String), Dict{Int, String}})
        @test isa(DefaultDictBase{Int, String}(String; passkey=false), DefaultDictBase{Int, String, typeof(String), Dict{Int, String}})
    end

    @testset "DefaultDict" begin
        @testset "construction" begin
            @test_throws ArgumentError DefaultDict()
            @test_throws ArgumentError DefaultDict(AbstractString, Int)
            @test_throws ArgumentError DefaultDict{AbstractString, Int}()

            @test isa(DefaultDict(0.0, 1 => 1.0), DefaultDict{Int, Float64, Float64})
        end

        @testset "Core Functionality" begin
            for F in [1, ()->1]
                # empty dictionary
                d = DefaultDict{Char, Int}(F)
                @test length(d) == 0
                @test isempty(d)
                @test d['c'] == 1
                @test setindex!(d, 10, 'd') === d
                @test !isempty(d)
                @test empty!(d) === d
                @test isempty(d)

                # access, modification
                @test (d['a'] += 1) == 2
                @test 'a' in keys(d)
                @test haskey(d, 'a')
                @test get(d, 'b', 0) == 0
                @test !('b' in keys(d))
                @test !haskey(d, 'b')
                @test pop!(d, 'a') == 2
                @test isempty(d)

                # pushing multiple pairs
                @test push!(d, 'c'=>3, 'd'=>4, 'e'=>5, 'f'=>6) === d
                empty!(d)

                # pushing multiple tuples
                @test push!(d, ('c',3), ('d',4), ('e',5), ('f',6)) === d
                empty!(d)

                @test sizehint!(d, 26) === d

                for c in 'a':'z'
                    d[c] = c-'a'+1
                end

                @test d['z'] == 26
                @test d['@'] == 1
                @test length(d) == 27
                @test delete!(d, '@') === d
                @test length(d) == 26

                for (k,v) in d
                    @test v == k-'a'+1
                end

                s = empty(d)
                @test typeof(s) === typeof(d)
                @test s.d.default == d.d.default

                @test sort(collect(keys(d))) == collect('a':'z')
                @test sort(collect(values(d))) == collect(1:26)
            end
        end

        @testset "From Dict" begin
            # Starting from an existing dictionary
            # Note: dictionary is copied upon construction
            e = Dict([('a',1), ('b',3), ('c',5)])
            f = DefaultDict(0, e)
            @test f['d'] == 0
            @test_throws KeyError e['d']
            e['e'] = 9
            @test e['e'] == 9
            @test f['e'] == 0
        end

        @testset "passkey" begin
            calls = 0
            g = DefaultDict{String, Int}(passkey=true) do key
                calls += 1
                return length(key)
            end
            @test g["foobar"] == 6
            @test calls == 1
            @test length(g) == 1
            @test g["baz"] == 3
            @test calls == 2
            @test length(g) == 2
            @test g["foobar"] == 6
            @test calls == 2
            @test length(g) == 2

            @testset "Incorrect Usage" begin
                bad_dds = [
                    DefaultDict{Int, Int}(k -> k, passkey=false),
                    DefaultDict{Int, Int}(() -> 3, passkey=true),
                ]
                for bad_dd in bad_dds
                    bad_dd[3] = 10
                    @test bad_dd[3] == 10
                    @test_throws MethodError bad_dd[234]
                end
            end
        end

        # Alternate constructor
        @test isa(DefaultDict(0.0), DefaultDict{Any, Any, Float64})
        @test isa(DefaultDict(0.0, [(1, 1.0)]), DefaultDict{Int, Float64, Float64})
    end

    @testset "DefaultOrderedDict" begin
        @testset "construction" begin
            @test_throws ArgumentError DefaultOrderedDict()
            @test_throws ArgumentError DefaultOrderedDict{AbstractString, Int}()
        end

        @testset "Core Functionality" begin
            for F in [1, ()->1]
                # empty dictionary
                d = DefaultOrderedDict{Char, Int}(F)
                @test length(d) == 0
                @test isempty(d)
                @test d['c'] == 1
                @test setindex!(d, 10, 'd') === d
                @test !isempty(d)
                @test empty!(d) === d
                @test isempty(d)

                # access, modification
                @test (d['a'] += 1) == 2
                @test 'a' in keys(d)
                @test haskey(d, 'a')
                @test get(d, 'b', 0) == 0
                @test !('b' in keys(d))
                @test !haskey(d, 'b')
                @test pop!(d, 'a') == 2
                @test isempty(d)

                # pushing multiple pairs
                @test push!(d, 'c'=>3, 'd'=>4, 'e'=>5, 'f'=>6) === d
                empty!(d)

                # pushing multiple tuples
                @test push!(d, ('c',3), ('d',4), ('e',5), ('f',6)) === d
                empty!(d)

                @test sizehint!(d, 26) === d

                for c in 'a':'z'
                    d[c] = c-'a'+1
                end

                @test d['z'] == 26
                @test d['@'] == 1
                @test length(d) == 27
                @test delete!(d, '@') === d
                @test length(d) == 26

                for (k,v) in d
                    @test v == k-'a'+1
                end

                @test collect(keys(d)) == collect('a':'z')
                @test collect(values(d)) == collect(1:26)

                s = empty(d)
                @test typeof(s) === typeof(d)
                @test s.d.default == d.d.default
            end
        end

        @testset "Alternate constructor" begin
            @test isa(DefaultOrderedDict(0.0), DefaultOrderedDict{Any, Any, Float64})
            @test isa(DefaultOrderedDict(0.0, [(1, 1.0)]), DefaultOrderedDict{Int, Float64, Float64})
        end

        @testset "issue #216" begin
            @test DataStructures.isordered(DefaultOrderedDict{Int, String})
        end

    end

end

@testset "AVLTree" begin
    @testset "inserting values" begin
        t = AVLTree{Int}()
        for i in 100:-1:1
            insert!(t, i)
        end

        @test length(t) == 100

        for i in 1:100
            @test haskey(t, i)
        end

        for i = 101:150
            @test !haskey(t, i)
        end
    end

    @testset "deleting values" begin
        t = AVLTree{Int}()
        for i in 1:100
            insert!(t, i)
        end
        for i in 1:2:100
            delete!(t, i)
        end

        @test length(t) == 50

        for i in 1:100
            if iseven(i)
                @test haskey(t, i)
            else
                @test !haskey(t, i)
            end
        end

        for i in 1:2:100
            insert!(t, i)
        end

        @test length(t) == 100
    end

    @testset "handling different cases of delete!" begin
        t2 = AVLTree{Int}()
        for i in 1:100000
            insert!(t2, i)
        end

        @test length(t2) == 100000

        nums = rand(1:100000, 8599)
        visited = Set()
        for num in nums
            if !(num in visited)
                delete!(t2, num)
                push!(visited, num)
            end
        end

        for i in visited
            @test !haskey(t2, i)
        end
        @test (length(t2) + length(visited)) == 100000
    end

    @testset "handling different cases of insert!" begin
        nums = rand(1:100000, 1000)
        t3 = AVLTree{Int}()
        uniq_nums = Set(nums)
        for num in uniq_nums
            insert!(t3, num)
        end
        @test length(t3) == length(uniq_nums)
    end

    @testset "in" begin
        t4 = AVLTree{Char}()
        push!(t4, 'a')
        push!(t4, 'b')
        @test length(t4) == 2
        @test in('a', t4)
        @test !in('c', t4)
    end

    @testset "search_node" begin
        t5 = AVLTree{Int}()
        for i in 1:32
            push!(t5, i)
        end
        n1 = search_node(t5, 21)
        @test n1.data == 21
        n2 = search_node(t5, 35)
        @test n2.data == 32
        n3 = search_node(t5, 0)
        @test n3.data == 1
    end

    @testset "getindex" begin
        t6 = AVLTree{Int}()
        for i in 1:10
            push!(t6, i)
        end
        for i in 1:10
            @test getindex(t6, i) == i
        end
        @test_throws BoundsError getindex(t6, 0)
        @test_throws BoundsError getindex(t6, 11)
    end

    @testset "key conversion in push!" begin
        t7 = AVLTree{Int}()
        push!(t7, Int8(1))
        @test length(t7) == 1
        @test haskey(t7, 1)
    end

    @testset "minimum_node" begin
        t8 = AVLTree{Int}()
        @test minimum_node(t8.root) == nothing
        for i in 1:32
            push!(t8, i)
        end
        m1 = minimum_node(t8.root)
        @test m1.data == 1
        node = t8.root
        while node.leftChild != nothing
            m = minimum_node(node.leftChild)
            @test m == m1
            node = node.leftChild
        end
    end

    @testset "rank" begin
        t9 = AVLTree{Int}()
        for i in 1:20
            push!(t9, i)
        end
        for i in 1:20
            @test sorted_rank(t9, i) == i
        end
        @test_throws KeyError sorted_rank(t9, 21)
    end
end

@testset "Queue" begin

    @testset "Constructors" begin
        s = Queue{Int}()
        @test isa(s, Queue{Int})

        s = Queue{Int}(5)
        @test isa(s, Queue{Int})
    end

    @testset "Core Functionality" begin
        s = Queue{Int}(5)
        n = 100

        @test length(s) == 0
        @test eltype(s) == Int
        @test eltype(typeof(s)) == Int
        @test isempty(s)
        @test_throws ArgumentError first(s)
        @test_throws ArgumentError last(s)
        @test_throws ArgumentError popfirst!(s)

        for i = 1 : n
            push!(s, i)
            @test first(s) == 1
            @test last(s) == i
            @test !isempty(s)
            @test length(s) == i
        end

        for i = 1 : n
            x = popfirst!(s)
            @test x == i
            if i < n
                @test first(s) == i + 1
                @test last(s) == n
            else
                @test_throws ArgumentError first(s)
                @test_throws ArgumentError last(s)
            end
            @test isempty(s) == (i == n)
            @test length(s) == n - i
        end
    end

    @testset "==" begin
        t = Queue{Int}()
        s = Queue{Int}()

        @test s == t
        push!(s, 10)
        @test s != t
        push!(t, 10)
        @test s == t
        push!(t, 20)
        @test s != t

        @testset "different types" begin
            r = Queue{Float32}()
            push!(r, 10)
            @test s == r
        end
    end

    @testset "emptyness" begin
        s = Queue{Int}()
        push!(s, 1)
        push!(s, 3)
        @test !isempty(s)
        empty!(s)
        @test isempty(s)
    end

    @testset "iter should return a FIFO collection" begin
        q = Queue{Int}(10)
        n = 100

        #an array to check iteration sequence against
        arr = Int64[]

        for i = 1:n
            push!(q,i)
            push!(arr,i)
        end

        @testset "iterator" begin
            index = 1
            for i in q
                @test(arr[index] == i)
                index += 1
            end
        end

        @testset "reverse iterator" begin
            index = length(arr)
            for i in Iterators.reverse(q)
                @test(arr[index] == i)
                index -= 1
            end
        end

        @test arr == [i for i in q]
        @test reverse(arr) == [i for i in Iterators.reverse(q)]
        @test first(Iterators.reverse(q)) === last(q)
        @test last(Iterators.reverse(q)) === first(q)
        @test length(Iterators.reverse(q)) === length(q)
    end

end # @testset Queue

# Benchmark on heaps

using DataStructures

# benchmark function

function benchmark_heap(title::String, h::AbstractHeap, xs::Vector{Float64})
    @assert isempty(h)

    # warming
    push!(h, 0.5)
    pop!(h)

    # bench
    n = length(xs)

    t1 = @elapsed for i = 1 : n
        push!(h, xs[i])
    end
    t2 = @elapsed for i = 1 : n
        pop!(h)
    end

    @printf("   On %-24s:  push.elapsed = %7.4fs  pop.elapsed = %7.4fs\n", title, t1, t2)
end


# Benchmark on push! and pop!

xs = rand(10^6)

h_bin  = binary_minheap(Float64)
h_mbin = mutable_binary_minheap(Float64)

benchmark_heap("BinaryHeap", h_bin, xs)
benchmark_heap("MutableBinaryHeap", h_mbin, xs)

using DataStructures
using Test
using Random
using Serialization

import DataStructures: IntSet

@test [] == detect_ambiguities(Base, Core, DataStructures)

tests = [
         "deprecations",
         "int_set",
         "sparse_int_set",
         "deque",
         "circ_deque",
         "sorted_containers",
         "stack",
         "queue",
         "accumulator",
         "disjoint_set",
         "binheap",
         "mutable_binheap",
         "minmax_heap",
         "default_dict",
         "trie",
         "list",
         "mutable_list",
         "multi_dict",
         "circular_buffer",
         "sorting",
         "priority_queue",
         "fenwick",
         "robin_dict",
         "ordered_robin_dict",
         "dibit_vector",
         "swiss_dict",
         "avl_tree",
         "red_black_tree", 
         "splay_tree"
        ]

if length(ARGS) > 0
    tests = ARGS
end

@testset "DataStructures" begin

for t in tests
    fp = joinpath(dirname(@__FILE__), "test_$t.jl")
    println("$fp ...")
    include(fp)
end

end # @testset

module DataStructures

    using Base: Iterators, HasEltype, HasLength, IteratorEltype, IteratorSize, SizeUnknown,
                lt, Ordering, ForwardOrdering, Forward, ReverseOrdering, Reverse, Lt,
                isbitsunion, isiterable, dict_with_eltype, KeySet, Callable, _tablesz,
                findnextnot, unsafe_getindex, unsafe_setindex!, peek

    import Base.insert!

    using OrderedCollections
    using OrderedCollections: isordered
    export OrderedDict, OrderedSet, LittleDict
    export DefaultDict, DefaultOrderedDict

    export complement, complement!

    export Deque, Stack, Queue, CircularDeque
    export capacity, num_blocks, top_with_handle, sizehint!

    export Accumulator, counter, reset!, inc!, dec!
    export IntDisjointSet, DisjointSet, num_groups, find_root!, in_same_set, root_union!
    export FenwickTree, length, inc!, dec!, incdec!, prefixsum

    export AbstractHeap, compare, extract_all!, extract_all_rev!
    export BinaryHeap, BinaryMinHeap, BinaryMaxHeap, nlargest, nsmallest
    export MutableBinaryHeap, MutableBinaryMinHeap, MutableBinaryMaxHeap
    export heapify!, heapify, heappop!, heappush!, isheap
    export BinaryMinMaxHeap, popmin!, popmax!, popall!
    export update!

    export Trie, subtrie, keys_with_prefix, partial_path, find_prefixes

    export LinkedList, Nil, Cons, nil, cons, head, tail, list
    export MutableLinkedList
    export SortedDict, SortedMultiDict, SortedSet
    export SMDSemiToken, SMDToken
    export SetSemiToken
    export pastendsemitoken, beforestartsemitoken
    export pastendtoken, beforestarttoken
    export searchsortedafter, searchequalrange
    export packcopy, packdeepcopy
    export exclusive, inclusive, semitokens, inclusive_key, exclusive_key
    export orderobject, ordtype, Lt, compare, onlysemitokens
    export tokens, onlytokens, poplast!

    export MultiDict, enumerateall
    export RobinDict
    export OrderedRobinDict, isordered
    export SwissDict

    export DiBitVector

    export RBTree, search_node, minimum_node
    export SplayTree, maximum_node
    export AVLTree, sorted_rank
    export SplayTree, maximum_node

    export findkey

    export push_return_semitoken!
    export token_firstindex, token_lastindex

    include("delegate.jl")

    include("deque.jl")
    include("circ_deque.jl")
    include("stack.jl")
    include("queue.jl")
    include("accumulator.jl")
    include("disjoint_set.jl")
    include("heaps.jl")

    include("default_dict.jl")
    include("dict_support.jl")
    include("trie.jl")

    include("int_set.jl")

    include("fenwick.jl")

    include("list.jl")
    include("mutable_list.jl")
    include("balanced_tree.jl")
    include("tokens.jl")

    import .Tokens: IntSemiToken

    include("multi_dict.jl")
    include("sorted_dict.jl")
    include("sorted_multi_dict.jl")
    include("sorted_set.jl")
    include("sorted_container_iteration.jl")
    include("robin_dict.jl")
    include("ordered_robin_dict.jl")
    include("swiss_dict.jl")
    export
        CircularBuffer,
        capacity,
        isfull
    include("circular_buffer.jl")

    export status
    export deref_key, deref_value, deref, advance, regress

    export PriorityQueue

    include("priorityqueue.jl")
    include("sparse_int_set.jl")
    export SparseIntSet

    include("dibit_vector.jl")
    include("avl_tree.jl")
    include("red_black_tree.jl")
    include("splay_tree.jl")

    include("deprecations.jl")


end

using DataStructures, Test
import DataStructures: IntSet

@testset "IntSet" begin
    @testset "Construction, collect" begin
        data_in = (1,5,100)
        s = IntSet(data_in)
        data_out = collect(s)
        @test all(map(d->in(d,data_out), data_in))
        @test length(data_out) == length(data_in)
    end

    @testset "eltype, empty" begin
        @test eltype(IntSet()) == Int
        @test eltype(typeof(IntSet())) == Int
        @test isequal(empty(IntSet([1,2,3])), IntSet())
    end

    @testset "show" begin
        @test sprint(show, IntSet()) == "IntSet([])"
        @test sprint(show, IntSet([1,2,3])) == "IntSet([1, 2, 3])"
        @test occursin("...,", sprint(show, complement(IntSet())))
    end

    @testset "Core Functionality" begin
        s = IntSet([0,1,10,20,200,300,1000,10000,10002])
        @test last(s) == 10002
        @test first(s) == 0
        @test length(s) == 9
        @test pop!(s) == 10002
        @test length(s) == 8
        @test popfirst!(s) == 0
        @test length(s) == 7
        @test !in(0,s)
        @test !in(10002,s)
        @test in(10000,s)
        @test_throws ArgumentError first(IntSet())
        @test_throws ArgumentError last(IntSet())
        t = copy(s)
        sizehint!(t, 20000) #check that hash does not depend on size of internal Array{UInt32, 1}
        @test hash(s) == hash(t)
        @test hash(complement(s)) == hash(complement(t))
    end

    @testset "setdiff / symdiff" begin
        @test setdiff(IntSet([1, 2, 3, 4]), IntSet([2, 4, 5, 6])) == IntSet([1, 3])
        @test symdiff(IntSet([1, 2, 3, 4]), IntSet([2, 4, 5, 6])) == IntSet([1, 3, 5, 6])
    end

    @testset "setdiff!" begin
        s2 = IntSet([1, 2, 3, 4])
        setdiff!(s2, IntSet([2, 4, 5, 6]))

        @test s2 == IntSet([1, 3])
    end

    @testset "issue #7851" begin
        @test_throws ArgumentError IntSet(-1)
        @test !(-1 in IntSet(0:10))
    end

    #@testset "issue #8570" begin
    #    # This requires 2^29 bytes of storage, which is too much for a simple test
    #    # s = IntSet(2^32)
    #    @test length(s) == 1
    #    for b in s; b; end
    #end

    @testset "Copy, copy!, empty" begin
        s1 = IntSet([1,2,3])
        s2 = empty(s1)
        copy!(s2, s1)
        s3 = copy(s2)
        @test s3 == s2 == s1
        @test collect(s3) == collect(s2) == [1,2,3]
    end

    @testset "complement! / pop!" begin
        c1 = complement!(IntSet())
        s1 = IntSet([1,2,3])

        pop!(c1, 1)
        pop!(c1, 2)
        pop!(c1, 3)
        c2 = empty(c1)
        copy!(c2, c1)
        c3 = copy(c2)
        c4 = complement(s1)
        @test c1 == c2 == c3 == c4
        @test c4 === sizehint!(c4, 100)
        @test c1 == c4
        @test last(c1) == typemax(Int)-1
        @test last(complement(IntSet())) == typemax(Int)-1
    end

    @testset "Push, union" begin
        # Push, union
        s1 = IntSet()
        @test_throws ArgumentError push!(s1, -1)
        push!(s1, 1, 10, 100, 1000)
        @test collect(s1) == [1, 10, 100, 1000]
        push!(s1, 606)
        @test collect(s1) == [1, 10, 100, 606, 1000]
        s2 = IntSet()
        @test s2 === union!(s2, s1)
        s3 = IntSet([1, 10, 100])
        union!(s3, [1, 606, 1000])
        s4 = union(IntSet([1, 100, 1000]), IntSet([10, 100, 606]))
        @test s1 == s2 == s3 == s4

        c1 = complement(s1)
        @test !(1 in c1)
        push!(c1, 1)
        @test 1 in c1
        push!(c1, 10, 100, 10)
        @test collect(complement(c1)) == [606, 1000]
        c2 = complement(IntSet([606, 1000]))
        @test c2 === union!(c2, c1)
        c3 = union!(complement(IntSet([10, 606, 1000])), complement(IntSet([1, 606, 1000, 2000])))
        @test c3 == union(complement(IntSet([1, 606, 1000, 2000])), complement(IntSet([10, 606, 1000])))
        c4 = union!(complement(IntSet([1, 10, 606, 1000, 1001])), complement(IntSet([606, 1000])))
        @test c4 == union(complement(IntSet([606, 1000])), complement(IntSet([1, 10, 606, 1000, 1001])))
        c5 = union!(complement(IntSet([10, 606, 1000])), IntSet([0, 10, 20, 30]))
        @test c5 == union(IntSet([0, 10, 20, 30]), complement(IntSet([10, 606, 1000])))
        c6 = union!(complement(IntSet([10, 606, 1000])), IntSet([10, 4000, 3]))
        @test c6 == union(IntSet([10, 4000, 3]), complement(IntSet([10, 606, 1000])))
        @test c1 == c2 == c3 == c4 == c5 == c6
    end

    @testset "pop!, delete!" begin
        s = IntSet(1:2:10)
        @test pop!(s, 1) == 1
        @test !(1 in s)
        @test_throws KeyError pop!(s, 1)
        @test_throws ArgumentError pop!(s, -1)
        @test_throws ArgumentError pop!(s, -1, 1)
        @test_throws ArgumentError pop!(()->throw(ErrorException()), s, -1)
        @test pop!(s, 1, 0) == 0
        @test s === delete!(s, 1)
        for i in s; pop!(s, i); end
        @test isempty(s)
        x = 0
        @test 1 == pop!(()->(x+=1), s, 100)
        @test x == 1
        push!(s, 100)
        @test pop!(()->throw(ErrorException()), s, 100) == 100
        push!(s, 1:2:10...)
        @test pop!(s) == 9
        @test pop!(s) == 7
        @test popfirst!(s) == 1
        @test popfirst!(s) == 3
        @test collect(s) == [5]
        empty!(s)
        @test isempty(s)

        c = complement(IntSet())
        @test pop!(c, 1) == 1
        @test !(1 in c)
        @test_throws KeyError pop!(c, 1)
        @test_throws ArgumentError pop!(c, -1)
        @test_throws ArgumentError pop!(c, -1, 1)
        @test_throws ArgumentError pop!(()->throw(ErrorException()), c, -1)
        @test pop!(c, 1, 0) == 0
        @test c === delete!(c, 1)
        @test popfirst!(c) == 0
        @test popfirst!(c) == 2
        @test_throws ArgumentError pop!(c)
        @test collect(complement(c)) == [0,1,2]
        @test empty!(c) == IntSet()
    end

    @testset "Intersect" begin
        @test isempty(intersect(IntSet()))
        @test isempty(intersect(IntSet(1:10), IntSet()))
        @test isempty(intersect(IntSet(), IntSet(1:10)))
        @test isempty(intersect(IntSet(), complement(IntSet())))
        @test isempty(intersect(IntSet(), complement(IntSet(1:10))))
        @test isempty(intersect(complement(IntSet()), IntSet()))
        @test isempty(intersect(complement(IntSet(1:10)), IntSet()))

        @test intersect(IntSet([1,2,3])) == IntSet([1,2,3])
        @test intersect(complement!(IntSet()), IntSet(1)) ==
              intersect(IntSet(1), complement!(IntSet())) == IntSet(1)

        @test intersect(IntSet(0:7), IntSet(3:10)) ==
              intersect(IntSet(3:10), IntSet(0:7)) == IntSet(3:7)
        @test intersect(complement(IntSet([0:2; 11:16])), IntSet(0:7)) ==
              intersect(IntSet(0:7), complement(IntSet([0:2; 11:16]))) == IntSet(3:7)

        @test intersect(complement(IntSet(5:12)), complement(IntSet(7:10))) ==
              intersect(complement(IntSet(7:10)), complement(IntSet(5:12))) == complement(IntSet(5:12))

        @test intersect(IntSet(0:10), IntSet(1:4), 0:5, [1,2,10]) == IntSet(1:2)
    end

    @testset "Setdiff" begin
        s1 = IntSet(1:100)
        setdiff!(s1, IntSet(1:2:100))
        s2 = setdiff(IntSet(1:100), IntSet(1:2:100))
        @test s1 == s2 == IntSet(2:2:100)
        @test collect(s1) == collect(2:2:100)

        s1 = IntSet(1:10)
        s2 = complement(IntSet(3:5))
        @test setdiff(s1, s2) == setdiff(s1, [0:2; 6:100]) == IntSet(3:5)
        @test isempty(setdiff(complement(IntSet()), complement(IntSet())))
        @test setdiff(complement(IntSet()), complement(IntSet(3:5))) == IntSet(3:5)
        @test setdiff(complement(IntSet(1:5)), complement(IntSet(3:10))) == IntSet([6, 7, 8, 9, 10])
        @test setdiff(complement(IntSet(2:2:10)), IntSet(1:5)) == complement(IntSet([1:5; 6:2:10]))
        @test setdiff!(complement(IntSet()), complement(IntSet())) == IntSet()
        @test setdiff!(complement(IntSet(0:2:10)), complement(IntSet(0:10))) == IntSet(1:2:9)
    end

    @testset "Symdiff" begin
        @test symdiff(IntSet([1, 2, 3, 4]), IntSet([2, 4, 5, 6])) ==
              symdiff(IntSet([2, 4, 5, 6]), IntSet([1, 2, 3, 4])) ==
              symdiff(IntSet([1, 2, 3, 4]), [2, 4, 5, 6]) ==
              symdiff(IntSet([2, 4, 5, 6]), [1, 2, 3, 4]) == IntSet([1, 3, 5, 6])
        @test symdiff(complement(IntSet()), IntSet(2:3)) ==
              symdiff(IntSet(2:3), complement(IntSet())) ==
              symdiff(complement(IntSet()), 2:3) ==complement(IntSet(2:3))

        @test symdiff(complement(IntSet(2:7)), IntSet(5:10)) ==
              symdiff(IntSet(5:10), complement(IntSet(2:7))) == complement(IntSet([2:4; 8:10]))
        @test symdiff(complement(IntSet(3:7)), complement(IntSet(5:10))) == IntSet([3:4; 8:10])
    end

    @testset "Subsets, equality" begin
        @test IntSet(2:2:10) < IntSet(1:10)
        @test !(IntSet(2:2:10) < IntSet(2:2:10))
        @test IntSet(2:2:10) <= IntSet(2:10)
        @test IntSet(2:2:10) <= IntSet(2:2:10)
        @test IntSet(1) < complement!(IntSet())
        @test IntSet(1) <= complement!(IntSet())
        @test !(IntSet(1) < complement!(IntSet(1)))
    end

    @testset "Test logic against Set" begin
        p = IntSet([0,1,4,5])
        resize!(p.bits, 6)
        q = IntSet([0,2,4,6])
        resize!(q.bits, 8)
        p′ = complement(p)
        q′ = complement(q)
        function collect10(itr)
            r = eltype(itr)[]
            for i in itr
                i > 10 && break
                push!(r, i)
            end
            r
        end
        a = Set(p)
        b = Set(q)
        a′ = Set(collect10(p′))
        b′ = Set(collect10(q′))
        for f in (union, intersect, setdiff, symdiff)
            @test collect(f(p, p)) == sort(collect(f(a, a)))
            @test collect(f(q, q)) == sort(collect(f(b, b)))
            @test collect(f(p, q)) == sort(collect(f(a, b)))
            @test collect(f(q, p)) == sort(collect(f(b, a)))

            @test collect10(f(p′, p)) == sort(collect(f(a′, a)))
            @test collect10(f(q′, q)) == sort(collect(f(b′, b)))
            @test collect10(f(p′, q)) == sort(collect(f(a′, b)))
            @test collect10(f(q′, p)) == sort(collect(f(b′, a)))

            @test collect10(f(p, p′)) == sort(collect(f(a, a′)))
            @test collect10(f(q, q′)) == sort(collect(f(b, b′)))
            @test collect10(f(p, q′)) == sort(collect(f(a, b′)))
            @test collect10(f(q, p′)) == sort(collect(f(b, a′)))

            @test collect10(f(p′, p′)) == sort(collect(f(a′, a′)))
            @test collect10(f(q′, q′)) == sort(collect(f(b′, b′)))
            @test collect10(f(p′, q′)) == sort(collect(f(a′, b′)))
            @test collect10(f(q′, p′)) == sort(collect(f(b′, a′)))
        end
    end

    @testset "other 1" begin
        s = IntSet()
        push!(s, 0, 2, 100)
        @test 0 in s
        @test !(1 in s)
        @test 2 in s
        @test 100 in s
        @test !(101 in s)
        @test !(1000 in s)
        @test first(s) == 0
        @test last(s) == 100
        @test s == IntSet([0, 2, 100])
        push!(s, 1000)
        @test [i for i in s] == [0, 2, 100, 1000]
        @test pop!(s) == 1000
        @test s == IntSet([0, 2, 100])
        @test hash(s) == hash(IntSet([0, 2, 100]))
    end

    @testset "other 2" begin
        b = 0:1000
        s = IntSet(b)
        @test collect(s) == collect(b)
        @test length(s) == length(b)
        @test pop!(s, 100) == 100
        @test collect(s) == [0:99; 101:1000]
        @test_throws KeyError pop!(s, 100)
        @test pop!(s, 100, 0) == 0
        @test pop!(s, 99, 0) == 99
        @test pop!(()->1, s, 99) == 1
        @test pop!(()->1, s, 98) == 98
    end

    @testset "show" begin
        show(IOBuffer(), IntSet())
        show(IOBuffer(), complement(IntSet()))
    end

end # @testset IntSet

# FIFO queue

"""
    Queue{T}() where {T}
    Queue{T}([blksize::Integer=1024])

Create a `Queue` object containing elements of type `T` for First In, First Out (FIFO) access.

# Parameters

- `T::Type` Queue element data type.
- `blksize::Integer=1024` Unrolled linked-list block size (in bytes). Default = 1024.

# Examples
```jldoctest
julia> q_int = Queue{Int64}() # create a queue with int elements
Queue{Int64}(Deque [Int64[]])

julia> q_float = Queue{Float64}() # create a queue with float elements
Queue{Float64}(Deque [Float64[]])
```
"""
mutable struct Queue{T}
    store::Deque{T}
end

Queue{T}() where {T} = Queue(Deque{T}())
Queue{T}(blksize::Integer) where {T} = Queue(Deque{T}(blksize))

"""
    isempty(q::Queue)

Check if queue `q` is empty.
"""
Base.isempty(q::Queue) = isempty(q.store)

"""
    length(q::Queue)

Return the number of elements in queue `q`.
"""
Base.length(q::Queue) = length(q.store)

"""
    eltype(::Type{Queue{T}}) where {T}

Return the type of the elements in the queue.
"""
Base.eltype(::Type{Queue{T}}) where {T} = T

"""
    first(q::Queue)

Get the first item from queue `q`.
"""
Base.first(q::Queue) = first(q.store)

"""
    last(q::Queue)

Get the last element in queue `q`.
"""
Base.last(s::Queue) = last(s.store)

"""
    push!(q::Queue, x)

Inserts the value `x` to the end of the queue `q`.
"""
function Base.push!(q::Queue, x)
    push!(q.store, x)
    return q
end

"""
    popfirst!(q::Queue)

Removes an element from the front of the queue `q` and returns it.
"""
Base.popfirst!(s::Queue) = popfirst!(s.store)

"""
    empty!(q::Queue)

Removes all elements from queue `q`.
"""
Base.empty!(s::Queue) = (empty!(s.store); s)

# Iterators

Base.iterate(q::Queue, s...) = iterate(q.store, s...)

Iterators.reverse(q::Queue) = Iterators.reverse(q.store)

"""
    ==(x::Queue, y::Queue)

Verify if queues `x` and `y` are equivalent in their contents.
"""
Base.:(==)(x::Queue, y::Queue) = x.store == y.store

@testset "CircularBuffer" begin

    @testset "Core Functionality" begin
        cb = CircularBuffer{Int}(5)
        @testset "When empty" begin
            @test length(cb) == 0
            @test capacity(cb) == 5
            @test_throws BoundsError first(cb)
            @test_throws BoundsError last(cb)
            @test isempty(cb) == true
            @test isfull(cb) == false
            @test eltype(cb) == Int
            @test eltype(typeof(cb)) == Int
        end

        @testset "With 1 element" begin
            push!(cb, 1)
            @test length(cb) == 1
            @test capacity(cb) == 5
            @test isfull(cb) == false
            @test first(cb) == last(cb)
        end

        @testset "Appending many elements" begin
            append!(cb, 2:8)
            @test length(cb) == capacity(cb)
            @test size(cb) == (length(cb),)
            @test isempty(cb) == false
            @test isfull(cb) == true
            @test convert(Array, cb) == Int[4,5,6,7,8]
        end

        @testset "getindex" begin
            @test cb[1] == 4
            @test cb[2] == 5
            @test cb[3] == 6
            @test cb[4] == 7
            @test cb[5] == 8
            @test_throws BoundsError cb[6]
            @test_throws BoundsError cb[3:6]
            @test cb[3:4] == Int[6,7]
            @test cb[[1,5]] == Int[4,8]
            @test first(cb) == 4
            @test last(cb) == 8
        end

        @testset "setindex" begin
            cb[3] = 999
            @test convert(Array, cb) == Int[4,5,999,7,8]
        end
    end

    @testset "other constructors" begin
        @testset "internal constructor" begin
            @test_throws ArgumentError CircularBuffer{Int64}(6,0,Vector{Int64}(undef,5))
            @test_throws ArgumentError CircularBuffer{Int64}(1,6,Vector{Int64}(undef,5))
        end
        @testset "capacity only" begin
            cb = CircularBuffer(10)
            @test length(cb) == 0
            @test typeof(cb) <: CircularBuffer{Any}
        end
        @testset "from vec inferred type with capacity" begin
            cb = CircularBuffer(1:5,10)
            @test length(cb) == 5
            @test typeof(cb) == CircularBuffer{Int}
        end
        @testset "from vec given type with capacity" begin
            cb = CircularBuffer{Float64}(1:5,10)
            @test length(cb) == 5
            @test typeof(cb) == CircularBuffer{Float64}
            @test collect(cb) == [1.0,2.0,3.0,4.0,5.0]
        end
        @testset "inferred capacity given type" begin
            cb = CircularBuffer{Float64}(1:5)
            @test length(cb) == 5
            @test typeof(cb) == CircularBuffer{Float64}
            @test collect(cb) == [1.0,2.0,3.0,4.0,5.0]
            @test capacity(cb) == 5
        end
        @testset "inferred capacity inferred type" begin
            cb = CircularBuffer(1:5)
            @test length(cb) == 5
            @test typeof(cb) == CircularBuffer{Int}
            @test collect(cb) == [1,2,3,4,5]
            @test capacity(cb) == 5
        end

    end

    @testset "pushfirst" begin
        cb = CircularBuffer{Int}(5)  # New, empty one for full test coverage
        for i in -5:5
            pushfirst!(cb, i)
        end
        arr = convert(Array, cb)
        @test arr == Int[5, 4, 3, 2, 1]
        for (idx, n) in enumerate(5:1)
            @test arr[idx] == n
        end
    end

    @testset "Issue 429" begin
        cb = CircularBuffer{Int}(5)
        map(x -> pushfirst!(cb, x), 1:8)
        pop!(cb)
        pushfirst!(cb, 9)
        @test length(cb.buffer) == cb.capacity
        arr = convert(Array, cb)
        @test arr == Int[9, 8, 7, 6, 5]
    end

    @testset "Issue 379" begin
        cb = CircularBuffer{Int}(5)
        pushfirst!(cb, 1)
        @test cb == [1]
        pushfirst!(cb, 2)
        @test cb == [2, 1]
    end

    @testset "empty!" begin
        cb = CircularBuffer{Int}(5)
        push!(cb, 13)
        empty!(cb)
        @test length(cb) == 0
    end

    @testset "pop!" begin
        cb = CircularBuffer{Int}(5)
        for i in 0:5    # one extra to force wraparound
            push!(cb, i)
        end
        for j in 5:-1:1
            @test pop!(cb) == j
            @test convert(Array, cb) == collect(1:j-1)
        end
        @test isempty(cb)
        @test_throws ArgumentError pop!(cb)
    end

    @testset "popfirst!" begin
        cb = CircularBuffer{Int}(5)
        for i in 0:5    # one extra to force wraparound
            push!(cb, i)
        end
        for j in 1:5
            @test popfirst!(cb) == j
            @test convert(Array, cb) == collect(j+1:5)
        end
        @test isempty(cb)
        @test_throws ArgumentError popfirst!(cb)
    end

    @testset "fill!" begin
        @testset "fill an empty buffer" begin
            cb = CircularBuffer{Int}(3)
            fill!(cb, 42)
            @test Array(cb) == [42, 42, 42]
        end
        @testset "fill a non empty buffer" begin
            cb = CircularBuffer{Int}(3)
            push!(cb, 21)
            fill!(cb, 42)
            @test Array(cb) == [21, 42, 42]
        end
    end

    @testset "Issue 754" begin
        cb = CircularBuffer{Int}(5)
        @test size(cb) == (0,)
        @test_throws InexactError push!(cb, 1.5)
        @test size(cb) == (0,)
        push!(cb, 1.0)
        @test size(cb) == (1,)
    end

    @testset "resize!" begin
        @testset "resize an empty buffer" begin
            cb = CircularBuffer{Int}(3)
            resize!(cb, 10)
            @test isempty(cb) && capacity(cb) == 10
        end
        @testset "resize a non empty buffer to smaller size" begin
            cb = CircularBuffer{Int}(10)
            append!(cb, -7:10)
            resize!(cb, 6)
            @test cb == 1:6
            append!(cb, 7:8)
            @test cb == 3:8
        end
        @testset "resize a non empty buffer to larger size" begin
            cb = CircularBuffer{Int}(10)
            append!(cb, -7:10)
            resize!(cb, 15)
            @test cb == 1:10
            append!(cb, 11:20)
            @test cb == 6:20
        end
    end
end

# Block-based deque
#######################################
#
#  DequeBlock
#
#######################################

mutable struct DequeBlock{T}
    data::Vector{T}  # only data[front:back] is valid
    capa::Int
    front::Int
    back::Int
    prev::DequeBlock{T}  # ref to previous block
    next::DequeBlock{T}  # ref to next block

    function DequeBlock{T}(capa::Int, front::Int) where T
        data = Vector{T}(undef, capa)
        blk = new{T}(data, capa, front, front-1)
        blk.prev = blk
        blk.next = blk
        return blk
    end
end

# block at the rear of the chain, elements towards the front
rear_deque_block(ty::Type{T}, n::Int) where {T} = DequeBlock{T}(n, 1)

# block at the head of the train, elements towards the back
head_deque_block(ty::Type{T}, n::Int) where {T} = DequeBlock{T}(n, n+1)

capacity(blk::DequeBlock) = blk.capa
Base.length(blk::DequeBlock) = blk.back - blk.front + 1
Base.isempty(blk::DequeBlock) = blk.back < blk.front
ishead(blk::DequeBlock) = blk.prev === blk
isrear(blk::DequeBlock) =  blk.next === blk


# reset the block to empty, and position

function reset!(blk::DequeBlock{T}, front::Int) where T
    blk.front = front
    blk.back = front - 1
    blk.prev = blk
    blk.next = blk
end

function Base.show(io::IO, blk::DequeBlock)  # avoids recursion into prev and next
    x = blk.data[blk.front:blk.back]
    print(io, "$(typeof(blk))(capa = $(blk.capa), front = $(blk.front), back = $(blk.back)): $x")
end


#######################################
#
#  Deque
#
#######################################

const DEFAULT_DEQUEUE_BLOCKSIZE = 1024

"""
    Deque{T}

The Deque type implements a double-ended queue using a list of blocks.
This data structure supports constant-time insertion/removal
of elements at both ends of a sequence.

"""
mutable struct Deque{T}
    nblocks::Int
    blksize::Int
    len::Int
    head::DequeBlock{T}
    rear::DequeBlock{T}

    function Deque{T}(blksize::Int) where T
        head = rear = rear_deque_block(T, blksize)
        new{T}(1, blksize, 0, head, rear)
    end

    Deque{T}() where {T} = Deque{T}(DEFAULT_DEQUEUE_BLOCKSIZE)
end

Base.isempty(q::Deque) = q.len == 0
Base.length(q::Deque) = q.len
num_blocks(q::Deque) = q.nblocks
Base.eltype(::Type{Deque{T}}) where T = T

"""
    first(q::Deque)

Returns the first element of the deque `q`.
"""
function Base.first(q::Deque)
    isempty(q) && throw(ArgumentError("Deque must be non-empty"))
    blk = q.head
    return blk.data[blk.front]
end

"""
    last(q::Deque)

Returns the last element of the deque `q`.
"""
function Base.last(q::Deque)
    isempty(q) && throw(ArgumentError("Deque must be non-empty"))
    blk = q.rear
    return blk.data[blk.back]
end


# Iteration

struct DequeIterator{T}
    q::Deque{T}
end

Base.last(qi::DequeIterator) = last(qi.q)

function Base.iterate(qi::DequeIterator{T}, (cb, i) = (qi.q.head, qi.q.head.front)) where T
    i > cb.back && return nothing
    x = cb.data[i]

    i += 1
    if i > cb.back && !isrear(cb)
        cb = cb.next
        i = 1
    end

    return (x, (cb, i))
end

# Backwards deque iteration

function Base.iterate(qi::Iterators.Reverse{<:Deque}, (cb, i) = (qi.itr.rear, qi.itr.rear.back))
    i < cb.front && return nothing
    x = cb.data[i]

    i -= 1
    # If we're past the beginning of a block, go to the previous one
    if i < cb.front && !ishead(cb)
        cb = cb.prev
        i = cb.back
    end

    return (x, (cb, i))
end

Base.iterate(q::Deque{T}, s...) where {T} = iterate(DequeIterator{T}(q), s...)

Base.length(qi::DequeIterator{T}) where {T} = qi.q.len

Base.collect(q::Deque{T}) where {T} = T[x for x in q]

# Showing

function Base.show(io::IO, q::Deque)
    print(io, "Deque [$(collect(q))]")
end

function Base.dump(io::IO, q::Deque)
    println(io, "Deque (length = $(q.len), nblocks = $(q.nblocks))")
    cb::DequeBlock = q.head
    i = 1
    while true
        print(io, "block $i [$(cb.front):$(cb.back)] ==> ")
        for j = cb.front : cb.back
            print(io, cb.data[j])
            print(io, ' ')
        end
        println(io)

        cb_next::DequeBlock = cb.next
        if cb !== cb_next
            cb = cb_next
            i += 1
        else
            break
        end
    end
end


# Manipulation

"""
    empty!(q::Deque{T})

Reset the deque.
"""
function Base.empty!(q::Deque{T}) where T
    # release all blocks except the head
    if q.nblocks > 1
        cb::DequeBlock{T} = q.rear
        while cb != q.head
            empty!(cb.data)
            cb = cb.prev
        end
    end

    # clean the head block (but retain the block itself)
    reset!(q.head, 1)

    # reset queue fields
    q.nblocks = 1
    q.len = 0
    q.rear = q.head
    return q
end


"""
    push!(q::Deque{T}, x)

Add an element to the back
"""
function Base.push!(q::Deque{T}, x) where T
    rear = q.rear

    if isempty(rear)
        rear.front = 1
        rear.back = 0
    end

    if rear.back < rear.capa
        @inbounds rear.data[rear.back += 1] = convert(T, x)
    else
        new_rear = rear_deque_block(T, q.blksize)
        new_rear.back = 1
        new_rear.data[1] = convert(T, x)
        new_rear.prev = rear
        q.rear = rear.next = new_rear
        q.nblocks += 1
    end
    q.len += 1
    return q
end

"""
    pushfirst!(q::Deque{T}, x)

Add an element to the front
"""
function Base.pushfirst!(q::Deque{T}, x) where T
    head = q.head

    if isempty(head)
        n = head.capa
        head.front = n + 1
        head.back = n
    end

    if head.front > 1
        @inbounds head.data[head.front -= 1] = convert(T, x)
    else
        n::Int = q.blksize
        new_head = head_deque_block(T, n)
        new_head.front = n
        new_head.data[n] = convert(T, x)
        new_head.next = head
        q.head = head.prev = new_head
        q.nblocks += 1
    end
    q.len += 1
    return q
end

"""
    pop!(q::Deque{T})

Remove the element at the back
"""
function Base.pop!(q::Deque{T}) where T
    isempty(q) && throw(ArgumentError("Deque must be non-empty"))
    rear = q.rear
    @assert rear.back >= rear.front

    @inbounds x = rear.data[rear.back]
    _unsetindex!(rear.data, rear.back) # see issue/884
    rear.back -= 1
    if rear.back < rear.front
        if q.nblocks > 1
            # release and detach the rear block
            empty!(rear.data)
            q.rear = rear.prev::DequeBlock{T}
            q.rear.next = q.rear
            q.nblocks -= 1
        end
    end
    q.len -= 1
    return x
end

"""
    popfirst!(q::Deque{T})

Remove the element at the front
"""
function Base.popfirst!(q::Deque{T}) where T
    isempty(q) && throw(ArgumentError("Deque must be non-empty"))
    head = q.head
    @assert head.back >= head.front

    @inbounds x = head.data[head.front]
    _unsetindex!(head.data, head.front) # see issue/884
    head.front += 1
    if head.back < head.front
        if q.nblocks > 1
            # release and detach the head block
            empty!(head.data)
            q.head = head.next::DequeBlock{T}
            q.head.prev = q.head
            q.nblocks -= 1
        end
    end
    q.len -= 1
    return x
end

const _deque_hashseed = UInt === UInt64 ? 0x950aa17a3246be82 : 0x4f26f881
function Base.hash(x::Deque, h::UInt)
    h += _deque_hashseed
    for (i, x) in enumerate(x)
        h += i * hash(x)
    end
    return h
end

function Base.:(==)(x::Deque, y::Deque)
    length(x) != length(y) && return false
    for (i, j) in zip(x, y)
        i == j || return false
    end
    return true
end

## This file implements 2-3 trees for sorted containers.
## The types and functions in this file are not exported; they
## are meant to be used by SortedDict, MultiMap and SortedSet.
## A 2-3 tree is a rooted trees in which all leaves are at the same
## depth (i.e., it is "balanced")
## and in which each internal node of the tree has either 2 or 3
## children.
## All the internal tree
## nodes are stored in an array of TreeNodes.  The bottom layer
## of internal tree nodes,
## called the "leaves" in this file, sit above one more layer
## of data nodes, which are stored in a different array.


## KDRec is one data node:
##  k: the key of the node
##  d: the data of the node
##  parent: the tree leaf that is the parent of this
##    node.  Parent pointers are needed in order
##    to implement tokens.
##  There are two constructors, the standard one (first)
##  and the incomplete one (second).  The incomplete constructor
##  is needed because when the data structure is first created,
##  there are no valid K or D values to store in the initial
##  data nodes.


macro invariant(expr)
end

macro invariant_support_statement(expr)
end


struct KDRec{K,D}
    parent::Int
    k::K
    d::D
    KDRec{K,D}(p::Int, k1::K, d1::D) where {K,D} = new{K,D}(p,k1,d1)
    KDRec{K,D}(p::Int) where {K,D} = new{K,D}(p)
end

## TreeNode is an internal node of the tree.
## child1,child2,child3:
##     These are the three children node numbers.
##     If the node is a 2-node (rather than 3), then child3 == 0.
##     If this is a leaf then child1,child2,child3 are subscripts
##       of data nodes, else they are subscripts  of other tree nodes.
## splitkey1:
##    the minimum key of the subtree at child2.  If this is a leaf
##    then it is the key of child2.
## splitkey2:
##    if child3 > 0 then splitkey2 is the minimum key of the subtree at child3.
##    If this is a leaf, then it is the key of child3.
## Again, there are two constructors for the same reason mentioned above.

struct TreeNode{K}
    child1::Int
    child2::Int
    child3::Int
    parent::Int
    splitkey1::K
    splitkey2::K
    TreeNode{K}(::Type{K}, c1::Int, c2::Int, c3::Int, p::Int) where {K} = new{K}(c1, c2, c3, p)
    TreeNode{K}(c1::Int, c2::Int, c3::Int, p::Int, sk1::K, sk2::K) where {K} =
        new{K}(c1, c2, c3, p, sk1, sk2)
end


## The next two functions are called to initialize the tree
## by inserting a dummy tree node with two children, the before-start
## marker whose index is 1 and the after-end marker whose index is 2.
## These two markers live in dummy data nodes.

function initializeTree!(tree::Vector{TreeNode{K}}) where K
    resize!(tree,1)
    tree[1] = TreeNode{K}(K, 1, 2, 0, 0)
    return nothing
end

function initializeData!(data::Vector{KDRec{K,D}}) where {K,D}
    resize!(data, 2)
    data[1] = KDRec{K,D}(1)
    data[2] = KDRec{K,D}(1)
    return nothing
end


## Type BalancedTree23{K,D,Ord} is 'base class' for
## SortedDict, SortedMultiDict and SortedSet.
## K = key type, D = data type
## Key type must support an ordering operation defined by Ordering
## object Ord.
## The default is Forward which implies that the ordering function
## is isless (see ordering.jl)
## The fields are as follows.
## ord: The ordering object.  Often the ordering type
##   is a singleton type, so this field is empty, but it
##   is still necessary to direct the multiple dispatch.
## data: the (key,data) pairs of the tree.
##   The first and second entries of the data array are dummy placeholders
##   for the beginning and end of the sorted order of the keys
## tree: the nodes of a 2-3 tree that sits above the data.
## rootloc: the index of the entry of tree (i.e., a subscript to
##   treenodes) that is the tree's root
## depth: the depth of the tree, (number
##    of tree levels, not counting the level of data at the bottom)
##    depth==1 means that there is a single root node
##      whose children are data nodes.
## freetreeinds: Array of indices of free locations in the
##    tree array (locations are freed due to deletion)
## freedatainds: Array of indices of free locations in the
##    data array (locations are freed due to deletion)
## useddatacells: BitSet (i.e., bit vector) showing which
##    data cells are taken.  The complementary positions are
##    exactly those stored in freedatainds.  This array is
##    used only for error checking.
## deletionchild and deletionleftkey are two work-arrays
## for the delete function.

mutable struct BalancedTree23{K, D, Ord <: Ordering}
    ord::Ord
    data::Vector{KDRec{K,D}}
    tree::Vector{TreeNode{K}}
    rootloc::Int
    depth::Int
    freetreeinds::Vector{Int}
    freedatainds::Vector{Int}
    useddatacells::BitSet
    # The next two arrays are used as a workspace by the delete!
    # function.
    deletionchild::Vector{Int}
    deletionleftkey::Vector{K}
    function BalancedTree23{K,D,Ord}(ord1::Ord) where {K,D,Ord<:Ordering}
        tree1 = Vector{TreeNode{K}}(undef, 1)
        initializeTree!(tree1)
        data1 = Vector{KDRec{K,D}}(undef, 2)
        initializeData!(data1)
        u1 = BitSet()
        push!(u1, 1, 2)
        new{K,D,Ord}(ord1, data1, tree1, 1, 1, Vector{Int}(), Vector{Int}(),
                     u1,
                     Vector{Int}(undef, 3), Vector{K}(undef, 3))
    end
end


## Function cmp2 checks a tree node with two children
## against a given key, and returns 1 if the given key is
## less than the node's splitkey or 2 else.  Special case
## if the node is a leaf and its right child is the end
## of the sorted order.

@inline function cmp2_nonleaf(o::Ordering,
                              treenode::TreeNode,
                              k)
    lt(o, k, treenode.splitkey1) ? 1 : 2
end


@inline function cmp2_leaf(o::Ordering,
                           treenode::TreeNode,
                           k)
    (treenode.child2 == 2) ||
    lt(o, k, treenode.splitkey1) ? 1 : 2
end


## Function cmp3 checks a tree node with three children
## against a given key, and returns 1 if the given key is
## less than the node's splitkey1, 2 if the key is greater than or
## equal to splitkey1 but less than splitkey2, or 3 else.  Special case
## if the node is a leaf and its right child is the end
## of the sorted order.

@inline function cmp3_nonleaf(o::Ordering,
                              treenode::TreeNode,
                              k)
    lt(o, k, treenode.splitkey1) ? 1 :
    lt(o, k, treenode.splitkey2) ? 2 : 3
end


@inline function cmp3_leaf(o::Ordering,
                           treenode::TreeNode,
                           k)
    lt(o, k, treenode.splitkey1) ?                           1 :
    (treenode.child3 == 2 || lt(o, k, treenode.splitkey2)) ? 2 : 3
end


## Function cmp2le checks a tree node with two children
## against a given key, and returns 1 if the given key is
## less than or equal to the node's splitkey or 2 else.  Special case
## if the node is a leaf and its right child is the end
## of the sorted order.

@inline function cmp2le_nonleaf(o::Ordering,
                                treenode::TreeNode,
                                k)
    !lt(o,treenode.splitkey1,k) ? 1 : 2
end


@inline function cmp2le_leaf(o::Ordering,
                             treenode::TreeNode,
                             k)
    treenode.child2 == 2 || !lt(o,treenode.splitkey1,k) ? 1 : 2
end


## Function cmp3le checks a tree node with three children
## against a given key, and returns 1 if the given key is
## less than or equal to the node's splitkey1, 2 if less than or equal
## to splitkey2, or
## 3 else. Special case
## if the node is a leaf and its right child is the end
## of the sorted order.

@inline function cmp3le_nonleaf(o::Ordering,
                                treenode::TreeNode,
                                k)
    !lt(o,treenode.splitkey1, k) ? 1 :
    !lt(o,treenode.splitkey2, k) ? 2 : 3
end

@inline function cmp3le_leaf(o::Ordering,
                             treenode::TreeNode,
                             k)
    !lt(o,treenode.splitkey1,k) ?                            1 :
    (treenode.child3 == 2 || !lt(o,treenode.splitkey2, k)) ? 2 : 3
end


## The empty! function deletes all data in the balanced tree.
## Therefore, it invalidates all indices.

function Base.empty!(t::BalancedTree23)
    resize!(t.data,2)
    initializeData!(t.data)
    resize!(t.tree,1)
    initializeTree!(t.tree)
    t.depth = 1
    t.rootloc = 1
    empty!(t.freetreeinds)
    empty!(t.freedatainds)
    empty!(t.useddatacells)
    push!(t.useddatacells, 1, 2)
    return nothing
end

## Default implementations of eq for Forward, Reverse
## and default ordering

eq(::ForwardOrdering, a, b) = isequal(a,b)
eq(::ReverseOrdering{ForwardOrdering}, a, b) = isequal(a,b)
eq(o::Ordering, a, b) = !lt(o, a, b) && !lt(o, b, a)


## The findkey function finds the index of a (key,data) pair in the tree
## where the given key lives (if it is present), or
## if the key is not present, to the lower bound for the key,
## i.e., the data item that comes immediately before it.
## If there are multiple equal keys, then it finds the last one.
## It returns the index of the key found and a boolean indicating
## whether the exact key was found or not.

function findkey(t::BalancedTree23, k)
    curnode = t.rootloc
    for depthcount = 1 : t.depth - 1
        @inbounds thisnode = t.tree[curnode]
        cmp = thisnode.child3 == 0 ?
                         cmp2_nonleaf(t.ord, thisnode, k) :
                         cmp3_nonleaf(t.ord, thisnode, k)
        curnode = cmp == 1 ? thisnode.child1 :
                  cmp == 2 ? thisnode.child2 : thisnode.child3
    end
    @inbounds thisnode = t.tree[curnode]
    cmp = thisnode.child3 == 0 ?
                cmp2_leaf(t.ord, thisnode, k) :
                cmp3_leaf(t.ord, thisnode, k)
    curnode = cmp == 1 ? thisnode.child1 :
              cmp == 2 ? thisnode.child2 : thisnode.child3
    @inbounds return curnode, (curnode > 2 && eq(t.ord, t.data[curnode].k, k))
end


## The findkeyless function finds the index of a (key,data) pair in the tree that
## with the greatest key that is less than the given key.  If there is no
## key less than the given key, then it returns 1 (the before-start node).

function findkeyless(t::BalancedTree23, k)
    curnode = t.rootloc
    for depthcount = 1 : t.depth - 1
        @inbounds thisnode = t.tree[curnode]
        cmp = thisnode.child3 == 0 ?
               cmp2le_nonleaf(t.ord, thisnode, k) :
               cmp3le_nonleaf(t.ord, thisnode, k)
        curnode = cmp == 1 ? thisnode.child1 :
                  cmp == 2 ? thisnode.child2 : thisnode.child3
    end
    @inbounds thisnode = t.tree[curnode]
    cmp = thisnode.child3 == 0 ?
            cmp2le_leaf(t.ord, thisnode, k) :
            cmp3le_leaf(t.ord, thisnode, k)
    curnode = cmp == 1 ? thisnode.child1 :
              cmp == 2 ? thisnode.child2 : thisnode.child3
    return curnode
end


## The following are helper routines for the insert! and delete! functions.
## They replace the 'parent' field of either an internal tree node or
## a data node at the bottom tree level.

function replaceparent!(data::Vector{KDRec{K,D}}, whichind::Int, newparent::Int) where {K,D}
    data[whichind] = KDRec{K,D}(newparent, data[whichind].k, data[whichind].d)
    return nothing
end

function replaceparent!(tree::Vector{TreeNode{K}}, whichind::Int, newparent::Int) where K
    tree[whichind] = TreeNode{K}(tree[whichind].child1, tree[whichind].child2,
                                 tree[whichind].child3, newparent,
                                 tree[whichind].splitkey1,
                                 tree[whichind].splitkey2)
    return nothing
end


## Helper function for either grabbing a brand new location in a
## array (if there are no free locations) or else grabbing a free
## location and marking it as used.  The return value is the
## index of the data just inserted into the vector.

function push_or_reuse!(a::Vector, freelocs::Vector{Int}, item)
    if isempty(freelocs)
        push!(a, item)
        return length(a)
    end
    loc = pop!(freelocs)
    a[loc] = item
    return loc
end


## Function insert! inserts a new data item into the tree.
## The arguments are the (K,D) pair to insert.
## The return values are a bool and an index.  The
## bool indicates whether the insertion inserted a new record (true) or
## whether it replaced an existing record (false).
## The index returned is the subscript in t.data where the
## inserted value sits.
## "allowdups" (i.e., "allow duplicate keys") means that no check is
## done whether the iterm
## is already in the tree, so insertion of a new item always succeeds.


function Base.insert!(t::BalancedTree23{K,D,Ord}, k, d, allowdups::Bool) where {K,D,Ord <: Ordering}

    ## First we find the greatest data node that is <= k.
    leafind, exactfound = findkey(t, k)
    parent = t.data[leafind].parent

    ## The following code is necessary because in the case of a
    ## brand new tree, the initial tree and data entries were incompletely
    ## initialized by the constructor.  In this case, the call to insert!
    ## underway carries
    ## valid K and D values, so these valid values may now be
    ## stored in the dummy placeholder nodes so that they no
    ## longer hold undefined references.

    if size(t.data,1) == 2
        @invariant t.rootloc == 1 && t.depth == 1
        t.tree[1] = TreeNode{K}(t.tree[1].child1, t.tree[1].child2,
                                t.tree[1].child3, t.tree[1].parent,
                                k, k)
        t.data[1] = KDRec{K,D}(t.data[1].parent, k, d)
        t.data[2] = KDRec{K,D}(t.data[2].parent, k, d)
    end

    ## If we have found exactly k in the tree, then we
    ## replace the data associated with k and return.

    if exactfound && !allowdups
        t.data[leafind] = KDRec{K,D}(parent, k,d)
        return false, leafind
    end

    # We get here if k was not already found in the tree or
    # if duplicates are allowed.
    # In this case we insert a new node.
    depth = t.depth
    ord = t.ord

    ## Store the new data item in the tree's data array.  Later
    ## go back and fix the parent.

    newind = push_or_reuse!(t.data, t.freedatainds, KDRec{K,D}(0,k,d))
    push!(t.useddatacells, newind)
    p1 = parent
    newchild = newind
    minkeynewchild = k
    splitroot = false
    curdepth = depth
    existingchild = leafind

    
    ## This loop ascends the tree (i.e., follows the path from a leaf to the root)
    ## starting from the parent p1 of
    ## where the new key k will go.
    ## Variables updated by the loop:
    ##   p1: parent of where the new node goes
    ##   newchild: index of the child to be inserted
    ##   minkeynewchild: the minimum key in the subtree rooted at newchild
    ##   existingchild: a child of p1; the newchild must
    ##      be inserted in the slot to the right of existingchild
    ##   curdepth: depth of newchild
    ## For each 3-node we encounter
    ## during the ascent, we add a new child, which requires splitting
    ## the 3-node into two 2-nodes.  Then we keep going until we hit the root.
    ## If we encounter a 2-node, then the ascent can stop; we can
    ## change the 2-node to a 3-node with the new child.

    while true


        # Let newchild1,...newchild4 be the new children of
        # the parent node
        # Initially, take the three children of the existing parent
        # node and set newchild4 to 0.

        newchild1 = t.tree[p1].child1
        newchild2 = t.tree[p1].child2
        minkeychild2 = t.tree[p1].splitkey1
        newchild3 = t.tree[p1].child3
        minkeychild3 = t.tree[p1].splitkey2
        p1parent = t.tree[p1].parent
        newchild4 = 0

        # Now figure out which of the 4 children is the new node
        # and insert it into newchild1 ... newchild4

        if newchild1 == existingchild
            newchild4 = newchild3
            minkeychild4 = minkeychild3
            newchild3 = newchild2
            minkeychild3 = minkeychild2
            newchild2 = newchild
            minkeychild2 = minkeynewchild
        elseif newchild2 == existingchild
            newchild4 = newchild3
            minkeychild4 = minkeychild3
            newchild3 = newchild
            minkeychild3 = minkeynewchild
        elseif newchild3 == existingchild
            newchild4 = newchild
            minkeychild4 = minkeynewchild
        else
            throw(AssertionError("Tree structure is corrupted 1"))
        end

        # Two cases: either we need to split the tree node
        # if newchild4>0 else we convert a 2-node to a 3-node
        # if newchild4==0

        if newchild4 == 0
            # Change the parent from a 2-node to a 3-node
            t.tree[p1] = TreeNode{K}(newchild1, newchild2, newchild3,
                                     p1parent, minkeychild2, minkeychild3)
            if curdepth == depth
                replaceparent!(t.data, newchild, p1)
            else
                replaceparent!(t.tree, newchild, p1)
            end
            break
        end
        # Split the parent
        t.tree[p1] = TreeNode{K}(newchild1, newchild2, 0,
                                 p1parent, minkeychild2, minkeychild2)
        newtreenode = TreeNode{K}(newchild3, newchild4, 0,
                                  p1parent, minkeychild4, minkeychild2)
        newparentnum = push_or_reuse!(t.tree, t.freetreeinds, newtreenode)
        if curdepth == depth
            replaceparent!(t.data, newchild2, p1)
            replaceparent!(t.data, newchild3, newparentnum)
            replaceparent!(t.data, newchild4, newparentnum)
        else
            replaceparent!(t.tree, newchild2, p1)
            replaceparent!(t.tree, newchild3, newparentnum)
            replaceparent!(t.tree, newchild4, newparentnum)
        end
        # Update the loop variables for the next level of the
        # ascension
        existingchild = p1
        newchild = newparentnum
        p1 = p1parent
        minkeynewchild = minkeychild3
        curdepth -= 1
        if curdepth == 0
            splitroot = true
            break
        end
    end

    # If the root has been split, then we need to add a level
    # to the tree that is the parent of the old root and the new node.

    if splitroot
        @invariant existingchild == t.rootloc
        newroot = TreeNode{K}(existingchild, newchild, 0,
                              0, minkeynewchild, minkeynewchild)
        
        newrootloc = push_or_reuse!(t.tree, t.freetreeinds, newroot)
        replaceparent!(t.tree, existingchild, newrootloc)
        replaceparent!(t.tree, newchild, newrootloc)
        t.rootloc = newrootloc
        t.depth += 1
    end
    return true, newind
end


## nextloc0: returns the next item in the tree according to the
## sort order, given an index i (subscript of t.data) of a current
## item.
## The routine returns 2 if there is no next item (i.e., we started
## from the last one in the sorted order).

function nextloc0(t, i::Int)
    ii = i
    @invariant i != 2 && i in t.useddatacells
    @inbounds p = t.data[i].parent
    nextchild = 0
    depthp = t.depth
    @inbounds while true
        if depthp < t.depth
            p = t.tree[ii].parent
        end
        if t.tree[p].child1 == ii
            nextchild = t.tree[p].child2
            break
        end
        if t.tree[p].child2 == ii && t.tree[p].child3 > 0
            nextchild = t.tree[p].child3
            break
        end
        ii = p
        depthp -= 1
    end
    @inbounds while true
        if depthp == t.depth
            return nextchild
        end
        p = nextchild
        nextchild = t.tree[p].child1
        depthp += 1
    end
end


## prevloc0: returns the previous item in the tree according to the
## sort order, given an index i (subscript of t.data) of a current
## item.
## The routine returns 1 if there is no previous item (i.e., we started
## from the first one in the sorted order).


function prevloc0(t::BalancedTree23, i::Int)
    @invariant i != 1 && i in t.useddatacells
    ii = i
    @inbounds p = t.data[i].parent
    prevchild = 0
    depthp = t.depth
    @inbounds while true
        if depthp < t.depth
            p = t.tree[ii].parent
        end
        if t.tree[p].child3 == ii
            prevchild = t.tree[p].child2
            break
        end
        if t.tree[p].child2 == ii
            prevchild = t.tree[p].child1
            break
        end
        ii = p
        depthp -= 1
    end
    @inbounds while true
        if depthp == t.depth
            return prevchild
        end
        p = prevchild
        c3 = t.tree[p].child3
        prevchild = c3 > 0 ? c3 : t.tree[p].child2
        depthp += 1
    end
end

## This function takes two indices into t.data and checks which
## one comes first in the sorted order by chasing them both
## up the tree until a common ancestor is found.
## The return value is -1 if i1 precedes i2, 0 if i1 == i2
##, 1 if i2 precedes i1.

function compareInd(t::BalancedTree23, i1::Int, i2::Int)
    @invariant(i1 in t.useddatacells && i2 in t.useddatacells)
    if i1 == i2
        return 0
    end
    i1a = i1
    i2a = i2
    p1 = t.data[i1].parent
    p2 = t.data[i2].parent
    @invariant_support_statement curdepth = t.depth
    curdepth = t.depth
    while true
        @invariant curdepth > 0
        if p1 == p2
            if i1a == t.tree[p1].child1
                @invariant t.tree[p1].child2 == i2a || t.tree[p1].child3 == i2a
                return -1
            end
            if i1a == t.tree[p1].child2
                if (t.tree[p1].child1 == i2a)
                    return 1
                end
                @invariant t.tree[p1].child3 == i2a
                return -1
            end
            @invariant i1a == t.tree[p1].child3
            @invariant t.tree[p1].child1 == i2a || t.tree[p1].child2 == i2a
            return 1
        end
        i1a = p1
        i2a = p2
        p1 = t.tree[i1a].parent
        p2 = t.tree[i2a].parent
        @invariant_support_statement curdepth -= 1
        curdepth -= 1
    end
end


## beginloc, endloc return the index (into t.data) of the first, last item in the
## sorted order of the tree.  beginloc works by going to the before-start marker
## (data node 1) and executing a next operation on it.  endloc is the opposite.

beginloc(t::BalancedTree23) = nextloc0(t,1)
endloc(t::BalancedTree23) = prevloc0(t,2)


## delete! routine deletes an entry from the balanced tree.

function Base.delete!(t::BalancedTree23{K,D,Ord}, it::Int) where {K,D,Ord<:Ordering}

    ## Put the cell indexed by 'it' into the deletion list.
    ##
    ## Create the following data items maintained in the
    ## upcoming loop.
    ##
    ## p is a tree-node ancestor of the deleted node
    ## The children of p are stored in
    ## t.deletionchild[..]
    ## The number of these children is newchildcount, which is 1, 2 or 3.
    ## The keys that lower bound the children
    ## are stored in t.deletionleftkey[..]
    ## There is a special case for t.deletionleftkey[1]; the
    ## flag deletionleftkey1_valid indicates that the left key
    ## for the immediate right neighbor of the
    ## deleted node has not yet been been stored in the tree.
    ## Once it is stored, t.deletionleftkey[1] is no longer needed
    ## or used.
    ## The flag mustdeleteroot means that the tree has contracted
    ## enough that it loses a level.

    p = t.data[it].parent
    newchildcount = 0
    c1 = t.tree[p].child1
    deletionleftkey1_valid = true
    if c1 != it
        deletionleftkey1_valid = false
        newchildcount += 1
        t.deletionchild[newchildcount] = c1
        t.deletionleftkey[newchildcount] = t.data[c1].k
    end
    c2 = t.tree[p].child2
    if c2 != it
        newchildcount += 1
        t.deletionchild[newchildcount] = c2
        t.deletionleftkey[newchildcount] = t.data[c2].k
    end
    c3 = t.tree[p].child3
    if c3 != it && c3 > 0
        newchildcount += 1
        t.deletionchild[newchildcount] = c3
        t.deletionleftkey[newchildcount] = t.data[c3].k
    end
    @invariant newchildcount == 1 || newchildcount == 2
    push!(t.freedatainds, it)
    pop!(t.useddatacells,it)
    defaultKey = t.tree[1].splitkey1
    curdepth = t.depth
    mustdeleteroot = false
    pparent = -1

    ## The following loop ascends the tree and contracts nodes (reduces their
    ## number of children) as
    ## needed.  If newchildcount == 2 or 3, then the ascent is terminated
    ## and a node is created with 2 or 3 children.
    ## If newchildcount == 1, then the ascent must continue since a tree
    ## node cannot have one child.

    while true
        pparent = t.tree[p].parent
        ## Simple cases when the new child count is 2 or 3
        if newchildcount == 2
            t.tree[p] = TreeNode{K}(t.deletionchild[1],
                                    t.deletionchild[2], 0, pparent,
                                    t.deletionleftkey[2], defaultKey)

            break
        end
        if newchildcount == 3
            t.tree[p] = TreeNode{K}(t.deletionchild[1], t.deletionchild[2],
                                    t.deletionchild[3], pparent,
                                    t.deletionleftkey[2], t.deletionleftkey[3])
            break
        end
        @invariant newchildcount == 1
        ## For the rest of this loop, we cover the case
        ## that p has one child.

        ## If newchildcount == 1 and curdepth==1, this means that
        ## the root of the tree has only one child.  In this case, we can
        ## delete the root and make its one child the new root (see below).

        if curdepth == 1
            mustdeleteroot = true
            break
        end

        ## We now branch on three cases depending on whether p is child1,
        ## child2 or child3 of its parent.

        if t.tree[pparent].child1 == p
            rightsib = t.tree[pparent].child2

            ## Here p is child1 and rightsib is child2.
            ## If rightsib has 2 children, then p and
            ## rightsib are merged into a single node
            ## that has three children.
            ## If rightsib has 3 children, then p and
            ## rightsib are reformed so that each has
            ## two children.

            if t.tree[rightsib].child3 == 0
                rc1 = t.tree[rightsib].child1
                rc2 = t.tree[rightsib].child2
                t.tree[p] = TreeNode{K}(t.deletionchild[1],
                                        rc1, rc2,
                                        pparent,
                                        t.tree[pparent].splitkey1,
                                        t.tree[rightsib].splitkey1)
                if curdepth == t.depth
                    replaceparent!(t.data, rc1, p)
                    replaceparent!(t.data, rc2, p)
                else
                    replaceparent!(t.tree, rc1, p)
                    replaceparent!(t.tree, rc2, p)
                end
                push!(t.freetreeinds, rightsib)
                newchildcount = 1
                t.deletionchild[1] = p
            else
                rc1 = t.tree[rightsib].child1
                t.tree[p] = TreeNode{K}(t.deletionchild[1], rc1, 0,
                                        pparent,
                                        t.tree[pparent].splitkey1,
                                        defaultKey)
                sk1 = t.tree[rightsib].splitkey1
                t.tree[rightsib] = TreeNode{K}(t.tree[rightsib].child2,
                                               t.tree[rightsib].child3,
                                               0,
                                               pparent,
                                               t.tree[rightsib].splitkey2,
                                               defaultKey)
                if curdepth == t.depth
                    replaceparent!(t.data, rc1, p)
                else
                    replaceparent!(t.tree, rc1, p)
                end
                newchildcount = 2
                t.deletionchild[1] = p
                t.deletionchild[2] = rightsib
                t.deletionleftkey[2] = sk1
            end

            ## If pparent had a third child (besides p and rightsib)
            ## then we add this to t.deletionchild

            c3 = t.tree[pparent].child3
            if c3 > 0
                newchildcount += 1
                t.deletionchild[newchildcount] = c3
                t.deletionleftkey[newchildcount] = t.tree[pparent].splitkey2
            end
            p = pparent
        elseif t.tree[pparent].child2 == p

            ## Here p is child2 and leftsib is child1.
            ## If leftsib has 2 children, then p and
            ## leftsib are merged into a single node
            ## that has three children.
            ## If leftsib has 3 children, then p and
            ## leftsib are reformed so that each has
            ## two children.

            leftsib = t.tree[pparent].child1
            lk = deletionleftkey1_valid ?
                      t.deletionleftkey[1] :
                      t.tree[pparent].splitkey1
            if t.tree[leftsib].child3 == 0
                lc1 = t.tree[leftsib].child1
                lc2 = t.tree[leftsib].child2
                t.tree[p] = TreeNode{K}(lc1, lc2,
                                        t.deletionchild[1],
                                        pparent,
                                        t.tree[leftsib].splitkey1,
                                        lk)
                if curdepth == t.depth
                    replaceparent!(t.data, lc1, p)
                    replaceparent!(t.data, lc2, p)
                else
                    replaceparent!(t.tree, lc1, p)
                    replaceparent!(t.tree, lc2, p)
                end
                push!(t.freetreeinds, leftsib)
                newchildcount = 1
                t.deletionchild[1] = p
            else
                lc3 = t.tree[leftsib].child3
                t.tree[p] = TreeNode{K}(lc3, t.deletionchild[1], 0,
                                        pparent, lk, defaultKey)
                sk2 = t.tree[leftsib].splitkey2
                t.tree[leftsib] = TreeNode{K}(t.tree[leftsib].child1,
                                              t.tree[leftsib].child2,
                                              0, pparent,
                                              t.tree[leftsib].splitkey1,
                                              defaultKey)
                if curdepth == t.depth
                    replaceparent!(t.data, lc3, p)
                else
                    replaceparent!(t.tree, lc3, p)
                end
                newchildcount = 2
                t.deletionchild[1] = leftsib
                t.deletionchild[2] = p
                t.deletionleftkey[2] = sk2
            end

            ## If pparent had a third child (besides p and leftsib)
            ## then we add this to t.deletionchild

            c3 = t.tree[pparent].child3
            if c3 > 0
                newchildcount += 1
                t.deletionchild[newchildcount] = c3
                t.deletionleftkey[newchildcount] = t.tree[pparent].splitkey2
            end
            p = pparent
            deletionleftkey1_valid = false
        else
            ## Here p is child3 and leftsib is child2.
            ## If leftsib has 2 children, then p and
            ## leftsib are merged into a single node
            ## that has three children.
            ## If leftsib has 3 children, then p and
            ## leftsib are reformed so that each has
            ## two children.

            @invariant t.tree[pparent].child3 == p
            leftsib = t.tree[pparent].child2
            lk = deletionleftkey1_valid ?
                       t.deletionleftkey[1] :
                       t.tree[pparent].splitkey2
            if t.tree[leftsib].child3 == 0
                lc1 = t.tree[leftsib].child1
                lc2 = t.tree[leftsib].child2
                t.tree[p] = TreeNode{K}(lc1, lc2,
                                        t.deletionchild[1],
                                        pparent,
                                        t.tree[leftsib].splitkey1,
                                        lk)
                if curdepth == t.depth
                    replaceparent!(t.data, lc1, p)
                    replaceparent!(t.data, lc2, p)
                else
                    replaceparent!(t.tree, lc1, p)
                    replaceparent!(t.tree, lc2, p)
                end
                push!(t.freetreeinds, leftsib)
                newchildcount = 2
                t.deletionchild[1] = t.tree[pparent].child1
                t.deletionleftkey[2] = t.tree[pparent].splitkey1
                t.deletionchild[2] = p
            else
                lc3 = t.tree[leftsib].child3
                t.tree[p] = TreeNode{K}(lc3, t.deletionchild[1], 0,
                                        pparent, lk, defaultKey)
                sk2 = t.tree[leftsib].splitkey2
                t.tree[leftsib] = TreeNode{K}(t.tree[leftsib].child1,
                                              t.tree[leftsib].child2,
                                              0, pparent,
                                              t.tree[leftsib].splitkey1,
                                              defaultKey)
                if curdepth == t.depth
                    replaceparent!(t.data, lc3, p)
                else
                    replaceparent!(t.tree, lc3, p)
                end
                newchildcount = 3
                t.deletionchild[1] = t.tree[pparent].child1
                t.deletionchild[2] = leftsib
                t.deletionchild[3] = p
                t.deletionleftkey[2] = t.tree[pparent].splitkey1
                t.deletionleftkey[3] = sk2
            end
            p = pparent
            deletionleftkey1_valid = false
        end
        curdepth -= 1
    end
    if mustdeleteroot
        @invariant !deletionleftkey1_valid
        @invariant p == t.rootloc
        t.rootloc = t.deletionchild[1]
        t.depth -= 1
        push!(t.freetreeinds, p)
    end

    ## If deletionleftkey1_valid, this means that the new
    ## min key of the deleted node and its right neighbors
    ## has never been stored in the tree.  It must be stored
    ## as splitkey1 or splitkey2 of some ancestor of the
    ## deleted node, so we continue ascending the tree
    ## until we find a node which has p (and therefore the
    ## deleted node) as its descendent through its second
    ## or third child.
    ## It cannot be the case that the deleted node is
    ## is a descendent of the root always through
    ## first children, since this would mean the deleted
    ## node is the leftmost placeholder, which
    ## cannot be deleted.

    if deletionleftkey1_valid
        while true
            pparentnode = t.tree[pparent]
            if pparentnode.child2 == p
                t.tree[pparent] = TreeNode{K}(pparentnode.child1,
                                              pparentnode.child2,
                                              pparentnode.child3,
                                              pparentnode.parent,
                                              t.deletionleftkey[1],
                                              pparentnode.splitkey2)
                break
            elseif pparentnode.child3 == p
                t.tree[pparent] = TreeNode{K}(pparentnode.child1,
                                              pparentnode.child2,
                                              pparentnode.child3,
                                              pparentnode.parent,
                                              pparentnode.splitkey1,
                                              t.deletionleftkey[1])
                break
            else
                p = pparent
                pparent = pparentnode.parent
                curdepth -= 1
                @invariant curdepth > 0
            end
        end
    end
    return nothing
end

# Build a balanced tree from an iterable in which the data is already
# sorted

function BalancedTree23{K,D,Ord}(::Val{true},
                                 iterable,
                                 ord::Ord,
                                 allowdups::Bool) where {K, D, Ord <: Ordering}
    m = BalancedTree23{K,D,Ord}(ord)
    lengthdata = length(m.data)
    @assert lengthdata == 2
    firsttrip = true
    for (k,d) in iterable
        # Must initialize the before-start and past-end markers
        # with live data to prevent references to undefined fields
        # later
        if firsttrip
            m.data[1] = KDRec{K,D}(m.data[1].parent, k, d)
            m.data[2] = KDRec{K,D}(m.data[2].parent, k, d)
        end

            
        if !firsttrip
            lt(ord, k, m.data[lengthdata].k) && throw(ArgumentError("Keys out of order"))
            if !allowdups 
                !lt(ord, m.data[lengthdata].k, k) && throw(ArgumentError("Repeated key"))
            end
        end
        push!(m.data, KDRec{K,D}(0, convert(K,k), convert(D,d)))
        lengthdata += 1
        push!(m.useddatacells, lengthdata)
        firsttrip = false
    end
    resize!(m.tree, 0)
    height = 0
    belowlevlength = lengthdata
    levbelowbaseind = 0
    child_belowaddress = Vector{Int}(undef, 3)
    child_keyaddress = Vector{Int}(undef, 3)
    keysbelow = Int[]
    newkeysbelow = Int[]

    while true  # loop on tree levels
        newlevbelowbaseind = length(m.tree)
        resize!(newkeysbelow, 0)
        # Loop over the nodes of the level below, stepping by 2's
        # to form the tree nodes on the new level.  One tree node (the
        # last one) may need to have three children if the
        # number of nodes on the level below is odd.
        for i = 1 : div(belowlevlength, 2)
            cbase = i * 2 - 2
            numchildren = (cbase == belowlevlength - 3) ? 3 : 2
            for whichc = 1  : numchildren
                i1 = cbase + whichc
                if height == 0
                    child_belowaddress[whichc] = (i1 == 1) ? 1 :
                        ((i1 == length(m.data)) ? 2 : i1 + 1)
                    child_keyaddress[whichc] = child_belowaddress[whichc]
                else
                    child_belowaddress[whichc] = levbelowbaseind + i1
                    child_keyaddress[whichc] = keysbelow[i1]
                end
            end
            if numchildren == 2
                child_belowaddress[3] = 0
                child_keyaddress[3] = child_keyaddress[2]
            end
            push!(newkeysbelow, child_keyaddress[1])
            push!(m.tree,
                  TreeNode{K}(child_belowaddress[1], child_belowaddress[2],
                              child_belowaddress[3], 0,
                              m.data[child_keyaddress[2]].k,
                              m.data[child_keyaddress[3]].k))
            myaddress = length(m.tree)
            if height == 0
                replaceparent!(m.data, child_belowaddress[1], myaddress)
                replaceparent!(m.data, child_belowaddress[2], myaddress)
                child_belowaddress[3] > 0 &&
                    replaceparent!(m.data, child_belowaddress[3], myaddress)
            else
                replaceparent!(m.tree, child_belowaddress[1], myaddress)
                replaceparent!(m.tree, child_belowaddress[2], myaddress)
                child_belowaddress[3] > 0 &&
                    replaceparent!(m.tree, child_belowaddress[3], myaddress)
            end
        end
        #update for the next level
        belowlevlength = length(m.tree) - newlevbelowbaseind
        keysbelow, newkeysbelow = newkeysbelow, keysbelow
        height += 1
        levbelowbaseind = newlevbelowbaseind
        belowlevlength == 1 && break  #root has been reached
    end
    m.rootloc = levbelowbaseind + 1
    m.depth = height
    m
end

mutable struct SplayTreeNode{K}
    leftChild::Union{SplayTreeNode{K}, Nothing}
    rightChild::Union{SplayTreeNode{K}, Nothing}
    parent::Union{SplayTreeNode{K}, Nothing}
    data::K

    SplayTreeNode{K}() where K = new{K}(nothing, nothing, nothing)
    SplayTreeNode{K}(d::K) where K = new{K}(nothing, nothing, nothing, d)
end

SplayTreeNode(d) = SplayTreeNode{Any}(d)
SplayTreeNode() = SplayTreeNode{Any}()

Base.setproperty!(x::SplayTreeNode{K}, f::Symbol, v) where {K} =
    setfield!(x, f, v)

mutable struct SplayTree{K}
    root::Union{SplayTreeNode{K}, Nothing}
    count::Int

    SplayTree{K}() where K = new{K}(nothing, 0)
end

Base.length(tree::SplayTree) = tree.count

SplayTree() = SplayTree{Any}()

function left_rotate!(tree::SplayTree, node_x::SplayTreeNode)
    node_y = node_x.rightChild
    node_x.rightChild = node_y.leftChild
    if node_y.leftChild != nothing
        node_y.leftChild.parent = node_x
    end
    node_y.parent = node_x.parent

    if node_x.parent == nothing
        tree.root = node_y
    elseif (node_x == node_x.parent.leftChild)
        node_x.parent.leftChild = node_y
    else
        node_x.parent.rightChild = node_y
    end
    if node_y != nothing
        node_y.leftChild = node_x
    end
    node_x.parent = node_y
end

function right_rotate!(tree::SplayTree, node_x::SplayTreeNode)
    node_y = node_x.leftChild
    node_x.leftChild = node_y.rightChild
    if node_y.rightChild != nothing
        node_y.rightChild.parent = node_x
    end
    node_y.parent = node_x.parent
    if node_x.parent == nothing
        tree.root = node_y
    elseif (node_x == node_x.parent.leftChild)
        node_x.parent.leftChild = node_y
    else
        node_x.parent.rightChild = node_y
    end
    node_y.rightChild = node_x
    node_x.parent = node_y
end

# The splaying operation moves node_x to the root of the tree using the series of rotations.
function splay!(tree::SplayTree, node_x::SplayTreeNode)
    while node_x.parent !== nothing
        parent = node_x.parent
        grand_parent = node_x.parent.parent
        if grand_parent === nothing
            # single rotation
            if node_x == parent.leftChild
                # zig rotation
                right_rotate!(tree, node_x.parent)
            else
                # zag rotation
                left_rotate!(tree, node_x.parent)
            end
            # double rotation
        elseif node_x == parent.leftChild && parent == grand_parent.leftChild
            # zig-zig rotation
            right_rotate!(tree, grand_parent)
            right_rotate!(tree, parent)
        elseif node_x == parent.rightChild && parent == grand_parent.rightChild
            # zag-zag rotation
            left_rotate!(tree, grand_parent)
            left_rotate!(tree, parent)
        elseif node_x == parent.rightChild && parent == grand_parent.leftChild
            # zig-zag rotation
            left_rotate!(tree, node_x.parent)
            right_rotate!(tree, node_x.parent)
        else
            # zag-zig rotation
            right_rotate!(tree, node_x.parent)
            left_rotate!(tree, node_x.parent)
        end
    end
end

function maximum_node(node::Union{SplayTreeNode, Nothing})
    (node == nothing) && return node
    while node.rightChild != nothing
        node = node.rightChild
    end
    return node
end

# Join operations joins two trees S and T
# All the items in S are smaller than the items in T.
# This is a two-step process.
# In the first step, splay the largest node in S. This moves the largest node to the root node.
# In the second step, set the right child of the new root of S to T.
function _join!(tree::SplayTree, s::Union{SplayTreeNode, Nothing}, t::Union{SplayTreeNode, Nothing})
    if s === nothing
        return t
    elseif t === nothing
        return s
    else
        x = maximum_node(s)
        splay!(tree, x)
        x.rightChild = t
        t.parent = x
        return x
    end
end

function search_node(tree::SplayTree{K}, d::K) where K
    node = tree.root
    prev = nothing
    while node != nothing && node.data != d
        prev = node
        if node.data < d
            node = node.rightChild
        else
            node = node.leftChild
        end
    end
    return (node == nothing) ? prev : node
end

function Base.haskey(tree::SplayTree{K}, d::K) where K
    node = tree.root
    if node === nothing
        return false
    else
        node = search_node(tree, d)
        (node === nothing) && return false
        is_found = (node.data == d)
        is_found && splay!(tree, node)
        return is_found
    end
end

Base.in(key, tree::SplayTree) = haskey(tree, key)

function Base.delete!(tree::SplayTree{K}, d::K) where K
    node = tree.root
    x = search_node(tree, d)
    (x == nothing) && return tree
    t = nothing
    s = nothing

    splay!(tree, x)

    if x.rightChild !== nothing
        t = x.rightChild
        t.parent = nothing
    end

    s = x
    s.rightChild = nothing

    if s.leftChild !== nothing
        s.leftChild.parent = nothing
    end

    tree.root = _join!(tree, s.leftChild, t)
    tree.count -= 1
    return tree
end

function Base.push!(tree::SplayTree{K}, d0) where K
    d = convert(K, d0)
    is_present = search_node(tree, d)
    if (is_present !== nothing) && (is_present.data == d)
        return tree
    end
    # only unique keys are inserted
    node = SplayTreeNode{K}(d)
    y = nothing
    x = tree.root

    while x !== nothing
        y = x
        if node.data > x.data
            x = x.rightChild
        else
            x = x.leftChild
        end
    end
    node.parent = y

    if y === nothing
        tree.root = node
    elseif node.data < y.data
        y.leftChild = node
    else
        y.rightChild = node
    end
    splay!(tree, node)
    tree.count += 1
    return tree
end

function Base.getindex(tree::SplayTree{K}, ind) where K
    @boundscheck (1 <= ind <= tree.count) || throw(KeyError("$ind should be in between 1 and $(tree.count)"))
    function traverse_tree_inorder(node::Union{SplayTreeNode, Nothing})
        if (node != nothing)
            left = traverse_tree_inorder(node.leftChild)
            right = traverse_tree_inorder(node.rightChild)
            append!(push!(left, node.data), right)
        else
            return K[]
        end
    end
    arr = traverse_tree_inorder(tree.root)
    return @inbounds arr[ind]
end

using Base: Ordering, Forward, Reverse, ForwardOrdering, ReverseOrdering
using DataStructures: IntSemiToken
import Base.lt
import DataStructures.eq


struct CaseInsensitive <: Ordering
end

lt(::CaseInsensitive, a, b) = isless(lowercase(a), lowercase(b))
eq(::CaseInsensitive, a, b) = isequal(lowercase(a), lowercase(b))



# For testing order objects

struct ForBack <: Ordering
    flag::Bool
end

lt(o::ForBack, a, b) = o.flag ? isless(a,b) : isless(b,a)


@noinline my_assert(stmt) = stmt ? nothing : throw(AssertionError("assertion failed"))

function my_primes(N)
    w = Vector{Bool}(undef, N)
    fill!(w,true)
    for k = 2 : N
        if w[k]
            w[2 * k : k : N] .= false
        end
    end
    p = Int[]
    for k = 2 : N
        if w[k]
            push!(p,k)
        end
    end
    p
end

remove_spaces(s::String) = replace(s, r"\s+"=>"")




## Function checkcorrectness checks a balanced tree for correctness.

function checkcorrectness(t::DataStructures.BalancedTree23{K,D,Ord},
                          allowdups=false)  where {K,D,Ord <: Ordering}
    dsz = size(t.data, 1)
    tsz = size(t.tree, 1)
    r = t.rootloc
    bfstreenodes = Vector{Int}()
    tdpth = t.depth
    intree = BitSet()
    levstart = Vector{Int}(undef, tdpth)
    push!(bfstreenodes, r)
    levstart[1] = 1
    push!(intree, r)
    for curdepth = 2 : tdpth
        levstart[curdepth] = size(bfstreenodes, 1) + 1
        for l = levstart[curdepth - 1] : levstart[curdepth] - 1
            anc = bfstreenodes[l]
            c1 = t.tree[anc].child1
            if in(c1, intree)
                println("anc = $anc c1 = $c1")
                throw(ErrorException("Tree contains loops 1"))
            end
            push!(bfstreenodes, c1)
            push!(intree, c1)
            c2 = t.tree[anc].child2
            if in(c2, intree)
                throw(ErrorException("Tree contains loops 2"))
            end
            push!(bfstreenodes, c2)
            push!(intree, c2)
            c3 = t.tree[anc].child3
            if c3 > 0
                if in(c3, intree)
                    throw(ErrorException("Tree contains loops 3"))
                end
                push!(bfstreenodes, c3)
                push!(intree, c3)
            end
        end
    end
    bfstreesize = size(bfstreenodes, 1)
    dataused = BitSet()
    minkeys = Vector{K}(undef, bfstreesize)
    maxkeys = Vector{K}(undef, bfstreesize)
    for s = levstart[tdpth] : bfstreesize
        anc = bfstreenodes[s]
        c1 = t.tree[anc].child1
        if s == levstart[tdpth]
            if c1 != 1
                throw(ErrorException("Leftmost data descendant should be node 1"))
            end
        else
            minkeys[s] = t.data[c1].k
        end
        c2 = t.tree[anc].child2
        c3 = t.tree[anc].child3
        lastchild = c3 > 0 ? c3 : c2
        if s == bfstreesize
            if lastchild != 2
                throw(ErrorException("Rightmost data descendant should be node 2"))
            end
        else
            maxkeys[s] = t.data[lastchild].k
        end
        if s > levstart[tdpth] &&
            (lt(t.ord, minkeys[s], maxkeys[s - 1]) ||
             (!lt(t.ord, maxkeys[s-1],minkeys[s]) && !allowdups))
            println("tdpth = ", tdpth, " s = ", s,
                    " maxkeys[s-1] = ", maxkeys[s-1],
                    " minkeys[s] = ", minkeys[s])
            throw(ErrorException("Data nodes out of order"))
        end
        if s < bfstreesize || c3 > 0
            if !eq(t.ord, t.tree[anc].splitkey1, t.data[c2].k)
                throw(ErrorException("Splitkey1 of leaf should match key of 2nd child"))
            end
        end
        if s < bfstreesize && c3 > 0
            if !eq(t.ord, t.tree[anc].splitkey2, t.data[c3].k)
                throw(ErrorException("Splitkey2 of leaf should match key of 1st child"))
            end
        end
        if t.data[c1].parent != anc || t.data[c2].parent != anc ||
            (c3 > 0 && t.data[c3].parent != anc)
            println("c1 = $c1 c2 = $c2 c3 = $c3 anc = $anc")
            println("t.data[c1].parent = $(t.data[c1].parent) t.data[c2].parent = $(t.data[c2].parent)")
            if c3 > 0
                println("t.data[c3].parent = $(t.data[c3].parent)")
            end
            throw(ErrorException("Incorrect parent node for data child"))
        end
        push!(dataused, c1)
        push!(dataused, c2)
        if c3 > 0
            push!(dataused, c3)
        end
    end
    for curdepth = tdpth - 1 : -1 : 1
        cp = levstart[curdepth + 1]
        for s = levstart[curdepth] : levstart[curdepth + 1] - 1
            anc = bfstreenodes[s]
            c1 = t.tree[anc].child1
            my_assert(c1 == bfstreenodes[cp])
            if s > levstart[curdepth]
                mk1 = minkeys[cp]
            end
            cp += 1
            if t.tree[c1].parent != anc
                throw(ErrorException("Parent/child1 links do not match"))
            end
            c2 = t.tree[anc].child2
            my_assert(c2 == bfstreenodes[cp])
            mk2 = minkeys[cp]
            cp += 1
            if t.tree[c2].parent != anc
                throw(ErrorException("Parent/child2 links do not match"))
            end
            c3 = t.tree[anc].child3
            my_assert(s == levstart[curdepth] ||
                    lt(t.ord,mk1,mk2) || (!lt(t.ord,mk2,mk1) && allowdups))
            if c3 > 0
                if t.tree[c3].parent != anc
                    throw(ErrorException("Parent/child3 links do not match"))
                end
                mk3 = minkeys[cp]
                cp += 1
                my_assert(lt(t.ord,mk2, mk3) ||
                        !lt(t.ord,mk3,mk2) && allowdups)
            end
            if s > levstart[curdepth]
                minkeys[s] = mk1
            end
            if !eq(t.ord, t.tree[anc].splitkey1, mk2)
                throw(ErrorException("Minkey2 not equal to minimum key among descendants of child2"))
            end
            if c3 > 0 && !eq(t.ord, t.tree[anc].splitkey2, mk3)
                throw(ErrorException("Minkey3 not equal to minimum key among descendants of child3"))
            end
        end
    end
    freedata = BitSet()
    for i = 1 : size(t.freedatainds,1)
        fdi = t.freedatainds[i]
        if in(fdi, freedata)
            throw(ErrorException("t.freedatainds has repeated element $i"))
        end
        if fdi < 1 || fdi > dsz
            throw(ErrorException("t.freedatainds entry out of range"))
        end
        push!(freedata, fdi)
    end
    if last(t.useddatacells) > dsz
        throw(ErrorException("t.useddatacells has indices larger than t.data size"))
    end
    for i = 1 : dsz
        if (in(i, dataused) && !in(i, t.useddatacells)) ||
            (!in(i,dataused) && in(i, t.useddatacells))
            throw(ErrorException("Mismatch between actual data cells used and useddatacells array"))
        end
        if (in(i, freedata) && in(i, dataused)) ||
            (!in(i,freedata) && !in(i, dataused))
            throw(ErrorException("Mismatch between t.freedatainds and t.useddatacells"))
        end
    end
    freetree = BitSet()
    for i = 1 : size(t.freetreeinds,1)
        tfi = t.freetreeinds[i]
        if in(tfi, freetree)
            throw(ErrorException("Free tree index repeated twice"))
        end
        if tfi < 1 || tfi > tsz
            throw(ErrorException("Free tree index out of range"))
        end
        push!(freetree, tfi)
    end
    for i = 1 : tsz
        if (!in(i, intree) && !in(i, freetree)) ||
            (in(i, intree) && in(i, freetree))
            throw(ErrorException("Mismatch between t.freetreeinds and actual cells used"))
        end
    end
end




function testSortedDictBasic()
    # a few basic tests of SortedDict to start
    m1 = SortedDict((Dict{String,String}()), Forward)
    my_assert(typeof(m1) == SortedDict{String, String, ForwardOrdering})
    kdarray = ["hello", "jello", "alpha", "beta", "fortune", "random",
               "july", "wednesday"]
    checkcorrectness(m1.bt, false)
    for i = 1 : div(size(kdarray,1), 2)
        k = kdarray[i*2-1]
        d = kdarray[i*2]
        #println("- inserting: k = $k d = $d")
        m1[k] = d
        checkcorrectness(m1.bt, false)
        # fulldump(m1.bt)
    end
    i1 = firstindex(m1)
    count = 0
    while i1 != pastendsemitoken(m1)
        count += 1
        k,d = deref((m1,i1))
        #println("+ reading: k = $k, d = $d")
        i1 = advance((m1,i1))
        checkcorrectness(m1.bt, false)
    end
    my_assert(count == 4)
    # Check that issue 239 (cf 781) is resolved
    ks = ["a", "c", "b"]
    vs = [1,2,3]
    s = SortedDict(zip(ks,vs))
    my_assert(keytype(s) == String)
    my_assert(valtype(s) == Int)
    true
end

function testSortedDictMethods()
    # test all methods of SortedDict here except loops
    m0 = SortedDict(Dict{Int, Float64}())
    my_assert(typeof(m0) == SortedDict{Int,Float64,ForwardOrdering})
    m1 = SortedDict(Dict(8=>32.0, 12=>33.1, 6=>18.2))
    my_assert(typeof(m1) == SortedDict{Int,Float64,ForwardOrdering})
    m01 = SortedDict(8=>32.0, 12=>33.1, 6=>18.2)
    my_assert(typeof(m01) == SortedDict{Int,Float64,ForwardOrdering})
    m11 = SortedDict((8=>32.0, 12=>33.1, 6=>18.2))
    my_assert(typeof(m11) == SortedDict{Int,Float64,ForwardOrdering})
    m02 = SortedDict{Int,Float64}()
    my_assert(typeof(m02) == SortedDict{Int,Float64,ForwardOrdering})
    m03 = SortedDict([(1,2.0), (3,4.0), (5,6.0)])
    my_assert(typeof(m03) == SortedDict{Int,Float64,ForwardOrdering})
    m04 = SortedDict{Int,Float64}(Pair[1=>1, 2=>2.0])
    my_assert(typeof(m04) == SortedDict{Int,Float64,ForwardOrdering})
    m05 = SortedDict{Int,Float64}(Reverse, Pair[1=>1, 2=>2.0])
    my_assert(typeof(m05) == SortedDict{Int,Float64,ReverseOrdering{ForwardOrdering}})
    m06a = SortedDict(Pair[1=>2.0, 3=>'a'])
    my_assert(typeof(m06a) == SortedDict{Int,Any,ForwardOrdering})
    m06b = SortedDict([(1,2.0), (3,'a')])
    my_assert(typeof(m06b) == SortedDict{Int,Any,ForwardOrdering})
    m07a = SortedDict(Pair[1.0=>2, 2=>3])
    my_assert(typeof(m07a) == SortedDict{Real, Int, ForwardOrdering})
    m07b = SortedDict([(1.0,2), (2,3)])
    my_assert(typeof(m07b) == SortedDict{Real,Int,ForwardOrdering})
    m08a = SortedDict(Pair[1.0=>2, 2=>'a'])
    my_assert(typeof(m08a) == SortedDict{Real,Any,ForwardOrdering})
    m08b = SortedDict([(1.0,2), (2,'a')])
    my_assert(typeof(m08b) == SortedDict{Real,Any,ForwardOrdering})
    m09a = SortedDict(Pair{Int}[1=>2, 3=>'a'])
    my_assert(typeof(m09a) == SortedDict{Int,Any,ForwardOrdering})
    m09b = SortedDict([(1,2), (3,'a')])  # test issue 239
    my_assert(typeof(m09a) == SortedDict{Int,Any,ForwardOrdering})

    my_assert(m0 == m02)
    my_assert(isequal(m0, m02))
    my_assert(m1 == m01)
    my_assert(isequal(m1, m01))
    my_assert(m1 == m11)
    my_assert(isequal(m1, m11))

    # Test Exceptions
    @test_throws ArgumentError SortedDict([1,2,3,4])
    @test_throws BoundsError SortedDict{Int,Int}([1,2,3,4])


    expected = ([6,8,12], [18.2, 32.0, 33.1])
    checkcorrectness(m1.bt, false)
    ii = firstindex(m1)
    m2 = packdeepcopy(m1)
    m3 = packcopy(m1)
    p = first(m1)
    my_assert(p[1] == 6 && p[2] == 18.2)
    my_assert(in(Pair(8,32.0),m3))
    my_assert(!in(Pair(8,32.1),m3))
    push!(m1, 12 => 33.2)
    checkcorrectness(m1.bt, false)
    my_assert(length(m1) == 3)
    my_assert(m1[12] == 33.2)
    push!(m1, 12 => 33.1)
    my_assert(length(m1) == 3)
    my_assert(m1[12] == 33.1)
    for j = 1 : 3
        my_assert(ii != pastendsemitoken(m1))
        pr = deref((m1,ii))
        my_assert(pr[1] == expected[1][j] && pr[2] == expected[2][j])
        checkcorrectness(m1.bt, false)
        oldii = ii
        ii = advance((m1,ii))
        delete!((m1,oldii))
    end
    checkcorrectness(m1.bt, false)
    checkcorrectness(m2.bt, false)
    my_assert(length(m2) == 3)
    ii = firstindex(m2)
    for j = 1 : 3
        pr = deref((m2,ii))
        my_assert(pr[1] == expected[1][j] && pr[2] == expected[2][j])
        ii = advance((m2,ii))
    end

    checkcorrectness(m3.bt, false)
    my_assert(length(m3) == 3)
    ii = firstindex(m3)
    for j = 1 : 3
        pr = deref((m3,ii))
        my_assert(pr[1] == expected[1][j] && pr[2] == expected[2][j])
        ii = advance((m3,ii))
    end

    my_assert(isempty(m1))
    my_assert(length(m1) == 0)
    N = 1000
    for i = N : -1 : 2
        m1[i] = convert(Float64,i) ^ 2
        if i % 200 == 0
            checkcorrectness(m1.bt, false)
        end
    end
    my_assert(!isempty(m1))
    my_assert(length(m1) == N - 1)
    for i = 2 : N
        d = pop!(m1, i)
        my_assert(d == convert(Float64,i)^2)
        if i % 200 == 0
            checkcorrectness(m1.bt, false)
        end
    end
    my_assert(isempty(m1))
    my_assert(length(m1) == 0)
    N = 1000
    for i = 2:N
        m1[i] = convert(Float64,i) ^ 2
    end
    my_assert(!isempty(m1))
    my_assert(length(m1) == N - 1)
    for i = 2 : N
        d = pop!(m1, i, -1.0)
        my_assert(d == convert(Float64,i)^2)
        d2 = pop!(m1, i, -1.0)
        my_assert(d2 == -1.0)
        d3 = pop!(m1, i, nothing)
        my_assert(d3 == nothing)

        if i % 200 == 0
            checkcorrectness(m1.bt, false)
        end
    end
    my_assert(isempty(m1))
    my_assert(length(m1) == 0)
    for i = N : -1 : 2
        m1[i] = convert(Float64,i) ^ 2
        if i % 200 == 0
            checkcorrectness(m1.bt, false)
        end
    end
    ii = lastindex(m1)
    for i = 1 : N - 1
        pr = deref((m1,ii))
        my_assert(pr[1] == N + 1 - i && pr[2] == convert(Float64,pr[1]) ^ 2)
        ii = regress((m1,ii))
    end
    lastprime = 1
    while true
        ii = searchsortedafter(m1, lastprime)
        if ii == pastendsemitoken(m1)
            break
        end
        j = deref_key((m1,ii))
        for k = j * 2 : j : N
            p = findkey(m1, k)
            if p != pastendsemitoken(m1)
                delete!((m1,p))
            end
        end
        lastprime = j
    end
    checkcorrectness(m1.bt, false)
    my_assert(ii == pastendsemitoken(m1))
    my_assert(status((m1,ii)) == 3)
    my_assert(status((m1,IntSemiToken(-1))) == 0)
    t = 0
    u = 0.0
    for pr in m1
        t += pr[1]
        u += pr[2]
    end
    numprimes = length(m1)
    pn = convert(Array{Int64}, my_primes(N))
    my_assert(t == sum(pn))
    my_assert(u == sum(pn.^2))
    ij = lastindex(m1)
    my_assert(deref_key((m1,ij)) == last(pn) &&
       convert(Float64, last(pn)^2) ==  deref_value((m1,ij)))
    m1[6] = 49.0
    my_assert(length(m1) == numprimes + 1)
    my_assert(m1[6] == 49.0)
    b, i6 = push_return_semitoken!(m1, 6=>50.0)
    my_assert(length(m1) == numprimes + 1)
    my_assert(!b)
    p = deref((m1,i6))
    my_assert(p[1] == 6 && p[2] == 50.0)
    m1[i6] = 9.0
    p = deref((m1,i6))
    my_assert(p[1] == 6 && p[2] == 9.0)
    my_assert(m1[i6] == 9.0)
    b2, i7 = push_return_semitoken!(m1, 8=>51.0)
    my_assert(b2)
    my_assert(length(m1) == numprimes + 2)
    p = deref((m1,i7))
    my_assert(p[1] == 8 && p[2] == 51.0)
    delete!((m1,i7))
    z = pop!(m1, 6)
    checkcorrectness(m1.bt, false)
    my_assert(z == 9.0)
    i8 = firstindex(m1)
    p = deref((m1,i8))
    my_assert(p[1] == 2 && p[2] == 4.0)
    my_assert(i8 != beforestartsemitoken(m1))
    my_assert(status((m1,i8)) == 1)
    i9 = regress((m1,i8))
    my_assert(i9 == beforestartsemitoken(m1))
    my_assert(status((m1,i9)) == 2)
    i10 = findkey(m1, 17)
    i11 = regress((m1,i10))
    my_assert(deref_key((m1,i11)) == 13)
    i12 = searchsortedfirst(m1, 47)
    i13 = searchsortedfirst(m1, 48)
    my_assert(deref_key((m1,i12)) == 47)
    my_assert(deref_key((m1,i13)) == 53)
    i14 = searchsortedafter(m1, 47)
    i15 = searchsortedafter(m1, 48)
    my_assert(deref_key((m1,i14)) == 53)
    my_assert(deref_key((m1,i15)) == 53)
    i16 = searchsortedlast(m1, 47)
    i17 = searchsortedlast(m1, 48)
    my_assert(deref_key((m1,i16)) == 47)
    my_assert(deref_key((m1,i17)) == 47)
    ww = my_primes(N)
    cc = last(m1)
    my_assert(cc[1] == last(ww))
    wwx = first(m1)
    my_assert(wwx[1] == 2)
    tpr = eltype(m1)
    my_assert(tpr == Pair{Int,Float64})
    tpr2 = eltype(typeof(m1))
    my_assert(tpr2 == Pair{Int,Float64})
    kt = keytype(m1)
    my_assert(kt == Int)
    kt2 = keytype(typeof(m1))
    my_assert(kt2 == Int)
    vt = valtype(m1)
    my_assert(vt == Float64)
    vt2 = valtype(typeof(m1))
    my_assert(vt2 == Float64)
    my_assert(ordtype(m1) == ForwardOrdering)
    my_assert(ordtype(typeof(m1)) == ForwardOrdering)

    co = orderobject(m1)
    my_assert(co == Forward)
    my_assert(haskey(m1, 71))
    my_assert(!haskey(m1, 77))
    my_assert(get(m1, 70, nothing) == nothing)
    my_assert(get(m1, 70, -45.2) == -45.2)
    my_assert(get(m1, 83, -45.2) == convert(Float64,83)^2)
    h = get!(m1, 5, 27.0)
    my_assert(h == 25.0)
    h = get!(m1, 6, 27.0)
    my_assert(h == 27.0)
    my_assert(m1[6] == 27.0)
    my_assert(length(m1) == length(ww) + 1)
    pop!(m1, 6)
    my_assert(getkey(m1,7, 9) == 7)
    my_assert(getkey(m1,7.0, 9) == 7)
    my_assert(getkey(m1,12, 9) == 9)
    my_assert(getkey(m1,12, nothing) == nothing)
    delete!(m1, 17)
    my_assert(length(m1) == length(ww) - 1)
    my_assert(deref_key((m1,advance((m1,findkey(m1,13))))) == 19)
    empty!(m1)
    checkcorrectness(m1.bt, false)
    my_assert(isempty(m1))
    c1 = SortedDict(Dict("Eggplants"=>3,
                        "Figs"=>9,
                        "Apples"=>7))
    my_assert(typeof(c1) == SortedDict{String, Int, ForwardOrdering})
    c2 = SortedDict(Dict("Eggplants"=>6,
                        "Honeydews"=>19,
                        "Melons"=>11))
    my_assert(!isequal(c1,c2))
    c3 = merge(c1, c2)
    checkcorrectness(c3.bt, false)
    c4 = SortedDict(Dict("Apples"=>7,
                        "Figs"=>9,
                        "Eggplants"=>6,
                        "Melons"=>11,
                        "Honeydews"=>19))
    my_assert(isequal(c3,c4))
    c5 = SortedDict(Dict("Apples"=>7))
    my_assert(!isequal(c4,c5))
    merge!(c1,c2)
    checkcorrectness(c1.bt, false)
    my_assert(isequal(c3,c1))
    merge!(c3,c3)
    my_assert(isequal(c3,c1))
    checkcorrectness(c3.bt, false)

    # issue #216
    my_assert(DataStructures.isordered(SortedDict{Int, String}))


    # check for get! and get
    dfc =  SortedDict{Int, Vector{Int}}()
    x1 = get!(dfc,1,[1])
    my_assert(x1 == [1])
    my_assert(x1 === dfc[1])
    my_assert(x1 === get!(dfc, 1, [1000]))
    my_assert(x1 === get(dfc, 1, [1000]))

    x2 = get!(()->[2], dfc, 2)
    my_assert(x2 == [2])
    my_assert(x2 === dfc[2])
    my_assert(x2 === get!(()->[1000], dfc, 2))
    my_assert(x2 === get(()->[1000], dfc, 2))

    my_assert([42] == get(()->[42], dfc, 3))
    my_assert(!haskey(dfc, 3))
    my_assert([43] == get(dfc, 4, [43]))
    my_assert(!haskey(dfc, 4))
    @test_throws ArgumentError SortedDict(Forward, Forward)
    @test_throws ArgumentError SortedDict{Int,Int}(Forward, Forward)
    @test_throws ArgumentError SortedDict(Val(true), Forward)
    @test_throws ArgumentError SortedDict{Int,Int}(Val(true), Forward)
    my_assert(isequal(SortedDict{Int,Int}(ForBack(true), 1=>3,2=>7),
                      SortedDict{Int,Int}(ForBack(false), 1=>3, 2=>7)))
    my_assert(!isequal(SortedDict{Int,Int}(ForBack(true), 1=>3,2=>7),
                      SortedDict{Int,Int}(ForBack(false), 1=>3, 2=>8)))
    my_assert(isequal(SortedDict(1=>3,2=>7),
                      Dict(1=>3,2=>7)))
    my_assert(!isequal(SortedDict(1=>3,2=>7),
                       Dict(1=>3, 2=>8)))

    my_assert(isequal(merge(SortedDict{Float64,Int}(ForBack(true), 3.5=>2, 4.5=>8),
                            SortedDict{Float64,Int}(ForBack(false), 2.3=>2, 9.9=>8)),
                      SortedDict{Float64,Int}(ForBack(true), 3.5 => 2, 4.5 => 8,
                                              2.3 => 2, 9.9 => 8)))
    my_assert(!isequal(merge(SortedDict{Float64,Int}(ForBack(true), 3.5=>2, 4.5=>8),
                             SortedDict{Float64,Int}(ForBack(false), 2.3=>2, 9.9=>9)),
                       SortedDict{Float64,Int}(ForBack(true), 3.5 => 2, 4.5 => 8,
                                              2.3 => 2, 9.9 => 8)))
    my_assert(isequal(merge(SortedDict{Float64,Int}(ForBack(true), 3.5=>2, 4.5=>8),
                            Dict(2.3=>2, 9.9=>8)),
                      SortedDict{Float64,Int}(ForBack(true), 3.5 => 2, 4.5 => 8,
                                              2.3 => 2, 9.9 => 8)))
    my_assert(!isequal(merge(SortedDict{Float64,Int}(ForBack(true), 3.5=>2, 4.5=>8),
                             Dict(2.3=>2, 9.9=>9)),
                       SortedDict{Float64,Int}(ForBack(true), 3.5 => 2, 4.5 => 8,
                                               2.3 => 2, 9.9 => 8)))
    true
end



function bitreverse(i)
    zeroi = zero(i)
    onei = one(i)
    twoi = onei + onei
    r = zeroi
    for j = 1 : 32
        r *= twoi
        r += (i & onei)
        i = div(i,twoi)
    end
    r
end



function testSortedDictLoops()
    z = 0x00000000
    T = typeof(z)
    ## Test the loops
    zero1 = zero(z)
    one1 = one(z)
    two1 = one1 + one1
    m1 = SortedDict{T,T}()
    N = 1000
    for l = 1 : N
        lUi = convert(T, l)
        m1[bitreverse(lUi)] = lUi
    end
    count = 0
    # issue 767
    for (stok,k,v) in semitokens(inclusive(m1, firstindex(m1), lastindex(m1)))
        for (stok2,k2,v2) in semitokens(exclusive(m1, firstindex(m1), pastendsemitoken(m1)))
            c = compare(m1,stok,stok2)
            if c < 0
                my_assert(deref_key((m1,stok)) < deref_key((m1,stok2)))
            elseif c == 0
                my_assert(deref_key((m1,stok)) == deref_key((m1,stok2)))
            else
                my_assert(deref_key((m1,stok)) > deref_key((m1,stok2)))
            end
            count += 1
        end
    end
    my_assert(eltype(semitokens(exclusive(m1, firstindex(m1), pastendsemitoken(m1)))) ==
           Tuple{IntSemiToken, T, T})
    my_assert(count == N^2)
    N = 1000
    sk = zero1
    sv = zero1
    skhalf = zero1
    svhalf = zero1
    for l = 1 : N
        lUi = convert(T, l)
        brl = bitreverse(lUi)
        sk += brl
        m1[brl] = lUi
        sv += lUi
        if brl < div(N, 2)
            skhalf += brl
            svhalf += lUi
        end
    end
    count = 0
    sk2 = zero1
    sv2 = zero1
    for (k,v) in m1
        sk2 += k
        sv2 += v
        count += 1
    end
    my_assert(count == N)
    my_assert(sk2 == sk)
    my_assert(sv == sv2)
    sk2 = zero1
    for k in keys(m1)
        sk2 += k
    end
    my_assert(eltype(keys(m1)) == T)
    my_assert(sk2 == sk)

    sk2a = zero1


    for k in eachindex(m1)
        sk2a += k
    end
    my_assert(eltype(eachindex(m1)) == T)
    my_assert(sk2a == sk)



    sk2b = zero1
    for st in onlysemitokens(m1)
        sk2b += deref_key((m1,st))
    end
    my_assert(sk2b == sk)

    sv2 = zero1
    for v in values(m1)
        sv2 += v
    end
    my_assert(eltype(values(m1)) == T)

    my_assert(sv == sv2)
    count = 0
    for (st,k) in semitokens(keys(m1))
        my_assert(deref_key((m1,st)) == k)
        count += 1
    end
    my_assert(eltype(semitokens(keys(m1))) == Tuple{IntSemiToken, T})

    my_assert(count == N)
    count = 0
    for (st,v) in semitokens(values(m1))
        my_assert(deref_value((m1,st)) == v)
        count += 1
    end
    my_assert(count == N)
    my_assert(eltype(semitokens(values(m1))) == Tuple{IntSemiToken, T})

    pos1 = searchsortedfirst(m1, div(N,2))
    sk2 = zero1
    for k in keys(exclusive(m1, firstindex(m1), pos1))
        sk2 += k
    end
    my_assert(sk2 == skhalf)
    my_assert(eltype(keys(exclusive(m1, firstindex(m1), pos1))) == T)



    sk2a = zero1
    for k in eachindex(exclusive(m1, firstindex(m1), pos1))
        sk2a += k
    end
    my_assert(sk2a == skhalf)
    my_assert(eltype(eachindex(exclusive(m1, firstindex(m1), pos1))) == T)



    sv2 = zero1
    for v in values(exclusive(m1, firstindex(m1), pos1))
        sv2 += v
    end
    my_assert(sv2 == svhalf)
    count = 0
    for (k,v) in exclusive(m1, pastendsemitoken(m1), pastendsemitoken(m1))
        count += 1
    end
    my_assert(eltype(keys(exclusive(m1, firstindex(m1), pos1))) == T)
    my_assert(count == 0)


    count = 0
    for (k,v) in inclusive(m1, firstindex(m1), beforestartsemitoken(m1))
        count += 1
    end
    my_assert(count == 0)
    my_assert(eltype(keys(inclusive(m1, firstindex(m1), beforestartsemitoken(m1)))) == T)


    count = 0
    sk5 = zero1
    for k in eachindex(inclusive(m1, firstindex(m1), firstindex(m1)))
        sk5 += k
        count += 1
    end
    my_assert(count == 1 && sk5 == deref_key((m1,firstindex(m1))))
    my_assert(eltype(eachindex(inclusive(m1, firstindex(m1), firstindex(m1)))) == T)

    factors = SortedMultiDict{Int,Int}()
    N = 1000
    len = 0
    sum1 = 0
    sum2 = 0
    for factor = 1 : N
        for multiple = factor : factor : N
            push_return_semitoken!(factors, multiple=>factor)
            sum1 += multiple
            sum2 += factor
            len += 1
        end
    end

    sum1a = 0
    sum2a = 0

    for (k,v) in factors
        sum1a += k
        sum2a += v
    end
    my_assert(sum1a == sum1 && sum2a == sum2)





    sum1a = 0
    sum2a = 0
    for st in eachindex(factors)
        (k,v) = deref((factors,st))
        sum1a += k
        sum2a += v
    end
    my_assert(sum1a == sum1 && sum2a == sum2)

    sum1a = 0
    sum2a = 0
    for st in onlysemitokens(factors)
        (k,v) = deref((factors,st))
        sum1a += k
        sum2a += v
    end
    my_assert(sum1a == sum1 && sum2a == sum2)
    my_assert(eltype(onlysemitokens(factors)) == IntSemiToken)

    sum2 = 0
    for (k,v) in inclusive(factors,
                           searchsortedfirst(factors,70),
                           searchsortedlast(factors,70))
        sum2 += v
    end

    my_assert(sum2 == 1 + 2 + 5 + 7 + 10 + 14 + 35 + 70)
    my_assert(eltype(inclusive(factors,
                           searchsortedfirst(factors,70),
                           searchsortedlast(factors,70))) == Pair{Int,Int})


    sum2 = 0
    for st in eachindex(inclusive(factors,
                                  searchsortedfirst(factors,70),
                                  searchsortedlast(factors,70)))
        v = deref_value((factors,st))
        sum2 += v
    end

    my_assert(sum2 == 1 + 2 + 5 + 7 + 10 + 14 + 35 + 70)
    my_assert(eltype(eachindex(inclusive(factors,
                                     searchsortedfirst(factors,70),
                                     searchsortedlast(factors,70)))) == IntSemiToken)



    sum3 = 0
    for (k,v) in exclusive(factors,
                           searchsortedfirst(factors,60),
                           searchsortedfirst(factors,61))
        sum3 += v
    end
    my_assert(sum3 == 1 + 2 + 3 + 4 + 5 + 6 + 10 + 12 + 15 + 20 + 30 + 60)
    my_assert(eltype(exclusive(factors,
                           searchsortedfirst(factors,70),
                           searchsortedlast(factors,70))) == Pair{Int,Int})


    sum3 = 0
    for st in eachindex(exclusive(factors,
                                  searchsortedfirst(factors,60),
                                  searchsortedfirst(factors,61)))
        v = deref_value((factors,st))
        sum3 += v
    end
    my_assert(sum3 == 1 + 2 + 3 + 4 + 5 + 6 + 10 + 12 + 15 + 20 + 30 + 60)
    my_assert(eltype(eachindex(exclusive(factors,
                                     searchsortedfirst(factors,70),
                                     searchsortedlast(factors,70)))) == IntSemiToken)


    sum4 = 0
    for k in keys(factors)
        sum4 += k
    end
    my_assert(sum4 == sum1)
    my_assert(eltype(keys(factors)) == Int)




    sum5 = 0
    for v in values(factors)
        sum5 += v
    end

    my_assert(sum5 == sum2a)
    my_assert(eltype(values(factors)) == Int)

    sum2 = 0
    for k in keys(inclusive(factors,
                            searchsortedfirst(factors,70),
                            searchsortedlast(factors,70)))
        sum2 += k
    end
    my_assert(sum2 == 70 * 8)
    my_assert(eltype(keys(inclusive(factors,
                                searchsortedfirst(factors,70),
                                searchsortedlast(factors,70)))) ==  Int)


    sum3 = 0
    for k in keys(exclusive(factors,
                            searchsortedfirst(factors,60),
                            searchsortedfirst(factors,61)))
        sum3 += k
    end
    my_assert(sum3 == 60 * 12)
    my_assert(eltype(keys(exclusive(factors,
                                searchsortedfirst(factors,60),
                                searchsortedfirst(factors,61)))) == Int)



    sum2 = 0
    for v in values(inclusive(factors,
                              searchsortedfirst(factors,70),
                              searchsortedlast(factors,70)))
        sum2 += v
    end
    my_assert(sum2 == 1 + 2 + 5 + 7 + 10 + 14 + 35 + 70)
    my_assert(eltype(values(inclusive(factors,
                                  searchsortedfirst(factors,60),
                                  searchsortedfirst(factors,61)))) == Int)

    sum3 = 0
    for v in values(exclusive(factors,
                              searchsortedfirst(factors,60),
                              searchsortedfirst(factors,61)))
        sum3 += v
    end
    my_assert(sum3 == 1 + 2 + 3 + 4 + 5 + 6 + 10 + 12 + 15 + 20 + 30 + 60)
    my_assert(eltype(values(exclusive(factors,
                                  searchsortedfirst(factors,60),
                                  searchsortedfirst(factors,61)))) == Int)

    sum1b = 0
    sum2b = 0
    for (st,k,v) in semitokens(factors)
        my_assert(deref_value((factors,st)) == v)
        sum1b += k
        sum2b += v
    end
    my_assert(sum1b == sum1a && sum2b == sum2a)
    my_assert(eltype(semitokens(factors)) == Tuple{IntSemiToken, Int, Int})

    sum2 = 0
    for (st,k,v) in semitokens(inclusive(factors,
                                         searchsortedfirst(factors,70),
                                         searchsortedlast(factors,70)))
        my_assert(deref_value((factors,st)) == v)
        sum2 += v
    end
    my_assert(sum2 == 1 + 2 + 5 + 7 + 10 + 14 + 35 + 70)
    my_assert(eltype(semitokens(inclusive(factors,
                                         searchsortedfirst(factors,70),
                                         searchsortedlast(factors,70)))) ==
        Tuple{IntSemiToken, Int, Int})

    sum3 = 0
    for (st,k,v) in semitokens(exclusive(factors,
                                         searchsortedfirst(factors,60),
                                         searchsortedfirst(factors,61)))
        my_assert(deref_value((factors,st)) == v)
        sum3 += v
    end
    my_assert(sum3 == 1 + 2 + 3 + 4 + 5 + 6 + 10 + 12 + 15 + 20 + 30 + 60)
    my_assert(eltype(semitokens(exclusive(factors,
                                      searchsortedfirst(factors,60),
                                      searchsortedfirst(factors,61)))) ==
         Tuple{IntSemiToken, Int, Int})

    sum4 = 0
    for (st,k) in semitokens(keys(factors))
        my_assert(deref_key((factors,st)) == k && mod(k,deref_value((factors,st))) == 0)
        sum4 += k
    end
    my_assert(sum4 == sum1)
    my_assert(eltype(semitokens(keys(factors))) == Tuple{IntSemiToken,Int})

    sum5 = 0
    for (st,v) in semitokens(values(factors))
        my_assert(deref_value((factors,st)) == v)
        sum5 += v
    end
    my_assert(sum5 == sum2a)
    my_assert(eltype(semitokens(values(factors))) == Tuple{IntSemiToken,Int})

    sum2 = 0
    for (st,k) in semitokens(keys(inclusive(factors,
                                           searchsortedfirst(factors,70),
                                           searchsortedlast(factors,70))))
        my_assert(deref_key((factors,st)) == k && mod(k,deref_value((factors,st))) == 0)
        sum2 += k
    end
    my_assert(sum2 == 70 * 8)
    my_assert(eltype(semitokens(keys(inclusive(factors,
                                           searchsortedfirst(factors,70),
                                           searchsortedlast(factors,70))))) ==
        Tuple{IntSemiToken, Int})

    sum3 = 0
    for (st,k) in semitokens(keys(inclusive(factors,
                                            searchsortedfirst(factors,60),
                                            searchsortedlast(factors,60))))
        my_assert(deref_key((factors,st)) == k && mod(k,deref_value((factors,st))) == 0)
        sum3 += k
    end
    my_assert(sum3 == 60 * 12)
    my_assert(eltype(semitokens(keys(inclusive(factors,
                                            searchsortedfirst(factors,60),
                                            searchsortedlast(factors,60))))) ==
        Tuple{IntSemiToken, Int})

    sum2 = 0
    for (st,v) in semitokens(values(inclusive(factors,
                                              searchsortedfirst(factors,70),
                                              searchsortedlast(factors,70))))
        my_assert(deref_value((factors,st)) == v)
        sum2 += v
    end
    my_assert(sum2 == 1 + 2 + 5 + 7 + 10 + 14 + 35 + 70)
    my_assert(eltype(semitokens(values(inclusive(factors,
                                              searchsortedfirst(factors,70),
                                              searchsortedlast(factors,70))))) ==
      Tuple{IntSemiToken, Int})

    sum3 = 0
    for (st,v) in semitokens(values(exclusive(factors,
                                              searchsortedfirst(factors,60),
                                              searchsortedfirst(factors,61))))
        my_assert(deref_value((factors,st)) == v)
        sum3 += v
    end
    my_assert(sum3 == 1 + 2 + 3 + 4 + 5 + 6 + 10 + 12 + 15 + 20 + 30 + 60)
    my_assert(eltype(semitokens(values(exclusive(factors,
                                              searchsortedfirst(factors,60),
                                              searchsortedfirst(factors,61))))) ==
       Tuple{IntSemiToken, Int})

    s = SortedSet([39, 24, 2, 14, 45, 107, 66])
    my_assert(typeof(s) == SortedSet{Int, ForwardOrdering})
    sum1 = 0
    for k in s
        sum1 += k
    end
    my_assert(sum1 == sum([39, 24, 2, 14, 45, 107, 66]))

    sum1 = 0
    for (st,k) in semitokens(s)
        my_assert(deref((s,st)) == k)
        sum1 += k
    end
    my_assert(sum1 == sum([39, 24, 2, 14, 45, 107, 66]))
    my_assert(eltype(semitokens(s)) == Tuple{IntSemiToken, Int})


    sum1 = 0
    for st in onlysemitokens(s)
        k = deref((s,st))
        sum1 += k
    end
    my_assert(sum1 == sum([39, 24, 2, 14, 45, 107, 66]))
    my_assert(eltype(onlysemitokens(s)) == IntSemiToken)


    sum1 = 0
    for st in eachindex(s)
        k = deref((s,st))
        sum1 += k
    end
    my_assert(sum1 == sum([39, 24, 2, 14, 45, 107, 66]))
    my_assert(eltype(eachindex(s)) == IntSemiToken)


    sum2 = 0
    for k in inclusive(s,
                       searchsortedfirst(s, 24),
                       searchsortedfirst(s, 66))
        sum2 += k
    end
    my_assert(sum2 == 24 + 39 + 45 + 66)
    my_assert(eltype(inclusive(s,
                       searchsortedfirst(s, 24),
                       searchsortedfirst(s, 66))) == Int)


    sum2 = 0
    for st in eachindex(inclusive(s,
                                  searchsortedfirst(s, 24),
                                  searchsortedfirst(s, 66)))
        sum2 += deref((s,st))
    end
    my_assert(sum2 == 24 + 39 + 45 + 66)
    my_assert(eltype(eachindex(inclusive(s,
                                     searchsortedfirst(s, 24),
                                     searchsortedfirst(s, 66)))) == IntSemiToken)




    sum2 = 0
    for (st,k) in semitokens(inclusive(s,
                                       searchsortedfirst(s, 24),
                                       searchsortedfirst(s, 66)))
        my_assert(deref((s,st)) == k)
        sum2 += k
    end
    my_assert(sum2 == 24 + 39 + 45 + 66)
    my_assert(eltype(semitokens(inclusive(s,
                                       searchsortedfirst(s, 24),
                                       searchsortedfirst(s, 66)))) ==
      Tuple{IntSemiToken, Int})


    sum2 = 0
    for st in onlysemitokens(inclusive(s,
                                       searchsortedfirst(s, 24),
                                       searchsortedfirst(s, 66)))
        sum2 += deref((s,st))
    end
    my_assert(sum2 == 24 + 39 + 45 + 66)
    my_assert(eltype(onlysemitokens(inclusive(s,
                                          searchsortedfirst(s, 24),
                                          searchsortedfirst(s, 66)))) == IntSemiToken)




    sum3 = 0
    for k in exclusive(s,
                       searchsortedfirst(s, 24),
                       searchsortedfirst(s, 66))
        sum3 += k
    end
    my_assert(sum3 == 24 + 39 + 45)
    my_assert(eltype(exclusive(s,
                       searchsortedfirst(s, 24),
                       searchsortedfirst(s, 66))) == Int)


    sum3 = 0
    for (st,k) in semitokens(exclusive(s,
                                       searchsortedfirst(s, 24),
                                       searchsortedfirst(s, 66)))
        my_assert(deref((s,st)) == k)
        sum3 += k
    end
    my_assert(sum3 == 24 + 39 + 45)
    my_assert(eltype(semitokens(exclusive(s,
                                       searchsortedfirst(s, 24),
                                       searchsortedfirst(s, 66)))) ==
     Tuple{IntSemiToken, Int})


    sum3 = 0
    for st in eachindex(exclusive(s,
                                  searchsortedfirst(s, 24),
                                  searchsortedfirst(s, 66)))
        sum3 += deref((s,st))
    end
    my_assert(sum3 == 24 + 39 + 45)
    my_assert(eltype(eachindex(exclusive(s,
                                     searchsortedfirst(s, 24),
                            searchsortedfirst(s, 66)))) == IntSemiToken)
    true
end






function testSortedDictOrderings()
    ## Test use of alternative orderings in test5
    keylist = ["Apple", "aPPle", "berry", "CHerry", "Dairy", "diary"]
    vallist = [6,9,-4,2,1,8]
    m = SortedDict{String,Int}()
    for j = 1:6
        m[keylist[j]] = vallist[j]
    end
    checkcorrectness(m.bt, false)
    expectedord1 = [1,4,5,2,3,6]
    count = 0
    for p in m
        count += 1
        my_assert(p[1] == keylist[expectedord1[count]] &&
                p[2] == vallist[expectedord1[count]])
    end
    my_assert(count == 6)
    m2 = SortedDict((Dict{String, Int}()), Reverse)
    for j = 1 : 6
        m2[keylist[j]] = vallist[j]
    end
    checkcorrectness(m2.bt, false)
    expectedord2 = [6,3,2,5,4,1]
    count = 0
    for p in m2
        count += 1
        my_assert(p[1] == keylist[expectedord2[count]] &&
                p[2] == vallist[expectedord2[count]])
    end
    my_assert(count == 6)
    m3 = SortedDict((Dict{String, Int}()), CaseInsensitive())
    for j = 1 : 6
        m3[keylist[j]] = vallist[j]
    end
    my_assert("BERRY" in keys(m3))
    my_assert(!("BERRY" in collect(keys(m3))))
    checkcorrectness(m3.bt, false)
    expectedord3 = [2,3,4,5,6]
    count = 0
    for p in m3
        count += 1
        my_assert(p[1] == keylist[expectedord3[count]] &&
                p[2] == vallist[expectedord3[count]])
    end
    my_assert(count == 5)
    m3empty = empty(m3)
    my_assert(eltype(m3empty) == Pair{String, Int} &&
       orderobject(m3empty) == CaseInsensitive() &&
       length(m3empty) == 0 && ordtype(m3empty) == CaseInsensitive &&
       ordtype(typeof(m3empty)) == CaseInsensitive)
    m4 = SortedDict((Dict{String,Int}()), Lt((x,y) -> isless(lowercase(x),lowercase(y))))
    for j = 1 : 6
        m4[keylist[j]] = vallist[j]
    end
    checkcorrectness(m4.bt, false)
    count = 0
    for p in m4
        count += 1
        my_assert(p[1] == keylist[expectedord3[count]] &&
                p[2] == vallist[expectedord3[count]])
    end
    my_assert(count == 5)
    true
end

function testSortedMultiDict()
    test_dict = Dict('a'=>1, 'b'=>2, 'c'=>3)

    # Test all methods of SortedMultiDict except loops
    factors = SortedMultiDict{Int,Int}()
    my_assert(typeof(factors) == SortedMultiDict{Int,Int,ForwardOrdering})
    factors2 = SortedMultiDict(test_dict)
    my_assert(typeof(factors2) == SortedMultiDict{Char,Int,ForwardOrdering})
    factors3 = SortedMultiDict{Char,Int}(test_dict)
    my_assert(typeof(factors3) == SortedMultiDict{Char,Int,ForwardOrdering})
    factors4 = SortedMultiDict{Char,Float32}(Reverse, test_dict)
    my_assert(typeof(factors4) == SortedMultiDict{Char,Float32,ReverseOrdering{ForwardOrdering}})

    test_pair_array = Pair{Char}['a'=>1, 'b'=>2, 'c'=>3]
    factors5 = SortedMultiDict(test_pair_array)
    my_assert(typeof(factors5) == SortedMultiDict{Char,Int,ForwardOrdering})
    # test for `show` method for sortedmultidict
    str1 = repr(MIME{Symbol("text/plain")}(), factors5)
    my_assert(Meta.parse(str1).head == :call)
    #@test factors2 == factors3   # Broken!  TODO: fix me...
    my_assert(isequal(factors2, factors3))
    my_assert(!isequal(SortedMultiDict{Int,Int,ForBack}(ForBack(true), [1=>2, 1=>3, 0=>1]),
                       SortedMultiDict{Int,Int,ForBack}(ForBack(false), [1=>2, 1=>3, 0=>1])))

    N = 1000
    checkcorrectness(factors.bt, true)
    len = 0
    for factor = 1 : N
        for multiple = factor : factor : N
            push_return_semitoken!(factors, multiple=>factor)
            len += 1
        end
    end
    my_assert(length(factors) == len)
    my_assert(Pair(70,2) in factors)
    my_assert(Pair(70,14) in factors)
    my_assert(!(Pair(70,15) in factors))
    my_assert(!(Pair(N+1,15) in factors))
    my_assert(eltype(factors) == Pair{Int,Int})
    my_assert(eltype(typeof(factors)) == Pair{Int,Int})

    my_assert(keytype(factors) == Int)
    my_assert(keytype(typeof(factors)) == Int)
    my_assert(valtype(factors) == Int)
    my_assert(valtype(typeof(factors)) == Int)
    my_assert(ordtype(factors) == ForwardOrdering)
    my_assert(ordtype(typeof(factors)) == ForwardOrdering)

    my_assert(2 in values(factors))
    push!(factors, 70 => 3)
    my_assert(length(factors) == len+1)
    my_assert(Pair(70,3) in factors)
    i = searchsortedfirst(factors, 70)
    dcount = 0
    for (s,k,v) in semitokens(inclusive(factors, i, lastindex(factors)))
        my_assert(k == 70)
        if v == 3
            delete!((factors,s))
            dcount += 1
            break
        end
    end
    my_assert(dcount == 1)

    my_assert(orderobject(factors) == Forward)
    my_assert(haskey(factors, 60))
    my_assert(!haskey(factors, -1))
    my_assert(60 in keys(factors))
    my_assert(!(-1 in keys(factors)))
    checkcorrectness(factors.bt, true)
    i = firstindex(factors)
    i = advance((factors,i))
    my_assert(deref((factors,i)) == Pair(2,1))
    my_assert(deref_key((factors,i)) == 2)
    my_assert(deref_value((factors,i)) == 1)
    my_assert(factors[i] == 1)
    factors[i] = 7
    my_assert(deref((factors,i)) == Pair(2,7))
    factors[i] = 1
    i = regress((factors,i))
    i = regress((factors,i))
    my_assert(i == beforestartsemitoken(factors))
    pr = first(factors)
    my_assert(pr == Pair(1,1))
    pr2 = last(factors)
    my_assert(pr2 == Pair(N,N))
    i = searchsortedfirst(factors,77)
    my_assert(deref((factors,i)) == Pair(77,1))
    i = searchsortedlast(factors,77)
    my_assert(deref((factors,i)) == Pair(77,77))
    i = searchsortedafter(factors,77)
    my_assert(deref((factors,i)) == Pair(78,1))
    expected = [1,2,4,5,8,10,16,20,40,80]
    i1,i2 = searchequalrange(factors, 80)
    i = i1
    for e in expected
        my_assert(deref_value((factors,i)) == e)
        i = advance((factors,i))
    end
    my_assert(compare(factors,i,i2) != 0)
    my_assert(compare(factors,regress((factors,i)),i2) == 0)
    my_assert(compare(factors,i,i1) != 0)
    push_return_semitoken!(factors, 80=>6)
    my_assert(length(factors) == len + 1)
    checkcorrectness(factors.bt, true)
    expected1 = deepcopy(expected)
    push!(expected1, 6)
    i1,i2 = searchequalrange(factors, 80)
    i = i1
    for e in expected1
        my_assert(deref_value((factors,i)) == e)
        i = advance((factors,i))
    end
    my_assert(compare(factors,i2,regress((factors,i))) == 0)
    my_assert(compare(factors,i,i1) != 0)
    delete!((factors,i2))
    my_assert(length(factors) == len)
    checkcorrectness(factors.bt, true)
    i1,i2 = searchequalrange(factors, 80)
    i = i1
    for e in expected
        my_assert(deref_value((factors,i)) == e)
        i = advance((factors,i))
    end
    my_assert(compare(factors,regress((factors,i)),i2) == 0)
    my_assert(!isempty(factors))
    empty!(factors)
    checkcorrectness(factors.bt, true)
    my_assert(length(factors) == 0)
    my_assert(isempty(factors))
    i = firstindex(factors)
    my_assert(i == pastendsemitoken(factors))
    i = lastindex(factors)
    my_assert(i == beforestartsemitoken(factors))
    i1,i2 = searchequalrange(factors, N + 2)
    my_assert(i1 == pastendsemitoken(factors))
    my_assert(i2 == beforestartsemitoken(factors))
    m1 = SortedMultiDict("apples"=>2.0, "apples"=>1.0, "bananas"=>1.5)
    my_assert(typeof(m1) == SortedMultiDict{String, Float64, ForwardOrdering})
    checkcorrectness(m1.bt, true)
    m2 = SortedMultiDict("bananas"=>1.5, "apples"=>2.0, "apples"=>1.0)
    checkcorrectness(m2.bt, true)
    m3 = SortedMultiDict("apples"=>1.0, "apples"=>2.0, "bananas"=>1.5)
    checkcorrectness(m3.bt, true)
    my_assert(isequal(m1,m2))
    my_assert(!isequal(m1,m3))
    my_assert(!isequal(m1, SortedMultiDict("apples"=>2.0)))
    b,stok = push_return_semitoken!(m2, "cherries"=>6.1)
    my_assert(b)
    checkcorrectness(m2.bt, true)
    my_assert(!isequal(m1,m2))
    delete!((m2,stok))
    checkcorrectness(m2.bt, true)
    my_assert(isequal(m1,m2))
    m4 = deepcopy(m2)
    checkcorrectness(m4.bt, true)
    my_assert(isequal(m1,m4))
    m5 = packcopy(m2)
    checkcorrectness(m5.bt, true)
    my_assert(isequal(m1,m5))
    m6 = packdeepcopy(m2)
    checkcorrectness(m6.bt, true)
    my_assert(isequal(m1,m6))

    m1 = SortedMultiDict(zip(["bananas", "apples", "cherries", "cherries", "oranges"],
                             [1.0, 2.0, 3.0, 4.0, 5.0]))
    my_assert(typeof(m1) == SortedMultiDict{String, Float64, ForwardOrdering})
    m2 = SortedMultiDict(zip(["apples", "cherries", "cherries", "bananas", "plums"],
                             [6.0, 7.0, 8.0, 9.0, 10.0]))
    m3 = SortedMultiDict(zip(["apples", "apples", "bananas", "bananas",
                              "cherries", "cherries", "cherries", "cherries",
                              "oranges", "plums"],
                             [2.0, 6.0, 1.0, 9.0, 3.0, 4.0, 7.0, 8.0, 5.0, 10.0]))
    m3empty = empty(m3)
    my_assert((eltype(m3empty) == Pair{String, Float64}) &&
        orderobject(m3empty) == Forward &&
        length(m3empty) == 0)
    m4 = merge(m1, m2)
    my_assert(isequal(m3, m4))
    m5a = SortedMultiDict(Pair{Any,Any}[1=>4.5, 2=>8, 8=>6//7])  #address issue 239
    my_assert(eltype(m5a) == Pair{Int,Real})
    m5 = merge(m2, m1)
    my_assert(!isequal(m3, m5))
    merge!(m1, m2)
    my_assert(isequal(m1, m3))
    m7 = SortedMultiDict{Int,Int}()
    n1 = 10000
    for k = 1 : n1
        push_return_semitoken!(m7, k=>k+1)
    end
    for k = 1 : n1
        push_return_semitoken!(m7, k=>k+2)
    end
    for k = 1 : n1
        i1, i2 = searchequalrange(m7, k)
        count = 0
        for (key,v) in inclusive(m7, i1, i2)
            count += 1
            my_assert(key == k)
            my_assert(v == k + count)
        end
        my_assert(count == 2)
        count = 0
        for (key,v) in inclusive(m7, searchequalrange(m7,k))
            count += 1
            my_assert(key == k)
            my_assert(v == k + count)
        end
        my_assert(count == 2)
    end
    my_assert(isequal(merge(SortedMultiDict{Int,Float64}(1=>3.0,
                                                         2=>2.2),
                            Dict(1=>2.0, 2=>2.3)),
                      SortedMultiDict{Int,Float64}(1=>3.0, 1=>2.0, 2=>2.2, 2=>2.3)))
    my_assert(!isequal(merge(SortedMultiDict{Int,Float64}(1=>3.0,
                                                          2=>2.2),
                            Dict(1=>2.0, 2=>2.3)),
                      SortedMultiDict{Int,Float64}(1=>2.0, 1=>3.0, 2=>2.2, 2=>2.3)))
    my_assert(isequal(merge(SortedMultiDict{Int,Float64,ForBack}(ForBack(true),
                                                                 [1=>3.0,2=>2.2]),
                            SortedMultiDict{Int,Float64,ForBack}(ForBack(false),
                                                                 [1=>2.0,2=>2.3])),
                      SortedMultiDict{Int,Float64,ForBack}(ForBack(true),
                                                           [1=>3.0, 1=>2.0,
                                                            2=>2.2, 2=>2.3])))
    my_assert(!isequal(merge(SortedMultiDict{Int,Float64,ForBack}(ForBack(true),
                                                                  [1=>3.0, 2=>2.2]),
                             SortedMultiDict{Int,Float64,ForBack}(ForBack(false),
                                                                  [1=>2.0,2=>2.3])),
                      SortedMultiDict{Int,Float64,ForBack}(ForBack(true),
                                                           [1=>3.0, 1=>2.0,
                                                           2=>2.3, 2=>2.2])))

    
    # issue #216
    my_assert(DataStructures.isordered(SortedMultiDict{Int, String}))
    # issue #773
    s = SortedMultiDict{Int, Int}()           
    push_return_semitoken!(s, 4=>41)
    push_return_semitoken!(s, 3=>31)
    push_return_semitoken!(s, 2=>21)
    push_return_semitoken!(s, 2=>22)
    push_return_semitoken!(s, 2=>23)
    push_return_semitoken!(s, 2=>24)
    push_return_semitoken!(s, 2=>25)
    push_return_semitoken!(s, 2=>26)
    push_return_semitoken!(s, 1=>11)
    push_return_semitoken!(s, 1=>12)
    _,st1 = push_return_semitoken!(s, 1=>13)
    _,st2 = push_return_semitoken!(s, 1=>14)
    _,st3 = push_return_semitoken!(s, 1=>15)
    _,st4 = push_return_semitoken!(s, 1=>16)
    _,st5 = push_return_semitoken!(s, 1=>17)
    _,st6 = push_return_semitoken!(s, 1=>18)
    delete!((s, st6))
    delete!((s, st5))
    delete!((s, st4))
    delete!((s, st3))
    delete!((s, st2))
    delete!((s, st1))
    push_return_semitoken!(s, 1=>19)
    checkcorrectness(s.bt, true)
    my_assert(length(SortedMultiDict{Int,Int}(Val(true), [1=>2,3=>7,3=>15])) == 3)
    my_assert(length(SortedMultiDict{Int,Int}(Val(true), [8=>2,3=>7,3=>15], Reverse)) == 3)
    true
end


function testSortedSet()
    # Test SortedSet
    N = 1000
    sm = 0.0

    m = SortedSet(Float64[])
    my_assert(typeof(m) == SortedSet{Float64, ForwardOrdering})
    mm = SortedSet{Float64}()
    my_assert(typeof(mm) == SortedSet{Float64, ForwardOrdering})
    #@test m == mm   # Broken!  TODO: Fix me...
    my_assert(isequal(m, mm))

    my_assert(typeof(SortedSet()) == SortedSet{Any, ForwardOrdering})
    my_assert(typeof(SortedSet{Float64}()) == SortedSet{Float64, ForwardOrdering})
    my_assert(typeof(SortedSet(Reverse)) == SortedSet{Any, ReverseOrdering{ForwardOrdering}})
    my_assert(typeof(SortedSet{Float64}(Reverse)) == SortedSet{Float64, ReverseOrdering{ForwardOrdering}})
    my_assert(typeof(SortedSet([1,2,3])) == SortedSet{Int, ForwardOrdering})
    my_assert(typeof(SortedSet{Float32}([1,2,3])) == SortedSet{Float32, ForwardOrdering})
    my_assert(typeof(SortedSet(Reverse, [1,2,3])) == SortedSet{Int, ReverseOrdering{ForwardOrdering}})
    my_assert(typeof(SortedSet{Float32}(Reverse, [1,2,3])) == SortedSet{Float32, ReverseOrdering{ForwardOrdering}})
    my_assert(typeof(SortedSet([1,2,3], Reverse)) == SortedSet{Int, ReverseOrdering{ForwardOrdering}})
    my_assert(typeof(SortedSet{Float32}([1,2,3], Reverse)) == SortedSet{Float32, ReverseOrdering{ForwardOrdering}})

    my_assert(length(SortedSet{Int}(Val(true), [1,3,7])) == 3)
    my_assert(length(SortedSet{Int}(Val(true), [8,3,1], Reverse)) == 3)

    ss1 = SortedSet{String}(["berry", "cherry", "apple", "grape"])
    q = popfirst!(ss1)
    my_assert(q == "apple")
    my_assert(ss1 == Set(["berry", "cherry", "grape"]))
    q2 = poplast!(ss1)
    my_assert(q2 == "grape")
    my_assert(ss1 == Set(["cherry", "berry"]))
    my_assert(isequal(SortedSet{Int,ForBack}(ForBack(true), [5,6,4,8]),
                      SortedSet{Int,ForBack}(ForBack(false), [5,6,4,8])))
    my_assert(issetequal(SortedSet{Int,ForBack}(ForBack(true), [5,6,4,8]),
                      SortedSet{Int,ForBack}(ForBack(false), [5,6,4,8])))
    my_assert(!isequal(SortedSet{Int,ForBack}(ForBack(true), [5,6,4,8]),
                       SortedSet{Int,ForBack}(ForBack(false), [5,6,6,8])))
    my_assert(isequal(SortedSet{Int,ForBack}(ForBack(true), [5,6,4,8]),
                      SortedSet{Int,ForBack}(ForBack(true), [5,6,4,8])))
    my_assert(!isequal(SortedSet{Int,ForBack}(ForBack(true), [5,6,4,8]),
                       SortedSet{Int,ForBack}(ForBack(true), [5,6,6,8])))
    
              
    
    @test_throws ArgumentError SortedSet(Reverse, Reverse)
    @test_throws ArgumentError SortedSet{Int}(Reverse, Reverse)
    @test_throws ArgumentError SortedSet{Int}(Val(true), Reverse)
    @test_throws ErrorException deref_key(token_firstindex(SortedSet{Int}([6])))
    @test_throws ErrorException deref_value(token_firstindex(SortedSet{Int}([6])))

    smallest = 10.0
    largest = -10.0
    for j = 1 : N
        u = j * exp(1)
        ui = u - floor(u)
        push!(m, ui)
        sm += ui
        smallest = min(smallest,ui)
        largest = max(largest,ui)
    end
    isnew,st = push_return_semitoken!(m, 72.5)
    my_assert(isnew)
    my_assert(deref((m,st)) == 72.5)
    delete!((m,st))
    isnew,st = push_return_semitoken!(m, 73.5)
    my_assert(isnew)
    my_assert(deref((m,st)) == 73.5)
    delete!(m, 73.5)
    checkcorrectness(m.bt, false)
    count = 0
    sm2 = 0.0
    prev = -1.0
    for k in m
        sm2 += k
        count += 1
        my_assert(k >= prev)
    end
    my_assert(abs(sm2 - sm) <= 1e-10)
    my_assert(count == N)
    my_assert(length(m) == N)
    ii2 = searchsortedfirst(m, 0.5)
    i3 = firstindex(m)
    v = first(m)
    my_assert(v == smallest)
    my_assert(deref((m,i3)) == v)
    i4 = lastindex(m)
    w = last(m)
    my_assert(w == largest)
    my_assert(deref((m,i4)) == w)
    i5 = beforestartsemitoken(m)
    my_assert(advance((m,i5)) == i3)
    i6 = pastendsemitoken(m)
    my_assert(regress((m,i6)) == i4)
    my_assert(advance((m,i5)) != i4)
    my_assert(regress((m,i6)) != i3)
    j1 = searchsortedfirst(m,0.5)
    j2 = searchsortedlast(m,0.5)
    j3 = searchsortedafter(m,0.5)
    my_assert(deref((m,j1)) > 0.5)
    my_assert(deref((m,j2)) < 0.5)
    my_assert(advance((m,j2)) == j1)
    my_assert(j1 == j3)
    k1 = searchsortedfirst(m,smallest)
    k2 = searchsortedlast(m,smallest)
    k3 = searchsortedafter(m,smallest)
    my_assert(deref((m,k1)) == smallest)
    my_assert(deref((m,k2)) == smallest)
    my_assert(deref((m,regress((m,k3)))) == smallest)
    secondsmallest = deref((m,k3))
    sk = searchsortedfirst(m,0.4)
    ek = searchsortedfirst(m,0.6)
    dcount = 0
    for (st,k) in semitokens(exclusive(m,sk,ek))
        delete!((m,st))
        dcount += 1
        if dcount % 20 == 0
            checkcorrectness(m.bt, false)
        end
    end
    newcount = 0
    for k in m
        newcount += 1
        my_assert(k < 0.4 || k > 0.6)
    end
    my_assert(newcount == N - dcount)
    my_assert(smallest in m)
    my_assert(haskey(m,smallest))
    my_assert(!(0.5 in m))
    my_assert(!haskey(m,0.5))
    my_assert(eltype(m) == Float64)
    my_assert(eltype(typeof(m)) == Float64)
    my_assert(keytype(m) == Float64)
    my_assert(keytype(typeof(m)) == Float64)
    my_assert(orderobject(m) == Forward)
    my_assert(ordtype(m) == ForwardOrdering)
    my_assert(ordtype(typeof(m)) == ForwardOrdering)
    pop!(m, smallest)
    checkcorrectness(m.bt, false)
    my_assert(length(m) == N - dcount - 1)
    key1 = popfirst!(m)
    my_assert(key1 == secondsmallest)
    my_assert(length(m) == N - dcount - 2)
    checkcorrectness(m.bt, false)
    my_assert(!isempty(m))
    empty!(m)
    my_assert(isempty(m))
    m1 = SortedSet(["blue", "orange", "red"])
    my_assert(typeof(m1) == SortedSet{String, ForwardOrdering})
    m2 = SortedSet(["orange", "blue", "red"])
    m3 = SortedSet(["orange", "yellow", "red"])
    m3empty = empty(m3)
    my_assert(typeof(m3empty) == SortedSet{String, ForwardOrdering})
    my_assert(eltype(m3empty) == String &&
       length(m3empty) == 0)
    let m3empty_char = empty(m3, Char)
        @test typeof(m3empty_char) == SortedSet{Char, ForwardOrdering}
        Base.emptymutable(m3) == m3empty
        Base.emptymutable(m3, Char) == m3empty_char
    end
    my_assert(eltype(SortedSet((4,4.5,6//7))) == Real) # issue 239
    m3_reverse = SortedSet(DataStructures.FasterReverse(), ["orange", "yellow", "red"])
    let m3empty_reverse_char = empty(m3_reverse, Char)
        @test typeof(m3empty_reverse_char) == SortedSet{Char, DataStructures.FasterReverse}
    end
    my_assert(isequal(m1,m2))
    my_assert(!isequal(m1,m3))
    my_assert(!isequal(m1, SortedSet(["blue"])))
    m4 = packcopy(m3)
    my_assert(typeof(m4) == SortedSet{String, ForwardOrdering})
    my_assert(isequal(m3,m4))
    m5 = packdeepcopy(m4)
    my_assert(typeof(m5) == SortedSet{String, ForwardOrdering})
    my_assert(isequal(m3,m4))
    m6 = deepcopy(m5)
    my_assert(typeof(m6) == SortedSet{String, ForwardOrdering})
    my_assert(isequal(m3,m5))
    checkcorrectness(m1.bt, false)
    checkcorrectness(m2.bt, false)
    checkcorrectness(m3.bt, false)
    checkcorrectness(m4.bt, false)
    checkcorrectness(m5.bt, false)
    checkcorrectness(m5.bt, false)
    m7 = union(m1, ["yellow"])
    my_assert(typeof(m7) == SortedSet{String, ForwardOrdering})
    m8 = union(m3, SortedSet(["blue"]))
    my_assert(typeof(m8) == SortedSet{String, ForwardOrdering})
    my_assert(isequal(m7,m8))
    my_assert(!isequal(m1,m8))
    union!(m1, ["yellow"])
    my_assert(isequal(m1,m8))
    m8a = intersect(m8)
    my_assert(typeof(m8a) == SortedSet{String, ForwardOrdering})
    my_assert(isequal(m8a,m8))
    m9 = intersect(m8, SortedSet(["yellow", "red", "white"]))
    my_assert(typeof(m9) == SortedSet{String, ForwardOrdering})
    my_assert(isequal(m9, SortedSet(["red", "yellow"])))
    m9a = intersect(m8, SortedSet(["yellow", "red", "white"]), m8)
    my_assert(typeof(m9a) == SortedSet{String, ForwardOrdering})
    my_assert(isequal(m9a, SortedSet(["red", "yellow"])))
    my_assert(intersect(SortedSet{Int}([5,4,8,9]),
                        [5,6,9,2], [5,10,10,9]) == Set{Int}([5,9]))    
    my_assert(intersect(SortedSet{Int}([5,4,8,9]),
                        [5,6,9,2], [5,10,10,8]) != Set{Int}([5,9]))
    my_assert(isequal(intersect(SortedSet{Int,ForBack}(ForBack(true), [5,4,8,9]),
                                SortedSet{Int,ForBack}(ForBack(false), [5,7,8,9])),
                      SortedSet{Int}([5,8,9])))
    my_assert(!isequal(intersect(SortedSet{Int,ForBack}(ForBack(true), [5,4,8,9]),
                                 SortedSet{Int,ForBack}(ForBack(false), [5,7,8,9])),
                       SortedSet{Int}([5,8])))
    
    m10 = symdiff(m8,  SortedSet(["yellow", "red", "white"]))
    my_assert(typeof(m10) == SortedSet{String, ForwardOrdering})
    my_assert(isequal(m10, SortedSet(["white", "blue", "orange"])))
    m11 = symdiff(m8, SortedSet(["yellow", "red", "blue", "orange",
                                 "zinc"]))
    my_assert(typeof(m11) == SortedSet{String, ForwardOrdering})
    my_assert(isequal(m11, SortedSet(["zinc"])))
    m12 = symdiff(SortedSet(["yellow", "red", "blue", "orange",
                                 "zinc"]), m8)
    my_assert(isequal(m12, SortedSet(["zinc"])))
    my_assert(typeof(m12) == SortedSet{String, ForwardOrdering})
    my_assert(isequal(symdiff(SortedSet{String}(["yellow","red", "green", "iron"]),
                              ["iron", "yellow", "reed"]),
                      SortedSet{String}(["red", "reed", "green"])))
    my_assert(isequal(symdiff(SortedSet{String,ForBack}(ForBack(true),
                                                        ["yellow","red", "green", "iron"]),
                              SortedSet{String,ForBack}(ForBack(false),
                                                        ["iron", "yellow", "reed"])),
                      SortedSet{String,ForBack}(ForBack(false), ["red", "reed", "green"])))
    m13 = setdiff(m8, SortedSet(["yellow", "red", "white"]))
    my_assert(typeof(m13) == SortedSet{String, ForwardOrdering})
    my_assert(isequal(m13, SortedSet(["blue", "orange"])))
    m14 = setdiff(m8, SortedSet(["blue"]))
    my_assert(typeof(m14) == SortedSet{String, ForwardOrdering})
    my_assert(isequal(m14, SortedSet(["orange", "yellow", "red"])))
    my_assert(isequal(setdiff(SortedSet(["red", "purple", "pearl", "black"]),
                              ["red", "white", "white"],
                              ["blue", "black", "green"]),
                      SortedSet(["purple", "pearl"])))
    my_assert(isequal(setdiff(SortedSet{String,ForBack}(ForBack(true),
                                                        ["red", "purple", "pearl", "black"]),
                              SortedSet{String,ForBack}(ForBack(false),
                                                        ["purple", "hue", "pearl"])),
                      SortedSet{String}(["red", "black"])))
    
    my_assert(issubset(["yellow", "blue"], m8))
    my_assert(!issubset(["blue", "green"], m8))
    my_assert(issubset(SortedSet(["green", "white", "red"]),
                       SortedSet(["blue","white", "red", "green"])))
    my_assert(issubset(SortedSet(collect(1:5)),
                       SortedSet(collect(0:500))))
    my_assert(!issubset(SortedSet(collect(0:5)),
                       SortedSet(collect(1:500))))
    my_assert(issubset(SortedSet(collect(1:499)),
                       SortedSet(collect(0:500))))
    my_assert(!issubset(SortedSet(collect(0:499)),
                       SortedSet(collect(1:500))))
    my_assert(!issubset(SortedSet(collect(1:501)),
                       SortedSet(collect(1:500))))
    my_assert(issubset(SortedSet{Int,ForBack}(ForBack(false), [1,5]),
                       SortedSet{Int,ForBack}(ForBack(true), [1,5])))
    my_assert(!issubset(SortedSet{Int,ForBack}(ForBack(false), [1,5,6]),
                        SortedSet{Int,ForBack}(ForBack(true), [1,5])))
    setdiff!(m8, SortedSet(["yellow", "red", "white"]))
    my_assert(isequal(m8, SortedSet(["blue", "orange"])))
    my_assert(isequal(union(SortedSet{Int,ForBack}(ForBack(true), [1,2,3]),
                            SortedSet{Int,ForBack}(ForBack(false), [6,4,2])),
                      SortedSet{Int}([1,2,3,4,6])))
    
    true
end


# test the constructors of SortedDict and SortedMultiDict

function testSortedDictConstructors()
    sd1 = SortedDict("w" => 64, "p" => 12)
    my_assert(typeof(sd1) == SortedDict{String, Int, ForwardOrdering})
    my_assert(length(sd1) == 2 && first(sd1) == ("p"=>12) &&
        last(sd1) == ("w"=>64))
    sd2 = SortedDict(Reverse, "w" => 64, "p" => 12)
    my_assert(typeof(sd2) == SortedDict{String, Int, ReverseOrdering{ForwardOrdering}})
    my_assert(length(sd2) == 2 && last(sd2) == ("p"=>12) &&
        first(sd2) == ("w"=>64))
    sd3 = SortedDict(("w"=>64, "p"=>12))
    my_assert(typeof(sd3) == SortedDict{String, Int, ForwardOrdering})
    my_assert(length(sd3) == 2 && first(sd3) == ("p"=>12) &&
        last(sd3) == ("w"=>64))
    sd4 = SortedDict(("w"=>64, "p"=>12), Reverse)
    my_assert(typeof(sd4) == SortedDict{String, Int, ReverseOrdering{ForwardOrdering}})
    my_assert(length(sd4) == 2 && last(sd4) == ("p"=>12) &&
        first(sd4) == ("w"=>64))

    my_assert(typeof(SortedDict()) == SortedDict{Any,Any,ForwardOrdering})
    my_assert(typeof(SortedDict(CaseInsensitive())) == SortedDict{Any,Any,CaseInsensitive})
    my_assert(typeof(SortedDict{Int,Int}(Reverse)) == SortedDict{Int,Int,ReverseOrdering{ForwardOrdering}})
    my_assert(typeof(SortedDict{Int,Int}(Reverse, 1=>2)) == SortedDict{Int,Int,ReverseOrdering{ForwardOrdering}})
    my_assert(typeof(SortedDict{Int,Int}(1=>2)) == SortedDict{Int,Int,ForwardOrdering})
    my_assert(length(SortedDict{Int,Int}(Val(true), [1=>2,3=>7,8=>15])) == 3)
    my_assert(length(SortedDict{Int,Int}(Val(true), [8=>2,3=>7,1=>15], Reverse)) == 3)
    

    # @test_throws ArgumentError SortedDict(Reverse, Reverse)
    true
end

function testSortedMultiDictConstructors()
    sm1 = SortedMultiDict("w" => 64, "p" => 12, "p" => 9)
    my_assert(typeof(sm1) == SortedMultiDict{String, Int, ForwardOrdering})
    my_assert(length(sm1) == 3 && first(sm1) == ("p"=>12) &&
        last(sm1) == ("w"=>64))
    sm2 = SortedMultiDict(Reverse, "w" => 64, "p" => 12, "p" => 9)
    my_assert(typeof(sm2) == SortedMultiDict{String, Int, ReverseOrdering{ForwardOrdering}})
    my_assert(length(sm2) == 3 && last(sm2) == ("p"=>9) &&
        first(sm2) == ("w"=>64))
    sm3 = SortedMultiDict(("w"=>64, "p"=>12, "p"=> 9))
    my_assert(typeof(sm3) == SortedMultiDict{String, Int, ForwardOrdering})
    my_assert(length(sm3) == 3 && first(sm3) == ("p"=>12) &&
        last(sm3) == ("w"=>64))
    sm4 = SortedMultiDict(("w"=> 64, "p"=>12, "p"=>9), Reverse)
    my_assert(typeof(sm4) == SortedMultiDict{String, Int, ReverseOrdering{ForwardOrdering}})
    my_assert(length(sm4) == 3 && last(sm4) == ("p"=>9) &&
        first(sm4) == ("w"=>64))

    my_assert(typeof(SortedMultiDict()) == SortedMultiDict{Any,Any,ForwardOrdering})
    my_assert(typeof(SortedMultiDict(CaseInsensitive())) == SortedMultiDict{Any,Any,CaseInsensitive})
    my_assert(typeof(SortedMultiDict{Int,Int}(Reverse)) == SortedMultiDict{Int,Int,ReverseOrdering{ForwardOrdering}})
    # @test typeof(SortedMultiDict{Int,Int}(Reverse, 1=>2)) == SortedMultiDict{Int,Int,ReverseOrdering{ForwardOrdering}}
    # @test typeof(SortedMultiDict{Int,Int}(1=>2)) == SortedMultiDict{Int,Int,ForwardOrdering}
    true
end

function testTokens()
    ss1 = SortedSet(["turkey", "chicken", "duck", "goose"])
    ss2 = SortedSet(["turkey", "chicken", "duck", "goose"])
    t1 = token_firstindex(ss1)
    my_assert(t1 == (ss1, firstindex(ss1)))
    my_assert(t1 != (ss2, firstindex(ss1)))
    my_assert(t1 != (ss1, lastindex(ss1)))
    my_assert(advance(beforestarttoken(ss1)) == firstindex(ss1))
    my_assert(regress(pastendtoken(ss1)) == lastindex(ss1))

    # test the IteratorSize functions
    my_assert(length(collect(SortedSet([1,2,2,3]))) == 3)
    my_assert(length(collect(keys(SortedDict([1=>2,2=>3,2=>4,3=>4])))) == 3)
    ss3 = SortedSet([1,2,2,3])
    my_assert(length(collect(inclusive(ss3, firstindex(ss3), lastindex(ss3)))) == 3)
    my_assert(length(collect(exclusive(ss3, firstindex(ss3), lastindex(ss3)))) == 2)
    smd1 = SortedMultiDict(5=>"j", 1=>"a", 3=>"b", 1=>"c", 3=>"s")
    my_assert(typeof(smd1) == SortedMultiDict{Int,String, ForwardOrdering})
    result = String[]
    for (k,v) = exclusive_key(smd1, 1, 5)
        push!(result,v)
    end
    my_assert(result == ["a", "c", "b", "s"])
    result2 = String[]
    for (k,v) = inclusive_key(smd1, 1, 5)
        push!(result2, v)
    end
    my_assert(result2 == ["a", "c", "b", "s", "j"])
    count = 0
    for (t,k,v) in tokens(exclusive_key(smd1, 1, 5))
        count += 1
        my_assert(deref(t) == (k=>v))
        my_assert(deref_value(t) == result[count])
    end
    my_assert(count == 4)
    my_assert(eltype(tokens(exclusive_key(smd1, 1, 5))) ==
              Tuple{Tuple{SortedMultiDict{Int,String,ForwardOrdering},IntSemiToken},
                    Int, String})
    count = 0
    for (t,k,v) in tokens(smd1)
        count += 1
        my_assert(deref(t) == (k=>v))
        my_assert(deref_value(t) == result2[count])
    end
    my_assert(count == 5)
    count = 0
    for (t,k) in tokens(keys(smd1))
        count += 1
        my_assert(deref_key(t) == k)
        my_assert(deref_value(t) == result2[count])
    end
    my_assert(count == 5)
    my_assert(eltype(tokens(keys(smd1))) ==
              Tuple{Tuple{SortedMultiDict{Int,String,ForwardOrdering}, IntSemiToken},Int})
    count = 0
    for (t,v) in tokens(values(smd1))
        count += 1
        my_assert(deref_value(t) == v)
        my_assert(deref_value(t) == result2[count])
    end
    my_assert(count == 5)
    my_assert(eltype(tokens(values(smd1))) ==
              Tuple{Tuple{SortedMultiDict{Int,String,ForwardOrdering}, IntSemiToken},String})
    count = 0
    for t in onlytokens(smd1)
        count += 1
        my_assert(deref_value(t) == result2[count])
    end
    my_assert(count == 5)
    my_assert(eltype(onlytokens(smd1)) == Tuple{SortedMultiDict{Int,String,ForwardOrdering},
                                                IntSemiToken})
        
    
    count = 0
    for t in onlytokens(exclusive_key(smd1, 1, 5))
        count += 1
        my_assert(deref_value(t) == result[count])
    end
    my_assert(count == 4)

    count = 4
    # Issue 671
    for t in onlytokens(Iterators.reverse(exclusive_key(smd1, 1, 5)))
        my_assert(deref_value(t) == result[count])
        count -= 1
    end
    my_assert(count == 0)
    count = 5
    for t in onlytokens(Iterators.reverse(smd1))
        my_assert(deref_value(t) == result2[count])
        count -= 1
    end
    my_assert(count == 0)

    count = 0
    for (k,v) in Iterators.reverse(exclusive(smd1, firstindex(smd1), firstindex(smd1)))
        count +=1
    end
    my_assert(count == 0)


    count = 5
    for (k,v) in Iterators.reverse(inclusive(smd1, firstindex(smd1), lastindex(smd1)))
        my_assert(v == result2[count])
        count -= 1
    end
    my_assert(count == 0)

    count = 0
    for (k,v) in Iterators.reverse(inclusive(smd1,
                                             advance((smd1, firstindex(smd1))),
                                             firstindex(smd1)))
        count += 1
    end
    my_assert(count == 0)

    
    count = 0
    for t in Iterators.reverse(exclusive_key(smd1, 1, 1))
        count += 1
    end
    my_assert(count == 0)

    count = 5
    for t in onlytokens(Iterators.reverse(inclusive(smd1, firstindex(smd1), lastindex(smd1))))
        my_assert(deref_value(t) == result2[count])
        count -= 1
    end
    my_assert(count == 0)

    count = 0
    for t in onlytokens(Iterators.reverse(inclusive(smd1, lastindex(smd1), firstindex(smd1))))
        my_assert(deref_value(t) == result2[count])
    end
    my_assert(count == 0)
    
    
        
    
    count = 0
    for t in Iterators.reverse(onlytokens(Iterators.reverse(exclusive_key(smd1, 1, 5))))
        count += 1
        my_assert(deref_value(t) == result[count])
    end
    my_assert(count == 4)
    my_assert(keytype(exclusive_key(smd1, 1, 5)) == Int)
    my_assert(valtype(exclusive_key(smd1, 1, 5)) == String)
    count = 0
    for (k,v) in pairs(exclusive_key(smd1, 1, 5))
        count += 1
        my_assert(v == result[count])
    end
    my_assert(keytype(exclusive_key(smd1,1, 5)) == Int)
    my_assert(keytype(typeof(exclusive_key(smd1,1, 5))) == Int)
    my_assert(valtype(exclusive_key(smd1,1, 5)) == String)
    my_assert(valtype(typeof(exclusive_key(smd1,1, 5))) == String)
    my_assert(count == 4)
    count = 0
    for (k,v) in pairs(smd1)
        count += 1
        my_assert(v == result2[count])
    end
    my_assert(count == 5)
    count = 0
    for t in token_firstindex(smd1) : token_lastindex(smd1)  # address issue 669
        count += 1
        my_assert(deref_value(t) == result2[count])
    end
    my_assert(count == 5)
    count = 1
    for t in token_firstindex(smd1) + 1 : token_lastindex(smd1) - 1
        count += 1
        my_assert(deref_value(t) == result2[count])
    end
    my_assert(count == 4)
    true
end
        
              

function testSortedAllocs()
    d = SortedDict{Int,Int}(Base.Order.ForwardOrdering())
    x = @allocated empty!(d)
    my_assert(x == 0)
    true
end

@testset "SortedContainers" begin
    @test testSortedDictBasic()
    @test testSortedDictMethods()
    @test testSortedDictLoops()
    @test testSortedDictOrderings()
    @test testSortedMultiDict()
    @test testSortedSet()
    @test testSortedDictConstructors()
    @test testSortedMultiDictConstructors()
    @test testTokens()
    @test testSortedAllocs()


    # test all the errors of sorted containers
    m = SortedDict(Dict("a" => 6, "bb" => 9))
    @test_throws KeyError println(m["b"])
    m2 = SortedDict{String,Int}()
    @test_throws BoundsError println(first(m2))
    @test_throws BoundsError println(last(m2))
    i1 = findkey(m,"a")
    delete!((m,i1))
    i2 = findkey(m,"bb")
    @test_throws BoundsError iterate(inclusive(m,i1,i2))
    @test_throws BoundsError iterate(exclusive(m,i1,i2))
    @test m === delete!(m,"a") # Okay to delete! nonexistent keys
    @test_throws KeyError pop!(m,"a")
    m3 = SortedDict((Dict{String, Int}()), Reverse)
    @test_throws BoundsError m[i1]
    @test_throws BoundsError regress((m,beforestartsemitoken(m)))
    @test_throws BoundsError advance((m,pastendsemitoken(m)))
    m1 = SortedMultiDict{Int,Int}()
    @test_throws ArgumentError SortedMultiDict([1,2,3])
    @test_throws ArgumentError SortedMultiDict(Forward, [1,2,3])
    @test_throws BoundsError SortedMultiDict{Int,Int}([1,2,3])
    @test_throws BoundsError SortedMultiDict{Int,Int}(Forward, [1,2,3])
    @test_throws ArgumentError SortedMultiDict(Forward, Reverse)
    @test_throws ArgumentError SortedMultiDict{Int,Int}(Forward, Reverse)
    @test_throws ArgumentError SortedMultiDict(Val(true), Forward)
    @test_throws ArgumentError SortedMultiDict{Int,Int}(Val(true), Forward)
    #@test_throws ArgumentError isequal(SortedMultiDict("a"=>1), SortedMultiDict("b"=>1.0))
    #@test_throws ArgumentError isequal(SortedMultiDict(["a"=>1],Reverse), SortedMultiDict(["b"=>1]))
    @test_throws MethodError SortedMultiDict{Char,Int}(Forward, ["aa"=>2, "bbb"=>5])
    @test_throws MethodError SortedMultiDict(Forward, [("aa",2)=>2, "bbb"=>5])
    @test_throws BoundsError first(m1)
    @test_throws BoundsError last(m1)

    s = SortedSet([3,5])
    @test s === delete!(s,7) # Okay to delete! nonexistent keys
    @test_throws KeyError pop!(s, 7)
    popfirst!(s)
    popfirst!(s)
    @test_throws BoundsError popfirst!(s)
    @test_throws BoundsError first(s)
    @test_throws BoundsError last(s)
    @test_throws MethodError isequal(SortedSet(["a"]), SortedSet([1]))
    #@test_throws ArgumentError isequal(SortedSet(["a"]), SortedSet(["b"],Reverse))
    #@test_throws ErrorException (("a",6) in m)
    #@test_throws ArgumentError ((2,5) in m1)
    @test_throws ErrorException get(SortedDict(1=>3), SortedDict(1=>3), 1)

    s = SortedSet([10,30,50])
    @test pop!(s,10) == 10
    @test pop!(s,30,-1) == 30
    @test pop!(s,30, nothing) == nothing
    @test pop!(s,50, nothing) == 50
    @test pop!(s,50, nothing) == nothing
    @test isempty(s)
    @test_throws ErrorException pop!(s)

    # Test AbstractSet/AbstractDict interface
    for m in [SortedSet([1,2]), SortedDict(1=>2, 2=>3), SortedMultiDict(1=>2, 1=>3)]
        # copy()
        let m1 = copy(m)
            @test isequal(m1, m)
            @test typeof(m1) === typeof(m)
        end
        let m1 = Base.copymutable(m)
            @test isequal(m1, m)
            @test typeof(m1) === typeof(m)
        end
    end
end

#  multi-value dictionary (multidict)

struct MultiDict{K,V}
    d::Dict{K,Vector{V}}

    MultiDict{K,V}() where {K,V} = new{K,V}(Dict{K,Vector{V}}())
    MultiDict{K,V}(kvs) where {K,V} = new{K,V}(Dict{K,Vector{V}}(kvs))
    MultiDict{K,V}(ps::Pair{K,Vector{V}}...) where {K,V} = new{K,V}(Dict{K,Vector{V}}(ps...))
end

MultiDict() = MultiDict{Any,Any}()
MultiDict(kv::Tuple{}) = MultiDict()
MultiDict(kvs) = multi_dict_with_eltype(kvs, eltype(kvs))

multi_dict_with_eltype(kvs, ::Type{Tuple{K,Vector{V}}}) where {K,V} = MultiDict{K,V}(kvs)
function multi_dict_with_eltype(kvs, ::Type{Tuple{K,V}}) where {K,V}
    md = MultiDict{K,V}()
    for (k,v) in kvs
        insert!(md, k, v)
    end
    return md
end
multi_dict_with_eltype(kvs, t) = MultiDict{Any,Any}(kvs)


MultiDict(kv::AbstractArray{Pair{K,V}}) where {K,V}  = MultiDict(kv...)
function MultiDict(ps::Pair{K,V}...) where {K,V}
    md = MultiDict{K,V}()
    for (k,v) in ps
        insert!(md, k, v)
    end
    return md
end

## Functions

## Most functions are simply delegated to the wrapped Dict

@delegate MultiDict.d [ Base.haskey, Base.get, Base.get!, Base.getkey,
                        Base.getindex, Base.length, Base.isempty, Base.eltype,
                        Base.iterate, Base.keys, Base.values]

Base.sizehint!(d::MultiDict, sz::Integer) = (sizehint!(d.d, sz); d)
Base.copy(d::MultiDict) = MultiDict(d)
Base.empty(d::MultiDict{K,V}) where {K,V} = MultiDict{K,V}()
Base.:(==)(d1::MultiDict, d2::MultiDict) = d1.d == d2.d
Base.delete!(d::MultiDict, key) = (delete!(d.d, key); d)
Base.empty!(d::MultiDict) = (empty!(d.d); d)

function Base.insert!(d::MultiDict{K,V}, k, v) where {K,V}
    if !haskey(d.d, k)
        d.d[k] = V[]
    end
    push!(d.d[k], v)
    return d
end

function Base.in(pr::(Tuple{Any,Any}), d::MultiDict{K,V}) where {K,V}
    k = convert(K, pr[1])
    v = get(d,k,Base.secret_table_token)
    (v !== Base.secret_table_token) && (pr[2] in v)
end

function Base.pop!(d::MultiDict, key, default)
    vs = get(d, key, Base.secret_table_token)
    if vs === Base.secret_table_token
        if default !== Base.secret_table_token
            return default
        else
            throw(KeyError(key))
        end
    end
    v = pop!(vs)
    (length(vs) == 0) && delete!(d, key)
    return v
end
Base.pop!(d::MultiDict, key) = pop!(d, key, Base.secret_table_token)

Base.push!(d::MultiDict, kv::Pair) = insert!(d, kv[1], kv[2])
#Base.push!(d::MultiDict, kv::Pair, kv2::Pair) = (push!(d.d, kv, kv2); d)
#Base.push!(d::MultiDict, kv::Pair, kv2::Pair, kv3::Pair...) = (push!(d.d, kv, kv2, kv3...); d)

Base.push!(d::MultiDict, kv) = insert!(d, kv[1], kv[2])
#Base.push!(d::MultiDict, kv, kv2...) = (push!(d.d, kv, kv2...); d)

Base.count(d::MultiDict) = length(keys(d)) == 0 ? 0 : mapreduce(k -> length(d[k]), +, keys(d))
Base.size(d::MultiDict) = (length(keys(d)), count(d::MultiDict))

# enumerate

struct EnumerateAll
    d::MultiDict
end
enumerateall(d::MultiDict) = EnumerateAll(d)

Base.length(e::EnumerateAll) = count(e.d)

function Base.iterate(e::EnumerateAll)
    V = eltype(eltype(values(e.d)))
    vs = V[]
    dstate = iterate(e.d.d)
    vstate = iterate(vs)
    dstate === nothing || vstate === nothing && return nothing
    k = nothing
    while vstate === nothing
        ((k, vs), dst) = dstate
        dstate = iterate(e.d.d, dst)
        vstate = iterate(vs)
    end
    v, vst = vstate
    return ((k, v), (dstate, k, vs, vstate))
end

function Base.iterate(e::EnumerateAll, s)
    dstate, k, vs, vstate = s
    dstate === nothing || vstate === nothing && return nothing
    while vstate === nothing
        ((k, vs), dst) = dstate
        dstate = iterate(e.d.d, dst)
        vstate = iterate(vs)
    end
    v, vst = vstate
    return ((k, v), (dstate, k, vs, vstate))
end

module BenchHeap

using DataStructures
using BenchmarkTools
using Random

function push_heap(h::AbstractHeap, xs::Vector)
    n = length(xs)

    for i = 1 : n
        push!(h, xs[i])
    end
end

function pop_heap(h::AbstractHeap)
    n = length(h)

    for i = 1 : n
        pop!(h)
    end
end

suite = BenchmarkGroup()

heaptypes = [BinaryHeap, MutableBinaryHeap]
aexps = [1,3]
datatypes = [Int, Float64]
baseorderings = Dict(
    "Min" => Base.ForwardOrdering,
    #"Max" => Base.ReverseOrdering,
    )
fastfloatorderings = Dict(
    "Min" => DataStructures.FasterForward,
    "Max" => DataStructures.FasterReverse,
    )

for heap in heaptypes
    for aexp in aexps
        for dt in datatypes
            Random.seed!(0)
            a = rand(dt, 10^aexp)

            # Dict types to force use of abstract type if containing single value
            orderings = Dict{String, DataType}(baseorderings)
            if dt == Float64
                # swap to faster ordering operation
                for (k,v) in orderings
                    if haskey(fastfloatorderings, k)
                        orderings["Slow"*k] = v
                        orderings[k] = fastfloatorderings[k]
                    end
                end
            end

            for (ord_str, ord) in orderings
                prepath = [string(heap)]
                postpath = [string(dt), "10^"*string(aexp), ord_str]
                suite[vcat(prepath, ["make"], postpath)] =
                    @benchmarkable $(heap){$dt,$ord}($a)
                suite[vcat(prepath, ["push"], postpath)] =
                    @benchmarkable push_heap(h, $a) setup=(h=$(heap){$dt,$ord}())
                suite[vcat(prepath, ["pop"], postpath)] =
                    @benchmarkable pop_heap(h) setup=(h=$(heap){$dt,$ord}($a))
            end
        end
    end
end

fast_extreme_orderings = Dict(
    nsmallest => DataStructures.FasterForward(),
    nlargest => DataStructures.FasterReverse(),
    )

for func in [nlargest, nsmallest]
    fastord = fast_extreme_orderings[func]
    for aexp in [4]
        Random.seed!(0);
        a = rand(10^aexp);
        for nexp in [2]
            n = 10^nexp
            suite[["Slow " * string(func), "a=rand(10^"*string(aexp)*")", "n=10^"*string(nexp)]] =
                @benchmarkable $(func)($n, $a)
            suite[[string(func), "a=rand(10^"*string(aexp)*")", "n=10^"*string(nexp)]] =
                @benchmarkable DataStructures.nextreme($fastord, $n, $a)
        end
    end
end

end  # module

BenchHeap.suite

# Test of binary heaps

@testset "BinaryHeaps" begin

    @testset "make heap" begin
        vs = [4, 1, 3, 2, 16, 9, 10, 14, 8, 7]
        vs2 = collect(enumerate(vs))
        ordering = Base.Order.By(last)

        @testset "construct heap" begin
            BinaryHeap{Int, Base.ForwardOrdering}()
            BinaryHeap{Int, Base.ForwardOrdering}(vs)

            BinaryHeap{Int, Base.ReverseOrdering}()
            BinaryHeap{Int, Base.ReverseOrdering}(vs)

            BinaryMinHeap{Int}()
            BinaryMinHeap{Int}(vs)
            BinaryMinHeap(vs)

            BinaryMaxHeap{Int}()
            BinaryMaxHeap{Int}(vs)
            BinaryMaxHeap(vs)

            BinaryHeap{eltype(vs2)}(ordering)
            BinaryHeap{eltype(vs2)}(ordering, vs2)
            BinaryHeap(ordering, vs2)

            @test true
        end

        @testset "Type Aliases" begin
            # https://github.com/JuliaCollections/DataStructures.jl/issues/686
            @test BinaryMaxHeap{Int}() isa BinaryMaxHeap{Int}
            @test BinaryMinHeap{Int}() isa BinaryMinHeap{Int}
        end

        @testset "implicit conversion" begin
            BinaryHeap{Float64, Base.ForwardOrdering}(vs)
            BinaryMinHeap{Float64}(vs)
            BinaryMaxHeap{Float64}(vs)
            BinaryHeap{Tuple{Int, Float64}}(ordering, vs2)

            @test true
        end

        @testset "confirm heap" begin
            @test isheap([1, 2, 3, 4, 7, 9, 10, 14, 8, 16])
            @test isheap([16, 14, 10, 8, 7, 3, 9, 1, 4, 2], Base.Reverse)

            @test !isheap([16, 14, 10, 8, 7, 3, 9, 1, 4, 2])
            @test !isheap([1, 2, 3, 4, 7, 9, 10, 14, 8, 16], Base.Reverse)
            @test !isheap([15, 2, 3, 4, 7, 9, 10, 14, 8, 16])
            @test !isheap([15, 2, 3, 4, 7, 9, 10, 14, 8, 16], Base.Reverse)
        end

        @testset "make min heap" begin
            h = BinaryMinHeap(vs)

            @test length(h) == 10
            @test !isempty(h)
            @test first(h) == 1
            @test isheap([1, 2, 3, 4, 7, 9, 10, 14, 8, 16])
            @test sizehint!(h, 100) === h
        end

        @testset "make max heap" begin
            h = BinaryMaxHeap(vs)

            @test length(h) == 10
            @test !isempty(h)
            @test first(h) == 16
            @test isheap([16, 14, 10, 8, 7, 3, 9, 1, 4, 2], Base.Reverse)
            @test sizehint!(h, 100) === h
        end

        @testset "make custom ordering heap" begin
            h = BinaryHeap(ordering, vs2)

            @test length(h) == 10
            @test !isempty(h)
            @test first(h) == (2, 1)
            @test isheap([(2, 1), (4, 2), (3, 3), (1, 4), (10, 7), (6, 9), (7, 10), (8, 14), (9, 8), (5, 16)], ordering)
            @test sizehint!(h, 100) === h
        end

        @testset "extract all" begin
            @test sort(vs) == extract_all!(BinaryMinHeap(vs))
            @test reverse(sort(vs)) == extract_all_rev!(BinaryMinHeap(vs))
        end

        @testset "push!" begin
            @testset "push! hmin" begin
                hmin = BinaryMinHeap{Int}()
                @test length(hmin) == 0
                @test isempty(hmin)

                ss = Any[
                    [4],
                    [1, 4],
                    [1, 4, 3],
                    [1, 2, 3, 4],
                    [1, 2, 3, 4, 16],
                    [1, 2, 3, 4, 16, 9],
                    [1, 2, 3, 4, 16, 9, 10],
                    [1, 2, 3, 4, 16, 9, 10, 14],
                    [1, 2, 3, 4, 16, 9, 10, 14, 8],
                    [1, 2, 3, 4, 7, 9, 10, 14, 8, 16]]

                for i = 1 : length(vs)
                    push!(hmin, vs[i])
                    @test length(hmin) == i
                    @test !isempty(hmin)
                    @test isequal(hmin.valtree, ss[i])
                end

                @testset "pop! hmin" begin
                    @test isequal(extract_all!(hmin), [1, 2, 3, 4, 7, 8, 9, 10, 14, 16])
                    @test isempty(hmin)
                end
            end

            @testset "push! hmax" begin
                hmax = BinaryMaxHeap{Int}()
                @test length(hmax) == 0
                @test isempty(hmax)

                ss = Any[
                    [4],
                    [4, 1],
                    [4, 1, 3],
                    [4, 2, 3, 1],
                    [16, 4, 3, 1, 2],
                    [16, 4, 9, 1, 2, 3],
                    [16, 4, 10, 1, 2, 3, 9],
                    [16, 14, 10, 4, 2, 3, 9, 1],
                    [16, 14, 10, 8, 2, 3, 9, 1, 4],
                    [16, 14, 10, 8, 7, 3, 9, 1, 4, 2]]

                for i = 1 : length(vs)
                    push!(hmax, vs[i])
                    @test length(hmax) == i
                    @test !isempty(hmax)
                    @test isequal(hmax.valtree, ss[i])
                end

                @testset "pop! hmax" begin
                    @test isequal(extract_all!(hmax), [16, 14, 10, 9, 8, 7, 4, 3, 2, 1])
                    @test isempty(hmax)
                end
            end

            @testset "push! custom ordering" begin
                heap = BinaryHeap{Tuple{Int,Int}}(ordering)
                @test length(heap) == 0
                @test isempty(heap)

                ss = Any[
                    [(1, 4)],
                    [(2, 1), (1, 4)],
                    [(2, 1), (1, 4), (3, 3)],
                    [(2, 1), (4, 2), (3, 3), (1, 4)],
                    [(2, 1), (4, 2), (3, 3), (1, 4), (5, 16)],
                    [(2, 1), (4, 2), (3, 3), (1, 4), (5, 16), (6, 9)],
                    [(2, 1), (4, 2), (3, 3), (1, 4), (5, 16), (6, 9), (7, 10)],
                    [(2, 1), (4, 2), (3, 3), (1, 4), (5, 16), (6, 9), (7, 10), (8, 14)],
                    [(2, 1), (4, 2), (3, 3), (1, 4), (5, 16), (6, 9), (7, 10), (8, 14), (9, 8)],
                    [(2, 1), (4, 2), (3, 3), (1, 4), (10, 7), (6, 9), (7, 10), (8, 14), (9, 8), (5, 16)]]

                for i = 1 : length(vs2)
                    push!(heap, vs2[i])
                    @test length(heap) == i
                    @test !isempty(heap)
                    @test isequal(heap.valtree, ss[i])
                end

                @testset "pop! custom ordering" begin
                    @test isequal(extract_all!(heap), sort(vs2, order=ordering))
                    @test isempty(heap)
                end
            end
        end

    end

    @testset "hybrid push! and pop!" begin
        h = BinaryMinHeap{Int}()

        @testset "push1" begin
            push!(h, 5)
            push!(h, 10)
            @test isequal(h.valtree, [5, 10])
        end

        @testset "pop1" begin
            @test pop!(h) == 5
            @test isequal(h.valtree, [10])
        end

        @testset "push2" begin
            push!(h, 7)
            push!(h, 2)
            @test isequal(h.valtree, [2, 10, 7])
        end

        @testset "pop2" begin
            @test pop!(h) == 2
            @test isequal(h.valtree, [7, 10])
        end
    end

    @testset "nlargest and nsmallest" begin
        ss = [100,103,-12,-109,67,4,65,-52,-97,-32,-24,114,-128,
            102,-56,-17,-41,25,-30,-84,26,-84,48,49,-5,-38,28,
            114,-54,96,-55,67,74,127,-61,124,11,-7,93,-51,110,
            -106,-84,-90,-18,-12,-116,21,115,50]
        square = x -> x^2

        for n = -1:length(ss) + 1
            r = 1:min(n, length(ss))

            @test nlargest(n, ss) == sort(ss, rev=true)[r]
            @test nsmallest(n, ss) == sort(ss)[r]

            @test nlargest(n, ss, by=square) == sort(ss, by=square, rev=true)[r]
            @test nsmallest(n, ss, by=square) == sort(ss, by=square)[r]

            @test nlargest(n, ss) == DataStructures.nextreme(DataStructures.FasterReverse(), n, ss)
            @test nsmallest(n, ss) == DataStructures.nextreme(DataStructures.FasterForward(), n, ss)
        end
    end

    @testset "push! type conversion" begin # issue 399
        h = BinaryMinHeap{Float64}()
        push!(h, 3.0)
        push!(h, 5)
        push!(h, Rational(4, 8))
        push!(h, Complex(10.1, 0.0))

        @test isequal(h.valtree, [0.5, 5.0, 3.0, 10.1])
    end
end # @testset BinaryHeap

struct FenwickTree{T}
    bi_tree::Vector{T} #bi_tree is shorthand for Binary Indexed Tree, an alternative name for Fenwick Tree
    n::Int
end

"""
    FenwickTree{T}(n::Integer)

Constructs a [`FenwickTree`](https://en.wikipedia.org/wiki/Fenwick_tree) of length `n`.

"""
FenwickTree{T}(n::Integer) where T = FenwickTree{T}(zeros(T, n), n)

"""
    FenwickTree(counts::AbstractArray)

Constructs a [`FenwickTree`](https://en.wikipedia.org/wiki/Fenwick_tree) from an array of `counts`

"""
function FenwickTree(a::AbstractVector{U}) where U
    n = length(a)
    tree = FenwickTree{U}(n)
    @inbounds for i = 1:n
        inc!(tree, i, a[i])
    end
    tree
end

Base.length(ft::FenwickTree) = ft.n
Base.eltype(::Type{FenwickTree{T}}) where T = T

"""
    inc!(ft::FenwickTree{T}, ind::Integer, val)

Increases the value of the [`FenwickTree`] by `val` from the index `ind` upto the length of the Fenwick Tree.

"""
function inc!(ft::FenwickTree{T}, ind::Integer, val = 1) where T
    val0 = convert(T, val)
    i = ind
    n = ft.n
    @boundscheck 1 <= i <= n || throw(ArgumentError("$i should be in between 1 and $n"))
    @inbounds while i <= n
        ft.bi_tree[i] += val0
        i += i&(-i)
    end
end

"""
    dec!(ft::FenwickTree, ind::Integer, val)

Decreases the value of the [`FenwickTree`] by `val` from the index `ind` upto the length of the Fenwick Tree.

"""
dec!(ft::FenwickTree, ind::Integer, val = 1 ) = inc!(ft, ind, -val)

"""
    incdec!(ft::FenwickTree{T}, left::Integer, right::Integer, val)

Increases the value of the [`FenwickTree`] by `val` from the indices from `left` and decreases it from the `right`.

"""
function incdec!(ft::FenwickTree{T}, left::Integer, right::Integer, val = one(T)) where T
    val0 = convert(T, val)
    inc!(ft, left, val0)
    dec!(ft, right, val0)
end

"""
    prefixsum(ft::FenwickTree{T}, ind::Integer)

Return the cumulative sum from index 1 upto `ind` of the [`FenwickTree`](@ref)

# Examples
```
julia> f = FenwickTree{Int}(6)
julia> inc!(f, 2, 5)
julia> prefixsum(f, 1)
 0
julia> prefixsum(f, 3)
 5
```
"""
function prefixsum(ft::FenwickTree{T}, ind::Integer) where T
    sum = zero(T)
    ind < 1 && return sum
    i = ind
    n = ft.n
    @boundscheck 1 <= i <= n || throw(ArgumentError("$i should be in between 1 and $n"))
    @inbounds while i > 0
        sum += ft.bi_tree[i]
        i -= i&(-i)
    end
    sum
end

Base.getindex(ft::FenwickTree{T}, ind::Integer) where T = prefixsum(ft, ind)

# Test of binary heaps

# auxiliary functions

function heap_values(h::MutableBinaryHeap{VT,O}) where {VT,O}
    n = length(h)
    nodes = h.nodes
    @assert length(nodes) == n
    vs = Vector{VT}(undef, n)
    for i = 1 : n
        vs[i] = nodes[i].value
    end
    vs
end

function list_values(h::MutableBinaryHeap{VT,O}) where {VT,O}
    n = length(h)
    nodes = h.nodes
    nodemap = h.node_map
    vs = Vector{VT}()
    for i = 1 : length(nodemap)
        id = nodemap[i]
        if id > 0
            push!(vs, nodes[id].value)
        end
    end
    vs
end

function verify_heap(h::MutableBinaryHeap{VT,O}) where {VT,O}
    ord = h.ordering
    nodes = h.nodes
    n = length(h)
    m = div(n,2)
    for i = 1 : m
        v = nodes[i].value
        lc = i * 2
        if lc <= n
            if Base.lt(ord, nodes[lc].value, v)
                return false
            end
        end
        rc = lc + 1
        if rc <= n
            if Base.lt(ord, nodes[rc].value, v)
                return false
            end
        end
    end
    return true
end

@testset "MutableBinheap" begin

    vs = [4, 1, 3, 2, 16, 9, 10, 14, 8, 7]
    vs2 = collect(enumerate(vs))
    ordering = Base.Order.By(last)

    @testset "construct heap" begin
        MutableBinaryHeap{Int, Base.ForwardOrdering}()
        MutableBinaryHeap{Int, Base.ForwardOrdering}(vs)

        MutableBinaryHeap{Int, Base.ReverseOrdering}()
        MutableBinaryHeap{Int, Base.ReverseOrdering}(vs)

        MutableBinaryMinHeap{Int}()
        MutableBinaryMinHeap{Int}(vs)
        MutableBinaryMinHeap(vs)

        MutableBinaryMaxHeap{Int}()
        MutableBinaryMaxHeap{Int}(vs)
        MutableBinaryMaxHeap(vs)

        MutableBinaryHeap{eltype(vs2)}(ordering)
        MutableBinaryHeap{eltype(vs2)}(ordering, vs2)
        MutableBinaryHeap(ordering, vs2)

        @test true
    end

    @testset "Type Aliases" begin
        # https://github.com/JuliaCollections/DataStructures.jl/issues/686
        @test MutableBinaryMaxHeap{Int}() isa MutableBinaryMaxHeap{Int}
        @test MutableBinaryMinHeap{Int}() isa MutableBinaryMinHeap{Int}
    end

    @testset "basic tests" begin
        h = MutableBinaryMinHeap{Int}()

        @test length(h) == 0
        @test isempty(h)
        @test eltype(h) == Int
        @test eltype(typeof(h)) == Int
    end

    @testset "make mutable binary minheap" begin
        h = MutableBinaryMinHeap(vs)

        @test length(h) == 10
        @test !isempty(h)
        @test first(h) == 1
        @test isequal(list_values(h), vs)
        @test isequal(heap_values(h), [1, 2, 3, 4, 7, 9, 10, 14, 8, 16])
        @test sizehint!(h, 100) === h
    end

    @testset "make mutable binary maxheap" begin
        h = MutableBinaryMaxHeap(vs)

        @test length(h) == 10
        @test !isempty(h)
        @test first(h) == 16
        @test isequal(list_values(h), vs)
        @test isequal(heap_values(h), [16, 14, 10, 8, 7, 3, 9, 1, 4, 2])
        @test sizehint!(h, 100) === h
    end

    @testset "make mutable binary custom ordering heap" begin
        h = MutableBinaryHeap(ordering, vs2)

        @test length(h) == 10
        @test !isempty(h)
        @test first(h) == (2, 1)
        @test isequal(list_values(h), vs2)
        @test isequal(heap_values(h), [(2, 1), (4, 2), (3, 3), (1, 4), (10, 7), (6, 9), (7, 10), (8, 14), (9, 8), (5, 16)])
        @test sizehint!(h, 100) === h
    end

    @testset "hmin / push! / pop!" begin
        hmin = MutableBinaryMinHeap{Int}()
        @test length(hmin) == 0
        @test isempty(hmin)

        # test push!
        ss = Any[
            [4],
            [1, 4],
            [1, 4, 3],
            [1, 2, 3, 4],
            [1, 2, 3, 4, 16],
            [1, 2, 3, 4, 16, 9],
            [1, 2, 3, 4, 16, 9, 10],
            [1, 2, 3, 4, 16, 9, 10, 14],
            [1, 2, 3, 4, 16, 9, 10, 14, 8],
            [1, 2, 3, 4, 7, 9, 10, 14, 8, 16]]
        for i = 1 : length(vs)
            ia = push!(hmin, vs[i])
            @test ia == i
            @test length(hmin) == i
            @test !isempty(hmin)
            @test isequal(list_values(hmin), vs[1:i])
            @test isequal(heap_values(hmin), ss[i])
        end

        # test pop!
        @test isequal(extract_all!(hmin), [1, 2, 3, 4, 7, 8, 9, 10, 14, 16])
        @test isempty(hmin)
    end

    @testset "hmax / push! / pop!" begin
        hmax = MutableBinaryMaxHeap{Int}()
        @test length(hmax) == 0
        @test isempty(hmax)

        # test push!
        ss = Any[
            [4],
            [4, 1],
            [4, 1, 3],
            [4, 2, 3, 1],
            [16, 4, 3, 1, 2],
            [16, 4, 9, 1, 2, 3],
            [16, 4, 10, 1, 2, 3, 9],
            [16, 14, 10, 4, 2, 3, 9, 1],
            [16, 14, 10, 8, 2, 3, 9, 1, 4],
            [16, 14, 10, 8, 7, 3, 9, 1, 4, 2]]
        for i = 1 : length(vs)
            ia = push!(hmax, vs[i])
            @test ia == i
            @test length(hmax) == i
            @test !isempty(hmax)
            @test isequal(list_values(hmax), vs[1:i])
            @test isequal(heap_values(hmax), ss[i])
        end

        # test pop!
        @test isequal(extract_all!(hmax), [16, 14, 10, 9, 8, 7, 4, 3, 2, 1])
        @test isempty(hmax)
    end

    @testset "Custom ordering push! / pop!" begin
        heap = MutableBinaryHeap{Tuple{Int,Int}}(ordering)
        @test length(heap) == 0
        @test isempty(heap)

        # test push!
        ss = Any[
            [(1, 4)],
            [(2, 1), (1, 4)],
            [(2, 1), (1, 4), (3, 3)],
            [(2, 1), (4, 2), (3, 3), (1, 4)],
            [(2, 1), (4, 2), (3, 3), (1, 4), (5, 16)],
            [(2, 1), (4, 2), (3, 3), (1, 4), (5, 16), (6, 9)],
            [(2, 1), (4, 2), (3, 3), (1, 4), (5, 16), (6, 9), (7, 10)],
            [(2, 1), (4, 2), (3, 3), (1, 4), (5, 16), (6, 9), (7, 10), (8, 14)],
            [(2, 1), (4, 2), (3, 3), (1, 4), (5, 16), (6, 9), (7, 10), (8, 14), (9, 8)],
            [(2, 1), (4, 2), (3, 3), (1, 4), (10, 7), (6, 9), (7, 10), (8, 14), (9, 8), (5, 16)]]
        for i = 1 : length(vs2)
            ia = push!(heap, vs2[i])
            @test ia == i
            @test length(heap) == i
            @test !isempty(heap)
            @test isequal(list_values(heap), vs2[1:i])
            @test isequal(heap_values(heap), ss[i])
        end

        # test pop!
        @test isequal(extract_all!(heap), sort(vs2, order=ordering))
        @test isempty(heap)
    end

    @testset "hybrid push! and pop!" begin
        h = MutableBinaryMinHeap{Int}()

        push!(h, 5)
        push!(h, 10)
        @test isequal(heap_values(h), [5, 10])
        @test isequal(list_values(h), [5, 10])

        @test pop!(h) == 5
        @test isequal(heap_values(h), [10])
        @test isequal(list_values(h), [10])

        push!(h, 7)
        push!(h, 2)
        @test isequal(heap_values(h), [2, 10, 7])
        @test isequal(list_values(h), [10, 7, 2])

        @test pop!(h) == 2
        @test isequal(heap_values(h), [7, 10])
        @test isequal(list_values(h), [10, 7])

    end

    @testset "test delete!" begin
        vs = [1, 2, 4, 6, 3]
        h = MutableBinaryMinHeap(vs)

        @test isequal(heap_values(delete!(h, 1)), [2, 3, 4, 6])
        @test isequal(heap_values(delete!(h, 5)), [2, 6, 4])
        @test_throws BoundsError delete!(h, 10)
        @test_throws BoundsError delete!(h, 0)
        @test_throws BoundsError delete!(h, -5)
        @test pop!(h) == 2
        @test pop!(h) == 4
        push!(h, 2)
        @test pop!(h) == 2
        @test pop!(h) == 6
        @test isempty(h)
        #bubble_up test
        vv = [1, 9, 22, 17, 11, 33, 27, 21, 19]
        hp = MutableBinaryMinHeap(vv)
        delete!(hp, 6)
        @test isequal(extract_all!(hp), [1, 9, 11, 17, 19, 21, 22, 27])
    end

    @testset "test delete! at end" begin
        h = MutableBinaryMinHeap{Int}()
        push!(h, 1)
        handle = push!(h, 2)
        delete!(h, handle)
        @test isequal(heap_values(h), [1])
    end

    @testset "test delete! at end of 3-element heap" begin
        h = MutableBinaryMinHeap{Int}()
        push!(h, 1)
        push!(h, 2)
        handle = push!(h, 3)
        delete!(h, handle)
        @test isequal(heap_values(h), [1, 2])
    end

    @testset "test update! and top_with_handle" begin
        for (hf,m) = [(MutableBinaryMinHeap,-2.0), (MutableBinaryMaxHeap,2.0)]
            xs = rand(100)
            h = hf(xs)
            @test length(h) == 100
            @test verify_heap(h)

            for t = 1:1000
                i = rand(1:100)
                v = rand()
                xs[i] = v
                update!(h, i, v)
                @test length(h) == 100
                @test verify_heap(h)
                @test isequal(list_values(h), xs)

                v, i = top_with_handle(h)
                update!(h, i, m)
                xs[i] = m
                @test length(h) == 100
                @test verify_heap(h)
                @test isequal(list_values(h), xs)
                @test top_with_handle(h) == (m, i)

                update!(h, i, -m)
                xs[i] = -m
                @test length(h) == 100
                @test verify_heap(h)
                @test isequal(list_values(h), xs)
                @test top_with_handle(h)[2] ≠ i

                update!(h, i, v)
                xs[i] = v
                @test length(h) == 100
                @test verify_heap(h)
                @test isequal(list_values(h), xs)
                @test top_with_handle(h) == (v, i)

                i = rand(1:100)
                v = rand()
                h[i] = v
                xs[i] = v
                @test length(h) == 100
                @test verify_heap(h)
                @test isequal(list_values(h), xs)
                @test v == h[i]
            end
        end
    end

    @testset "test push! and update! conversion" begin # issue 399
        h = MutableBinaryMinHeap{Float64}()
        push!(h, 3.0)
        push!(h, 5)
        push!(h, Rational(4, 8))
        push!(h, Complex(10.1, 0.0))
        @test isequal(heap_values(h), [0.5, 5.0, 3.0, 10.1])

        update!(h, 2, 20)
        @test isequal(heap_values(h), [0.5, 10.1, 3.0, 20.0])
    end

    @testset "T is a Union" begin
        h = MutableBinaryMinHeap{Union{Int, Float64}}()
        push!(h, 1)
        push!(h, 2.0)
        update!(h, 1, 1.5)
        update!(h, 2, 3)
        @test pop!(h) === 1.5
        @test pop!(h) === 3
    end
  
    @testset "empty!" begin
        vs = [4, 1, 3, 2, 16, 9, 10, 14, 8, 7]
        vs2 = collect(enumerate(vs))
        ordering = Base.Order.By(last)

        for h in (MutableBinaryMinHeap(vs), MutableBinaryMaxHeap(vs), MutableBinaryHeap(ordering, vs2))
            @test length(h) == length(vs)
            @test !isempty(h)
            ret = empty!(h)
            @test ret === h
            @test length(ret) == 0
            @test isempty(ret)
            @test verify_heap(ret)
        end
    end
end # @testset MutableBinheap

# it has unique keys
# leftChild has keys which are less than the node
# rightChild has keys which are greater than the node
# color is true if it's a Red Node, else it's false
mutable struct RBTreeNode{K}
    color::Bool
    data::Union{K, Nothing}
    leftChild::Union{Nothing, RBTreeNode{K}}
    rightChild::Union{Nothing, RBTreeNode{K}}
    parent::Union{Nothing, RBTreeNode{K}}

    RBTreeNode{K}() where K = new{K}(true, nothing, nothing, nothing, nothing)

    RBTreeNode{K}(d::K) where K = new{K}(true, d, nothing, nothing, nothing)
end

RBTreeNode() = RBTreeNode{Any}()
RBTreeNode(d) = RBTreeNode{Any}(d)

Base.setproperty!(x::RBTreeNode{K}, f::Symbol, v) where {K} =
    setfield!(x, f, v)

function create_null_node(K::Type)
    node = RBTreeNode{K}()
    node.color = false
    return node
end

mutable struct RBTree{K}
    root::RBTreeNode{K}
    nil::RBTreeNode{K}
    count::Int

    function RBTree{K}() where K
        rb = new()
        rb.nil = create_null_node(K)
        rb.root = rb.nil
        rb.count = 0
        return rb
    end
end

RBTree() = RBTree{Any}()

Base.length(tree::RBTree) = tree.count

"""
    search_node(tree, key)

Returns the last visited node, while traversing through in binary-search-tree fashion looking for `key`.
"""
search_node(tree, key)

function search_node(tree::RBTree{K}, d::K) where K
    node = tree.root
    while node !== tree.nil && d != node.data
        if d < node.data
            node = node.leftChild
        else
            node = node.rightChild
        end
    end
    return node
end

"""
    haskey(tree, key)

Returns true if `key` is present in the `tree`, else returns false.
"""
function Base.haskey(tree::RBTree{K}, d::K) where K
    node = search_node(tree, d)
    return (node.data == d)
end

"""
    insert_node!(tree::RBTree, node::RBTreeNode)

Inserts `node` at proper location by traversing through the `tree` in a binary-search-tree fashion.
"""
function insert_node!(tree::RBTree, node::RBTreeNode)
    node_y = nothing
    node_x = tree.root

    while node_x !== tree.nil
        node_y = node_x
        if node.data < node_x.data
            node_x = node_x.leftChild
        else
            node_x = node_x.rightChild
        end
    end

    node.parent = node_y
    if node_y == nothing
        tree.root = node
    elseif node.data < node_y.data
        node_y.leftChild = node
    else
        node_y.rightChild = node
    end
end

"""
    left_rotate!(tree::RBTree, node_x::RBTreeNode)

Performs a left-rotation on `node_x` and updates `tree.root`, if required.
"""
function left_rotate!(tree::RBTree, node_x::RBTreeNode)
    node_y = node_x.rightChild
    node_x.rightChild = node_y.leftChild
    if node_y.leftChild !== tree.nil
        node_y.leftChild.parent = node_x
    end
    node_y.parent = node_x.parent
    if (node_x.parent == nothing)
        tree.root = node_y
    elseif (node_x == node_x.parent.leftChild)
        node_x.parent.leftChild = node_y
    else
        node_x.parent.rightChild = node_y
    end
    node_y.leftChild = node_x
    node_x.parent = node_y
end

"""
    right_rotate!(tree::RBTree, node_x::RBTreeNode)

Performs a right-rotation on `node_x` and updates `tree.root`, if required.
"""
function right_rotate!(tree::RBTree, node_x::RBTreeNode)
    node_y = node_x.leftChild
    node_x.leftChild = node_y.rightChild
    if node_y.rightChild !== tree.nil
        node_y.rightChild.parent = node_x
    end
    node_y.parent = node_x.parent
    if (node_x.parent == nothing)
        tree.root = node_y
    elseif (node_x == node_x.parent.leftChild)
        node_x.parent.leftChild = node_y
    else
        node_x.parent.rightChild = node_y
    end
    node_y.rightChild = node_x
    node_x.parent = node_y
end

"""
   fix_insert!(tree::RBTree, node::RBTreeNode)

This method is called to fix the property of having no two adjacent nodes of red color in the `tree`.
"""
function fix_insert!(tree::RBTree, node::RBTreeNode)
    parent = nothing
    grand_parent = nothing
    # for root node, we need to change the color to black
    # other nodes, we need to maintain the property such that
    # no two adjacent nodes are red in color
    while  node != tree.root && node.parent.color
        parent = node.parent
        grand_parent = parent.parent

        if (parent == grand_parent.leftChild) # parent is the leftChild of grand_parent
            uncle = grand_parent.rightChild

            if (uncle.color) # uncle is red in color
                grand_parent.color = true
                parent.color = false
                uncle.color = false
                node = grand_parent
            else  # uncle is black in color
                if (node == parent.rightChild) # node is rightChild of its parent
                    node = parent
                    left_rotate!(tree, node)
                end
                # node is leftChild of its parent
                node.parent.color = false
                node.parent.parent.color = true
                right_rotate!(tree, node.parent.parent)
            end
        else # parent is the rightChild of grand_parent
            uncle = grand_parent.leftChild

            if (uncle.color) # uncle is red in color
                grand_parent.color = true
                parent.color = false
                uncle.color = false
                node = grand_parent
            else  # uncle is black in color
                if (node == parent.leftChild) # node is leftChild of its parent
                    node = parent
                    right_rotate!(tree, node)
                end
                # node is rightChild of its parent
                node.parent.color = false
                node.parent.parent.color = true
                left_rotate!(tree, node.parent.parent)
            end
        end
    end
    tree.root.color = false
end

"""
    insert!(tree, key)

Inserts `key` in the `tree` if it is not present.
"""
function Base.insert!(tree::RBTree{K}, d::K) where K
    # if the key exists in the tree, no need to insert
    haskey(tree, d) && return tree

    # insert, if not present in the tree
    node = RBTreeNode{K}(d)
    node.leftChild = node.rightChild = tree.nil

    insert_node!(tree, node)

    if node.parent == nothing
        node.color = false
    elseif node.parent.parent == nothing
        ;
    else
        fix_insert!(tree, node)
    end
    tree.count += 1
    return tree
end

"""
    push!(tree, key)

Inserts `key` in the `tree` if it is not present.
"""
function Base.push!(tree::RBTree{K}, key0) where K
    key = convert(K, key0)
    insert!(tree, key)
end

"""
    delete_fix(tree::RBTree, node::Union{RBTreeNode, Nothing})

This method is called when a black node is deleted because it violates the black depth property of the RBTree.
"""
function delete_fix(tree::RBTree, node::Union{RBTreeNode, Nothing})
    while node != tree.root && !node.color
         if node == node.parent.leftChild
            sibling = node.parent.rightChild
            if sibling.color
                sibling.color = false
                node.parent.color = true
                left_rotate!(tree, node.parent)
                sibling = node.parent.rightChild
            end

            if !sibling.rightChild.color && !sibling.leftChild.color
                sibling.color = true
                node = node.parent
            else
                if !sibling.rightChild.color
                    sibling.leftChild.color = false
                    sibling.color = true
                    right_rotate!(tree, sibling)
                    sibling = node.parent.rightChild
                end

                sibling.color = node.parent.color
                node.parent.color = false
                sibling.rightChild.color = false
                left_rotate!(tree, node.parent)
                node = tree.root
            end
        else
            sibling = node.parent.leftChild
            if sibling.color
                sibling.color = false
                node.parent.color = true
                right_rotate!(tree, node.parent)
                sibling = node.parent.leftChild
            end

            if !sibling.rightChild.color && !sibling.leftChild.color
                sibling.color = true
                node = node.parent
            else
                if !sibling.leftChild.color
                    sibling.rightChild.color = false
                    sibling.color = true
                    left_rotate!(tree, sibling)
                    sibling = node.parent.leftChild
                end

                sibling.color = node.parent.color
                node.parent.color = false
                sibling.leftChild.color = false
                right_rotate!(tree, node.parent)
                node = tree.root
            end
        end
    end
    node.color = false
    return nothing
end

"""
    rb_transplant(tree::RBTree, u::Union{RBTreeNode, Nothing}, v::Union{RBTreeNode, Nothing})

Replaces `u` by `v` in the `tree` and updates the `tree` accordingly.
"""
function rb_transplant(tree::RBTree, u::Union{RBTreeNode, Nothing}, v::Union{RBTreeNode, Nothing})
    if u.parent == nothing
        tree.root = v
    elseif u == u.parent.leftChild
        u.parent.leftChild = v
    else
        u.parent.rightChild = v
    end
    v.parent = u.parent
end

"""
   minimum_node(tree::RBTree, node::RBTreeNode)

Returns the RBTreeNode with minimum value in subtree of `node`.
"""
function minimum_node(tree::RBTree, node::RBTreeNode)
    (node === tree.nil) && return node
    while node.leftChild !== tree.nil
        node = node.leftChild
    end
    return node
end

"""
    delete!(tree::RBTree, key)

Deletes `key` from `tree`, if present, else returns the unmodified tree.
"""
function Base.delete!(tree::RBTree{K}, d::K) where K
    z = tree.nil
    node = tree.root

    while node !== tree.nil
        if node.data == d
            z = node
        end

        if d < node.data
            node = node.leftChild
        else
            node = node.rightChild
        end
    end

    (z === tree.nil) && return tree

    y = z
    y_original_color = y.color
    x = RBTreeNode{K}()
    if z.leftChild === tree.nil
        x = z.rightChild
        rb_transplant(tree, z, z.rightChild)
    elseif z.rightChild === tree.nil
        x = z.leftChild
        rb_transplant(tree, z, z.leftChild)
    else
        y = minimum_node(tree, z.rightChild)
        y_original_color = y.color
        x = y.rightChild

        if y.parent == z
            x.parent = y
        else
            rb_transplant(tree, y, y.rightChild)
            y.rightChild = z.rightChild
            y.rightChild.parent = y
        end

        rb_transplant(tree, z, y)
        y.leftChild = z.leftChild
        y.leftChild.parent = y
        y.color = z.color
    end

    !y_original_color && delete_fix(tree, x)
    tree.count -= 1
    return tree
end

Base.in(key, tree::RBTree) = haskey(tree, key)

"""
    getindex(tree, ind)

Gets the key present at index `ind` of the tree. Indexing is done in increasing order of key.
"""
function Base.getindex(tree::RBTree{K}, ind) where K
    @boundscheck (1 <= ind <= tree.count) || throw(ArgumentError("$ind should be in between 1 and $(tree.count)"))
    function traverse_tree_inorder(node::RBTreeNode{K}) where K
        if (node !== tree.nil)
            left = traverse_tree_inorder(node.leftChild)
            right = traverse_tree_inorder(node.rightChild)
            append!(push!(left, node.data), right)
        else
            return K[]
        end
    end
    arr = traverse_tree_inorder(tree.root)
    return @inbounds arr[ind]
end

@testset "DiBitVectors" begin
    d0 = DiBitVector()
    d1 = DiBitVector(10)
    d2 = DiBitVector(10, 0)

    @test_throws ArgumentError DiBitVector(5, 4)
    @test_throws ArgumentError DiBitVector(5, -1)

    @test_throws ArgumentError DiBitVector(-5)
    @test_throws ArgumentError DiBitVector(-5, 1)

    @test length(d0) == 0
    @test isempty(d0)
    @test_throws ArgumentError pop!(d0)
    push!(d0, 1)
    @test length(d0) == 1
    @test pop!(d0) == 1
    @test length(d0) == 0
    @test_throws ArgumentError pop!(d0)

    @test length(d1) == length(d2) == 10
    @test d1 == d2
    @test all(d1 .== 0)
    @test all(d2 .== 0)

    @test size(d1) == size(d2) == (10,)

    d3 = DiBitVector(30, 3)
    @test all(d3 .== 3)
    @test d3[1] == d3[end] == 3

    push!(d3, 0)
    @test length(d3) == 31 && length(d3.data) == 1
    push!(d3, 1)
    @test length(d3) == 32 && length(d3.data) == 1
    push!(d3, 2)
    @test length(d3) == 33 && length(d3.data) == 2
    push!(d3, 3)
    @test length(d3) == 34 && length(d3.data) == 2

    @test pop!(d3) == 3
    @test length(d3) == 33 && length(d3.data) == 2
    @test pop!(d3) == 2
    @test length(d3) == 32 && length(d3.data) == 1
    @test pop!(d3) == 1
    @test length(d3) == 31 && length(d3.data) == 1
    @test pop!(d3) == 0
    @test length(d3) == 30 && length(d3.data) == 1
    @test pop!(d3) == 3
    @test length(d3) == 29 && length(d3.data) == 1

    @test zero(d3) == DiBitVector(length(d3))

    @test_throws BoundsError d3[0]
    @test_throws BoundsError d3[-1]
    @test_throws BoundsError d3[99991]
end

@testset "OrderedRobinDict" begin

    @testset "Constructors" begin
        @test isa(@inferred(OrderedRobinDict()), OrderedRobinDict{Any,Any})
        @test isa(@inferred(OrderedRobinDict([(1,2.0)])), OrderedRobinDict{Int,Float64})
        @test isa(@inferred(OrderedRobinDict([("a",1),("b",2)])), OrderedRobinDict{String,Int})
        @test isa(@inferred(OrderedRobinDict(Pair(1, 1.0))), OrderedRobinDict{Int,Float64})
        @test isa(@inferred(OrderedRobinDict(Pair(1, 1.0), Pair(2, 2.0))), OrderedRobinDict{Int,Float64})
        @test isa(@inferred(OrderedRobinDict{Int,Float64}(Pair(1, 1), Pair(2, 2))), OrderedRobinDict{Int,Float64})
        @test isa(@inferred(OrderedRobinDict(Pair(1, 1.0), Pair(2, 2.0), Pair(3, 3.0))), OrderedRobinDict{Int,Float64})
        @test OrderedRobinDict(()) == OrderedRobinDict{Any,Any}()
        @test isa(@inferred(OrderedRobinDict([Pair(1, 1.0), Pair(2, 2.0)])), OrderedRobinDict{Int,Float64})
        @test_throws ArgumentError OrderedRobinDict([1,2,3,4])
        iter = Iterators.filter(x->x.first>1, [Pair(1, 1.0), Pair(2, 2.0), Pair(3, 3.0)])
        @test @inferred(OrderedRobinDict(iter)) == OrderedRobinDict{Int,Float64}(2=>2.0, 3=>3.0)
        iter = Iterators.drop(1:10, 1)
        @test_throws ArgumentError OrderedRobinDict(iter)
    end

    @testset "empty dictionary" begin
        d = OrderedRobinDict{Char, Int}()
        @test length(d) == 0
        @test isempty(d)
        @test_throws KeyError d['c'] == 1
        d['c'] = 1
        @test !isempty(d)
        @test_throws KeyError d[0.01]
        @test isempty(empty(d))
        empty!(d)
        @test isempty(d)

        # access, modification
        for c in 'a':'z'
            d[c] = c - 'a' + 1
        end

        @test (d['a'] += 1) == 2
        @test 'a' in keys(d)
        @test haskey(d, 'a')
        @test get(d, 'B', 0) == 0
        @test getkey(d, 'b', nothing) == 'b'
        @test getkey(d, 'B', nothing) == nothing
        @test !('B' in keys(d))
        @test !haskey(d, 'B')
        @test pop!(d, 'a') == 2

        @test collect(keys(d)) == collect('b':'z')
        @test collect(values(d)) == collect(2:26)
        @test collect(d) == [Pair(a,i) for (a,i) in zip('b':'z', 2:26)]
    end

    @testset "convert" begin
        d = OrderedRobinDict{Int,Float32}(i=>Float32(i) for i = 1:10)
        @test convert(OrderedRobinDict{Int,Float32}, d) === d
        dc = convert(OrderedRobinDict{Int,Float64}, d)
        @test dc !== d
        @test keytype(dc) == Int
        @test valtype(dc) == Float64
        @test keys(dc) == keys(d)
        @test collect(values(dc)) == collect(values(d))
    end

    @testset "Issue #60" begin
        od60 = OrderedRobinDict{Int,Int}()
        od60[1] = 2

        ranges = [2:5, 6:9, 10:13]
        for range in ranges
            for i = range
                od60[i] = i+1
            end
            for i = range
                delete!( od60, i )
            end
        end
        od60[14]=15

        @test od60[14] == 15
    end

    @testset "Fixes issue 857" begin
        h = OrderedRobinDict{Any,Any}([("a", missing), ("b", -2)])
        @test 5 == (h["a"] = 5)
        @test "b" in keys(h)
        @test haskey(h,"b")
    end


    # #############################
    # Copied and modified from Base/test/dict.jl

    # OrderedRobinDict

    @testset "OrderedRobinDict{Int,Int}" begin
        h = OrderedRobinDict{Int,Int}()
        for i=1:10000
            h[i] = i+1
        end

        @test collect(h) == [Pair(x,y) for (x,y) in zip(1:10000, 2:10001)]

        for i=1:2:10000
            delete!(h, i)
        end
        for i=1:2:10000
            h[i] = i+1
        end

        for i=1:10000
            @test h[i]==i+1
        end

        for i=1:10000
            delete!(h, i)
        end
        @test isempty(h)

        h[77] = 100
        @test h[77]==100

        for i=1:10000
            h[i] = i+1
        end

        for i=1:2:10000
            delete!(h, i)
        end

        for i=10001:20000
            h[i] = i+1
        end

        for i=2:2:10000
            @test h[i]==i+1
        end

        for i=10000:20000
            @test h[i]==i+1
        end
    end

    @testset "OrderedRobinDict{Any,Any}" begin
        h = OrderedRobinDict{Any,Any}([("a", 3)])
        @test h["a"] == 3
        h["a","b"] = 4
        @test h["a","b"] == h[("a","b")] == 4
        h["a","b","c"] = 4
        @test h["a","b","c"] == h[("a","b","c")] == 4
    end

    @testset "KeyError" begin
        z = OrderedRobinDict()
        get_KeyError = false
        try
            z["a"]
        catch _e123_
            get_KeyError = isa(_e123_, KeyError)
        end
        @test get_KeyError
    end

    @testset "filter" begin
        _d = OrderedRobinDict([("a", 0)])
        v = [k for k in filter(x->length(x)==1, collect(keys(_d)))]
        @test isa(v, Vector{String})
    end

    @testset "from tuple/vector/pairs/tuple of pair 1" begin
        d = OrderedRobinDict(((1, 2), (3, 4)))
        d2 = OrderedRobinDict([(1, 2), (3, 4)])
        d3 = OrderedRobinDict(1 => 2, 3 => 4)
        d4 = OrderedRobinDict((1 => 2, 3 => 4))

        @test d[1] === 2
        @test d[3] === 4

        @test d == d2 == d3 == d4
        @test isa(d, OrderedRobinDict{Int,Int})
        @test isa(d2, OrderedRobinDict{Int,Int})
        @test isa(d3, OrderedRobinDict{Int,Int})
        @test isa(d4, OrderedRobinDict{Int,Int})

        h = OrderedRobinDict{Int, Char}(1=>'a')
        @test h[1] == 'a'
    end

    @testset "from tuple/vector/pairs/tuple of pair 2" begin
        d = OrderedRobinDict(((1, 2), (3, "b")))
        d2 = OrderedRobinDict([(1, 2), (3, "b")])
        d3 = OrderedRobinDict(1 => 2, 3 => "b")
        d4 = OrderedRobinDict((1 => 2, 3 => "b"))

        @test d2[1] === 2
        @test d2[3] == "b"

        ## TODO: tuple of tuples doesn't work for mixed tuple types
        # @test d == d2 == d3 == d4
        # @test isa(d, OrderedRobinDict{Int,Any})
        @test d2 == d3 == d4
        @test isa(d2, OrderedRobinDict{Int,Any})
        @test isa(d3, OrderedRobinDict{Int,Any})
        @test isa(d4, OrderedRobinDict{Int,Any})
    end

    @testset "from tuple/vector/pairs/tuple of pair 3" begin
        d = OrderedRobinDict(((1, 2), ("a", 4)))
        d2 = OrderedRobinDict([(1, 2), ("a", 4)])
        d3 = OrderedRobinDict(1 => 2, "a" => 4)
        d4 = OrderedRobinDict((1 => 2, "a" => 4))

        @test d2[1] === 2
        @test d2["a"] === 4

        ## TODO: tuple of tuples doesn't work for mixed tuple types
        # @test d == d2 == d3 == d4
        @test d2 == d3 == d4
        # @test isa(d, OrderedRobinDict{Any,Int})
        @test isa(d2, OrderedRobinDict{Any,Int})
        @test isa(d3, OrderedRobinDict{Any,Int})
        @test isa(d4, OrderedRobinDict{Any,Int})
    end

    @testset "from tuple/vector/pairs/tuple of pair 4" begin
        d = OrderedRobinDict(((1, 2), ("a", "b")))
        d2 = OrderedRobinDict([(1, 2), ("a", "b")])
        d3 = OrderedRobinDict(1 => 2, "a" => "b")
        d4 = OrderedRobinDict((1 => 2, "a" => "b"))

        @test d[1] === 2
        @test d["a"] == "b"

        @test d == d2 == d3 == d4
        @test isa(d, OrderedRobinDict{Any,Any})
        @test isa(d2, OrderedRobinDict{Any,Any})
        @test isa(d3, OrderedRobinDict{Any,Any})
        @test isa(d4, OrderedRobinDict{Any,Any})
    end

    @testset "first" begin
        @test_throws ArgumentError first(OrderedRobinDict())
        @test first(OrderedRobinDict([(:f, 2)])) == Pair(:f,2)
    end

    @testset "Issue #1821" begin
        d = OrderedRobinDict{String, Vector{Int}}()
        d["a"] = [1, 2]
        @test_throws MethodError d["b"] = 1
        @test isa(repr(d), AbstractString)  # check that printable without error
    end

    @testset "Issue #2344" begin
        bestkey(d, key) = key
        bestkey(d::AbstractDict{K,V}, key) where {K<:AbstractString,V} = string(key)
        bar(x) = bestkey(x, :y)
        @test bar(OrderedRobinDict([(:x, [1,2,5])])) == :y
        @test bar(OrderedRobinDict([("x", [1,2,5])])) == "y"
    end

    @testset "isequal" begin
        @test  isequal(OrderedRobinDict(), OrderedRobinDict())
        @test  isequal(OrderedRobinDict([(1, 1)]), OrderedRobinDict([(1, 1)]))
        @test !isequal(OrderedRobinDict([(1, 1)]), OrderedRobinDict())
        @test !isequal(OrderedRobinDict([(1, 1)]), OrderedRobinDict([(1, 2)]))
        @test !isequal(OrderedRobinDict([(1, 1)]), OrderedRobinDict([(2, 1)]))

        @test isequal(OrderedRobinDict(), sizehint!(OrderedRobinDict(),96))

        # Here is what currently happens when dictionaries of different types
        # are compared. This is not necessarily desirable. These tests are
        # descriptive rather than proscriptive.
        @test !isequal(OrderedRobinDict([(1, 2)]), OrderedRobinDict([("dog", "bone")]))
        @test isequal(OrderedRobinDict{Int,Int}(), OrderedRobinDict{AbstractString,AbstractString}())
    end

    @testset "data_in" begin
        # Generate some data to populate dicts to be compared
        data_in = [ (rand(1:1000), randstring(2)) for _ in 1:1001 ]

        # Populate the first dict
        d1 = OrderedRobinDict{Int, String}()
        for (k,v) in data_in
            d1[k] = v
        end
        data_in = collect(d1)
        # shuffle the data
        for i in 1:length(data_in)
            j = rand(1:length(data_in))
            data_in[i], data_in[j] = data_in[j], data_in[i]
        end
        # Inserting data in different (shuffled) order should result in
        # equivalent dict.
        d2 = OrderedRobinDict{Int, AbstractString}()
        for (k,v) in data_in
            d2[k] = v
        end

        @test  isequal(d1, d2)
        d3 = copy(d2)
        d4 = copy(d2)
        # Removing an item gives different dict
        delete!(d1, data_in[rand(1:length(data_in))][1])
        @test !isequal(d1, d2)
        # Changing a value gives different dict
        d3[data_in[rand(1:length(data_in))][1]] = randstring(3)
        !isequal(d1, d3)
        # Adding a pair gives different dict
        d4[1001] = randstring(3)
        @test !isequal(d1, d4)
    end

    @testset "get!" begin
        # get! (get with default values assigned to the given location)
        f(x) = x^2
        d = OrderedRobinDict(8 => 19)

        @test get!(d, 8, 5) == 19
        @test get!(d, 19, 2) == 2

        @test get!(d, 42) do  # d is updated with f(2)
            f(2)
        end == 4

        @test get!(d, 42) do  # d is not updated
            f(200)
        end == 4

        @test get(d, 13) do   # d is not updated
            f(4)
        end == 16

        @test d == OrderedRobinDict(8=>19, 19=>2, 42=>4)
    end

    @testset "Issue #5886" begin
        d5886 = OrderedRobinDict()
        for k5886 in 1:11
            d5886[k5886] = 1
        end
        for k5886 in keys(d5886)
            # undefined ref if not fixed
            d5886[k5886] += 1
        end
    end

    @testset "Issue #216" begin
        @test !isordered(Dict{Int, String})
        @test isordered(OrderedRobinDict{Int, String})
    end

    @testset "Test merging" begin
        a = OrderedRobinDict("foo"  => 0.0, "bar" => 42.0)
        b = OrderedRobinDict("フー" => 17, "バー" => 4711)
        @test isa(merge(a, b), OrderedRobinDict{String,Float64})
    end

    @testset "Issue #9295" begin
        d = OrderedRobinDict()
        @test push!(d, 'a'=> 1) === d
        @test d['a'] == 1
        @test push!(d, 'b' => 2, 'c' => 3) === d
        @test d['b'] == 2
        @test d['c'] == 3
        @test push!(d, 'd' => 4, 'e' => 5, 'f' => 6) === d
        @test d['d'] == 4
        @test d['e'] == 5
        @test d['f'] == 6
        @test length(d) == 6
    end

    @testset "Serialization" begin
        s = IOBuffer()
        od = OrderedRobinDict{Char,Int64}()
        for c in 'a':'e'
            od[c] = c-'a'+1
        end
        serialize(s, od)
        seek(s, 0)
        dd = deserialize(s)
        @test isa(dd, OrderedRobinDict{Char,Int64})
        @test dd == od
        close(s)
    end

    @testset "Issue #148" begin
        d148 = OrderedRobinDict(
                    :gps => [],
                    :direction => 1:8,
                    :weather => 1:10
            )

        d148_2 = OrderedRobinDict(
            :time => 1:10,
            :features => OrderedRobinDict(
                :gps => 1:5,
                :direction => 1:8,
                :weather => 1:10
            )
        )
    end

    @testset "Issue #400" begin
        @test filter(p->first(p) > 1, OrderedRobinDict(1=>2, 3=>4)) isa OrderedRobinDict
    end

    @testset "Test that OrderedRobinDict merge with combiner returns type OrderedRobinDict" begin
        @test merge(+, OrderedRobinDict(:a=>1, :b=>2), OrderedRobinDict(:b=>7, :c=>4)) == OrderedRobinDict(:a=>1, :b=>9, :c=>4)
        @test merge(+, OrderedRobinDict(:a=>1, :b=>2), Dict(:b=>7, :c=>4)) isa OrderedRobinDict
    end

    @testset "pop!" begin
        h = OrderedRobinDict{Int, Int}()
        for i in 1:10
            h[i] = i+1
        end
        for i in 10:-1:1
            @test pop!(h) == (i => i+1)
        end

        d = OrderedRobinDict(1=>'a', 2=>'b', 3=>'c')
        @test pop!(d, 4, 'e') == 'e'
    end

    @testset "filter!" begin
        h = OrderedRobinDict{Int, Int}()
        for i in 1:100
            h[i] = i
        end
        filter!(x->isodd(x.first), h)
        for i in 1:2:100
            @test h[i] == i
        end
    end

end # @testset OrderedRobinDict

# This was formerly a part of Julia. License is MIT: http://julialang.org/license

import Base.Order.Reverse


@testset "PriorityQueue" begin

    # Test dequeing in sorted order.
    function test_issorted!(pq::PriorityQueue, priorities, rev=false)
        last = dequeue!(pq)
        while !isempty(pq)
            value = dequeue!(pq)
            if !rev
                @test priorities[last] <= priorities[value]
            else
                @test priorities[value] <= priorities[last]
            end
            value = last
        end
    end

    function test_isrequested!(pq::PriorityQueue, keys)
        i = 0
        while !isempty(pq)
            krqst =  keys[i+=1]
            krcvd = dequeue!(pq, krqst)
            @test krcvd == krqst
        end
    end

    @testset "Constructors" begin
        pmax = 1000
        n = 10000
        r = rand(1:pmax, n)
        priorities = Dict(zip(1:n, r))

        ks, vs = 1:n+1, rand(1:pmax, n)

        @testset "building from Dict" begin
            pq1 = PriorityQueue(priorities)
            test_issorted!(pq1, priorities)

            pq2 = PriorityQueue(priorities)
            test_isrequested!(pq2, 1:n)

            priorities = Dict(zip(ks, vs))
            pq4 = PriorityQueue(priorities)
            test_issorted!(pq4, priorities)
        end

        @testset "parameterized constructor tests pq5" begin
            pq5 = PriorityQueue{Int,Int}()
            for (k,v) in priorities
                pq5[k] = v
            end
            test_issorted!(pq5, priorities)
        end

        @testset "parameterized constructor tests pq6" begin
            pq6 = PriorityQueue{Int,Int}(priorities)
            test_issorted!(pq6, priorities)
        end

        @testset "parameterized constructor tests pq7" begin
            pq7 = PriorityQueue{Int,Int}(Reverse, priorities)
            test_issorted!(pq7, priorities, true)
        end

        @testset "parameterized constructor tests pq8" begin
            pq8 = PriorityQueue{Int,Int}(Reverse)
            for (k,v) in priorities
                pq8[k] = v
            end
            test_issorted!(pq8, priorities, true)
        end

        @testset "construction from pairs" begin
            @testset "pq9" begin
                pq9 = PriorityQueue('a'=>1, 'b'=>2)
                @test peek(pq9) == ('a'=>1)
            end

            @testset "pq10" begin
                pq10 = PriorityQueue(Reverse, 'a'=>1, 'b'=>2)
                @test peek(pq10) == ('b'=>2)
            end

            @testset "pq11" begin
                pq11 = PriorityQueue(Pair{Char}['a'=>1,'b'=>2])
                @test peek(pq11) == ('a'=>1)
            end
        end

        @testset "duplicate key => ArgumentError" begin
            @test_throws ArgumentError PriorityQueue('a'=>1, 'a'=>2)
        end

        @testset "Not a pair/tuple => ArguentError" begin
            @test_throws ArgumentError PriorityQueue(['a'])
            @test_throws ArgumentError PriorityQueue(Reverse, ['a'])
            @test_throws ArgumentError PriorityQueue{Char,Int}(Base.Order.Reverse, ['a'])
        end

        @testset "Silly test" begin
            @test_throws ArgumentError PriorityQueue(Reverse, Reverse)
        end

    end

    @testset "PriorityQueueMethods" begin
        pq1 = PriorityQueue('a'=>1, 'b'=>2)

        @testset "peek/get/dequeue!/get!" begin
            @test peek(pq1) == ('a'=>1)
            @test get(pq1, 'a', 0) == 1
            @test get(pq1, 'c', 0) == 0
            @test get!(pq1, 'b', 20) == 2
            @test dequeue!(pq1) == 'a'
            @test dequeue!(pq1) == 'b'
            @test get!(pq1, 'c', 0) == 0
            @test peek(pq1) == ('c'=>0)
            @test get!(pq1, 'c', 3) == 0
        end

        pmax = 1000
        n = 10000
        ks, vs = 1:n, rand(1:pmax, n)
        priorities = Dict(zip(ks, vs))

        @testset "peek" begin
            pq1 = PriorityQueue(priorities)
            lowpri = findmin(vs)
            @test peek(pq1)[2] == pq1[ks[lowpri[2]]]
        end

        @testset "enqueue error throw" begin
            ks, vs = 1:n, rand(1:pmax, n)
            pq = PriorityQueue(zip(ks, vs))
            @test_throws ArgumentError enqueue!(pq, 1, 10)
        end

        @testset "Iteration" begin
            pq = PriorityQueue(priorities)
            pq2 = PriorityQueue()
            for kv in pq
                enqueue!(pq2, kv)
            end
            @test pq == pq2
        end

        @testset "enqueing pairs via enqueue!" begin
            pq = PriorityQueue()
            for kv in priorities
                enqueue!(pq, kv)
            end
            test_issorted!(pq, priorities)
        end

        @testset "enqueing values via enqueue!" begin
            pq = PriorityQueue()
            for (k, v) in priorities
                enqueue!(pq, k, v)
            end
            test_issorted!(pq, priorities)
        end

        @testset "enqueing via assign" begin
            pq = PriorityQueue()
            for (k, v) in priorities
                pq[k] = v
            end
            test_issorted!(pq, priorities)
        end

        @testset "changing priorities" begin
            pq = PriorityQueue()
            for (k, v) in priorities
                pq[k] = v
            end

            for _ in 1:n
                k = rand(1:n)
                v = rand(1:pmax)
                pq[k] = v
                priorities[k] = v
            end

            test_issorted!(pq, priorities)
        end

        @testset "dequeuing" begin
            pq = PriorityQueue(priorities)
            @test_throws KeyError dequeue!(pq, 0)

            @test 10 == dequeue!(pq, 10)
            while !isempty(pq)
                @test 10 != dequeue!(pq)
            end
        end

        @testset "dequeuing pair" begin
            priorities2 = Dict(zip('a':'e', 5:-1:1))
            pq = PriorityQueue(priorities2)
            @test_throws KeyError dequeue_pair!(pq, 'g')
            @test dequeue_pair!(pq) == ('e'=> 1)
            @test dequeue_pair!(pq, 'b') == ('b'=>4)
            @test length(pq) == 3
        end

        @testset "delete!" begin
            pq = PriorityQueue(Base.Order.Forward, "a"=>2, "b"=>3, "c"=>1)
            pq_out = delete!(pq, "b")
            @test pq === pq_out
            @test Set(collect(pq)) == Set(["a"=>2, "c"=>1])
        end

        @testset "empty!" begin
            pq = PriorityQueue(Base.Order.Forward, "a"=>2, "b"=>3, "c"=>1)
            @test !isempty(pq)
            empty!(pq)
            @test isempty(pq)
            enqueue!(pq, "a"=>2)
            @test length(pq) == 1
        end
    end

    @testset "Iteration" begin
        pq = PriorityQueue(["a" => 10, "b" => 5, "c" => 15])
        @test collect(pq)         == ["b" => 5, "a" => 10, "c" => 15]
        @test collect(keys(pq))   == ["b", "a", "c"]
        @test collect(values(pq)) == [5, 10, 15]
    end

    @testset "UnorderedIteration" begin
        pq = PriorityQueue(["a" => 10, "b" => 5, "c" => 15])
        res = Pair{String, Int}[]
        next = iterate(pq, false)
        while next !== nothing
            p, i = next
            push!(res, p)
            next = iterate(pq, i)
        end
        @test Set(res) == Set(["a" => 10, "b" => 5, "c" => 15])
        empty!(res)
        next = iterate(pq, true)
        while next !== nothing
            p, i = next
            push!(res, p)
            next = iterate(pq, i)
        end
        @test res == ["b" => 5, "a" => 10, "c" => 15]
    end

    # Copy and merge operations in PriorityQueue utilize unordered
    # iteration
    @testset "Copy and Merge" begin
        v = [i for i=10000:-1:1]
        pq1 = PriorityQueue(zip(v, 10 .* v))
        @test collect(merge!(Dict(), pq1)) != collect(pq1)
        pq = PriorityQueue(["a" => 10, "b" => 5, "c" => 15])
        sd = SortedDict(["d"=>6, "e"=>4])
        merge!(sd, pq)
        @test collect(sd) == ["a" => 10, "b" => 5, "c" => 15, "d" => 6, "e" => 4]
        d = merge!(Dict("d"=> 6), pq)
        @test Set(collect(d)) == Set(["c" => 15, "b" => 5, "a" => 10, "d" => 6])
        sd = SortedDict(["c"=>6, "e"=>4])
        merge!(+, sd, pq)
        @test collect(sd) == ["a" => 10, "b" => 5, "c" => 21, "e" => 4]
        pq1 = empty(pq)
        @test length(pq1) == 0
        pq1 = copy(pq)
        @test pq1 isa PriorityQueue
    end

    @testset "LowLevelHeapOperations" begin
        pmax = 1000
        n = 10000
        r = rand(1:pmax, n)
        priorities = Dict(zip(1:n, r))

        @testset "low level heap operations" begin
            xs = heapify!([v for v in values(priorities)])
            @test issorted([heappop!(xs) for _ in length(priorities)])
        end

        @testset "heapify/issorted" begin
            xs = heapify(10:-1:1)
            @test issorted([heappop!(xs) for _ in 1:10])
        end

        @testset "heappush!" begin
            xs = Vector{Int}()
            for priority in values(priorities)
                heappush!(xs, priority)
            end
            @test issorted([heappop!(xs) for _ in length(priorities)])
        end

        @testset "isheap" begin
            @test isheap([1, 2, 3], Base.Order.Forward)
            @test !isheap([1, 2, 3], Base.Order.Reverse)
        end
    end

end # @testset "PriorityQueue"

# benchmark of deque

using DataStructures

# push_back

function batch_pushback!(v::Container, n::Int, e::T) where {Container,T}
    for i = 1 : n
        push!(v, e)
    end
end

v = Int[]
q = Deque{Int}()

batch_pushback!(v, 10, 0)
t1 = @elapsed batch_pushback!(v, 10^7, 0)

batch_pushback!(q, 10, 0)
t2 = @elapsed batch_pushback!(q, 10^7, 0)

println("push back 10^7 integers:")
@printf("    Vector:   elapsed = %8.4fs\n", t1)
@printf("    Deque:    elapsed = %8.4fs\n", t2)


# push_front

function batch_pushfront!(v::Container, n::Int, e::T) where {Container,T}
    for i = 1 : n
        pushfirst!(v, e)
    end
end

v = Int[]
q = Deque{Int}()

batch_pushfront!(v, 10, 0)
t1 = @elapsed batch_pushfront!(v, 10^7, 0)

batch_pushfront!(q, 10, 0)
t2 = @elapsed batch_pushfront!(q, 10^7, 0)

println("push front 10^7 integers:")
@printf("    Vector:   elapsed = %8.4fs\n", t1)
@printf("    Deque:    elapsed = %8.4fs\n", t2)


# traverse

function traverse(container)
    for e in container
    end
end

traverse(v)
t1 = @elapsed traverse(v)

traverse(q)
t2 = @elapsed traverse(q)

println("traverse 10^7 integers:")
@printf("    Vector:   elapsed = %8.4fs\n", t1)
@printf("    Deque:    elapsed = %8.4fs\n", t2)

# sum

sum(v)
t1 = @elapsed sum(v)

sum(q)
t2 = @elapsed sum(q)

println("sum 10^7 integers:")
@printf("    Vector:   elapsed = %8.4fs\n", t1)
@printf("    Deque:    elapsed = %8.4fs\n", t2)

@testset "DisjointSet" begin

    @testset "IntDisjointSets" begin
        for T in [Int, UInt8, Int8, UInt16, Int16, UInt32, Int32, UInt64]
            @testset "eltype = $(T)" begin
                s = IntDisjointSets(T(10))
                s2 = IntDisjointSets{T}(10)

                @testset "basic tests" begin
                    @test length(s) == 10
                    @test length(s2) == 10
                    @test eltype(s) == T
                    @test eltype(s2) == T
                    @test eltype(typeof(s)) == T
                    @test eltype(typeof(s2)) == T
                    @test num_groups(s) == T(10)
                    @test num_groups(s2) == T(10)

                    for i = 1:10
                        @test find_root!(s, T(i)) == T(i)
                    end
                    @test_throws BoundsError find_root!(s, T(11))

                    @test !in_same_set(s, T(2), T(3))
                end

                @testset "union!" begin
                    union!(s, T(2), T(3))
                    @test num_groups(s) == T(9)
                    @test in_same_set(s, T(2), T(3))
                    @test find_root!(s, T(3)) == T(2)
                    union!(s, T(3), T(2))
                    @test num_groups(s) == T(9)
                    @test in_same_set(s, T(2), T(3))
                    @test find_root!(s, T(3)) == T(2)
                end

                @testset "more tests" begin
                    # We cannot support arbitrary indexing and still use @inbounds with IntDisjointSets
                    # (and it's not useful anyway)
                    @test_throws MethodError push!(s, T(22))

                    @test push!(s) == T(11)
                    @test num_groups(s) == T(10)

                    @test union!(s, T(8), T(7)) == T(8)
                    @test union!(s, T(5), T(6)) == T(5)
                    @test union!(s, T(8), T(5)) == T(8)
                    @test num_groups(s) == T(7)
                    @test find_root!(s, T(6)) == T(8)
                    union!(s, T(2), T(6))
                    @test find_root!(s, T(2)) == T(8)
                    root1 = find_root!(s, T(6))
                    root2 = find_root!(s, T(2))
                    @test root_union!(s, T(root1), T(root2)) == T(8)
                    @test union!(s, T(5), T(6)) == T(8)
                end
            end
        end
    end

    @testset "IntDisjointSets overflow" begin
        for T in [UInt8, Int8]
            s = IntDisjointSets(T(typemax(T)-1))
            push!(s)
            @test_throws ArgumentError push!(s)
        end
    end

    @testset "DisjointSets" begin
        # DisjointSets supports arbitrary indices
        s = DisjointSets{Int}(1:10)

        @testset "constructor" begin
            @test DisjointSets() isa DisjointSets{Any}
            @test DisjointSets{Int}(1:10) isa DisjointSets{Int}
            @test DisjointSets{Float64}(1.0:10.0...) isa DisjointSets{Float64}
            @test DisjointSets(collect(1:10)) isa DisjointSets{Int}
            @test DisjointSets(collect(1.0:10.0)...) isa DisjointSets{Float64}
            @test DisjointSets(x*im for x = 1:10) isa DisjointSets{Complex{Int}}
            g = (x % 2 == 0 ? x+1//x : x*im for x = 1:10)
            @test DisjointSets(g) isa DisjointSets{Number}
        end

        @testset "basic tests" begin
            @test length(s) == 10
            @test num_groups(s) == 10
            @test eltype(s) == Int
            @test eltype(typeof(s)) == Int
            @test length(empty(s)) == num_groups(empty(s)) == 0
            @test empty(s) isa DisjointSets{eltype(s)}
            @test collect(s) == collect(1:10)
            g = (x % 2 == 0 ? x+1//x : x*im for x = 1:10)
            s1 = DisjointSets(g)
            @test length(s1) == 10
            @test sizehint!(s1, 100) === s1

            r = [find_root!(s, i) for i in 1 : 10]
            @test isequal(r, collect(1:10))
        end

        @testset "union!" begin
            for i = 1 : 5
                x = 2 * i - 1
                y = 2 * i
                union!(s, x, y)
                @test find_root!(s, x) == find_root!(s, y)
            end


            @test union!(s, 1, 4) == find_root!(s, 1)
            @test union!(s, 3, 5) == find_root!(s, 1)
            @test union!(s, 7, 9) == find_root!(s, 7)

            @test length(s) == 10
            @test num_groups(s) == 2
        end

        @testset "r0" begin
            r0 = [ find_root!(s,i) for i in 1:10 ]
            # Since this is a DisjointSet (not IntDisjointSet), the root for 17 will be 17, not 11
            push!(s, 17)

            @test length(s) == 11
            @test num_groups(s) == 3

            r0 = [ r0 ; 17]
            r = [find_root!(s, i) for i in [1 : 10; 17] ]
            @test isequal(r, r0)
        end

        @testset "root_union!" begin
            root1 = find_root!(s, 7)
            root2 = find_root!(s, 3)
            @test root1 != root2
            root_union!(s, 7, 3)
            @test find_root!(s, 7) == find_root!(s, 3)
        end

        @testset "Some tests using non-integer disjoint sets" begin
            elems = ["a", "b", "c", "d"]
            a = DisjointSets{AbstractString}(elems)
            @test collect(a) == ["a", "b", "c", "d"]
            union!(a, "a", "b")
            @test in_same_set(a,"a","b")
            @test find_root!(a,"a") == find_root!(a,"b")
            @test find_root!(a,"a") in elems
            @test !in_same_set(a, "c", "d")
            # union returns new root
            @test find_root!(a,"a") == union!(a,"b","c")
            union!(a,"c","d")
            # Now they should be in same set, and a is transitively connected to d
            @test in_same_set(a,"a", "d")
            # Root element should thus be same for all:
            @test all(find_root!(a,first(elems)) .== map(x->find_root!(a,x),elems))

            #@test_throws KeyError find_root!(a,"f")

            push!(a, "f")
            @test find_root!(a,"a") != find_root!(a,"f")
        end
    end

end # @testset DisjointSet

@testset "Deque" begin
    @testset "empty dequeue" begin
        @testset "empty dequeue 1" begin
            q = Deque{Int}()
            @test length(q) == 0
            @test isempty(q)
            @test eltype(q) == Int
            @test eltype(typeof(q)) == Int
            @test q.blksize == DataStructures.DEFAULT_DEQUEUE_BLOCKSIZE
            @test_throws ArgumentError first(q)
            @test_throws ArgumentError last(q)
            @test length(sprint(dump,q)) >= 0
        end

        @testset "empty dequeue 3" begin
            q = DataStructures.DequeBlock{Int}(0,0)
            @test length(q) == 0
            @test capacity(q) == 0
            @test isempty(q)
            @test length(sprint(show,q)) >= 0
        end

        @testset "empty dequeue 4" begin
            q = Deque{Int}(3)
            @test length(q) == 0
            @test isempty(q)
            @test q.blksize == 3
            @test num_blocks(q) == 1
            @test_throws ArgumentError first(q)
            @test_throws ArgumentError last(q)
            @test isa(collect(q), Vector{Int})
            @test collect(q) == Int[]
        end
    end

    @testset "Core Functionality" begin
        n = 10

        @testset "push last / pop last" begin
            q = Deque{Int}(3)

            @testset "push last" begin
                for i = 1 : n
                    push!(q, i)
                    @test length(q) == i
                    @test isempty(q) == false
                    @test num_blocks(q) == div(i-1, 3) + 1

                    @test first(q) == 1
                    @test last(q) == i

                    k = 1
                    for j in q
                        @test j == k
                        k += 1
                    end
                    cq = collect(q)
                    @test isa(cq, Vector{Int})
                    @test cq == collect(1:i)
                    @test length(sprint(show,q)) >= 0
                end
            end

            @testset "pop last" begin
                for i = 1 : n
                    x = pop!(q)
                    @test length(q) == n - i
                    @test isempty(q) == (i == n)
                    @test num_blocks(q) == div(n-i-1, 3) + 1
                    @test x == n - i + 1

                    if !isempty(q)
                        @test first(q) == 1
                        @test last(q) == n - i
                    else
                        @test_throws ArgumentError first(q)
                        @test_throws ArgumentError last(q)
                    end

                    cq = collect(q)
                    @test cq == collect(1:n-i)
                end
            end
        end

        @testset "push first / pop first" begin
            q = Deque{Int}(3)

            @testset "push first" begin
                for i = 1 : n
                    pushfirst!(q, i)
                    @test length(q) == i
                    @test isempty(q) == false
                    @test num_blocks(q) == div(i-1, 3) + 1

                    @test first(q) == i
                    @test last(q) == 1

                    cq = collect(q)
                    @test isa(cq, Vector{Int})
                    @test cq == collect(i:-1:1)
                end
            end

            @testset "pop first" begin
                for i = 1 : n
                    x = popfirst!(q)
                    @test length(q) == n - i
                    @test isempty(q) == (i == n)
                    @test num_blocks(q) == div(n-i-1, 3) + 1
                    @test x == n - i + 1

                    if !isempty(q)
                        @test first(q) == n - i
                        @test last(q) == 1
                    else
                        @test_throws ArgumentError first(q)
                        @test_throws ArgumentError last(q)
                    end

                    cq = collect(q)
                    @test cq == collect(n-i:-1:1)
                end
            end
        end
    end

    @testset "random operations" begin
        q = Deque{Int}(5)
        r = Int[]
        m = 100

        for k = 1 : m
            la = rand(1:20)
            x = rand(1:1000, la)

            for i = 1 : la
                if rand(Bool)
                    push!(r, x[i])
                    push!(q, x[i])
                else
                    pushfirst!(r, x[i])
                    pushfirst!(q, x[i])
                end
            end

            @test length(q) == length(r)
            @test collect(q) == r

            lr = rand(1:length(r))
            for i = 1 : lr
                if rand(Bool)
                    pop!(r)
                    pop!(q)
                else
                    popfirst!(r)
                    popfirst!(q)
                end
            end

            @test length(q) == length(r)
            @test collect(q) == r
        end
    end

    @testset "hash and ==" begin
        a = Deque{Int64}(2)
        b = Deque{Int64}(3)
        # Note: blksize does not distinguish == or hash
        @test a == b
        @test hash(a) === hash(b)
        push!(a, 1)
        @test a != b
        push!(a, 2)
        push!(b, 2, 1)
        @test a != b
        @test hash(a) !== hash(b)
        popfirst!(b)
        push!(b, 2)
        @test a == b
        @test hash(a) == hash(b)
    end

    @testset "issue #38" begin
        q = Deque{Int}(1)
        push!(q,1)
        @test !isempty(q)
        empty!(q)
        @test isempty(q)
    end

    @testset "empty!" begin
        q = Deque{Int}(1)
        push!(q,1)
        push!(q,2)
        @test length(sprint(dump,q)) >= 0
        @test typeof(empty!(q)) === typeof(Deque{Int}())
        @test isempty(q)
        @test num_blocks(q) == 1
        @test q.head === q.rear
        @test sizeof(q.head.data) == q.head.capa * sizeof(eltype(q))
    end

    @testset "push! after empty!" begin
        q = Deque{Int}(1)
        push!(q,1)
        push!(q,2)
        empty!(q)
        push!(q,3)
        @test length(q) == 1
        @test first(q) == 3
        @test last(q) == 3
        @test num_blocks(q) == 1
    end

    @testset "pop! and popfirst! don't leak" begin
        q = Deque{String}(5)
        GC.gc(true)

        @testset "pop! doesn't leak" begin
            push!(q,"foo")
            push!(q,"bar")
            ss2 = Base.summarysize(q.head)
            pop!(q)
            GC.gc(true)
            ss1 = Base.summarysize(q.head)
            @test ss1 < ss2
        end
        @testset "popfirst! doesn't leak" begin
            push!(q,"baz")
            push!(q,"bug")
            ss2 = Base.summarysize(q.head)
            popfirst!(q)
            GC.gc(true)
            ss1 = Base.summarysize(q.head)
            @test ss1 < ss2
        end
    end
end # @testset Deque

"""
    Stack{T}() where {T}
    Stack{T}(blksize::Integer) where {T}

Create a `Stack` object containing elements of type `T` for **Last In, First Out**
(LIFO) access.

# Parameters
- `T::Type` Stack element data type.
- `blksize::Integer` Unrolled linked-list block size (in bytes) used in the
    underlying representation of the stack. Default = 1024. 

# Examples
```jldoctest
julia> s_int = Stack{Int64}() # create a stack with Int64 elements
Stack{Int64}(Deque [Int64[]])

julia> s_float = Stack{Float64}() # create a stack with Float64 elements
Stack{Float64}(Deque [Float64[]])
```
"""
mutable struct Stack{T}
    store::Deque{T}
end

Stack{T}() where {T} = Stack(Deque{T}())
Stack{T}(blksize::Integer) where {T} = Stack(Deque{T}(blksize))

"""
    isempty(s::Stack)

Returns `true` if stack `s` is empty - i.e. has no elements - or `false` otherwise.
"""
Base.isempty(s::Stack) = isempty(s.store)


"""
    length(s::Stack)

Return the number of elements in stack `s`.
"""
Base.length(s::Stack) = length(s.store)


"""
    eltype(::Type{Stack{T}}) where {T}

Return the type of the elements in the stack.
"""
Base.eltype(::Type{Stack{T}}) where {T} = T


"""
    first(s::Stack)

Get the first element of `s` in *Last In, First Out* order. Since `s` is a stack,
the first element will be the element at the top of `s` (also known as "peek" of
the stack).

# Example
```jldoctest
julia> s = Stack{Float32}()
Stack{Float32}(Deque [Float32[]])

julia> for i in range(1, 0.2, 5)
           push!(s, i)
       end

julia> s
Stack{Float32}(Deque [Float32[1.0, 0.8, 0.6, 0.4, 0.2]])

julia> first(s)
0.2f0
```
"""
Base.first(s::Stack) = last(s.store)

"""
    last(s::Stack)

Get the last element of `s` in *Last In, First Out*. Since `s` is a stack, the last
element will be the at bottom of the stack.

# Example
```jldoctest
julia> s = Stack{Float32}()
Stack{Float32}(Deque [Float32[]])

julia> for i in range(1, 0.2, 5)
           push!(s, i)
       end

julia> s
Stack{Float32}(Deque [Float32[1.0, 0.8, 0.6, 0.4, 0.2]])

julia> last(s)
1.0f0
```
"""
Base.last(s::Stack) = first(s.store)


"""
    push!(s::Stack, x)

Insert new element `x` in top of stack `s`.
"""
function Base.push!(s::Stack, x)
    push!(s.store, x)
    return s
end


"""
    pop!(s::Stack) 

Remove and return the top element from stack `s`.
"""
Base.pop!(s::Stack) = pop!(s.store)


"""
    empty!(s::Stack)

Make `s` empty by inplace-removing all its elements.
"""
Base.empty!(s::Stack) = (empty!(s.store); s)

Base.iterate(st::Stack, s...) = iterate(Iterators.reverse(st.store), s...)

Iterators.reverse(s::Stack{T}) where {T} = DequeIterator{T}(s.store)


"""
    ==(x::Stack, y::Stack)

Check if stacks `x` and `y` are equal in terms of their contents and the order in
which they are present in the stack. Internally calls `==()` for each of the pairs
formed by the elements of `x` and `y` in the order they appear in the stack.

# Example
```jldoctest
julia> s1, s2 = Stack{String}(), Stack{String}()
(Stack{String}(Deque [String[]]), Stack{String}(Deque [String[]]))

julia> for string in ["foo", "bar", "42"]
          push!(s1, string)
          push!(s2, string)
       end

julia> s1 == s2
true

julia> pop!(s1)
"42"

julia> s1 == s2
false
```
```jldoctest
julia> a, b = Stack{Int}(), Stack{Int}()
(Stack{Int64}(Deque [Int64[]]), Stack{Int64}(Deque [Int64[]]))

julia> for num in [1, 2, 3, 4] push!(a, num) end

julia> for num in [1, 2, 4, 3] push!(b, num) end

julia> a == b # same elements but in different order
false
```
"""
Base.:(==)(x::Stack, y::Stack) = x.store == y.store

## Functions in this file implement many kinds of iterations over
## SortedDict, SortedMultiDict, and SortedSet.
## The iteration state is a "semitoken".
## A "token" is a (container,index_into_container) 2-tuple,
## while semitokens are the second part, index_into_container.

# From tokens.jl:
# abstract type AbstractSemiToken end

# struct IntSemiToken <: AbstractSemiToken
#     address::Int
# end

const SDMContainer = Union{SortedDict, SortedMultiDict}
const SortedContainer = Union{SDMContainer, SortedSet}
const Token = Tuple{SortedContainer, IntSemiToken}
const SortedDictToken = Tuple{SortedDict, IntSemiToken}
const SortedMultiDictToken = Tuple{SortedMultiDict, IntSemiToken}
const SDMToken = Tuple{SDMContainer, IntSemiToken}
const SortedSetToken = Tuple{SortedSet, IntSemiToken}

Base.:(==)(t1::Token, t2::Token) = (t1[1] === t2[1] && t1[2] == t2[2])


"""
    Base.firstindex(m::SortedContainer)

Return the semitoken of
the first entry of the container `m`, or the past-end semitoken
if the container is empty.  This function was called
`startof` (now deprecated) in previous versions of the package.
Time: O(log *n*)
"""  
Base.firstindex(m::SortedContainer) = IntSemiToken(beginloc(m.bt))


"""
    token_firstindex(m::SortedContainer)


Return the token of
the first entry of the sorted container `m`, or the past-end token
if the container is empty.  Time: O(log *n*)
"""  
token_firstindex(m::SortedContainer) = (m, firstindex(m))



"""
    Base.lastindex(m::SortedContainer)

Return the semitoken of the
last entry of the sorted container `m`, or the before-start semitoken
if the container is empty.   This function was called `endof` (now
deprecated) in previous versions of the package.
Time: O(log *n*)
"""
Base.lastindex(m::SortedContainer) = IntSemiToken(endloc(m.bt))


"""
    token_lastindex(m::SortedContainer)

Return the token of the
last entry of the sorted container `m`, or the before-start semitoken
if the container is empty.  Time: O(log *n*)
"""
token_lastindex(m::SortedContainer) = (m, lastindex(m))


"""
    pastendsemitoken(m::SortedContainer)

Return the semitoken
of the entry that is one past the end of the sorted container `m`.
Time: O(1)
"""
pastendsemitoken(::SortedContainer) = IntSemiToken(2)


"""
    pastendtoken(m::SortedContainer)

Return the token
of the entry that is one past the end of the sorted container `m`.
Time: O(1)
"""
pastendtoken(m::SortedContainer) = (m, pastendsemitoken(m))



"""
    beforestartsemitoken(m::SortedContainer)

Return the semitoken
of the entry that is one before the beginning of the 
sorted container `m`.  Time: O(1)
"""
beforestartsemitoken(::SortedContainer) = IntSemiToken(1)


"""
    beforestarttoken(m::SortedContainer)

Return the token
of the entry that is one before the beginning of the 
sorted container `m`. Time: O(1)
"""
beforestarttoken(m::SortedContainer) = (m, beforestartsemitoken(m))



"""
    Base.delete!(token::Token) 

Delete the item indexed by the token from a sorted container.  
A `BoundsError` is thrown if the token is invalid.
Prepending with
`@inbounds` may elide the correctness check and will result
in undefined behavior if the token is invalid.
Time: O(log *n*).
"""
Base.@propagate_inbounds function Base.delete!(ii::Token)
    Base.@boundscheck has_data(ii)
    delete!(ii[1].bt, ii[2].address)
end


"""
    advance(token::Token)
    advance((m,st))

Return the semitoken of the item in a sorted container
one after the given token.  A `BoundsError` is thrown if the token is
the past-end token.  
Prepending with
`@inbounds` may elide the correctness check and will result
in undefined behavior if the token is invalid or
points to the past-end token.
The second form creates the token
in-place as a tuple of a  container `m` and a semitoken `st`.
Time: O(log *n*)
"""
Base.@propagate_inbounds function advance(ii::Token)
    Base.@boundscheck not_pastend(ii)
    IntSemiToken(nextloc0(ii[1].bt, ii[2].address))
end


"""
    regress(token::Token)
    regress((m,st))

Return the semitoken of the item in a sorted container
one before the given token.  A `BoundsError` is thrown if the token is
the before-start token.  
Prepending with
`@inbounds` may elide the correctness check and will result
in undefined behavior if the token is invalid or
points to the before-start token.
The second form creates the token
in-place as a tuple of a container `m` and a semitoken `st`.
Time: O(log *n*)
"""
Base.@propagate_inbounds function regress(ii::Token)
    Base.@boundscheck not_beforestart(ii)
    IntSemiToken(prevloc0(ii[1].bt, ii[2].address))
end


"""
    status(token::Token) 
    status((m, st))

Determine the status of a token.  Return values are:
-  0 = invalid token
-  1 = valid and points to live data
-  2 = before-start token
-  3 = past-end token
The second form creates the token
in-place as a tuple of a sorted container `m` and a semitoken `st`.
Time: O(1)
"""
status(ii::Token) =
       !(ii[2].address in ii[1].bt.useddatacells) ? 0 :
         ii[2].address == 1 ?                       2 :
         ii[2].address == 2 ?                       3 : 1

"""
    compare(m::SortedContainer, s::IntSemiToken, t::IntSemiToken)

Determine the  relative position according to the
sort order of the  data items indexed
by tokens `(m,s)` and  `(m,t)`.  Return:
- `-1`if`(m,s)` precedes `(m,t)`, 
- `0` if `s == t` 
- `1` if `(m,s)`succeeds `(m,t)`. 
The relative positions are determined 
from the tree topology without any key
comparisons. Time: O(log *n*)
"""
compare(m::SortedContainer, s::IntSemiToken, t::IntSemiToken) =
      compareInd(m.bt, s.address, t.address)


"""
    ordtype(sc::SortedSet)
    ordtype(sc::SortedDict)
    ordtype(sc::SortedMultiDict)

Return the order type for a sorted container.
This function may also be applied to the type itself.
Time: O(1)
"""
@inline ordtype(::SortedSet{K,Ord}) where {K, Ord} = Ord
@inline ordtype(::Type{SortedSet{K,Ord}}) where {K, Ord} = Ord
@inline ordtype(::SortedDict{K,D,Ord}) where {K, D, Ord} = Ord
@inline ordtype(::Type{SortedDict{K,D,Ord}}) where {K, D, Ord} = Ord
@inline ordtype(::SortedMultiDict{K,D, Ord}) where {K, D, Ord} = Ord
@inline ordtype(::Type{SortedMultiDict{K,D, Ord}}) where {K, D, Ord} = Ord

"""
    orderobject(sc::SortedContainer)

Return the order object used to construct the container. Time: O(1)
"""
@inline orderobject(m::SortedContainer) = m.bt.ord


"""
    deref(token::Token)
    deref((m,st))

Return the data item indexed by the token.  If
the container is a `SortedSet`, then this is a key in the set.
If the container is a `SortedDict` or `SortedMultiDict`, then
this is a key=>value pair.  It is a `BoundsError` if the token
is invalid or is the before-start or past-end token.  
Prepending with
`@inbounds` may elide the correctness check and will result
in undefined behavior if the token is invalid or
points to the before-start or past-end token.
The 
second form creates the token in-place as a tuple of a 
sorted container `m` 
and a semitoken `st`.  Time: O(1)
"""
function deref(ii::Token)
    error("This is not reachable because the specialized methods below will always be selected but is here to make the doc work")
end

Base.@propagate_inbounds function deref(ii::SortedDictToken)
    Base.@boundscheck has_data(ii)
    @inbounds kdrec = ii[1].bt.data[ii[2].address]
    return Pair(kdrec.k, kdrec.d)
end

Base.@propagate_inbounds function deref(ii::SortedMultiDictToken)
    Base.@boundscheck has_data(ii)
    @inbounds kdrec = ii[1].bt.data[ii[2].address]
    return Pair(kdrec.k, kdrec.d)
end


Base.@propagate_inbounds function deref(ii::SortedSetToken)
    Base.@boundscheck has_data(ii)
    @inbounds k = ii[1].bt.data[ii[2].address].k
    return k
end


"""
    deref_key(token::Token)
    deref_key((m,st))

Return the key portion of a data item (a key=>value pair) in a 
`SortedDict` or `SortedMultiDict` indexed by the token.
It is a `BoundsError` if the token
is invalid or is the before-start or past-end token. 
Prepending with
`@inbounds` may elide the correctness check and will result
in undefined behavior if the token is invalid or
points to the before-start or past-end token.
The 
second form creates the token in-place as a tuple of a container `m` 
and a semitoken `st`.  Time: O(1)
"""
function deref_key(ii::Token)
    error("Cannot invoke deref_key on a SortedSet")
end


Base.@propagate_inbounds function deref_key(ii::SDMToken)
    Base.@boundscheck has_data(ii)
    @inbounds k = ii[1].bt.data[ii[2].address].k
    return k
end


"""
    deref_value(token::Token)
    deref_value((m,st))

Returns the value portion of a data item (a key=>value pair)
in a `SortedDict` or `SortedMultiDict` 
indexed by the token. 
It is a `BoundsError` if the token
is invalid or is the before-start or past-end token. 
Prepending with
`@inbounds` may elide the correctness check and will result
in undefined behavior if the token is invalid or
points to the before-start or past-end token.
The 
second form creates the token in-place as a tuple of a container `m` 
and a semitoken `st`.  Time: O(1)
"""
function deref_value(ii::Token)
    error("Cannot invoke deref_key on a SortedSet")
end

Base.@propagate_inbounds function deref_value(ii::SDMToken)
    Base.@boundscheck has_data(ii)
    @inbounds d = ii[1].bt.data[ii[2].address].d
    return d
end


"""
    Base.first(sc::SortedContainer)

Return the 
first item (a `k=>v` pair for SortedDict and
SortedMultiDict or an element for SortedSet) in `sc` according to the sorted
order in the container. It is a `BoundsError` to call this function on
an empty container.  Equivalent to `deref(token_startindex(sc))`. Time: O(log *n*)
"""
Base.first(m::SortedContainer) = deref(token_firstindex(m))


"""
    Base.last(sc::SortedContainer)

Return the last item (a `k=>v` pair for SortedDict and
SortedMultiDict or a key for SortedSet) in `sc` according to the sorted
order in the container. It is a `BoundsError` to call this function on an
empty container. Equivalent to `deref(token_lastindex(sc))`. Time: O(log *n*)
"""
Base.last(m::SortedContainer) = deref(token_lastindex(m))



"""
    Base.getindex(m::SortedDict, st::IntSemiToken)
    Base.getindex(m::SortedMultiDict, st::IntSemiToken)

Retrieve value portion of item from SortedDict or SortedMultiDict
`m` indexed by `st`, a semitoken. Notation `m[st]` appearing in 
an expression
is equivalent to [`deref_value(token::Token)`](@ref) where `token=(m,st)`.  
It is a `BoundsError` if the token is invalid.  Prepending with
`@inbounds` may elide the correctness check and results in undefined
behavior if the token is invalid.
Time: O(1)
"""
Base.@propagate_inbounds function Base.getindex(m::SortedDict,
                       i::IntSemiToken)
    @boundscheck has_data((m,i))
    @inbounds d = m.bt.data[i.address].d
    return d
end
# Must repeat this to break ambiguity; cannot use SDMContainer.
Base.@propagate_inbounds function Base.getindex(m::SortedMultiDict,
                       i::IntSemiToken)
    @boundscheck has_data((m,i))
    @inbounds d = m.bt.data[i.address].d
    return d
end



"""
    Base.setindex!(m::SortedDict, newvalue, st::IntSemiToken)
    Base.setindex!(m::SortedMultiDict, newvalue, st::IntSemiToken)

Set the value portion of item from SortedDict or SortedMultiDict
`m` indexed by `st`, a semitoken to `newvalue`.  
A `BoundsError` is thrown if the token is invalid.
Prepending with `@inbounds` may elide the correctness check and
results in undefined behavior if the token is invalid.
Time: O(1)
"""
Base.@propagate_inbounds function Base.setindex!(m::SortedDict,
                        d_,
                        i::IntSemiToken)
    @boundscheck has_data((m,i))
    @inbounds m.bt.data[i.address] =
        KDRec{keytype(m),valtype(m)}(m.bt.data[i.address].parent,
                                     m.bt.data[i.address].k,
                                     convert(valtype(m),d_))
    return m
end

## Must repeat this to break ambiguity; cannot use SDMContainer
Base.@propagate_inbounds function Base.setindex!(m::SortedMultiDict,
                        d_,
                        i::IntSemiToken)
    @boundscheck has_data((m,i))
    @inbounds m.bt.data[i.address] =
        KDRec{keytype(m),valtype(m)}(m.bt.data[i.address].parent,
                                     m.bt.data[i.address].k,
                                     convert(valtype(m),d_))
    return m
end


"""
    Base.searchsortedfirst(m::SortedContainer, k)

Return the semitoken of the first item in the 
sorted container `m` that is greater than or equal to
`k` in the sort order.
If there is no
such item, then the past-end semitoken is returned.  Time: O(*c* log *n*)

"""
function Base.searchsortedfirst(m::SortedContainer, k_)
    i = findkeyless(m.bt, convert(keytype(m), k_))
    IntSemiToken(nextloc0(m.bt, i))
end


"""
    searchsortedafter(m::SortedContainer, k)

Return the semitoken of the first item in the container that is greater than
`k` in the sort order.  If there is no
such item, then the past-end semitoken is returned. Time: O(*c* log *n*)
"""
function searchsortedafter(m::SortedContainer, k_)
    i, exactfound = findkey(m.bt, convert(keytype(m), k_))
    IntSemiToken(nextloc0(m.bt, i))
end


"""
    Base.searchsortedlast(m::SortedContainer, k)

Return the semitoken of the last item in the container that is less than or equal
to `k` in sort order.  If there is no
such item, then the before-start semitoken is returned.  Time: O(*c* log *n*)
"""
function Base.searchsortedlast(m::SortedContainer, k_)
    i, exactfound = findkey(m.bt, convert(keytype(m),k_))
    IntSemiToken(i)
end


## The next four are correctness-checking routines.  They are
## not exported.


not_beforestart(i::Token) =
    (!(i[2].address in i[1].bt.useddatacells) ||
     i[2].address == 1) && throw(BoundsError())

not_pastend(i::Token) =
    (!(i[2].address in i[1].bt.useddatacells) ||
     i[2].address == 2) && throw(BoundsError())


has_data(i::Token) =
    (!(i[2].address in i[1].bt.useddatacells) ||
     i[2].address < 3) && throw(BoundsError())




# Container iterables IterableObject{C, R, KV, T, D}
# have five independent parameters as follows
#    C is the type of container, i.e., SortedSet{K,Ord}, SortedDict{K,D,Ord}
#          or SortedMultiDict{K,D,Ord}
#    R indicates whether the iteration is over the entire container,
#          an exclusive range (i.e., a:b where b is omitted) or
#          over an inclusive range (i.e., a:b where b is included)
#    KV indicates whether the iteration is supposed to return keys, values, or both
#       If T is set to onlysemitokens or onlytokens, then this parameter
#       has no effect
#    T indicates whether to return tokens or semitokens in addition to
#       keys and values
#    D indicates whether the iteration is forward or reverse
#



# This struct indicates iteration over the entire container is specified

abstract type RangeTypes end

struct EntireContainer <: RangeTypes
end

# This struct stores an exclusive range
struct ExclusiveRange <: RangeTypes
    first::Int
    pastlast::Int
end

# This struct stores an inclusive range
struct InclusiveRange <: RangeTypes
    first::Int
    last::Int
end


abstract type KVIterTypes end


# This struct indicates 'keys' iteration
struct KeysIter <: KVIterTypes
end

# This struct indicates 'vals' iteration
struct ValsIter <: KVIterTypes
end

# This struct indicates keys+vals iteration
struct KeysValsIter <: KVIterTypes
end

default_KVIterType(::SDMContainer) = KeysValsIter
default_KVIterType(::SortedSet) = KeysIter

abstract type TokenIterTypes end

# This struct indicates 'semitokens' iteration
struct SemiTokenIter <: TokenIterTypes
end

# This struct indicates 'tokens' iteration
struct TokenIter <: TokenIterTypes
end

# This struct indicates 'onlysemitokens' iteration
struct OnlySemiTokenIter <: TokenIterTypes
end

# This struct indicates 'onlytokens' iteration
struct OnlyTokenIter <: TokenIterTypes
end

# This struct indicates neither tokens nor semitokens iteration
struct NoTokens <: TokenIterTypes
end


# This struct indicates  forward iteration

abstract type IterDirection end

struct ForwardIter <: IterDirection
end

# This struct indicates reverse iteration
struct ReverseIter <: IterDirection
end


struct IterableObject{C <: SortedContainer,
                      R <: RangeTypes,
                      Kv <: KVIterTypes,
                      T <: TokenIterTypes,
                      D <: IterDirection}
    m::C
    r::R
end

const SortedContainerIterable = Union{IterableObject, SortedContainer}


base_iterable_object(m::SortedContainer) =
    IterableObject{typeof(m),
                   EntireContainer,
                   default_KVIterType(m),
                   NoTokens,
                   ForwardIter}(m, EntireContainer())

exclusive(m::SortedContainer, (ii1, ii2)::Tuple{IntSemiToken, IntSemiToken}) =
    IterableObject{typeof(m),
                   ExclusiveRange,
                   default_KVIterType(m),
                   NoTokens,
                   ForwardIter}(m, ExclusiveRange(ii1.address, ii2.address))


exclusive(m::SortedContainer, ii1::IntSemiToken, ii2::IntSemiToken) =
    exclusive(m, (ii1, ii2))

exclusive_key(m::SortedContainer, key1, key2) =
    exclusive(m, (searchsortedfirst(m, key1), searchsortedfirst(m, key2)))


inclusive(m::SortedContainer, (ii1, ii2)::Tuple{IntSemiToken, IntSemiToken}) =
    IterableObject{typeof(m),
                   InclusiveRange,
                   default_KVIterType(m),
                   NoTokens,
                   ForwardIter}(m, InclusiveRange(ii1.address, ii2.address))

inclusive(m::SortedContainer,ii1::IntSemiToken, ii2::IntSemiToken) =
    inclusive(m, (ii1, ii2))

inclusive_key(m::SortedContainer, key1, key2) =
    inclusive(m, (searchsortedfirst(m, key1), searchsortedlast(m, key2)))


Base.keys(ito::IterableObject{C, R, KeysValsIter, T, D}) where
{C <: SDMContainer, R, T, D} = 
    IterableObject{C, R, KeysIter, T, D}(ito.m, ito.r)

Base.keys(m::SDMContainer) = keys(base_iterable_object(m))

Base.pairs(ito::IterableObject{<: SDMContainer, R, KV, T, D}) where {R, KV, T, D} = ito
Base.pairs(m::SDMContainer) = base_iterable_object(m)


Base.values(ito::IterableObject{C, R, KeysValsIter, T, D}) where
{C <: SDMContainer, R, T, D} = 
    IterableObject{C, R, ValsIter, T, D}(ito.m, ito.r)

Base.values(m::SDMContainer) = values(base_iterable_object(m))

semitokens(ito::IterableObject{C, R, KV, NoTokens, D}) where {C, R, KV, D} =
    IterableObject{C, R, KV, SemiTokenIter, D}(ito.m, ito.r)

semitokens(m::SortedContainer) = semitokens(base_iterable_object(m))

tokens(ito::IterableObject{C, R, KV, NoTokens, D}) where {C, R, KV, D} =
    IterableObject{C, R, KV, TokenIter, D}(ito.m, ito.r)

tokens(m::SortedContainer) = tokens(base_iterable_object(m))

onlysemitokens(ito::IterableObject{C, R, KV, NoTokens, D}) where {C, R, KV, D} =
    IterableObject{C, R, KV, OnlySemiTokenIter, D}(ito.m, ito.r)

onlysemitokens(m::SortedContainer) = onlysemitokens(base_iterable_object(m))

onlytokens(ito::IterableObject{C, R, KV, NoTokens, D}) where  {C, R, KV, D} =
    IterableObject{C, R, KV, OnlyTokenIter, D}(ito.m, ito.r)

onlytokens(m::SortedContainer) = onlytokens(base_iterable_object(m))


Base.Iterators.reverse(ito::IterableObject{C, R, KV, T, ForwardIter}) where {C, R, KV, T} =
    IterableObject{C, R, KV, T, ReverseIter}(ito.m, ito.r)

Base.Iterators.reverse(ito::IterableObject{C, R, KV, T, ReverseIter}) where {C, R, KV, T} =
    IterableObject{C, R, KV, T, ForwardIter}(ito.m, ito.r)

Base.Iterators.reverse(m::SortedContainer) = Iterators.reverse(base_iterable_object(m))

struct SAIterationState
    next::Int
    final::Int
end


# The iterate function is decomposed into three pieces:
# The iteration_init function initializes the iteration state and
# also stores the final state.  It
# does different things depending on the parameter R (range) and D (direction).
# The get_item function retrieves the requested data from the
# the container and depends on the KV and D parameters.
# The next function updates the iteration state to the next item
# and depends on the D (direction) parameter.


iteration_init(ito::IterableObject{C, EntireContainer, KV, T, ForwardIter}) where
{C, KV, T} = SAIterationState(beginloc(ito.m.bt), 2)

iteration_init(ito::IterableObject{C, EntireContainer, KV, T, ReverseIter}) where
{C, KV, T} = SAIterationState(endloc(ito.m.bt), 1)

function iteration_init(ito::IterableObject{C, ExclusiveRange, KV, T, ForwardIter}) where
{C, KV, T}
    (!(ito.r.first in ito.m.bt.useddatacells) || ito.r.first == 1 ||
     !(ito.r.pastlast in ito.m.bt.useddatacells)) &&
     throw(BoundsError())
    if compareInd(ito.m.bt, ito.r.first, ito.r.pastlast) < 0
        return SAIterationState(ito.r.first, ito.r.pastlast)
    else
        return SAIterationState(2, 2)
    end
end

function iteration_init(ito::IterableObject{C, ExclusiveRange, KV, T, ReverseIter}) where
{C, KV, T}
    (!(ito.r.first in ito.m.bt.useddatacells) || ito.r.first == 2 ||
     !(ito.r.pastlast in ito.m.bt.useddatacells)) &&
     throw(BoundsError())
    if compareInd(ito.m.bt, ito.r.first, ito.r.pastlast) < 0
        return SAIterationState(prevloc0(ito.m.bt, ito.r.pastlast),
                                prevloc0(ito.m.bt, ito.r.first))
    else
        return SAIterationState(2, 2)
    end
end

function iteration_init(ito::IterableObject{C, InclusiveRange, KV, T, ForwardIter}) where
{C, KV, T}
    (!(ito.r.first in ito.m.bt.useddatacells) || ito.r.first == 1 ||
     !(ito.r.last in ito.m.bt.useddatacells) || ito.r.last == 2) &&
     throw(BoundsError())
    if compareInd(ito.m.bt, ito.r.first, ito.r.last) <= 0
        return SAIterationState(ito.r.first, nextloc0(ito.m.bt, ito.r.last))
    else
        return SAIterationState(2, 2)
    end
end    


function iteration_init(ito::IterableObject{C, InclusiveRange, KV, T, ReverseIter}) where
{C, KV, T}
    (!(ito.r.first in ito.m.bt.useddatacells) || ito.r.first == 2 ||
     !(ito.r.last in ito.m.bt.useddatacells) || ito.r.last == 1) &&
     throw(BoundsError())
    if compareInd(ito.m.bt, ito.r.first, ito.r.last) <= 0
        return SAIterationState(ito.r.last, prevloc0(ito.m.bt, ito.r.first))
    else
        return SAIterationState(2, 2)
    end
end

iteration_init(m::SortedContainer) = iteration_init(base_iterable_object(m))

@inline function get_item0(ito::IterableObject{C, R, KeysIter, T, D},
                           state::SAIterationState) where {C, R, T, D} 
    @inbounds k = ito.m.bt.data[state.next].k
    return k
end


@inline function get_item0(ito::IterableObject{C, R, ValsIter, T, D},
                           state::SAIterationState) where {C, R, T, D} 
    @inbounds v = ito.m.bt.data[state.next].d
    return v
end


@inline function get_item0(ito::IterableObject{C, R, KeysValsIter, T, D},
                           state::SAIterationState) where {C, R, T, D}
    @inbounds dt = ito.m.bt.data[state.next]
    return (dt.k => dt.d)
end

get_item(ito::IterableObject{C, R, KeysIter, TokenIter, D},
         state::SAIterationState) where {C, R, D} =
             ((ito.m, IntSemiToken(state.next)), get_item0(ito, state))

Base.eltype(::Type{IterableObject{C, R, KeysIter, TokenIter, D}}) where {C, R, D} =
    Tuple{Tuple{C,IntSemiToken}, keytype(C)}


get_item(ito::IterableObject{C, R, ValsIter, TokenIter, D},
         state::SAIterationState) where {C, R, D} =
             ((ito.m, IntSemiToken(state.next)), get_item0(ito, state))

Base.eltype(::Type{IterableObject{C, R, ValsIter, TokenIter, D}}) where {C, R, D} =
    Tuple{Tuple{C,IntSemiToken}, valtype(C)}


function get_item(ito::IterableObject{C, R, KeysValsIter, TokenIter, D},
                  state::SAIterationState) where {C, R, D}
    i = get_item0(ito, state)
    ((ito.m, IntSemiToken(state.next)), i.first, i.second)
end

Base.eltype(::Type{IterableObject{C, R, KeysValsIter, TokenIter, D}}) where {C, R, D} =
    Tuple{Tuple{C,IntSemiToken}, keytype(C), valtype(C)}

get_item(ito::IterableObject{C, R, KeysIter, SemiTokenIter, D},
         state::SAIterationState) where {C, R, D} = 
             (IntSemiToken(state.next), get_item0(ito, state))

Base.eltype(::Type{IterableObject{C, R, KeysIter, SemiTokenIter, D}}) where {C, R, D} =
    Tuple{IntSemiToken, keytype(C)}

get_item(ito::IterableObject{C, R, ValsIter, SemiTokenIter, D},
         state::SAIterationState) where {C, R, D} = 
             (IntSemiToken(state.next), get_item0(ito, state))

Base.eltype(::Type{IterableObject{C, R, ValsIter, SemiTokenIter, D}}) where {C, R, D} =
    Tuple{IntSemiToken, valtype(C)}

function get_item(ito::IterableObject{C, R, KeysValsIter, SemiTokenIter, D},
                  state::SAIterationState) where {C, R, D}
    i = get_item0(ito, state)
    (IntSemiToken(state.next), i.first, i.second)
end

Base.eltype(::Type{IterableObject{C, R, KeysValsIter, SemiTokenIter, D}}) where {C, R, D} =
    Tuple{IntSemiToken, keytype(C), valtype(C)}

get_item(ito::IterableObject{C, R, KV, OnlyTokenIter, D},
         state::SAIterationState) where {C, R, KV, D} =
             (ito.m, IntSemiToken(state.next))

Base.eltype(::Type{IterableObject{C, R, KV, OnlyTokenIter, D}}) where {C, KV, R, D} =
    Tuple{C, IntSemiToken}


get_item(ito::IterableObject{C, R, KV, OnlySemiTokenIter, D},
         state::SAIterationState) where {C, R, KV, D} = 
             IntSemiToken(state.next)


Base.eltype(::Type{IterableObject{C, R, KV, OnlySemiTokenIter, D}}) where {C, R, KV, D} = IntSemiToken

get_item(ito::IterableObject{C, R, KV, NoTokens, D},
         state::SAIterationState) where {C, R, KV, D} = 
             get_item0(ito, state)

Base.eltype(::Type{IterableObject{C, R, KeysIter, NoTokens, D}}) where {C, R, D} =
    keytype(C)
Base.eltype(::Type{IterableObject{C, R, ValsIter, NoTokens, D}}) where {C, R, D} =
    valtype(C)
Base.eltype(::Type{IterableObject{C, R, KeysValsIter, NoTokens, D}}) where {C, R, D} =
    eltype(C)

Base.eltype(::ItObj) where {ItObj <: IterableObject} = eltype(ItObj)

get_item(m::SortedContainer, state::SAIterationState) =
    get_item(base_iterable_object(m), state)


function next(ito::IterableObject{C, R, KV, T, ForwardIter},
              state::SAIterationState) where {C, R, KV, T} 
    sn = state.next
    (sn < 3 || !(sn in ito.m.bt.useddatacells)) && throw(BoundsError())
    SAIterationState(nextloc0(ito.m.bt, sn), state.final)
end

function next(ito::IterableObject{C, R, KV, T, ReverseIter},
              state::SAIterationState) where {C, R, KV, T}
    sn = state.next
    (sn < 3 || !(sn in ito.m.bt.useddatacells)) && throw(BoundsError())
    SAIterationState(prevloc0(ito.m.bt, sn), state.final)
end

next(m::SortedContainer, state::SAIterationState) =
    next(base_iterable_object(m), state)

"""
    Base.iterate(iter::SortedContainerIterable)

with the following helper functions to construct a `SortedContainerIterable`:

    inclusive(m::SortedContainer, st1, st2)
    inclusive(m::SortedContainer, (st1, st2))
    inclusive_key(m::SortedContainer, key1, key2)
    inclusive_key(m::SortedContainer, (key1, key2))
    exclusive(m::SortedContainer, st1, st2)
    exclusive(m::SortedContainer, (st1, st2))
    exclusive_key(m::SortedContainer, key1, key2)
    exclusive_key(m::SortedContainer, (key1, key2))
    Base.keys(b)
    Base.values(b)
    Base.pairs(b)
    Base.eachindex(b)
    tokens(kv)
    semitokens(kv)
    onlytokens(kv)
    onlysemitokens(kv)
    Base.Iterators.reverse(m)
    (:)(a,b)



Iterate over a sorted container, typically 
within a for-loop, comprehension, or generator.
Here, `iter` is an iterable object constructed from a sorted
container.  The possible iterable objects are constructed from
the helper functions as follows:

A *basic* iterable object is either 
- an entire sorted container `m`,
- `inclusive(m, (st1, st2))` or equivalently `inclusive(m, st1, st2)`, 
- `inclusive_key(m, (k1, k2))` or equivalently `inclusive_key(m, k1, k2)`
- `a:b`, where `a` and `b` are tokens addressing the same container
- `exclusive(m, (st1, st2))` or equivalently `exclusive(m, st1, st2)`
- `exclusive_key(m, (k1, k2))` or equivalently `exclusive_key(m, k1, k2)`

These extract ranges of consecutive items in the containers.  In the
`inclusive` and `exclusive` constructions,
constructions, `m` is a container, `st1` and `st2` are semitokens.  The
`inclusive` range includes both endpoints `st1` and `st2`. 
The inclusive 
iteration is empty if `compare(m,st1,st2)<0`. The `exclusive` range includes
endpoint `st1` but not `st2`.  The exclusive iteration is empty if
`compare(m,st1,st2)<=0`.  In the exclusive iteration, it is acceptable
if `st2` is the past-end semitoken.  


The range `exclusive_key` means all data items with keys between `k1` up to but
excluding items with key `k2`.  For this range to be nonempty, 
`k1<k2` must hold (in the sort order).  
The range `inclusive_key` means all data items with
keys between `k1` and `k2` inclusive.  For this range to be nonempty, `k1<=k2`
must hold.


A *kv* iterable object has the form 
- `b`, a basic iterable object
- `keys(b)` where `b` is a basic object.  Extract keys only (not applicable
   to SortedSet)
- `values(b)` where `b` is a basic object.  Extract values only
   (not applicable to SortedSet).
- `pairs(b)` where `b` is a basic object. Extracts key=>value pairs
   (not applicable to SortedSet).  
   This is the same as just specifying `b` and is provided only for compatibility
   with `Base.pairs`.  

A *tkv* object has the form 
- `kv`, a kv iterable object
- `tokens(kv)` where `kv` is a kv iterable object.  
   Return 2-tuples of the form `(t,w)`, where `t` is the
   token of the item and `w` is a key or value if `kv` is a keys or values
   iteration, or `(t,k,v)` if `kv` is a pairs iteration. 
- `semitokens(kv)` where `kv` is a kv iterable object.  
   Return pairs of the form `(st,w)`, where `st` is the
   token of the item and `w` is a key or value if `kv` is a keys or values
   iteration, or `(st,k,v)` if `kv` is a pairs iteration.
- `onlytokens(kv)` where `kv` is a kv iterable object. Return only tokens
   of the data items but not the items themselves.  
   The `keys`, `values`, or `pairs` modifiers described above
   are ignored.
- `onlysemitokens(kv)` where `kv` is a kv iterable object. Return only semitokens
   of the data items but not the items themselves.  
   The `keys`, `values`, or `pairs` modifiers described above
   are ignored.

Finally, a tkv iteration can be reversed by the `Iterators.reverse` function.  The
`Iterators.reverse` function
may be nested in an arbitrary position with respect to the other operations described 
above. Two reverse operations cancel each other out.  For example,
`Iterators.reverse(keys(Iterators.reverse(m)))` is the same iteration as `keys(m)`.

For compatibility with `Base`, there is also an `eachindex` function:
`eachindex(b)` where the base object `b` a SortedDict is
the same as `keys(b)` (to be compatible with Dict).  
On the other hand, `eachindex(b)` where the
base object `b` is a SortedSet or SortedMultiDict is the
same as `onlysemitokens(b)`.

Colon notation `a:b`  is equivalent
to `onlytokens(inclusive(a[1], a[2], b[2]))`, in other words, it yields
an iteration that provides all the tokens of items in the sort order ranging
from token `a` up to token `b`. It is required that `a[1]===b[1]` (i.e.,
`a` and `b` are tokens for the same container).  Exclusive iteration using
colon notation is obtained via `a : b-1`.

# Examples:

```julia
   for (k,v) in sd
       <body>
   end
```
Here, `sd` is a `SortedDict` or `SortedMultiDict`.  The variables `(k,v)` 
are set to consecutive key-value pairs.  All items in the container are
produced in order.


```julia
   for k in inclusive(ss, st1, st2)
       <body>
   end
```
Here, `ss` is a `SortedSet`, and `st1`, and `st2` are semitokens indexing `ss`.
The elements of the set between `st1` and `st2` inclusive are returned.


```julia
   for (t,k) in tokens(keys(exclusive_key(sd, key1, key2)))
      <body>
   end
```
Here, `sd` is a `SortedDict` or `SortedMultiDict`, `key1` and `key2` are keys
indexing `sd`.  In this case, `t` will be tokens of consecutive items,
while `k` will be the corresponding keys.  The returned keys lie between `key1` and
`key2` excluding `key2`.

```julia
   for (t,k) in Iterators.reverse(tokens(keys(exclusive_key(sd, key1, key2))))
      <body>
   end
```
Same as above, except the iteration is in the reverse order.

Writing on the objects returned by `values` is not currently supported, e.g.,
the following `map!` statement is not implemented even though the 
analogous statement is available for `Dict` in Base.
```julia
    s = SortedDict(3=>4)
    map!(x -> x*2, values(s))
```
The workaround is an explicit loop:
```julia
    s = SortedDict(3=>4)
    for t in onlysemitokens(s)
        s[t] *= 2
    end
```

Running time for all iterations: O(*c*(*s* + log *n*)), where
*s* is the number of steps from start to end of the iteration.
"""
function Base.iterate(s::SortedContainerIterable,
                      state = iteration_init(s))
    if state.next == state.final
        return nothing
    else
        return (get_item(s, state), next(s, state))
    end
end

Base.keytype(::IterableObject{C, R, KeysValsIter, NoTokens, D}) where
{C <: SDMContainer, R, D} = keytype(C)

Base.keytype(::Type{IterableObject{C, R, KeysValsIter, NoTokens, D}}) where
{C <: SDMContainer, R, D} = keytype(C)

Base.valtype(::IterableObject{C, R, KeysValsIter, NoTokens, D}) where
{C <: SDMContainer, R, D} = valtype(C)

Base.valtype(::Type{IterableObject{C, R, KeysValsIter, NoTokens, D}}) where
{C <: SDMContainer, R, D} = valtype(C)

Base.IteratorSize(::Type{T} where {T <: SortedContainer}) = HasLength()
Base.IteratorSize(::Type{IterableObject{C, EntireContainer, KV, T, D}}) where
{C, KV, T, D} = HasLength()

Base.IteratorSize(::Type{IterableObject{C, ExclusiveRange, KV, T, D}}) where
{C, KV, T, D} = SizeUnknown()

Base.IteratorSize(::Type{IterableObject{C, InclusiveRange, KV, T, D}}) where
{C, KV, T, D} = SizeUnknown()

Base.length(ito::IterableObject{C, EntireContainer, KV, T, D}) where
{C, KV, T, D} = length(ito.m)


"""
    Base.in(x, iter::SortedContainerIterable)

Returns true if `x` is in `iter`, where `iter` refers to any of the
iterable objects described under [`Base.iterate(iter::SortedContainerIterable)`](@ref),
and `x` is of the appropriate type. For all of the iterables
except the five listed below, the algorithm used is a linear-time
search. For example, the call:

    (k=>v) in exclusive(sd, st1, st2)

where `sd` is a SortedDict, `st1` and `st2` are semitokens, `k` is a
key, and `v` is a value, will loop over all entries in the
dictionary between the two tokens and a compare for equality using
`isequal` between the indexed item and `k=>v`.

The five exceptions are:

```julia
(k=>v) in sd
(k=>v) in smd
k in ss
k in keys(sd)
k in keys(smd)
```

Here, `sd` is a SortedDict, `smd` is a SortedMultiDict, and `ss` is
a SortedSet.

These five invocations of `in` use the index structure of the sorted
container and test equality based on the order object of the keys
rather than `isequal`. Therefore, these five are all faster than
linear-time looping. To force the use of `isequal` test on
the keys rather than the order object (thus slowing the execution
from logarithmic to linear time), replace the above five constructs
with these:

```julia
(k=>v) in collect(sd)
(k=>v) in collect(smd)
k in collect(ss)
k in collect(keys(sd))
k in collect(keys(smd))
```
"""
Base.in(x, m::SortedContainerIterable) =
    invoke(in, Tuple{Any,Any}, x, m)

Base.in(k, ito::IterableObject{C, EntireContainer, KeysIter, NoTokens, D}) where
{C, D} = haskey(ito.m, k)


"""
    haskey(sc::SortedContainer, k)

Return `true` iff key `k` is present in `sc`.  Equivalent
to 
`in(k,sc)` for a SortedSet, or to `in(k,keys(sc))` for
a SortedDict or SortedMultiDict.  Time: O(*c* log *n*)
"""
@inline function Base.haskey(m::SortedContainer, k_) 
    i, exactfound = findkey(m.bt, convert(keytype(m),k_))
    return exactfound
end


Base.eachindex(sd::SortedDict) = keys(sd)
Base.eachindex(sdm::SortedMultiDict) = onlysemitokens(sdm)
Base.eachindex(ss::SortedSet) = onlysemitokens(ss)


Base.eachindex(ito::IterableObject{C, R, KeysValsIter, NoTokens, D}) where
{C <: SortedDict, R, D} = keys(ito)

Base.eachindex(ito::IterableObject{C, R, KV, NoTokens, D}) where
{C <: SortedMultiDict, R, KV, D} = onlysemitokens(ito)

Base.eachindex(ito::IterableObject{C, R, KV, NoTokens, D}) where
{C <: SortedSet, R, KV, D} = onlysemitokens(ito)


"""
   empty!(m)

Empty a sorted container
"""

Base.empty!(m::SortedContainer) = (empty!(m.bt); m)
Base.length(m::SortedContainer) = length(m.bt.data) - length(m.bt.freedatainds) - 2
Base.isempty(m::SortedContainer) = length(m) == 0


function Base.:(:)(t1::Token, t2::Token)
    t1[1] !== t2[1] &&
        throw(ArgumentError("First and second arguments of colon operator on sorted container tokens must refer to the same container"))
    IterableObject{typeof(t1[1]), InclusiveRange, default_KVIterType(t1[1]), OnlyTokenIter,
                   ForwardIter}(t1[1], InclusiveRange(t1[2].address, t2[2].address))
end


"""
    Base.+(t::Token, j::Integer)
    Base.-(t::Token, j::Integer)
Return the token that is `j` positions ahead (if `+`) or behind (if `-`) of `t`.
Here, `t` is a token for a sorted container and `j` is an integer. 
If `j` is negative, then `+` regresses while `-` advances.
If the operation `t+j` or `t-j` reaches the before-start 
or past-end positions in the container,
then the before-start/past-end tokens are returned (and there is no error).
Time: O(*j*+log *n*), so this function is not optimized for long jumps.
"""
Base.:(+)(t1::Token, numstep::Integer) = numstep >= 0 ? stepforward(t1, numstep) : stepback(t1, -numstep)

Base.:(-)(t1::Token, numstep::Integer) = numstep >= 0 ? stepback(t1, numstep) : stepforward(t1, -numstep)


function stepforward(t1::Token, numstep::Integer)
    m = t1[1]
    j = t1[2].address
    !(j in m.bt.useddatacells) && throw(BoundsError())
    for i = 1 : numstep
        j == 2 && break
        j = nextloc0(m.bt, j)
    end
    (m, IntSemiToken(j))
end

function stepback(t1::Token, numstep::Integer)
    m = t1[1]
    j = t1[2].address
    !(j in m.bt.useddatacells) && throw(BoundsError())
    for i = 1 : numstep
        j == 1 && break
        j = prevloc0(m.bt, j)
    end
    (m, IntSemiToken(j))
end

@testset "LinkedList" begin

    @testset "basic tests" begin
        l = list(2, 3)
        @test length(l) == 2
        @test eltype(l) == Int
        @test eltype(typeof(l)) == Int
    end

    @testset "l0" begin
        l0 = nil(Char)
        @test length(l0) == 0
        @test l0 == nil(Char)
        @test l0 == nil()
        @test sprint(show,l0) == "nil(Char)"
    end

    @testset "l1" begin
        l1 = nil()
        @test length(l1) == 0
        @test l1 == nil()
        @test l1 == nil(Int)
        @test sprint(show,l1) == "nil()"
        @test typeof(list()) === typeof(l1)
        @test copy(l1) == l1
        @test map((x) -> x*2,l1) == l1
    end

    @testset "l2" begin
        l1 = nil()
        l2 = cons(1, l1)
        @test length(l2) == 1
        @test head(l2) == 1
        @test l2 == cons(1, l1)
        @test l2 == list(1)
        @test sprint(show,l2) == "list(1)"
        @test cat(l2) == l2
    end

    @testset "l3" begin
        l3 = list(2, 3)
        @test isa(l3, Cons{Int})
        @test length(l3) == 2
        @test head(l3) == 2
        @test head(tail(l3)) == 3
        @test l3 == list(2,3)
        @test collect(l3) == [2; 3]
        @test collect(copy(l3)) == [2; 3]
        @test sprint(show,l3) == "list(2, 3)"
    end

    @testset "l4" begin
        l1 = nil()
        l2 = cons(1, l1)
        l3 = list(2, 3)
        l4 = cat(l1, l2, l3)
        @test length(l4) == 3
        @test l4 == list(1, 2, 3)
        @test collect(l4) == [1; 2; 3]
        @test collect(copy(l4)) == [1; 2; 3]
        @test sprint(show,l4) == "list(1, 2, 3)"
    end

    @testset "l5" begin
        l4 = list(1, 2, 3)
        l5 = map((x) -> x*2, l4)
        @test isa(l5, Cons{Int})
        @test collect(l5) == [2; 4; 6]
    end

    @testset "l5b" begin
        l5 = list(2, 4, 6)
        l5b = map((x) -> "$x", l5)
        @test isa(l5b, Cons{String})
        @test collect(l5b) == ["2"; "4"; "6"]
    end

    @testset "l5" begin
        l5 = list(2, 4, 6)
        l6 = filter((x) -> x < 6, l5)
        @test length(l6) == 2
        @test l6.head == 2
        @test l6.tail.head == 4
        @test collect(l6) == [2, 4]
    end

    @testset "l7" begin
        l6 = list(2, 4)
        l7 = reverse(l6)
        @test length(l7) == 2
        @test l7.head == 4
        @test l7.tail.head == 2
    end

    @testset "l8" begin
        l5b = list("2", "4", "6")
        l6 = list(2, 4)
        l8 = cat(l5b, l6)
        @test collect(l8) == ["2"; "4"; "6"; 2; 4]
    end

    @testset "l9" begin
        l9 = cat(list(1, 2), list(3.0, 4.0))
        @test isa(l9, Cons{Real})
        @test collect(l9) == [1; 2; 3.0; 4.0]
    end

    @testset "l10" begin
        l10 = list(2, 4, 5.6, 10.5)
        @test collect(l10) == [2; 4; 5.6; 10.5]
    end

    @testset "test identity map" begin
        ex = :(a+b+2 * 2 + foo(2))
        l11 = list(ex.args...)
        @test collect(map(x->x, l11)) == collect(l11)
    end

    @testset "test promotion" begin
        l12 = list(Int(1), Float64(1))
        @test isa(l12, Cons{Float64})
    end

end # @testset LinkedList

using DataStructures, Test
import DataStructures: SparseIntSet

@testset "SparseIntSet" begin
    @testset "Construction, collect" begin
        data_in = (1,5,100)
        s = SparseIntSet(data_in)
        data_out = collect(s)
        @test all(map(d->in(d,data_out), data_in))
        @test length(data_out) == length(data_in)
    end

    @testset "eltype, empty" begin
        @test eltype(SparseIntSet()) == Int
        @test eltype(typeof(SparseIntSet())) == Int
        @test isequal(empty(SparseIntSet([1,2,3])), SparseIntSet())
    end

    @testset "Core Functionality" begin
        s = SparseIntSet([1,2,10,20,200,300,1000,10000,10002])
        @test last(s) == 10002
        @test first(s) == 1
        @test length(s) == 9
        @test pop!(s) == 10002
        @test length(s) == 8
        @test popfirst!(s) == 1
        @test length(s) == 7
        @test !in(1,s)
        @test !in(10002,s)
        @test in(10000,s)
        @test_throws ArgumentError first(SparseIntSet())
        @test_throws ArgumentError last(SparseIntSet())
        t = copy(s)
        s = SparseIntSet()
        push!(s, 1, 2, 100)
        @test 1 in s
        @test !(3 in s)
        @test 2 in s
        @test 100 in s
        @test !(101 in s)
        @test !(1000 in s)
        @test first(s) == 1
        @test last(s) == 100
        @test s == SparseIntSet([1, 2, 100])
        push!(s, 1000)
        @test [i for i in s] == [1, 2, 100, 1000]
        @test pop!(s) == 1000
        @test s == SparseIntSet([1, 2, 100])
        push!(s, 5000)
        push!(s, 2000)
        pop!(s, 5000)
        @test s.reverse[end] === DataStructures.NULL_INT_PAGE
        b = 1:1000
        s = SparseIntSet(b)
        @test collect(s) == collect(b)
        @test length(s) == length(b)
        @test pop!(s, 100) == 100
        @test_throws BoundsError pop!(s, 100)
        @test pop!(s, 100, 1) == 1
        @test pop!(s, 99, 1) == 99
        @test !in(500000, s)
        @test !in(99, s)
    end

    @testset "setdiff / symdiff" begin
        @test setdiff(SparseIntSet([1, 2, 3, 4]), SparseIntSet([2, 4, 5, 6])) == SparseIntSet([1, 3])
    end

    @testset "setdiff!" begin
        s2 = SparseIntSet([1, 2, 3, 4])
        setdiff!(s2, SparseIntSet([2, 4, 5, 6]))

        @test s2 == SparseIntSet([1, 3])
    end

    @testset "issue #7851" begin
        @test_throws DomainError SparseIntSet(-1)
        @test !(-1 in SparseIntSet(1:10))
    end
    @testset "Copy, copy!, empty" begin
        s1 = SparseIntSet([1,2,3])
        s2 = empty(s1)
        push!(s2, 10000)
        @test !in(10000, s1)
        copy!(s2, s1)
        @test !in(10000, s2)
        push!(s2, 10000)
        @test !in(10000, s1)
        s3 = copy(s2)
        push!(s3, 1000)
        @test !in(1000, s2)
        pop!(s3, 1000)
        pop!(s2, 10000)
        @test in(10000, s3)
        pop!(s3, 10000)
        @test s3 == s2 == s1
        @test collect(s3) == collect(s2) == [1,2,3]


    end

    @testset "Push, union" begin
        # Push, union
        s1 = SparseIntSet()
        @test_throws DomainError push!(s1, -1)
        push!(s1, 1, 10, 100, 1000)
        @test collect(s1) == [1, 10, 100, 1000]
        push!(s1, 606)
        @test collect(s1) == [1, 10, 100, 1000, 606]
        s2 = SparseIntSet()
        @test s2 === union!(s2, s1)
        s3 = SparseIntSet([1, 10, 100])
        union!(s3, [1, 606, 1000])
        s4 = union(SparseIntSet([1, 100, 1000]), SparseIntSet([10, 100, 606]))
        @test s1 == s2 == s3 == s4
    end

    @testset "pop!, delete!" begin
        s = SparseIntSet(1:2:10)
        @test pop!(s, 1) == 1
        @test !(1 in s)
        @test_throws BoundsError pop!(s, 1)
        @test_throws ArgumentError pop!(s, -1)
        @test_throws ArgumentError pop!(s, -1, 1)
        @test pop!(s, 1, 0) == 0
        is = copy(s.packed)
        for i in is; pop!(s, i); end
        @test isempty(s)
        push!(s, 1:2:10...)
        @test pop!(s) == 9
        @test pop!(s) == 7
        @test popfirst!(s) == 1
        @test popfirst!(s) == 5
        @test collect(s) == [3]
        empty!(s)
        @test isempty(s)
    end

    @testset "Intersect" begin
        @test isempty(intersect(SparseIntSet()))
        @test isempty(intersect(SparseIntSet(1:10), SparseIntSet()))
        @test isempty(intersect(SparseIntSet(), SparseIntSet(1:10)))

        @test intersect(SparseIntSet([1,2,3])) == SparseIntSet([1,2,3])

        @test intersect(SparseIntSet(1:7), SparseIntSet(3:10)) ==
              intersect(SparseIntSet(3:10), SparseIntSet(1:7)) == SparseIntSet(3:7)

        @test intersect!(SparseIntSet(1:10), SparseIntSet(1:4), 1:5, [1,2,10]) == SparseIntSet(1:2)
    end

    @testset "Setdiff" begin
        s1 = SparseIntSet(1:100)
        setdiff!(s1, SparseIntSet(1:2:100))
        s2 = setdiff(SparseIntSet(1:100), SparseIntSet(1:2:100))
        @test s1 == s2 == SparseIntSet(2:2:100)

        s1 = SparseIntSet(1:10)
        s2 = SparseIntSet([1:2; 6:100])
        @test setdiff(s1, s2) == setdiff(s1, [1:2; 6:100]) == SparseIntSet(3:5)
    end

    @testset "Subsets, equality" begin
        @test SparseIntSet(2:2:10) < SparseIntSet(1:10)
        @test !(SparseIntSet(2:2:10) < SparseIntSet(2:2:10))
        @test SparseIntSet(2:2:10) <= SparseIntSet(2:10)
        @test SparseIntSet(2:2:10) <= SparseIntSet(2:2:10)
    end
    @testset "zip" begin
    	a = SparseIntSet([1,2,3,5, 6, 9, 12, 24])
    	b = SparseIntSet([6, 12, 24, 1000, 2000, 3000])
    	c = SparseIntSet(2:2:100)
    	d = SparseIntSet(6:3:100)
    	e = SparseIntSet((6, 12))
    	s1 = 0
    	it = zip(a, b, c, d, e)
    	for (ia, ib, ic, id, ie) in it
	    	s1 += a.packed[ia] + b.packed[ib] + c.packed[ic] + d.packed[id] + e.packed[ie]
	    end
	    @test s1 == 5*(6+12)
    	s1 = 0
    	it = zip(a, b, c, d, exclude=(e,))
    	for (ia, ib, ic, id) in it
	    	s1 += a.packed[ia] + b.packed[ib] + c.packed[ic] + d.packed[id]
	    end
	    @test s1 == 4*24
	end
        if VERSION >= v"1.1"
            @test zip() isa Iterators.Zip  # issue 621
        end

end

## A SortedDict is a wrapper around balancedTree with methods similar
## to those of Julia container Dict.

mutable struct SortedDict{K, D, Ord <: Ordering} <: AbstractDict{K,D}
    bt::BalancedTree23{K,D,Ord}
end


"""
    SortedDict{K,V,Ord}(o::Ord=Forward) where {K, V, Ord <: Ordering}
    SortedDict{K,V,Ord}(o::Ord, kv) where {K, V, Ord <: Ordering}

Construct a `SortedDict` with key type `K` and value type
`V` with `o` ordering from an iterable `kv`.  The iterable should
generate either `Pair{K,V}` or `Tuple{K,V}`.  If omitted, then
the SortedDict is initially empty.  Time: O(*cn* log *n*) where
*n* is the length of the iterable.
"""
SortedDict{K,D,Ord}(o::Ord=Forward) where {K, D, Ord <: Ordering} =
    SortedDict{K,D,Ord}(BalancedTree23{K,D,Ord}(o))

function SortedDict{K,D,Ord}(o::Ord, kv) where {K, D, Ord <: Ordering}
    s = SortedDict{K,D,Ord}(BalancedTree23{K,D,Ord}(o))
    for (k, v) in kv
        s[k] = v
    end
    return s
end



"""
    SortedDict(o::Ord=Forward) where {Ord <: Ordering}
    SortedDict{K,V}(o::Ord=Forward) where {K,V,Ord<:Ordering}

Construct an empty `SortedDict` with key type `K` and value type
`V` with `o` ordering (default to forward ordering).  If
`K` and `V` are not specified as in the
first form, then they are assumed to both be `Any`.
Time: O(1)

**Note that a key type of `Any` or any other abstract type will lead
to slow performance, as the values are stored boxed (i.e., as
pointers), and insertion will require a run-time lookup of the
appropriate comparison function. It is recommended to always specify
a concrete key type, or to use one of the constructors in
which the key type is inferred.**
"""
SortedDict(o::Ord=Forward) where {Ord <: Ordering} = SortedDict{Any,Any,Ord}(o)
SortedDict{K,D}(o::Ord=Forward) where {K,D,Ord<:Ordering} =
    SortedDict{K,D,Ord}(o)



"""
    SortedDict(iter, o::Ord=Forward) where {Ord <: Ordering}
    SortedDict(o::Ordering, iter)
    SortedDict{K,V}(iter, o::Ordering=Forward) where {K,V}
    SortedDict{K,V}(o::Ordering, iter) where {K,V}

Construct a `SortedDict` from an arbitrary iterable object of
`key=>value` pairs or `(key,value)` tuples with order object `o`. The key type
and value type are inferred from the given iterable in the
first two forms.  The first two forms copy the
data three times, so
it is more efficient to explicitly specify `K` and `V` as in the
second two forms.  Time: O(*cn* log *n*)

"""
SortedDict(iter, o::Ord=Forward) where {Ord <: Ordering} =
    SortedDict(o, iter)

# TODO: figure out how to infer type without three copies

function SortedDict(o::Ordering, kv)
    c = collect(kv)
    if eltype(c) <: Pair
        c2 = collect((t.first, t.second) for t in c)
    elseif eltype(c) <: Tuple
        c2 = collect((t[1], t[2]) for t in c)
    else
        throw(ArgumentError("In SortedDict(o,kv), kv should contain either pairs or 2-tuples"))
    end
    SortedDict{eltype(c2).parameters[1], eltype(c2).parameters[2], typeof(o)}(o, c2)
end
SortedDict{K,D}(iter, o::Ordering=Forward) where {K, D} =
    SortedDict{K,D,typeof(o)}(o, iter)
SortedDict{K,D}(o::Ordering, iter) where {K, D} =
    SortedDict{K,D,typeof(o)}(o, iter)


"""
    SortedDict(ps::Pair...)
    SortedDict(o::Ordering, ps::Pair...)
    SortedDict{K,V}(ps::Pair...)
    SortedDict{K,V}(o::Ordering, ps::Pair...) where {K,V}

Construct a `SortedDict` from the given key-value pairs. 
The key type and value type are inferred from the
given key-value pairs in the first two forms.
The ordering is assumed to be `Forward`
ordering in the first and third form.  
The first two forms (where `K` and `V` are not specified
but inferred) involves copying the data three times 
and so is less efficient than the second two forms.
Time: O(*cn* log *n*)
"""
SortedDict(ps::Pair...) = SortedDict(Forward, ps)
SortedDict{K,D}(ps::Pair...) where {K,D} = SortedDict{K,D,ForwardOrdering}(Forward, ps)
SortedDict(o::Ordering, ps::Pair...) = SortedDict(o, ps)
SortedDict{K,D}(o::Ord, ps::Pair...) where {K,D,Ord<:Ordering} =
    SortedDict{K,D,Ord}(o, ps)



"""
    SortedDict{K,V}(::Val{true}, iterable) where {K, V}
    SortedDict{K,V}(::Val{true}, iterable, ord::Ordering) where {K,V}

Construct a `SortedDict` from an iterable whose eltype
is Tuple{K,V} or Pair{K,V} and that is already in sorted ordered. 
The first form assumes Forward ordering.  No duplicate
keys allowed.   Time: O(*cn*).
"""
SortedDict{K,D}(::Val{true}, iterable) where {K,D} =
    SortedDict{K,D}(Val(true), iterable, Forward)

function SortedDict{K,D}(::Val{true},
                         iterable,
                         ord::Ord) where {K,D,Ord <: Ordering}
    SortedDict{K, D, Ord}(BalancedTree23{K,D,Ord}(Val(true), iterable, ord, false))
end


## The following is needed to resolve ambiguities

SortedDict(::Ordering, ::Ordering) =
    throw(ArgumentError("Not a valid SortedDict constructor"))
SortedDict{K,D}(::Ordering, ::Ordering) where {K,D} =
    throw(ArgumentError("Not a valid SortedDict constructor"))
SortedDict(::Val{true}, ::Ordering) = throw(ArgumentError("Not a valid SortedDict constructor"))
SortedDict{K,D}(::Val{true}, ::Ordering) where {K,D} =
    throw(ArgumentError("Not a valid SortedDict constructor"))


"""
    Base.getindex(sd::SortedDict, k)

Retrieve the value associated with key `k` in SortedDict `sc`.
Yields a `KeyError` if `k` is not found.   The following
functions do not throw an error if the key is not found:
[`Base.get(sd::SortedDict,k,v)`](@ref) and
[`findkey(sd::SortedDict, k)`](@ref).
Time: O(*c* log *n*)
"""
@inline function Base.getindex(m::SortedDict, k_)
    i, exactfound = findkey(m.bt, convert(keytype(m),k_))
    !exactfound && throw(KeyError(k_))
    @inbounds return m.bt.data[i].d
end


"""
    Base.setindex!(sd::SortedDict, newvalue, k)

Assign or
reassign the value associated with the key `k` to `newvalue`.  Note
that the key is also overwritten; this is not necessarily a no-op
since the equivalence in the sort-order does not imply equality.
See also [`push_return_semitoken!(sd::SortedDict, p::Pair)`](@ref).
Time: O(*c* log *n*)
"""
@inline function Base.setindex!(m::SortedDict, d_, k_)
    insert!(m.bt, convert(keytype(m),k_), convert(valtype(m),d_), false)
    return m
end


"""
    Base.push!(sd::SortedDict, p::Pair)

Insert key-value pair `p`, i.e., a `k=>v` pair, into `sd`.
If the key `k` is already present, this overwrites the old value. 
The key is also overwritten (not necessarily a no-op, since 
sort-order equivalence may differ from equality).
The return value is `sd`.   See also [`push_return_semitoken!(sd::SortedDict, p::Pair)`](@ref).
Time: O(*c* log *n*)
"""
@inline function Base.push!(m::SortedDict{K,D}, pr::Pair) where {K,D}
    insert!(m.bt, convert(K, pr[1]), convert(D, pr[2]), false)
    return m
end


"""
    DataStructures.findkey(sd::SortedDict, k)

Return the semitoken that 
points to the item whose key is
`k`, or past-end semitoken if `k` is absent. 
See also  [`Base.getindex(sd::SortedDict, k)`](@ref)
Time: O(*c* log *n*)
"""
@inline function findkey(m::SortedDict, k_)
    ll, exactfound = findkey(m.bt, convert(keytype(m),k_))
    IntSemiToken(exactfound ? ll : 2)
end


"""
    DataStructures.push_return_semitoken!(sd::SortedDict, p::Pair)

Insert pair `p` of the form `k=>v` into `sd`.
If the key is already present in `sd`, this
overwrites the old value. Note that the key is also overwritten,
which is not necessarily a no-op because equivalence in the sort
order does not necessarily imply equality.  Unlike `push!`,
the
return value is a 2-tuple whose first entry is boolean and indicates
whether the insertion was new (i.e., the key was not previously
present) and whose second entry is the semitoken of the new entry.
This function replaces the deprecated `insert!(sd,k,v)`.
 Time: O(*c* log *n*)
"""
@inline function push_return_semitoken!(m::SortedDict, pr::Pair)
    b, i = insert!(m.bt, convert(keytype(m), pr.first), convert(valtype(m), pr.second), false)
    b, IntSemiToken(i)
end




@inline Base.eltype(m::SortedDict{K,D,Ord}) where {K,D,Ord <: Ordering} =  Pair{K,D}
@inline Base.keytype(m::SortedDict{K,D,Ord}) where {K,D,Ord <: Ordering} = K
@inline Base.valtype(m::SortedDict{K,D,Ord}) where {K,D,Ord <: Ordering} = D

"""
    Base.in(p::Pair, sd::SortedDict)

Return true if `p` is in `sd`.  Here, `p` is a key=>value pair. 
Time: O(*c* log *n* + *d*) where *d* stands for the
time to compare two values.
"""
@inline function Base.in(pr::Pair, m::SortedDict)
    i, exactfound = findkey(m.bt,convert(keytype(m),pr[1]))
    return exactfound && isequal(m.bt.data[i].d, convert(valtype(m),pr[2]))
end


"""
    Base.get(sd::SortedDict,k,default)
    Base.get(default_f::Union{Function,Type}, sd::SortedDict, k)

Return the value associated with key `k` where `sd` is a
SortedDict, or else returns `default` if `k` is not in `sd`.  
The second form obtains `default` as the return argument of
the function/type-constructor `default_f` (with no arguments) 
when the key is not present.
Time: O(*c* log *n*)
"""
@inline function Base.get(m::SortedDict, k_, default_)
    get(()->default_, m, k_)
end


function Base.get(default_::Union{Function,Type}, m::SortedDict{K,D}, k_) where {K,D}
    i, exactfound = findkey(m.bt, convert(K, k_))
    return exactfound ? m.bt.data[i].d : default_()
end

Base.get(m::SortedDict, n::SortedDict, ::Any) =
    error("Ambiguous invocation of 'get'; please select the correct version using Base.invoke")


"""
    Base.get!(sd::SortedDict,k,default)
    Base.get!(default_f::Union{Function,Type}, sd::SortedDict, k)

Return the value associated with key `k` where `sd` is a
SortedDict, or else return `default` if `k` is not in `sd`, and in the
latter case, inserts `(k,default)` into `sd`. 
The
second form computes a default value by calling
the function `default_f` (with no arguments) or the constructor of
type `default_f` when the key is not present.
Time: O(*c* log *n*)
"""
Base.get!(m::SortedDict, k_, default_) = get!(()->default_, m, k_)

function Base.get!(default_::Union{Function,Type}, m::SortedDict{K,D}, k_) where {K,D}
    k = convert(K,k_)
    i, exactfound = findkey(m.bt, k)
    if exactfound
        return m.bt.data[i].d
    else
        default = convert(D, default_())
        insert!(m.bt,k, default, false)
        return default
    end
end



"""
    Base.getkey(sd::SortedDict,k,defaultk)

Return the key `k` where `sd` is a SortedDict, if `k` is in `sd` else
it returns `defaultk`. If the container uses in its ordering an `eq`
method different from isequal (e.g., case-insensitive ASCII strings
illustrated below), then the return value is the actual key stored
in the SortedDict that is equivalent to `k` according to the `eq`
method, which might not be equal to `k`. Similarly, if the user
performs an implicit conversion as part of the call (e.g., the
container has keys that are floats, but the `k` argument to `getkey`
is an Int), then the returned key is the actual stored key rather
than `k`. Time: O(*c* log *n*)
"""
function Base.getkey(m::SortedDict{K,D,Ord}, k_, default_) where {K,D,Ord <: Ordering}
    i, exactfound = findkey(m.bt, convert(K, k_))
    exactfound ? m.bt.data[i].k : default_
end

## Function delete! deletes an item at a given
## key
"""
    Base.delete!(sd::SortedDict, k)

Delete the item whose key is `k` in `sd`.
After this operation
is complete, any token addressing the deleted item is invalid.
Returns `sc`.  This is a no-op if `k` is not present in `sd`.
 Time: O(*c* log *n*)
"""
@inline function Base.delete!(m::SortedDict, k_)
    i, exactfound = findkey(m.bt, convert(keytype(m), k_))
    if exactfound
        delete!(m.bt, i)
    end
    m
end

"""
    Base.pop!(sd::SortedDict, k)
    Base.pop!(sd::SortedDict, k, default)

Delete the item with key `k` in `sd` and
return the value that was associated with `k`.
If `k` is not in `sd`
return `default`, or throw a `KeyError` if `default` is not specified.
Time: O(*c* log *n*)
"""
@inline function Base.pop!(m::SortedDict, k_)
    i, exactfound = findkey(m.bt, convert(keytype(m), k_))
    !exactfound && throw(KeyError(k_))
    @inbounds d = m.bt.data[i].d
    delete!(m.bt, i)
    return d
end

@inline function Base.pop!(m::SortedDict, k_, default)
    i, exactfound = findkey(m.bt, convert(keytype(m), k_))
    !exactfound && return default
    @inbounds d = m.bt.data[i].d
    delete!(m.bt, i)
    return d
end


"""
    Base.isequal(sd1::SortedDict{K,V,Ord}, sd2::SortedDict{K,V,Ord}) where {K, V, Ord <: Ordering}

Check if two SortedDicts are equal in the sense that they contain
the same items; the keys are compared using the `eq` method, while
the values are compared with the `isequal` function.  
Note that `isequal` in this sense does not imply correspondence
between semitokens for items in `sd1` with those for `sd2`.  
Time: O(*cn*). Note
that if `K`, `V`, `Ord`, or the
order objects of sd1 and sd2 are different, then a fallback routine
`Base.isequal(::AbstractDict, ::AbstractDict)` is invoked.
Time: O(*cn*)
"""
function Base.isequal(m1::SortedDict{K, D, Ord}, m2::SortedDict{K, D, Ord}) where
{K, D, Ord <: Ordering}

    ord = orderobject(m1)
    if ord != orderobject(m2)
        return invoke((==), Tuple{AbstractDict, AbstractDict}, m1, m2)
    end
    p1 = firstindex(m1)
    p2 = firstindex(m2)
    while true
        p1 == pastendsemitoken(m1) && return p2 == pastendsemitoken(m2)
        p2 == pastendsemitoken(m2) && return false
        @inbounds k1,d1 = deref((m1,p1))
        @inbounds k2,d2 = deref((m2,p2))
        (!eq(ord,k1,k2) || !isequal(d1,d2)) && return false
        @inbounds p1 = advance((m1,p1))
        @inbounds p2 = advance((m2,p2))
    end
end


function mergetwo!(m::SortedDict{K,D,Ord},
                   m2) where {K,D,Ord <: Ordering}
    for (k,v) in m2
        m[convert(K,k)] = convert(D,v)
    end
end

Base.copymutable(m::SortedDict) = packcopy(m)
Base.copy(m::SortedDict) = packcopy(m)

# See sorted_set for the docstrings for packcopy and packdeepcopy

function packcopy(m::SortedDict{K,D,Ord}) where {K,D,Ord <: Ordering}
    SortedDict{K,D}(Val(true), m, orderobject(m))
end
function packdeepcopy(m::SortedDict{K,D,Ord}) where {K,D,Ord <: Ordering}
    m2 = deepcopy(m)
    SortedDict{K,D}(Val(true), m2, orderobject(m))
end


struct MergeManySortedDicts{K, D, Ord <: Ordering}
    vec::Vector{SortedDict{K,D,Ord}}
end

function Base.iterate(sds::MergeManySortedDicts{K, D, Ord},
                      state = [firstindex(sds.vec[i]) for i=1:length(sds.vec)]) where
{K, D, Ord <: Ordering}
    ord = orderobject(sds.vec[1])
    firsti = 0
    N = length(sds.vec)
    for i = 1 : N
        if state[i] != pastendsemitoken(sds.vec[i])
            firsti = i
            break
        end
    end
    firsti == 0 && return nothing
    foundi = firsti
    @inbounds firstk = deref_key((sds.vec[firsti], state[firsti]))
    for i = firsti + 1 : N
        if state[i] != pastendsemitoken(sds.vec[i])
            @inbounds k2 = deref_key((sds.vec[i], state[i]))
            if !lt(ord, firstk, k2)
                foundi = i
                firstk = k2
            end
        end
    end
    foundsemitoken = state[foundi]
    for i = firsti : N
        @inbounds if state[i] != pastendsemitoken(sds.vec[i]) &&
            eq(ord, deref_key((sds.vec[i], state[i])), firstk)
            state[i] = advance((sds.vec[i], state[i]))
        end
    end
    @inbounds return (deref((sds.vec[foundi], foundsemitoken)), state)
end

"""
    Base.merge!(sd::SortedDict{K,V,Ord}, d1::AbstractDict{K,V}...) where {K,V,Ord<:Ordering}

Merge one or more dicts `d1`, etc. into `sd`.
These must all must have the same key-value types.
In the case of keys duplicated among the arguments, the rightmost
argument that owns the key gets its value stored.
Time: O(*cN* log *N*), where *N*
is the total size of all the arguments.
"""
function Base.merge!(m::SortedDict{K,D,Ord},
                     others::AbstractDict{K,D}...) where {K,D,Ord <: Ordering}
    for o in others
        mergetwo!(m,o)
    end
end


"""
    Base.merge(sd::SortedDict{K,V,Ord}, d1::AbstractDict{K,V}...) where {K,V,Ord <: Ordering}

Merge one or more dicts into a single SortedDict
and return the new SortedDict.  Arguments `d1` etc.
must have the same key-value type as `sd`.
In the case of keys
duplicated among the arguments, the rightmost argument that owns the
key gets its value stored.  Time: O(*cN* log
*N*), where *N* is the total size of all the arguments.  If all
the arguments are SortedDicts with the same
key, value, and order object, then the time is O(*cN*).
"""
function Base.merge(m::SortedDict{K,D,Ord},
                    others::AbstractDict{K,D}...) where {K,D,Ord <: Ordering}
    result = packcopy(m)
    merge!(result, others...)
    return result
end

function Base.merge(m::SortedDict{K,D,Ord},
                    others::SortedDict{K,D,Ord}...) where {K, D, Ord <: Ordering}
    sds = MergeManySortedDicts{K, D, Ord}(SortedDict{K,D,Ord}[m])
    for sd in others
        if orderobject(sd) != orderobject(m)
            return invoke(merge,
                          Tuple{SortedDict{K,D,Ord}, Vararg{AbstractDict{K,D}}},
                          m, others...)
        end
        push!(sds.vec, sd)
    end
    SortedDict{K,D}(Val(true), sds, orderobject(m))
end



"""
    Base.empty(sc)

Return a new `SortedDict`, `SortedMultiDict`, or `SortedSet` of the same
type and with the same ordering as `sc` but with no entries (i.e.,
empty). Time: O(1)
"""
Base.empty(m::SortedDict{K,D,Ord}) where {K,D,Ord<:Ordering} =
    SortedDict{K,D,Ord}(orderobject(m))

OrderedCollections.isordered(::Type{T}) where {T<:SortedDict} = true

const SDMContainer = Union{SortedDict, SortedMultiDict}
const SAContainer = Union{SDMContainer, SortedSet}

const Token = Tuple{SAContainer, IntSemiToken}
const SDMToken = Tuple{SDMContainer, IntSemiToken}
const SetToken = Tuple{SortedSet, IntSemiToken}


## Function startof returns the semitoken that points
## to the first sorted order of the tree.  It returns
## the past-end token if the tree is empty.

@inline startof(m::SAContainer) = IntSemiToken(beginloc(m.bt))

## Function lastindex returns the semitoken that points
## to the last item in the sorted order,
## or the before-start marker if the tree is empty.

@inline Base.lastindex(m::SAContainer) = IntSemiToken(endloc(m.bt))

## Function pastendsemitoken returns the token past the end of the data.

@inline pastendsemitoken(::SAContainer) = IntSemiToken(2)

## Function beforestarttoken returns the token before the start of the data.

@inline beforestartsemitoken(::SAContainer) = IntSemiToken(1)

## delete! deletes an item given a token.

@inline function Base.delete!(ii::Token)
    has_data(ii)
    delete!(ii[1].bt, ii[2].address)
end

## Function advances takes a token and returns the
## next token in the sorted order.

@inline function advance(ii::Token)
    not_pastend(ii)
    IntSemiToken(nextloc0(ii[1].bt, ii[2].address))
end


## Function regresss takes a token and returns the
## previous token in the sorted order.

@inline function regress(ii::Token)
    not_beforestart(ii)
    IntSemiToken(prevloc0(ii[1].bt, ii[2].address))
end


## status of a token is 0 if the token is invalid, 1 if it points to
## ordinary data, 2 if it points to the before-start location and 3 if
## it points to the past-end location.


@inline status(ii::Token) =
       !(ii[2].address in ii[1].bt.useddatacells) ? 0 :
         ii[2].address == 1 ?                       2 :
         ii[2].address == 2 ?                       3 : 1

"""
    compare(m::SAContainer, s::IntSemiToken, t::IntSemiToken)

Determines the  relative positions of the  data items indexed
by `(m,s)` and  `(m,t)` in the sorted order. The  return value is `-1`
if `(m,s)` precedes `(m,t)`, `0` if they are equal, and `1` if `(m,s)`
succeeds `(m,t)`. `s`  and `t`  are semitokens  for the  same container `m`.
"""
@inline compare(m::SAContainer, s::IntSemiToken, t::IntSemiToken) =
      compareInd(m.bt, s.address, t.address)


@inline function deref(ii::SDMToken)
    has_data(ii)
    return Pair(ii[1].bt.data[ii[2].address].k, ii[1].bt.data[ii[2].address].d)
end

@inline function deref(ii::SetToken)
    has_data(ii)
    return ii[1].bt.data[ii[2].address].k
end

@inline function deref_key(ii::SDMToken)
    has_data(ii)
    return ii[1].bt.data[ii[2].address].k
end

@inline function deref_value(ii::SDMToken)
    has_data(ii)
    return ii[1].bt.data[ii[2].address].d
end


## Functions setindex! and getindex for semitokens.
## Note that we can't use SDMContainer here; we have
## to spell it out otherwise there is an ambiguity.

@inline function Base.getindex(m::SortedDict,
                          i::IntSemiToken)
    has_data((m,i))
    return m.bt.data[i.address].d
end

@inline function Base.getindex(m::SortedMultiDict,
                          i::IntSemiToken)
    has_data((m,i))
    return m.bt.data[i.address].d
end

@inline function Base.setindex!(m::SortedDict,
                           d_,
                           i::IntSemiToken)
    has_data((m,i))
    m.bt.data[i.address] = KDRec{keytype(m),valtype(m)}(m.bt.data[i.address].parent,
                                                         m.bt.data[i.address].k,
                                                         convert(valtype(m),d_))
    return m
end

@inline function Base.setindex!(m::SortedMultiDict,
                           d_,
                           i::IntSemiToken)
    has_data((m,i))
    m.bt.data[i.address] = KDRec{keytype(m),valtype(m)}(m.bt.data[i.address].parent,
                                                         m.bt.data[i.address].k,
                                                         convert(valtype(m),d_))
    return m
end


## This function takes a key and returns the token
## of the first item in the tree that is >= the given
## key in the sorted order.  It returns the past-end marker
## if there is none.

@inline function Base.searchsortedfirst(m::SAContainer, k_)
    i = findkeyless(m.bt, convert(keytype(m), k_))
    IntSemiToken(nextloc0(m.bt, i))
end

## This function takes a key and returns a token
## to the first item in the tree that is > the given
## key in the sorted order.  It returns the past-end marker
## if there is none.


@inline function searchsortedafter(m::SAContainer, k_)
    i, exactfound = findkey(m.bt, convert(keytype(m), k_))
    IntSemiToken(nextloc0(m.bt, i))
end

## This function takes a key and returns a token
## to the last item in the tree that is <= the given
## key in the sorted order.  It returns the before-start marker
## if there is none.

@inline function Base.searchsortedlast(m::SAContainer, k_)
    i, exactfound = findkey(m.bt, convert(keytype(m),k_))
    IntSemiToken(i)
end


## The next four are correctness-checking routines.  They are
## not exported.


@inline not_beforestart(i::Token) =
    (!(i[2].address in i[1].bt.useddatacells) ||
     i[2].address == 1) && throw(BoundsError())

@inline not_pastend(i::Token) =
    (!(i[2].address in i[1].bt.useddatacells) ||
     i[2].address == 2) && throw(BoundsError())


@inline has_data(i::Token) =
    (!(i[2].address in i[1].bt.useddatacells) ||
     i[2].address < 3) && throw(BoundsError())

#A counter type

"""
    Accumulator{T, V}

A accumulator is a data structure that maintains an accumulated total for each key.
The particular case where those totals are integers is a counter.
"""
struct Accumulator{T, V} <: AbstractDict{T, V}
    map::Dict{T, V}
end

## constructors

Accumulator{T, V}() where {T, V} = Accumulator{T, V}(Dict{T, V}())
Accumulator(map::AbstractDict) = Accumulator(Dict(map))
function Accumulator(p::Pair, ps::Pair...)
    a = Accumulator(Dict(p))
    for (k,v) in ps
        inc!(a, k, v)
    end
    a
end

counter(T::Type) = Accumulator{T, Int}()
counter(dct::AbstractDict{T, V}) where {T, V<:Integer} = Accumulator{T, V}(Dict(dct))

"""
    counter(seq)

Returns an `Accumulator` object containing the elements from `seq`.
"""
function counter(seq)
    ct = counter(eltype_for_accumulator(seq))
    for x in seq
        inc!(ct, x)
    end
    return ct
end

eltype_for_accumulator(seq::T) where T = eltype(T)
function eltype_for_accumulator(seq::Base.Generator)
    Base.@default_eltype(seq)
end


Base.copy(ct::Accumulator) = Accumulator(copy(ct.map))

Base.length(a::Accumulator) = length(a.map)

## retrieval

Base.get(ct::Accumulator, x, default) = get(ct.map, x, default)
# need to allow user specified default in order to
# correctly implement "informal" AbstractDict interface

Base.getindex(ct::Accumulator{T,V}, x) where {T,V} = get(ct.map, x, zero(V))

Base.setindex!(ct::Accumulator, x, v) = setindex!(ct.map, x, v)


Base.haskey(ct::Accumulator, x) = haskey(ct.map, x)

Base.values(ct::Accumulator) = values(ct.map)

Base.sum(ct::Accumulator) = sum(values(ct.map))

## iteration

Base.iterate(ct::Accumulator, s...) = iterate(ct.map, s...)

# manipulation

"""
    inc!(ct::Accumulator, x, [v=1])

Increments the count for `x` by `v` (defaulting to one)
"""
inc!(ct::Accumulator, x, v::Number) = (ct[x] += v)
inc!(ct::Accumulator{T, V}, x) where {T, V} = inc!(ct, x, one(V))

# inc! is preferred over push!, but we need to provide push! for the Bag interpretation
# which is used by classified_collections.jl
Base.push!(ct::Accumulator, x) = inc!(ct, x)
Base.push!(ct::Accumulator, x, a::Number) = inc!(ct, x, a)

# To remove ambiguities related to Accumulator now being a subtype of AbstractDict
Base.push!(ct::Accumulator, x::Pair)  = inc!(ct, x)


"""
    dec!(ct::Accumulator, x, [v=1])

Decrements the count for `x` by `v` (defaulting to one)
"""
dec!(ct::Accumulator, x, v::Number) = (ct[x] -= v)
dec!(ct::Accumulator{T,V}, x) where {T,V} = dec!(ct, x, one(V))

#TODO: once we are done deprecating `pop!` for `reset!` then add `pop!` as an alias for `dec!`

"""
    merge!(ct1::Accumulator, others...)

Merges the other counters into `ctl`,
summing the counts for all elements.
"""
function Base.merge!(ct::Accumulator, other::Accumulator)
    for (x, v) in other
        inc!(ct, x, v)
    end
    return ct
end


function Base.merge!(ct1::Accumulator, others::Accumulator...)
    for ct in others
        merge!(ct1,ct)
    end
    return ct1
end


"""
     merge(counters...)

Creates a new counter with total counts equal to the sum of the counts in the counters given as arguments.

See also merge!
"""
function Base.merge(ct1::Accumulator, others::Accumulator...)
    ct = copy(ct1)
    merge!(ct,others...)
end

"""
    reset!(ct::Accumulator, x)

Remove a key `x` from an accumulator, and return its current value
"""
reset!(ct::Accumulator{<:Any,V}, x) where V = haskey(ct.map, x) ? pop!(ct.map, x) : zero(V)

"""
     nlargest(acc::Accumulator, [n])

Returns a sorted vector of the `n` most common elements, with their counts.
If `n` is omitted, the full sorted collection is returned.

This corresponds to Python's `Counter.most_common` function.

Example
```
julia> nlargest(counter("abbbccddddda"))

4-element Array{Pair{Char,Int64},1}:
 'd'=>5
 'b'=>3
 'c'=>2
 'a'=>2


julia> nlargest(counter("abbbccddddda"),2)

2-element Array{Pair{Char,Int64},1}:
 'd'=>5
 'b'=>3

```
"""
nlargest(acc::Accumulator) = sort!(collect(acc), by=last, rev=true)
nlargest(acc::Accumulator, n) = partialsort!(collect(acc), 1:n, by=last, rev=true)


"""
     nsmallest(acc::Accumulator, [n])

Returns a sorted vector of the `n` least common elements, with their counts.
If `n` is omitted, the full sorted collection is returned.

This is the opposite of the `nlargest` function.
For obvious reasons this will not include zero counts for items not encountered.
(unless those elements are added to he accumulator directly, eg via `acc[foo]=0)
"""
nsmallest(acc::Accumulator) = sort!(collect(acc), by=last, rev=false)
nsmallest(acc::Accumulator, n) = partialsort!(collect(acc), 1:n, by=last, rev=false)


###########################################################
## Multiset operations

struct MultiplicityException{K, V} <: Exception
    k::K
    v::V
end

function Base.showerror(io::IO, err::MultiplicityException)
    print(io, "When using an `Accumulator` as a multiset, all elements must have positive multiplicity")
    print(io, " element `$(err.k)` has multiplicity $(err.v)")
end

drop_nonpositive!(a::Accumulator, k) = (a[k] > 0 || delete!(a.map, k))


function Base.setdiff(a::Accumulator, b::Accumulator)
    ret = copy(a)
    for (k, v) in b
        v > 0 || throw(MultiplicityException(k, v))
        dec!(ret, k, v)
        drop_nonpositive!(ret, k)
    end
    return ret
end

Base.issubset(a::Accumulator, b::Accumulator) = all(b[k] >= v for (k, v) in a)

Base.union(a::Accumulator, b::Accumulator, c::Accumulator...) = union(union(a,b), c...)
Base.union(a::Accumulator, b::Accumulator) = union!(copy(a), b)
function Base.union!(a::Accumulator, b::Accumulator)
    for (kb, vb) in b
        va = a[kb]
        vb >= 0 || throw(MultiplicityException(kb, vb))
        va >= 0 || throw(MultiplicityException(kb, va))
        a[kb] = max(va, vb)
    end
    return a
end


Base.intersect(a::Accumulator, b::Accumulator, c::Accumulator...) = intersect(intersect(a,b), c...)
Base.intersect(a::Accumulator, b::Accumulator) = intersect!(copy(a), b)
function Base.intersect!(a::Accumulator, b::Accumulator)
    for k in union(keys(a), keys(b)) # union not intersection as we want to check both multiplicities
        va = a[k]
        vb = b[k]
        va >= 0 || throw(MultiplicityException(k, va))
        vb >= 0 || throw(MultiplicityException(k, vb))

        a[k] = min(va, vb)
        drop_nonpositive!(a, k) # Drop any that ended up zero
    end
    return a
end
function Base.show(io::IO, acc::Accumulator{T,V}) where {T,V}
    l = length(acc)
    if l>0
        print(io, "Accumulator(")
    else
        print(io,"Accumulator{$T,$V}(")
    end
    for (count, (k, v)) in enumerate(acc)
        print(io, k, " => ", v)
        if count < l
            print(io, ", ")
        end
    end
    print(io, ")")
end

# tests for min-max heaps
using DataStructures: _make_binary_minmax_heap, is_minmax_heap, children_and_grandchildren
using Base.Order: Forward, Reverse

@testset "Binary MinMax Heaps" begin

    @testset "construct heap" begin
        vs = [10, 4, 6, 1, 16, 2, 20, 17, 13, 5]

        BinaryMinMaxHeap{Int}()
        BinaryMinMaxHeap{Int}(vs)
        BinaryMinMaxHeap(vs)

        @test true
    end

    @testset "is_minmax_heap tests" begin
        mmheap = [0, 10, 9, 2, 3, 4, 5]
        @test is_minmax_heap(mmheap)
        @test is_minmax_heap([])
        @test is_minmax_heap([rand()])
    end

    @testset "basic tests" begin
        h = BinaryMinMaxHeap{Int}()

        @test length(h) == 0
        @test isempty(h)
        @test eltype(h) == Int
        @test eltype(typeof(h)) == Int
        @test sizehint!(h, 100) === h
    end

    @testset "make heap tests" begin
        vs = [10, 4, 6, 1, 16, 2, 20, 17, 13, 5]

        @testset "make from array tests" begin
            h = BinaryMinMaxHeap(vs)
            @test length(h) == 10
            @test !isempty(h)
            @test first(h) == minimum(h) == 1
            @test maximum(h) == 20
            @test is_minmax_heap(h.valtree)
        end

        @testset "make from random arrays tests" begin
            for i = 1:20
                A = rand(50)
                vtree = _make_binary_minmax_heap(A)
                @test is_minmax_heap(vtree)
            end
        end

        @testset "push! tests" begin
            h = BinaryMinMaxHeap{Int}()

            @test length(h) == 0
            @test isempty(h)

            push!(h, 1)
            @test first(h) == 1
            push!(h, 2)
            @test is_minmax_heap(h.valtree)
            push!(h, 10)
            @test is_minmax_heap(h.valtree)
            push!(h, rand(Int))
            @test is_minmax_heap(h.valtree)
            for i = 1:5
                A = rand(20)
                hs = BinaryMinMaxHeap(A)
                for j = 1:4
                    push!(hs, rand())
                    @test is_minmax_heap(hs.valtree)
                end
            end
        end
    end

    @testset "pop! tests" begin
        @testset "popmin! tests" begin
            h = BinaryMinMaxHeap([1])
            @test popmin!(h) == 1
            @test length(h) == 0
            @test isempty(h)
            h = BinaryMinMaxHeap([1, 3, 2])
            @test popmin!(h) == 1
            @test length(h) == 2
            @test is_minmax_heap(h.valtree)
            @test minimum(h) == 2
            for i = 1:20
                A = rand(50)
                h = BinaryMinMaxHeap(A)
                minval = minimum(A)
                @test popmin!(h) == minval
                @test length(h) == 49
                @test is_minmax_heap(h.valtree)
            end
        end
        @testset "popmax! tests" begin
            h = BinaryMinMaxHeap([1])
            @test popmax!(h) == 1
            @test length(h) == 0
            @test isempty(h)
            h = BinaryMinMaxHeap([1, 2, 3])
            @test popmax!(h) == 3
            @test length(h) == 2
            @test is_minmax_heap(h.valtree)
            @test maximum(h) == 2
            h = BinaryMinMaxHeap([1, 3, 2])
            @test popmax!(h) == 3
            @test length(h) == 2
            @test is_minmax_heap(h.valtree)
            @test maximum(h) == 2
        end
    end

    @testset "empty!" begin
        h = BinaryMinMaxHeap([1, 4, 3, 10, 2])
        ret = empty!(h)
        @test ret === h
        @test length(ret) == 0
        @test isempty(ret)
    end

    @testset "popall!" begin
        @testset "popmin! tests" begin
            A = rand(Int, 50)
            sorted_A = sort(A)
            h = BinaryMinMaxHeap(A)
            @test popall!(h) == sorted_A
            @test isempty(h)
            @test length(h) == 0

            h = BinaryMinMaxHeap(A)
            @test popmin!(h, 10) == sorted_A[1:10]
            @test !isempty(h)
            @test length(h) == 40
        end
        @testset "popmax! tests" begin
            A = rand(Int, 50)
            sorted_A = sort(A, order=Reverse)
            h = BinaryMinMaxHeap(A)
            @test popall!(h, Reverse) == sorted_A
            @test length(h) == 0
            @test isempty(h)

            h = BinaryMinMaxHeap(A)
            @test popmax!(h, 10) == sorted_A[1:10]
            @test length(h) == 40
            @test !isempty(h)
        end
    end

    @testset "type conversion" begin
        h = BinaryMinMaxHeap{Float64}()
        push!(h, 3.)
        push!(h, 5)
        push!(h, Rational(4, 8))
        push!(h, Complex(10.1, 0.0))

        @test h.valtree == [0.5, 10.1, 3.0, 5.0]
    end

    @testset "children_and_grandchildren tests" begin
        @test children_and_grandchildren(1, 1) == Int[]
        @test children_and_grandchildren(2, 1) == [2]
        @test children_and_grandchildren(3, 1) == [2, 3]
        @test children_and_grandchildren(7, 1) == [2, 4, 5, 3, 6, 7]
        @test children_and_grandchildren(10, 2) == [4, 8, 9, 5, 10]
    end

    @testset "throw errors tests" begin
        h = BinaryMinMaxHeap{Int}()
        @test_throws ArgumentError pop!(h)
        @test_throws ArgumentError popmin!(h)
        @test_throws ArgumentError popmax!(h)

        @test_throws ArgumentError minimum(h)
        @test_throws ArgumentError maximum(h)

    end
end

@testset "MultiDict" begin

    @testset "Constructors" begin
        KVS = ('a',[1])
        KV = ('a',1)
        @test isa(MultiDict(), MultiDict{Any,Any})
        @test isa(MultiDict(()), MultiDict{Any,Any})
        @test isa(MultiDict([KVS]), MultiDict{Char,Int})
        @test isa(MultiDict([KV]), MultiDict{Char,Int})
        @test isa(MultiDict([KV, KVS]), MultiDict{Char,Any})

        PVS = 1 => [1.0]
        PV = 1 => 1.0
        @test eltype(MultiDict{Char,Int}()) === Pair{Char,Vector{Int}}
        @test isa(MultiDict(PVS), MultiDict{Int,Array{Float64,1}})
        @test isa(MultiDict(PVS, PVS), MultiDict{Int,Array{Float64,1}})
        @test isa(MultiDict([PVS, PVS]), MultiDict{Int,Array{Float64,1}})
        @test isa(MultiDict(PV), MultiDict{Int,Float64})
        @test isa(MultiDict(PV, PV), MultiDict{Int,Float64})
        @test isa(MultiDict([PV, PV]), MultiDict{Int,Float64})
    end

    @testset "Core Functionality" begin
        # setindex!, getindex, length, isempty, empty!, in
        # copy, empty, get, haskey, getkey, iterate
        d = MultiDict{Char,Int}()

        @test length(d) == 0
        @test isempty(d)

        @test insert!(d, 'a', 1) == MultiDict{Char,Int}([('a', [1])])
        @test getindex(d, 'a') == [1]
        @test_throws MethodError insert!(d, 'a', [2,3]) == MultiDict{Char,Int}([('a', [1,2,3])])
        @test insert!(d, 'a', 2) == MultiDict{Char,Int}([('a', [1,2])])
        @test insert!(d, 'a', 3) == MultiDict{Char,Int}([('a', [1,2, 3])])
        @test getindex(d, 'a') == [1,2,3]

        @test_throws KeyError d['c'] == 1
        insert!(d, 'c', 1)

        # order changed from v0.4 to v0.5
        @test collect(keys(d)) == ['c', 'a'] || collect(keys(d)) == ['a', 'c']
        @test collect(values(d)) == Array{Int,1}[[1],[1,2,3]] || collect(values(d)) == Array{Int,1}[[1,2,3], [1]]

        @test get(d, 'a', 0) == [1,2,3]
        @test get(d, 'b', 0) == 0

        @test haskey(d, 'a')
        @test !haskey(d, 'b')
        @test getkey(d, 'a', 0) == 'a'
        @test getkey(d, 'b', 0) == 0

        @test copy(d) == d
        @test empty(d) == MultiDict{Char,Int}()

        @testset "order changed from v0.4 to v0.5" begin
            dict = [kv for kv in d]
            @test  dict == [Pair('c', [1]), Pair('a', [1,2,3])] ||
                    dict == [Pair('a', [1,2,3]), Pair('c', [1])]
        end

        @testset "in" begin
            @test in(('c', 1), d)
            @test in(('a', 1), d)
            @test in(('a', 2), d)
        end

        @testset "isempty / empty!" begin
            @test !isempty(d)
            empty!(d)
            @test isempty(d)
        end

        @testset "pop!" begin
            d = MultiDict{Char,Int}([('a', [1,2,3]), ('c', [1])])
            @test_throws KeyError pop!(d, 'b')
            @test pop!(d, 'a') == 3
            @test pop!(d, 'a') == 2
            @test pop!(d, 'a') == 1
            @test !haskey(d, 'a')
            @test pop!(d, 'b', 0) == 0
        end
    end

    @testset "delete!" begin
        d = MultiDict{Char,Int}([('a', [1,2,3]), ('c', [1])])
        @test delete!(d, 'b') == d
        @test delete!(d, 'a') == MultiDict{Char,Int}([('c', [1])])
    end

    @testset "setindex!" begin
        d = MultiDict{Char,Int}()
        @test insert!(d, 'a', 1) == MultiDict{Char,Int}([('a', [1])])
        @test insert!(d, 'a', 1) == MultiDict{Char,Int}([('a', [1, 1])])
    end

    @testset "push!" begin
        d = MultiDict{Char,Int}()
        @test push!(d, ('a',1)) == MultiDict{Char,Int}([('a', [1])])
        @test push!(d, ('a',1)) == MultiDict{Char,Int}([('a', [1,1])])
        empty!(d)
        @test push!(d,'a'=>1) == MultiDict{Char,Int}([('a', [1])])
        @test push!(d, 'a'=>1) == MultiDict{Char,Int}([('a', [1,1])])

        @testset "get!" begin
            @test get!(d, 'a', []) == [1,1]
            @test get!(d, 'b', []) == Int[]
            @test get!(d, 'c', [1]) == [1]
            @test_throws MethodError get!(d, 'd', 1)
        end
    end

    @testset "special functions: count, enumerateall" begin
        #not appending arrays to one array, using array of arrays
        d = MultiDict{Char,Array{Int,1}}()
        @test count(d) == 0
        for i in 1:15
            insert!(d, rand('a':'f'), rand()>0.5 ? [rand(1:10)] : rand(1:10, rand(1:3)))
        end
        @test 15 <= count(d) <=45
        @test size(d) == (length(d), count(d))

        #= --- broken phlavenk ----
        allvals = [kv for kv in enumerateall(d)]
        @test length(allvals) == count(d)
        @test all(kv->in(kv,d), enumerateall(d))

        # @test length(d) == 15
        # @test length(values(d)) == 15
        # @test length(keys(d)) <= 6
        --- broken phlavenk ---- =#
    end

end # @testset MultiDict

"""
    CircularBuffer{T}(n)

The CircularBuffer type implements a circular buffer of fixed capacity
where new items are pushed to the back of the list, overwriting values
in a circular fashion.

Allocate a buffer of elements of type `T` with maximum capacity `n`.
"""
mutable struct CircularBuffer{T} <: AbstractVector{T}
    capacity::Int
    first::Int
    length::Int
    buffer::Vector{T}

    CircularBuffer{T}(capacity::Int) where {T} = new{T}(capacity, 1, 0, Vector{T}(undef, capacity))
end

CircularBuffer(capacity) = CircularBuffer{Any}(capacity)

"""
    empty!(cb::CircularBuffer)

Reset the buffer.
"""
function Base.empty!(cb::CircularBuffer)
    cb.length = 0
    return cb
end

Base.@propagate_inbounds function _buffer_index_checked(cb::CircularBuffer, i::Int)
    @boundscheck if i < 1 || i > cb.length
        throw(BoundsError(cb, i))
    end
    _buffer_index(cb, i)
end

@inline function _buffer_index(cb::CircularBuffer, i::Int)
    n = cb.capacity
    idx = cb.first + i - 1
    return ifelse(idx > n, idx - n, idx)
end

"""
    cb[i]

Get the i-th element of CircularBuffer.

* `cb[1]` to get the element at the front
* `cb[end]` to get the element at the back
"""
@inline Base.@propagate_inbounds function Base.getindex(cb::CircularBuffer, i::Int)
    cb.buffer[_buffer_index_checked(cb, i)]
end

"""
    cb[i] = data

Store data to the `i`-th element of `CircularBuffer`.
"""
@inline Base.@propagate_inbounds function Base.setindex!(cb::CircularBuffer, data, i::Int)
    cb.buffer[_buffer_index_checked(cb, i)] = data
    return cb
end

"""
    pop!(cb::CircularBuffer)

Remove the element at the back.
"""
@inline function Base.pop!(cb::CircularBuffer)
    @boundscheck (cb.length == 0) && throw(ArgumentError("array must be non-empty"))
    i = _buffer_index(cb, cb.length)
    cb.length -= 1
    return @inbounds cb.buffer[i]
end

"""
    push!(cb::CircularBuffer, data)

Add an element to the back and overwrite front if full.
"""
@inline function Base.push!(cb::CircularBuffer, data)
    # if full, increment and overwrite, otherwise push
    if cb.length == cb.capacity
        cb.first = (cb.first == cb.capacity ? 1 : cb.first + 1)
    else
        cb.length += 1
    end
    @inbounds cb.buffer[_buffer_index(cb, cb.length)] = data
    return cb
end

"""
    popfirst!(cb::CircularBuffer)

Remove the element from the front of the `CircularBuffer`.
"""
function Base.popfirst!(cb::CircularBuffer)
    @boundscheck (cb.length == 0) && throw(ArgumentError("array must be non-empty"))
    i = cb.first
    cb.first = (cb.first + 1 > cb.capacity ? 1 : cb.first + 1)
    cb.length -= 1
    return @inbounds cb.buffer[i]
end

"""
    pushfirst!(cb::CircularBuffer, data)

Insert one or more items at the beginning of CircularBuffer
and overwrite back if full.
"""
function Base.pushfirst!(cb::CircularBuffer, data)
    # if full, decrement and overwrite, otherwise pushfirst
    cb.first = (cb.first == 1 ? cb.capacity : cb.first - 1)
    if length(cb) < cb.capacity
        cb.length += 1
    end
    @inbounds cb.buffer[cb.first] = data
    return cb
end

"""
    append!(cb::CircularBuffer, datavec::AbstractVector)

Push at most last `capacity` items.
"""
function Base.append!(cb::CircularBuffer, datavec::AbstractVector)
    # push at most last `capacity` items
    n = length(datavec)
    for i in max(1, n-capacity(cb)+1):n
        push!(cb, datavec[i])
    end
    return cb
end

"""
    fill!(cb::CircularBuffer, data)

Grows the buffer up-to capacity, and fills it entirely.
It doesn't overwrite existing elements.
"""
function Base.fill!(cb::CircularBuffer, data)
    for i in 1:capacity(cb)-length(cb)
        push!(cb, data)
    end
    return cb
end

"""
    length(cb::CircularBuffer)

Return the number of elements currently in the buffer.
"""
Base.length(cb::CircularBuffer) = cb.length

"""
    size(cb::CircularBuffer)

Return a tuple with the size of the buffer.
"""
Base.size(cb::CircularBuffer) = (length(cb),)

"""
    isempty(cb::CircularBuffer)

Test whether the buffer is empty.
"""
Base.isempty(cb::CircularBuffer) = cb.length == 0

""""
    capacity(cb::CircularBuffer)

Return capacity of CircularBuffer.
"""
capacity(cb::CircularBuffer) = cb.capacity

# Base might define `isfull` from julia 1.11 onwards, see julia PR #53159
if isdefined(Base, :isfull)
    import Base: isfull
end

"""
    isfull(cb::CircularBuffer)

Test whether the buffer is full.
"""
isfull(cb::CircularBuffer) = length(cb) == cb.capacity

"""
    first(cb::CircularBuffer)

Get the first element of CircularBuffer.
"""
Base.@propagate_inbounds function Base.first(cb::CircularBuffer)
    @boundscheck (cb.length == 0) && throw(BoundsError(cb, 1))
    return cb.buffer[cb.first]
end
"""
    last(cb::CircularBuffer)

Get the last element of CircularBuffer.
"""
Base.@propagate_inbounds function Base.last(cb::CircularBuffer)
    @boundscheck (cb.length == 0) && throw(BoundsError(cb, 1))
    return cb.buffer[_buffer_index(cb, cb.length)]
end

# Disjoint-Set

############################################################
#
#   A forest of disjoint sets of integers
#
#   Since each element is an integer, we can use arrays
#   instead of dictionary (for efficiency)
#
#   Disjoint sets over other key types can be implemented
#   based on an IntDisjointSet through a map from the key
#   to an integer index
#
############################################################

_intdisjointset_bounds_err_msg(T) = "the maximum number of elements in IntDisjointSet{$T} is $(typemax(T))"

"""
    IntDisjointSet{T<:Integer}(n::Integer)

A forest of disjoint sets of integers, which is a data structure
(also called a union–find data structure or merge–find set)
that tracks a set of elements partitioned
into a number of disjoint (non-overlapping) subsets.
"""
mutable struct IntDisjointSet{T<:Integer}
    parents::Vector{T}
    ranks::Vector{T}
    ngroups::T
end

IntDisjointSet(n::T) where {T<:Integer} = IntDisjointSet{T}(collect(Base.OneTo(n)), zeros(T, n), n)
IntDisjointSet{T}(n::Integer) where {T<:Integer} = IntDisjointSet{T}(collect(Base.OneTo(T(n))), zeros(T, T(n)), T(n))
Base.length(s::IntDisjointSet) = length(s.parents)
function Base.sizehint!(s::IntDisjointSet, n::Integer)
    sizehint!(s.parents, n)
    sizehint!(s.ranks, n)
    return s
end
Base.in(i::Integer, s::IntDisjointSet) = checkbounds(Bool, s.parents, i)

"""
    num_groups(s::IntDisjointSet)

Get a number of groups.
"""
num_groups(s::IntDisjointSet) = s.ngroups
Base.eltype(::Type{IntDisjointSet{T}}) where {T<:Integer} = T

# find the root element of the subset that contains x
# path compression is implemented here
function find_root_impl!(parents::Vector{T}, x::Integer) where {T<:Integer}
    p = parents[x]
    @inbounds if parents[p] != p
        parents[x] = p = _find_root_impl!(parents, p)
    end
    return p
end

# unsafe version of the above
function _find_root_impl!(parents::Vector{T}, x::Integer) where {T<:Integer}
    @inbounds p = parents[x]
    @inbounds if parents[p] != p
        parents[x] = p = _find_root_impl!(parents, p)
    end
    return p
end

"""
    find_root!(s::IntDisjointSet{T}, x::T)

Find the root element of the subset that contains an member `x`.
Path compression happens here.
"""
find_root!(s::IntDisjointSet{T}, x::T) where {T<:Integer} = find_root_impl!(s.parents, x)

"""
    in_same_set(s::IntDisjointSet{T}, x::T, y::T)

Returns `true` if `x` and `y` belong to the same subset in `s`, and `false` otherwise.
"""
in_same_set(s::IntDisjointSet{T}, x::T, y::T) where {T<:Integer} = find_root!(s, x) == find_root!(s, y)

"""
    union!(s::IntDisjointSet{T}, x::T, y::T)

Merge the subset containing `x` and that containing `y` into one
and return the root of the new set.
"""
function Base.union!(s::IntDisjointSet{T}, x::T, y::T) where {T<:Integer}
    parents = s.parents
    xroot = find_root_impl!(parents, x)
    yroot = find_root_impl!(parents, y)
    return xroot != yroot ? root_union!(s, xroot, yroot) : xroot
end

"""
    root_union!(s::IntDisjointSet{T}, x::T, y::T)

Form a new set that is the union of the two sets whose root elements are
`x` and `y` and return the root of the new set.
Assume `x ≠ y` (unsafe).
"""
function root_union!(s::IntDisjointSet{T}, x::T, y::T) where {T<:Integer}
    parents = s.parents
    rks = s.ranks
    @inbounds xrank = rks[x]
    @inbounds yrank = rks[y]

    if xrank < yrank
        x, y = y, x
    elseif xrank == yrank
        rks[x] += one(T)
    end
    @inbounds parents[y] = x
    s.ngroups -= one(T)
    return x
end

"""
    push!(s::IntDisjointSet{T})

Make a new subset with an automatically chosen new element `x`.
Returns the new element. Throw an `ArgumentError` if the
capacity of the set would be exceeded.
"""
function Base.push!(s::IntDisjointSet{T}) where {T<:Integer}
    l = length(s)
    l < typemax(T) || throw(ArgumentError(_intdisjointset_bounds_err_msg(T)))
    x = l + one(T)
    push!(s.parents, x)
    push!(s.ranks, zero(T))
    s.ngroups += one(T)
    return x
end

"""
    DisjointSet{T}(xs)

A forest of disjoint sets of arbitrary value type `T`.

It is a wrapper of `IntDisjointSet{Int}`, which uses a
dictionary to map the input value to an internal index.
"""
mutable struct DisjointSet{T} <: AbstractSet{T}
    intmap::Dict{T,Int}
    revmap::Vector{T}
    internal::IntDisjointSet{Int}

    DisjointSet{T}() where T = new{T}(Dict{T,Int}(), Vector{T}(), IntDisjointSet(0))
    function DisjointSet{T}(xs) where T    # xs must be iterable
        imap = Dict{T,Int}()
        rmap = Vector{T}()
        n = length(xs)::Int
        sizehint!(imap, n)
        sizehint!(rmap, n)
        id = 0
        for x in xs
            imap[x] = (id += 1)
            push!(rmap,x)
        end
        return new{T}(imap, rmap, IntDisjointSet(n))
    end
end

DisjointSet() = DisjointSet{Any}()
DisjointSet(xs) = _DisjointSet(xs, Base.IteratorEltype(xs))
_DisjointSet(xs, ::Base.HasEltype) = DisjointSet{eltype(xs)}(xs)
function _DisjointSet(xs, ::Base.EltypeUnknown)
    T = Base.@default_eltype(xs)
    (isconcretetype(T) || T === Union{}) || return Base.grow_to!(DisjointSet{T}(), xs)
    return DisjointSet{T}(xs)
end

Base.iterate(s::DisjointSet) = iterate(s.revmap)
Base.iterate(s::DisjointSet, i) = iterate(s.revmap, i)

Base.length(s::DisjointSet) = length(s.internal)
Base.in(el, s::DisjointSet) = haskey(s.intmap, el)

"""
    num_groups(s::DisjointSet)

Get a number of groups.
"""
num_groups(s::DisjointSet) = num_groups(s.internal)
Base.eltype(::Type{DisjointSet{T}}) where T = T
Base.empty(s::DisjointSet{T}, ::Type{U}=T) where {T,U} = DisjointSet{U}()
function Base.sizehint!(s::DisjointSet, n::Integer)
    sizehint!(s.intmap, n)
    sizehint!(s.revmap, n)
    sizehint!(s.internal, n)
    return s
end

"""
    find_root!{T}(s::DisjointSet{T}, x::T)

Find the root element of the subset in `s` which has the element `x` as a member.
"""
find_root!(s::DisjointSet{T}, x::T) where {T} = s.revmap[find_root!(s.internal, s.intmap[x])]

"""
    in_same_set(s::DisjointSet{T}, x::T, y::T)

Return `true` if `x` and `y` belong to the same subset in `s`, and `false` otherwise.
"""
in_same_set(s::DisjointSet{T}, x::T, y::T) where {T} = in_same_set(s.internal, s.intmap[x], s.intmap[y])

"""
    union!(s::DisjointSet{T}, x::T, y::T)

Merge the subset containing `x` and that containing `y` into one
and return the root of the new set.
"""
Base.union!(s::DisjointSet{T}, x::T, y::T) where {T} = s.revmap[union!(s.internal, s.intmap[x], s.intmap[y])]

"""
    root_union!(s::DisjointSet{T}, x::T, y::T)

Form a new set that is the union of the two sets whose root elements are
`x` and `y` and return the root of the new set.
Assume `x ≠ y` (unsafe).
"""
root_union!(s::DisjointSet{T}, x::T, y::T) where {T} = s.revmap[root_union!(s.internal, s.intmap[x], s.intmap[y])]

"""
    push!(s::DisjointSet{T}, x::T)

Make a new subset containing `x` if any existing subset of `s` does not contain `x`.
"""
function Base.push!(s::DisjointSet{T}, x::T) where T
    haskey(s.intmap, x) && return x
    id = push!(s.internal)
    s.intmap[x] = id
    push!(s.revmap, x) # Note, this assumes invariant: length(s.revmap) == id
    return x
end

# Dictionary which returns (and sets) a default value for a requested item not
# already in to the dictionary

# DefaultDictBase is the main class used to in Default*Dicts.
#
# Each related (immutable) Default*Dict class contains a single
# DefaultDictBase object as a member, and delegates almost all
# functions to this object.
#
# The main rationale for doing this instead of using type aliases is
# that this way, we can have actual class names and constructors for
# each of the DefaultDictBase "subclasses", in some sense getting
# around the Julia limitation of not allowing concrete classes to be
# subclassed.
#

struct DefaultDictBase{K,V,F,D} <: AbstractDict{K,V}
    default::F
    d::D
    passkey::Bool

    check_D(D,K,V) = (D <: AbstractDict{K,V}) ||
        throw(ArgumentError("Default dict must be <: AbstractDict{$K,$V}"))

    DefaultDictBase{K,V,F,D}(x::F, kv::AbstractArray{Tuple{K,V}}; passkey=false) where {K,V,F,D} =
        (check_D(D,K,V); new{K,V,F,D}(x, D(kv), passkey))
    DefaultDictBase{K,V,F,D}(x::F, ps::Pair{K,V}...; passkey=false) where {K,V,F,D} =
        (check_D(D,K,V); new{K,V,F,D}(x, D(ps...), passkey))

    DefaultDictBase{K,V,F,D}(x::F, d::D; passkey=d.passkey) where {K,V,F,D<:DefaultDictBase} =
        (check_D(D,K,V); DefaultDictBase(x, d.d; passkey=passkey))
    DefaultDictBase{K,V,F,D}(x::F, d::D = D(); passkey=false) where {K,V,F,D} =
        (check_D(D,K,V); new{K,V,F,D}(x, d, passkey))
end

# Constructors

DefaultDictBase(; kwargs...) = throw(ArgumentError("no default specified"))
DefaultDictBase(k, v; kwargs...) = throw(ArgumentError("no default specified"))

# syntax entry points
DefaultDictBase(default::F; kwargs...) where {F} = DefaultDictBase{Any,Any,F,Dict{Any,Any}}(default; kwargs...)
DefaultDictBase(default::F, kv::AbstractArray{Tuple{K,V}}; kwargs...) where {K,V,F} = DefaultDictBase{K,V,F,Dict{K,V}}(default, kv; kwargs...)
DefaultDictBase(default::F, ps::Pair{K,V}...; kwargs...) where {K,V,F} = DefaultDictBase{K,V,F,Dict{K,V}}(default, ps...; kwargs...)
DefaultDictBase(default::F, d::D; kwargs...) where {F,D<:AbstractDict} = (K=keytype(d); V=valtype(d); DefaultDictBase{K,V,F,D}(default, d; kwargs...))

# Constructor for DefaultDictBase{Int,Float64}(0.0)
DefaultDictBase{K,V}(default::F; kwargs...) where {K,V,F} = DefaultDictBase{K,V,F,Dict{K,V}}(default; kwargs...)

# Functions

# most functions are simply delegated to the wrapped dictionary
@delegate DefaultDictBase.d [ Base.get, Base.haskey, Base.getkey, Base.pop!,
                              Base.iterate, Base.isempty, Base.length ]

# Some functions are delegated, but then need to return the main dictionary
# NOTE: push! is not included below, because the fallback version just
#       calls setindex!
@delegate_return_parent DefaultDictBase.d [ Base.delete!, Base.empty!, Base.setindex!, Base.sizehint! ]

Base.empty(d::DefaultDictBase{K,V,F}) where {K,V,F} = DefaultDictBase{K,V,F}(d.default; passkey=d.passkey)

Base.getindex(d::DefaultDictBase, key) = get!(d.d, key, d.default)

function Base.getindex(d::DefaultDictBase{K,V,F}, key) where {K,V,F<:Base.Callable}
    if d.passkey
        return get!(d.d, key) do
            d.default(key)
        end
    else
        return get!(d.d, key) do
            d.default()
        end
    end
end


################

# Here begins the actual definition of the DefaultDict and
# DefaultOrderedDict classes.  As noted above, these are simply
# wrappers around a DefaultDictBase object, and delegate all functions
# to that object

for _Dict in [:Dict, :OrderedDict]
    DefaultDict = Symbol("Default"*string(_Dict))
    @eval begin
        struct $DefaultDict{K,V,F} <: AbstractDict{K,V}
            d::DefaultDictBase{K,V,F,$_Dict{K,V}}

            $DefaultDict{K,V,F}(x, ps::Pair{K,V}...; kwargs...) where {K,V,F} =
                new{K,V,F}(DefaultDictBase{K,V,F,$_Dict{K,V}}(x, ps...; kwargs...))
            $DefaultDict{K,V,F}(x, kv::AbstractArray{Tuple{K,V}}; kwargs...) where {K,V,F} =
                new{K,V,F}(DefaultDictBase{K,V,F,$_Dict{K,V}}(x, kv; kwargs...))
            $DefaultDict{K,V,F}(x, d::$DefaultDict) where {K,V,F} = $DefaultDict(x, d.d)
            $DefaultDict{K,V,F}(x, d::$_Dict; kwargs...) where {K,V,F} =
                new{K,V,F}(DefaultDictBase{K,V,F,$_Dict{K,V}}(x, d; kwargs...))
            $DefaultDict{K,V,F}(x; kwargs...) where {K,V,F} =
                new{K,V,F}(DefaultDictBase{K,V,F,$_Dict{K,V}}(x; kwargs...))
        end

        ## Constructors

        $DefaultDict() = throw(ArgumentError("$DefaultDict: no default specified"))
        $DefaultDict(k,v) = throw(ArgumentError("$DefaultDict: no default specified"))

        # syntax entry points
        $DefaultDict(default::F; kwargs...) where {F} = $DefaultDict{Any,Any,F}(default; kwargs...)
        $DefaultDict(default::F, kv::AbstractArray{Tuple{K,V}}; kwargs...) where {K,V,F} = $DefaultDict{K,V,F}(default, kv; kwargs...)
        $DefaultDict(default::F, ps::Pair{K,V}...; kwargs...) where {K,V,F} = $DefaultDict{K,V,F}(default, ps...; kwargs...)

        $DefaultDict(default::F, d::AbstractDict; kwargs...) where {F} = ((K,V)= (Base.keytype(d), Base.valtype(d)); $DefaultDict{K,V,F}(default, $_Dict(d); kwargs...))

        # Constructor syntax: DefaultDictBase{Int,Float64}(default)
        $DefaultDict{K,V}(; kwargs...) where {K,V} = throw(ArgumentError("$DefaultDict: no default specified"))
        $DefaultDict{K,V}(default::F; kwargs...) where {K,V,F} = $DefaultDict{K,V,F}(default; kwargs...)

        ## Functions

        # Most functions are simply delegated to the wrapped DefaultDictBase object
        @delegate $DefaultDict.d [ Base.getindex, Base.get, Base.get!, Base.haskey,
                                   Base.getkey, Base.pop!, Base.iterate,
                                   Base.isempty, Base.length ]

        # Some functions are delegated, but then need to return the main dictionary
        # NOTE: push! is not included below, because the fallback version just
        #       calls setindex!
        @delegate_return_parent $DefaultDict.d [ Base.delete!, Base.empty!, Base.setindex!, Base.sizehint! ]

        # NOTE: The second and third definition of push! below are only
        # necessary for disambiguating with the fourth, fifth, and sixth
        # definitions of push! below.
        # If these are removed, the second and third definitions can be
        # removed as well.
        Base.push!(d::$DefaultDict, p::Pair) = (setindex!(d.d, p.second, p.first); d)
        Base.push!(d::$DefaultDict, p::Pair, q::Pair) = push!(push!(d, p), q)
        Base.push!(d::$DefaultDict, p::Pair, q::Pair, r::Pair...) = push!(push!(push!(d, p), q), r...)

        Base.push!(d::$DefaultDict, p) = (setindex!(d.d, p[2], p[1]); d)
        Base.push!(d::$DefaultDict, p, q) = push!(push!(d, p), q)
        Base.push!(d::$DefaultDict, p, q, r...) = push!(push!(push!(d, p), q), r...)

        Base.empty(d::$DefaultDict{K,V,F}) where {K,V,F} = $DefaultDict{K,V,F}(d.d.default)
        Base.in(key, v::Base.KeySet{K,T}) where {K,T<:$DefaultDict{K}} = key in keys(v.dict.d.d)
    end
end

OrderedCollections.isordered(::Type{T}) where {T<:DefaultOrderedDict} = true

## This should be uncommented to provide a DefaultSortedDict

# struct DefaultSortedDict{K,V,F} <: AbstractDict{K,V}
#     d::DefaultDictBase{K,V,F,SortedDict{K,V}}

#     DefaultSortedDict(x, kv::AbstractArray{(K,V)}) = new(DefaultDictBase{K,V,F,SortedDict{K,V}}(x, kv))
#     DefaultSortedDict(x, d::DefaultSortedDict) = DefaultSortedDict(x, d.d)
#     DefaultSortedDict(x, d::SortedDict) = new(DefaultDictBase{K,V,F,SortedDict{K,V}}(x, d))
#     DefaultSortedDict(x) = new(DefaultDictBase{K,V,F,SortedDict{K,V}}(x))
#     DefaultSortedDict(x, ks, vs) = new(DefaultDictBase{K,V,F,SortedDict{K,V}}(x,ks,vs))
# end

## Constructors

# DefaultSortedDict() = throw(ArgumentError("DefaultSortedDict: no default specified"))
# DefaultSortedDict(k,v) = throw(ArgumentError("DefaultSortedDict: no default specified"))

# # TODO: these mimic similar Dict constructors, but may not be needed
# DefaultSortedDict{K,V,F}(default::F, ks::AbstractArray{K}, vs::AbstractArray{V}) = DefaultSortedDict{K,V,F}(default,ks,vs)
# DefaultSortedDict{F}(default::F,ks,vs) = DefaultSortedDict{Any,Any,F}(default, ks, vs)

# # syntax entry points
# DefaultSortedDict{F}(default::F) = DefaultSortedDict{Any,Any,F}(default)
# DefaultSortedDict{K,V,F}(::Type{K}, ::Type{V}, default::F) = DefaultSortedDict{K,V,F}(default)
# DefaultSortedDict{K,V,F}(default::F, kv::AbstractArray{(K,V)}) = DefaultSortedDict{K,V,F}(default, kv)

# DefaultSortedDict{F}(default::F, d::AbstractDict) = ((K,V)=eltype(d); DefaultSortedDict{K,V,F}(default, SortedDict(d)))

## Functions

## Most functions are simply delegated to the wrapped DefaultDictBase object

# @delegate DefaultSortedDict.d [ getindex, get, get!, haskey,
#                                 getkey, pop!, start, next,
#                                 done, isempty, length]
# @delegate_return_parent DefaultSortedDict.d [ delete!, empty!, setindex!, sizehint! ]

# similar{K,V,F}(d::DefaultSortedDict{K,V,F}) = DefaultSortedDict{K,V,F}(d.d.default)
# in{T<:DefaultSortedDict}(key, v::Base.KeySet{T}) = key in keys(v.dict.d.d)

module BenchSparseIntSet

using DataStructures
using BenchmarkTools
using Random

suite = BenchmarkGroup()

rand_setup =  (
	Random.seed!(1234);
	ids1 = rand(1:30000, 1000);
	ids2 = rand(1:30000, 1000);
)

function create_fill_packed(ids1)
	y = SparseIntSet()
	for i in ids1
		push!(y, i)
	end
end

suite["create_fill"] =
	@benchmarkable create_fill_packed(ids1) setup=rand_setup

suite["in while not in"] =
	@benchmarkable in(23, y) evals=1000 setup=(y = SparseIntSet();)
suite["in while in"] =
	@benchmarkable in(5199, y) evals=1000 setup=(y=SparseIntSet(); push!(y, 5199))

function pop_push(y)
	pop!(y, 5199)
	push!(y, 5199)
end

suite["pop push worst case"] = @benchmarkable pop_push(y) setup=(y=SparseIntSet(); push!(y, 5199))
suite["pop push"] = @benchmarkable pop_push(y) setup=(y=SparseIntSet(); push!(y, 5199); push!(y, 5200))

function iterate_one_bench(x)
	t = 0
	for i in x
		t += i
	end
	return t
end
function iterate_two_bench(x,y)
	t = 0
	for (ix, iy) in zip(x, y)
		t += ix + iy
	end
	return t
end
function iterate_two_exclude_one_bench(x,y,z)
	t = 0
	for (ix, iy) in zip(x, y, exclude=(z,))
		t += ix + iy
	end
	return t
end

x_y_z_setup = (
	Random.seed!(1234);
	x = SparseIntSet(rand(1:30000, 1000));
	y = SparseIntSet(rand(1:30000, 1000));
	z = SparseIntSet(rand(1:30000, 1000));
)

suite["iterate one"] =
	@benchmarkable iterate_one_bench(x) setup=x_y_z_setup

suite["iterate two"] =
	@benchmarkable iterate_two_bench(x,y) setup=x_y_z_setup

suite["iterate two exclude one"] =
	@benchmarkable iterate_two_exclude_one_bench(x,y,z) setup=x_y_z_setup

end  # module
BenchSparseIntSet.suite

# the load factor after which the dictionary `rehash` happens
const ROBIN_DICT_LOAD_FACTOR = 0.70

"""
    RobinDict([itr])

`RobinDict{K,V}()` constructs a hash table with keys of type `K` and values of type `V`.
Keys are compared with [`isequal`](@ref) and hashed with [`hash`](@ref).
Given a single iterable argument, constructs a [`RobinDict`](@ref) whose key-value pairs
are taken from 2-tuples `(key,value)` generated by the argument.

# Examples
```jldoctest
julia> RobinDict([("A", 1), ("B", 2)])
RobinDict{String, Int64} with 2 entries:
  "B" => 2
  "A" => 1
```

Alternatively, a sequence of pair arguments may be passed.

```jldoctest
julia> RobinDict("A"=>1, "B"=>2)
RobinDict{String, Int64} with 2 entries:
  "B" => 2
  "A" => 1
```
"""
mutable struct RobinDict{K,V} <: AbstractDict{K,V}
    hashes::Vector{UInt32}
    keys::Array{K,1}
    vals::Array{V,1}
    count::Int
    idxfloor::Int
end

function RobinDict{K, V}() where {K, V}
    n = 16
    RobinDict{K, V}(zeros(UInt32, n), Vector{K}(undef, n), Vector{V}(undef, n), 0, 0)
end

function RobinDict{K, V}(d::RobinDict{K, V}) where {K, V}
    RobinDict{K, V}(copy(d.hashes), copy(d.keys), copy(d.vals), d.count, d.idxfloor)
end

function RobinDict{K,V}(kv) where V where K
    h = RobinDict{K,V}()
    for (k,v) in kv
        h[k] = v
    end
    return h
end
RobinDict{K,V}(p::Pair) where {K,V} = setindex!(RobinDict{K,V}(), p.second, p.first)
function RobinDict{K,V}(ps::Pair...) where V where K
    h = RobinDict{K,V}()
    sizehint!(h, length(ps))
    for p in ps
        h[p.first] = p.second
    end
    return h
end

RobinDict() = RobinDict{Any,Any}()
RobinDict(kv::Tuple{}) = RobinDict()
Base.copy(d::RobinDict) = RobinDict(d)
Base.empty(d::RobinDict, ::Type{K}, ::Type{V}) where {K, V} = RobinDict{K, V}()

RobinDict(ps::Pair{K,V}...) where {K,V} = RobinDict{K,V}(ps)
RobinDict(ps::Pair...)                  = RobinDict(ps)

RobinDict(d::AbstractDict{K, V}) where {K, V} = RobinDict{K, V}(d)

function RobinDict(kv)
    try
        return dict_with_eltype((K, V) -> RobinDict{K, V}, kv, eltype(kv))
    catch e
        if !isiterable(typeof(kv)) || !all(x -> isa(x, Union{Tuple,Pair}), kv)
            !all(x->isa(x,Union{Tuple,Pair}),kv)
            throw(ArgumentError("RobinDict(kv): kv needs to be an iterator of tuples or pairs"))
        else
            rethrow(e)
        end
    end
end

hash_key(key) = (hash(key)%UInt32) | 0x80000000
desired_index(hash, sz) = (hash & (sz - 1)) + 1

function calculate_distance(h::RobinDict{K, V}, index) where {K, V}
    @assert isslotfilled(h, index)
    sz = length(h.keys)
    @inbounds index_init = desired_index(h.hashes[index], sz)
    return (index - index_init + sz) & (sz - 1)
end

# insert algorithm
function rh_insert!(h::RobinDict{K, V}, key::K, val::V) where {K, V}
    # table full
    @assert h.count != length(h.keys)

    ckey, cval, chash = key, val, hash_key(key)
    sz = length(h.keys)
    index_init = desired_index(chash, sz)

    index_curr = index_init
    probe_distance = 0
    probe_current = 0
    @inbounds while true
        if (isslotempty(h, index_curr)) || (isslotfilled(h, index_curr) && isequal(h.keys[index_curr], ckey))
            break
        end
        probe_distance = calculate_distance(h, index_curr)

        if probe_current > probe_distance
            h.vals[index_curr], cval = cval, h.vals[index_curr]
            h.keys[index_curr], ckey = ckey, h.keys[index_curr]
            h.hashes[index_curr], chash = chash, h.hashes[index_curr]
            probe_current = probe_distance
        end
        probe_current += 1
        index_curr = (index_curr & (sz - 1)) + 1
    end

    @inbounds if isslotfilled(h, index_curr) && isequal(h.keys[index_curr], ckey)
        h.vals[index_curr] = cval
        return index_curr
    end

    @inbounds if isslotempty(h, index_curr)
        h.count += 1
    end

    @inbounds h.vals[index_curr] = cval
    @inbounds h.keys[index_curr] = ckey
    @inbounds h.hashes[index_curr] = chash

    @assert probe_current >= 0

    if h.idxfloor == 0
        h.idxfloor = index_curr
    else
        h.idxfloor = min(h.idxfloor, index_curr)
    end
    return index_curr
end

function rh_insert_for_rehash!(h_new::RobinDict{K, V}, key::K, val::V, hash::UInt32) where {K, V}
    # table full
    @assert h_new.count != length(h_new.keys)

    ckey, cval, chash = key, val, hash
    sz = length(h_new.keys)
    index_init = desired_index(chash, sz)

    index_curr = index_init
    probe_distance = 0
    probe_current = 0
    @inbounds while true
        if (isslotempty(h_new, index_curr))
            break
        end
        probe_distance = calculate_distance(h_new, index_curr)

        if probe_current > probe_distance
            h_new.vals[index_curr], cval = cval, h_new.vals[index_curr]
            h_new.keys[index_curr], ckey = ckey, h_new.keys[index_curr]
            h_new.hashes[index_curr], chash = chash, h_new.hashes[index_curr]
            probe_current = probe_distance
        end
        probe_current += 1
        index_curr = (index_curr & (sz - 1)) + 1
    end

    @inbounds if isslotempty(h_new, index_curr)
        h_new.count += 1
    end

    @inbounds h_new.vals[index_curr] = cval
    @inbounds h_new.keys[index_curr] = ckey
    @inbounds h_new.hashes[index_curr] = chash

    @assert probe_current >= 0

    if h_new.idxfloor == 0
        h_new.idxfloor = index_curr
    else
        h_new.idxfloor = min(h_new.idxfloor, index_curr)
    end
    return index_curr
end

#rehash! algorithm
function rehash!(h::RobinDict{K,V}, newsz = length(h.keys)) where {K, V}
    oldk = h.keys
    oldv = h.vals
    oldh = h.hashes
    sz = length(oldk)
    newsz = _tablesz(newsz)
    if h.count == 0
        resize!(h.keys, newsz)
        resize!(h.vals, newsz)
        resize!(h.hashes, newsz)
        fill!(h.hashes, 0)
        h.count = 0
        h.idxfloor = 0
        return h
    end

    h.keys = Vector{K}(undef, newsz)
    h.vals = Vector{V}(undef, newsz)
    h.hashes = zeros(UInt32,newsz)
    h.count = 0
    h.idxfloor = 0

    for i = 1:sz
        @inbounds if oldh[i] != 0
            k = oldk[i]
            v = oldv[i]
            rh_insert_for_rehash!(h, k, v, oldh[i])
        end
    end
    return h
end

function Base.sizehint!(d::RobinDict, newsz)
    newsz = _tablesz(newsz*2)  # *2 for keys and values in same array
    oldsz = length(d.keys)
    # grow at least 25%
    if newsz < (oldsz*5)>>2
        return d
    end
    rehash!(d, newsz)
end

Base.@propagate_inbounds isslotfilled(h::RobinDict, index) = (h.hashes[index] != 0)
Base.@propagate_inbounds isslotempty(h::RobinDict, index) = (h.hashes[index] == 0)


function Base.setindex!(h::RobinDict{K,V}, v0, key0) where {K, V}
    key = convert(K, key0)
    isequal(key, key0) || throw(ArgumentError("$key0 is not a valid key for type $K"))
    _setindex!(h, key, v0)
end

function _setindex!(h::RobinDict{K,V}, key::K, v0) where {K, V}
    v = convert(V, v0)
    sz = length(h.keys)
    (h.count > ROBIN_DICT_LOAD_FACTOR * sz) && rehash!(h, sz<<2)
    index = rh_insert!(h, key, v)
    @assert index > 0
    return h
end

"""
    empty!(collection) -> collection

Remove all elements from a `collection`.

# Examples
```jldoctest
julia> A = RobinDict("a" => 1, "b" => 2)
RobinDict{String, Int64} with 2 entries:
  "b" => 2
  "a" => 1

julia> empty!(A);

julia> A
RobinDict{String, Int64}()
```
"""
function Base.empty!(h::RobinDict{K,V}) where {K, V}
    sz = length(h.keys)
    empty!(h.hashes)
    empty!(h.keys)
    empty!(h.vals)
    resize!(h.keys, sz)
    resize!(h.vals, sz)
    resize!(h.hashes, sz)
    fill!(h.hashes, 0)
    h.count = 0
    h.idxfloor = 0
    return h
end

function rh_search(h::RobinDict{K, V}, key) where {K, V}
    sz = length(h.keys)
    chash = hash_key(key)
    index = desired_index(chash, sz)
    cdibs = 0
    @inbounds while true
        if isslotempty(h, index)
            return -1
        elseif cdibs > calculate_distance(h, index)
            return -1
        elseif h.hashes[index] == chash && (h.keys[index] === key || isequal(h.keys[index], key))
            return index
        end
        index = (index & (sz - 1)) + 1
    end
end

"""
    get!(collection, key, default)

Return the value stored for the given key, or if no mapping for the key is present, store
`key => default`, and return `default`.

# Examples
```jldoctest
julia> d = RobinDict("a"=>1, "b"=>2, "c"=>3);

julia> get!(d, "a", 5)
1

julia> get!(d, "d", 4)
4

julia> d
RobinDict{String, Int64} with 4 entries:
  "c" => 3
  "b" => 2
  "a" => 1
  "d" => 4
```
"""
Base.get!(collection, key, default)

Base.get!(h::RobinDict{K,V}, key0, default) where {K,V} = get!(()->default, h, key0)

"""
    get!(f::Function, collection, key)

Return the value stored for the given key, or if no mapping for the key is present, store
`key => f()`, and return `f()`.

This is intended to be called using `do` block syntax:
```julia
get!(dict, key) do
    # default value calculated here
    time()
end
```
"""
Base.get!(f::Function, collection, key)

function Base.get!(default::Callable, h::RobinDict{K,V}, key0::K) where {K, V}
    key = convert(K, key0)
    return _get!(default, h, key)
end

function _get!(default::Callable, h::RobinDict{K,V}, key::K) where V where K
    index = rh_search(h, key)

    index > 0 && return h.vals[index]

    v = convert(V, default())
    rh_insert!(h, key, v)
    return v
end

function Base.getindex(h::RobinDict{K, V}, key) where {K, V}
    index = rh_search(h, key)
    @inbounds return (index < 0) ? throw(KeyError(key)) : h.vals[index]
end

"""
    get(collection, key, default)

Return the value stored for the given key, or the given default value if no mapping for the
key is present.

# Examples
```jldoctest
julia> d = RobinDict("a"=>1, "b"=>2);

julia> get(d, "a", 3)
1

julia> get(d, "c", 3)
3
```
"""
function Base.get(h::RobinDict{K,V}, key, default) where {K, V}
    index = rh_search(h, key)
    @inbounds return (index < 0) ? default : h.vals[index]::V
end

"""
    get(f::Function, collection, key)

Return the value stored for the given key, or if no mapping for the key is present, return
`f()`.  Use [`get!`](@ref) to also store the default value in the dictionary.

This is intended to be called using `do` block syntax

```julia
get(dict, key) do
    # default value calculated here
    time()
end
```
"""
function Base.get(default::Callable, h::RobinDict{K,V}, key) where {K, V}
    index = rh_search(h, key)
    @inbounds return (index < 0) ? default() : h.vals[index]::V
end

"""
    haskey(collection, key) -> Bool

Determine whether a collection has a mapping for a given `key`.

# Examples
```jldoctest
julia> D = RobinDict('a'=>2, 'b'=>3)
RobinDict{Char, Int64} with 2 entries:
  'a' => 2
  'b' => 3

julia> haskey(D, 'a')
true

julia> haskey(D, 'c')
false
```
"""
Base.haskey(h::RobinDict, key) = (rh_search(h, key) > 0)
Base.in(key, v::KeySet{<:Any, <:RobinDict}) = (rh_search(v.dict, key) >= 0)

"""
    getkey(collection, key, default)

Return the key matching argument `key` if one exists in `collection`, otherwise return `default`.

# Examples
```jldoctest
julia> D = RobinDict('a'=>2, 'b'=>3)
RobinDict{Char, Int64} with 2 entries:
  'a' => 2
  'b' => 3

julia> getkey(D, 'a', 1)
'a': ASCII/Unicode U+0061 (category Ll: Letter, lowercase)

julia> getkey(D, 'd', 'a')
'a': ASCII/Unicode U+0061 (category Ll: Letter, lowercase)
```
"""
function Base.getkey(h::RobinDict{K,V}, key, default) where {K, V}
    index = rh_search(h, key)
    @inbounds return (index < 0) ? default : h.keys[index]::K
end

# backward shift deletion by not keeping any tombstones
function rh_delete!(h::RobinDict{K, V}, index) where {K, V}
    @assert index > 0

    # this assumes that there is a key/value present in the dictionary at index
    index0 = index
    sz = length(h.keys)
    @inbounds while true
        index0 = (index0 & (sz - 1)) + 1
        if isslotempty(h, index0) || calculate_distance(h, index0) == 0
            break
        end
    end
    #index0 represents the position before which we have to shift backwards

    # the backwards shifting algorithm
    curr = index
    next = (index & (sz - 1)) + 1

    @inbounds while next != index0
        h.vals[curr] = h.vals[next]
        h.keys[curr] = h.keys[next]
        h.hashes[curr] = h.hashes[next]
        curr = next
        next = (next & (sz-1)) + 1
    end

    #curr is at the last position, reset back to normal
    isbitstype(K) || isbitsunion(K) || ccall(:jl_arrayunset, Cvoid, (Any, UInt), h.keys, curr-1)
    isbitstype(V) || isbitsunion(V) || ccall(:jl_arrayunset, Cvoid, (Any, UInt), h.vals, curr-1)
    @inbounds h.hashes[curr] = 0x0

    h.count -= 1
    # this is necessary because key at idxfloor might get deleted
    h.idxfloor = get_next_filled(h, h.idxfloor)
    return h
end

function _pop!(h::RobinDict, index)
    @inbounds val = h.vals[index]
    rh_delete!(h, index)
    return val
end

function Base.pop!(h::RobinDict{K, V}, key0) where {K, V}
    key = convert(K, key0)
    index = rh_search(h, key)
    return index > 0 ? _pop!(h, index) : throw(KeyError(key))
end

"""
    pop!(collection, key[, default])

Delete and return the mapping for `key` if it exists in `collection`, otherwise return
`default`, or throw an error if `default` is not specified.

# Examples
```jldoctest
julia> d = RobinDict("a"=>1, "b"=>2, "c"=>3);

julia> pop!(d, "a")
1

julia> pop!(d, "d")
ERROR: KeyError: key "d" not found
Stacktrace:
[...]

julia> pop!(d, "e", 4)
4
```
"""
function Base.pop!(h::RobinDict{K, V}, key0, default) where {K, V}
    key = convert(K, key0)
    index = rh_search(h, key)
    return index > 0 ? _pop!(h, index) : default
end

function Base.pop!(h::RobinDict)
    isempty(h) && throw(ArgumentError("dict must be non-empty"))
    idx = h.idxfloor
    @inbounds key = h.keys[idx]
    @inbounds val = h.vals[idx]
    rh_delete!(h, idx)
    return key => val
end

"""
    delete!(collection, key)

Delete the mapping for the given key in a collection, and return the collection.

# Examples
```jldoctest
julia> d = RobinDict("a"=>1, "b"=>2)
RobinDict{String, Int64} with 2 entries:
  "b" => 2
  "a" => 1

julia> delete!(d, "b")
RobinDict{String, Int64} with 1 entry:
  "a" => 1
```
"""
function Base.delete!(h::RobinDict{K, V}, key0) where {K, V}
    key = convert(K, key0)
    index = rh_search(h, key)
    if index > 0
        rh_delete!(h, index)
    end
    return h
end

function get_next_filled(h::RobinDict, i)
    L = length(h.keys)
    (1 <= i <= L) || return 0
    for j = i:L
        @inbounds if isslotfilled(h, j)
            return  j
        end
    end
    return 0
end

Base.@propagate_inbounds _iterate(t::RobinDict{K,V}, i) where {K,V} = i == 0 ? nothing : (Pair{K,V}(t.keys[i],t.vals[i]), i == typemax(Int) ? 0 : get_next_filled(t, i+1))
Base.@propagate_inbounds function Base.iterate(t::RobinDict)
    _iterate(t, t.idxfloor)
end
Base.@propagate_inbounds Base.iterate(t::RobinDict, i) = _iterate(t, get_next_filled(t, i))

function _merge_kvtypes(d, others...)
    K, V = keytype(d), valtype(d)
    for other in others
        K = promote_type(K, keytype(other))
        V = promote_type(V, valtype(other))
    end
    return (K, V)
end

function Base.merge(d::RobinDict, others::AbstractDict...)
    K, V = _merge_kvtypes(d, others...)
    merge!(RobinDict{K,V}(), d, others...)
end

function Base.merge(combine::Function, d::RobinDict, others::AbstractDict...)
    K, V = _merge_kvtypes(d, others...)
    merge!(combine, RobinDict{K,V}(), d, others...)
end

mutable struct CircularDeque{T}
    buffer::Vector{T}
    capacity::Int
    n::Int
    first::Int
    last::Int
end

"""
    CircularDeque{T}(n)

Create a double-ended queue of maximum capacity `n`, implemented as a circular buffer. The element type is `T`.
"""
CircularDeque{T}(n::Int) where {T} = CircularDeque(Vector{T}(undef, n), n, 0, 1, n)

Base.length(D::CircularDeque) = D.n
Base.eltype(::Type{CircularDeque{T}}) where {T} = T

"""
    capacity(D::CircularDeque)

Return the capacity of the circular deque
"""
capacity(D::CircularDeque) = D.capacity

function Base.empty!(D::CircularDeque)
    D.n = 0
    D.first = 1
    D.last = D.capacity
    return D
end

Base.isempty(D::CircularDeque) = D.n == 0

"""
    first(D::CircularDeque)

Get the item at the front of the queue.
"""
@inline function Base.first(D::CircularDeque)
    @boundscheck D.n > 0 || throw(BoundsError())
    return @inbounds D.buffer[D.first]
end

"""
    last(D::CircularDeque)

Get the item from the back of the queue.
"""
@inline function Base.last(D::CircularDeque)
    @boundscheck D.n > 0 || throw(BoundsError())
    return @inbounds D.buffer[D.last]
end

@inline function Base.push!(D::CircularDeque, v)
    @boundscheck D.n < D.capacity || throw(BoundsError()) # prevent overflow
    D.n += 1
    tmp = D.last + 1
    D.last = ifelse(tmp > D.capacity, 1, tmp)  # wraparound
    @inbounds D.buffer[D.last] = v
    return D
end

@inline Base.@propagate_inbounds function Base.pop!(D::CircularDeque)
    v = last(D)
    _unsetindex!(D.buffer, D.last) # see issue/884
    D.n -= 1
    tmp = D.last - 1
    D.last = ifelse(tmp < 1, D.capacity, tmp)
    v
end

"""
    pushfirst!(D::CircularDeque, v)

Add an element to the front.
"""
@inline function Base.pushfirst!(D::CircularDeque, v)
    @boundscheck D.n < D.capacity || throw(BoundsError())
    D.n += 1
    tmp = D.first - 1
    D.first = ifelse(tmp < 1, D.capacity, tmp)
    @inbounds D.buffer[D.first] = v
    D
end

"""
    popfirst!(D::CircularDeque)

Remove the element at the front.
"""
@inline Base.@propagate_inbounds function Base.popfirst!(D::CircularDeque)
    v = first(D)
    _unsetindex!(D.buffer, D.first) # see issue/884
    D.n -= 1
    tmp = D.first + 1
    D.first = ifelse(tmp > D.capacity, 1, tmp)
    v
end

# getindex sans bounds checking
@inline function _unsafe_getindex(D::CircularDeque, i::Integer)
    j = D.first + i - 1
    if j > D.capacity
        j -= D.capacity
    end
    @inbounds ret = D.buffer[j]
    return ret
end

@inline function Base.getindex(D::CircularDeque, i::Integer)
    @boundscheck 1 <= i <= D.n || throw(BoundsError())
    return _unsafe_getindex(D, i)
end

# Iteration via getindex
@inline function Base.iterate(d::CircularDeque, i = 1)
    i == d.n + 1 ? nothing : (_unsafe_getindex(d, i), i+1)
end

function Base.show(io::IO, D::CircularDeque{T}) where T
    print(io, "CircularDeque{$T}([")
    for i = 1:length(D)
        print(io, D[i])
        i < length(D) && print(io, ',')
    end
    print(io, "])")
end

@testset "MutableLinkedList" begin

    @testset "empty list" begin
        l1 = MutableLinkedList{Int}()
        @test MutableLinkedList() == MutableLinkedList{Any}()
        @test iterate(l1) === nothing
        @test isempty(l1)
        @test length(l1) == 0
        @test lastindex(l1) == 0
        @test collect(l1) == Int[]
        @test eltype(l1) == Int
        @test eltype(typeof(l1)) == Int
        @test_throws ArgumentError pop!(l1)
        @test_throws ArgumentError popfirst!(l1)
    end

    @testset "core functionality" begin
        n = 10

        @testset "push back / pop back" begin
            l = MutableLinkedList{Int}()

            @testset "push back" begin
                for i = 1:n
                    push!(l, i)
                    @test last(l) == i
                    if i > 4
                        @test getindex(l, i) == i
                        @test getindex(l, 1:floor(Int, i/2)) == MutableLinkedList{Int}(1:floor(Int, i/2)...)
                        @test l[1:floor(Int, i/2)] == MutableLinkedList{Int}(1:floor(Int, i/2)...)
                        setindex!(l, 0, i - 2)
                        @test l == MutableLinkedList{Int}(1:i-3..., 0, i-1:i...)
                        setindex!(l, i - 2, i - 2)
                    end
                    @test lastindex(l) == i
                    @test length(l) == i
                    @test isempty(l) == false
                    for (j, k) in enumerate(l)
                        @test j == k
                    end
                    if i > 3
                        l1 = MutableLinkedList{Int32}(1:i...)
                        io = IOBuffer()
                        @test sprint(io -> show(io, iterate(l1))) == "(1, DataStructures.ListNode{Int32}(2))"
                        @test sprint(io -> show(io, iterate(l1, l1.node.next.next))) == "(2, DataStructures.ListNode{Int32}(3))"
                    end
                    cl = collect(l)
                    @test isa(cl, Vector{Int})
                    @test cl == collect(1:i)
                end
            end

            @testset "pop back" begin
                for i = 1:n
                    x = pop!(l)
                    @test length(l) == n - i
                    @test isempty(l) == (i == n)
                    @test x == n - i + 1
                    cl = collect(l)
                    @test cl == collect(1:n-i)
                end
            end
        end

        @testset "push front / pop front" begin
            l = MutableLinkedList{Int}()

            @testset "push front" begin
                for i = 1:n
                    pushfirst!(l, i)
                    @test first(l) == i
                    @test length(l) == i
                    @test isempty(l) == false
                    cl = collect(l)
                    @test isa(cl, Vector{Int})
                    @test cl == collect(i:-1:1)
                end
            end

            @testset "pop front" begin
                for i = 1:n
                    x = popfirst!(l)
                    @test length(l) == n - i
                    @test isempty(l) == (i == n)
                    @test x == n - i + 1
                    cl = collect(l)
                    @test cl == collect(n-i:-1:1)
                end
            end

        end

        @testset "append / delete / copy / reverse" begin
            for i = 1:n
                l = MutableLinkedList{Int}(1:n...)

                @testset "append" begin
                    l2 = MutableLinkedList{Int}(n+1:2n...)
                    append!(l, l2)
                    @test l == MutableLinkedList{Int}(1:2n...)
                    l3 = MutableLinkedList{Int}(1:n...)
                    append!(l3, n+1:2n...)
                    @test l3 == MutableLinkedList{Int}(1:2n...)
                end

                @testset "delete" begin
                    delete!(l, n+1:2n)
                    @test l == MutableLinkedList{Int}(1:n...)
                    for i = n:-1:1
                        delete!(l, i)
                    end
                    @test l == MutableLinkedList{Int}()
                    l = MutableLinkedList{Int}(1:n...)
                    @test_throws BoundsError delete!(l, n-1:2n)
                    @test_throws BoundsError delete!(l, 2n)
                end

                @testset "copy" begin
                    l2 = copy(l)
                    @test l == l2
                end

                @testset "reverse" begin
                    l2 = MutableLinkedList{Int}(n:-1:1...)
                    @test l == reverse(l2)
                end
            end
        end

        @testset "map / filter" begin
            for i = 1:n
                @testset "map" begin
                    l = MutableLinkedList{Int}(1:n...)
                    @test map(x -> 2x, l) == MutableLinkedList{Int}(2:2:2n...)
                    l2 = MutableLinkedList{Float64}()
                    @test map(x -> x*im, l2) == MutableLinkedList{Complex{Float64}}()
                    @test map(Int32, l2) == MutableLinkedList{Int32}()
                    f(x) = x % 2 == 0 ? convert(Int8, x) : convert(Float16, x)
                    @test typeof(map(f, l)) == MutableLinkedList{Real}
                end

                @testset "filter" begin
                    l = MutableLinkedList{Int}(1:n...)
                    @test filter(x -> x % 2 == 0, l) == MutableLinkedList{Int}(2:2:n...)
                end

                @testset "show" begin
                    l = MutableLinkedList{Int32}(1:n...)
                    io = IOBuffer()
                    @test sprint(io -> show(io, l.node.next)) == "$(typeof(l.node.next))($(l.node.next.data))"
                    io1 = IOBuffer()
                    write(io1, "MutableLinkedList{Int32}(");
                    write(io1, join(l, ", "));
                    write(io1, ")")
                    seekstart(io1)
                    @test sprint(io -> show(io, l)) == read(io1, String)
                end
            end
        end
    end

    @testset "random operations" begin
        l = MutableLinkedList{Int}()
        r = Int[]
        m = 100

        for k = 1 : m
            la = rand(1:20)
            x = rand(1:1000, la)

            for i = 1 : la
                if rand(Bool)
                    push!(r, x[i])
                    push!(l, x[i])
                else
                    pushfirst!(r, x[i])
                    pushfirst!(l, x[i])
                end
            end

            @test length(l) == length(r)
            @test collect(l) == r

            lr = rand(1:length(r))
            for i = 1 : lr
                if rand(Bool)
                    pop!(r)
                    pop!(l)
                else
                    popfirst!(r)
                    popfirst!(l)
                end
            end

            @test length(l) == length(r)
            @test collect(l) == r
        end
    end
end

@testset "Fenwick Tree" begin
    @testset "initialisation" begin
        f1 = FenwickTree{Float64}(5)
        @test f1.bi_tree == zeros(5)
        @test length(f1) == 5
        @test eltype(f1) == Float64
        @test eltype(typeof(f1)) == Float64

        arr = [1.2, 8.7, 7.2, 3.5]
        f3 = FenwickTree(arr)
        @test f3[1] == 1.2
        @test length(f3) == length(arr)
    end

    @testset "Point update and Point queries" begin
        f1 = FenwickTree{Int}(10)
        inc!(f1, 10, 5)
        @test prefixsum(f1, 10) == 5
        @test prefixsum(f1, 9) == 0
        @test prefixsum(f1, 1) == 0
        inc!(f1, 5, 7)
        @test prefixsum(f1, 8) == 7
        @test prefixsum(f1, 10) == 12
        @test prefixsum(f1, 5) == 7
        @test prefixsum(f1, 4) == 0

        dec!(f1, 7, 2)
        @test prefixsum(f1, 8) == 5
        @test prefixsum(f1, 6) == 7

        incdec!(f1, 2, 6, 3)
        @test prefixsum(f1, 3) == 3
        @test prefixsum(f1, 7) == 5
        
        @test prefixsum(f1, 0) == 0
        @test prefixsum(f1, -100) == 0

        @test_throws ArgumentError inc!(f1, 11)
    end

end

# Heaps

Heaps are data structures that efficiently maintain the minimum (or
maximum) for a set of data that may dynamically change.

All heaps in this package are derived from `AbstractHeap`, and provide
the following interface:

```julia
# Let `h` be a heap, `v` be a value, and `n` be an integer size

length(h)            # returns the number of elements

isempty(h)           # returns whether the heap is empty

push!(h, v)          # add a value to the heap

first(h)             # return the first (top) value of a heap

pop!(h)              # removes the first (top) value, and returns it

extract_all!(h)      # removes all elements and returns sorted array

extract_all_rev!(h)  # removes all elements and returns reverse sorted array

sizehint!(h, n)      # reserve capacity for at least `n` elements
```

Mutable heaps (values can be changed after being pushed to a heap) are
derived from `AbstractMutableHeap <: AbstractHeap`, and additionally
provides the following interface:

```julia
# Let `h` be a heap, `i` be a handle, and `v` be a value.

i = push!(h, v)            # adds a value to the heap and and returns a handle to v

update!(h, i, v)           # updates the value of an element (referred to by the handle i)

delete!(h, i)              # deletes the node with handle i from the heap

v, i = top_with_handle(h)  # returns the top value of a heap and its handle
```

Currently, both min/max versions of binary heap (type `BinaryHeap`) and
mutable binary heap (type `MutableBinaryHeap`) have been implemented.

Examples of constructing a heap:

```julia
h = BinaryMinHeap{Int}()
h = BinaryMaxHeap{Int}()             # create an empty min/max binary heap of integers

h = BinaryMinHeap([1,4,3,2])
h = BinaryMaxHeap([1,4,3,2])         # create a min/max heap from a vector

h = MutableBinaryMinHeap{Int}()
h = MutableBinaryMaxHeap{Int}()      # create an empty mutable min/max heap

h = MutableBinaryMinHeap([1,4,3,2])
h = MutableBinaryMaxHeap([1,4,3,2])  # create a mutable min/max heap from a vector
```

## Using alternate orderings

Heaps can also use alternate orderings apart from the default one defined by
`Base.isless`. This is accomplished by passing an instance of `Base.Ordering`
as the first argument to the constructor. The top of the heap will then be the
element that comes first according to this ordering.

The following example uses 2-tuples to track the index of each element in the
original array, but sorts only by the data value:

```julia
data = collect(enumerate(["foo", "bar", "baz"]))

h1 = BinaryHeap(data) # Standard lexicographic ordering for tuples
first(h1)             # => (1, "foo")

h2 = BinaryHeap(Base.By(last), data) # Order by 2nd element only
first(h2)                            # => (2, "bar")
```

If the ordering type is a singleton it can be passed as a type parameter to the
constructor instead:

```julia
BinaryHeap{T, O}()        # => BinaryHeap{T}(O())
MutableBinaryHeap{T, O}() # => MutableBinaryHeap{T}(O())
```

## Min-max heaps
Min-max heaps maintain the minimum _and_ the maximum of a set,
allowing both to be retrieved in constant (`O(1)`) time.
The min-max heaps in this package are subtypes of `AbstractMinMaxHeap <: AbstractHeap`
and have the same interface as other heaps with the following additions:

```julia
# Let h be a min-max heap, k an integer
minimum(h)     # return the smallest element
maximum(h)     # return the largest element

popmin!(h)     # remove and return the smallest element
popmin!(h, k)  # remove and return the smallest k elements

popmax!(h)     # remove and return the largest element
popmax!(h, k)  # remove and return the largest k elements

popall!(h)     # remove and return all the elements, sorted smallest to largest
popall!(h, o)  # remove and return all the elements according to ordering o
```

The usual `first(h)` and `pop!(h)` are defined to be `minimum(h)` and `popmin!(h)`,
respectively.

This package includes an implementation of a binary min-max heap (`BinaryMinMaxHeap`).
> Atkinson, M.D., Sack, J., Santoro, N., & Strothotte, T. (1986). Min-Max > Heaps and Generalized Priority Queues. Commun. ACM, 29, 996-1000.
> doi: [10.1145/6617.6621](https://doi.org/10.1145/6617.6621)

Examples:
```julia
h = BinaryMinMaxHeap{Int}()        # create an empty min-max heap with integer values

h = BinaryMinMaxHeap([1, 2, 3, 4]) # create a min-max heap from a vector
```

# Functions using heaps

Heaps can be used to extract the largest or smallest elements of an
array without sorting the entire array first:

```julia
data = [0,21,-12,68,-25,14]
nlargest(3, data)  # => [68,21,14]
nsmallest(3, data) # => [-25,-12,0]
```

Both methods also support the `by` and `lt` keywords to customize the sort order,
as in `Base.sort`:

```julia
nlargest(3, data, by=x -> x^2)  # => [68,-25,21]
nsmallest(3, data, by=x -> x^2) # => [0,-12,14]
```

The lower-level `DataStructures.nextreme` function takes a `Base.Ordering`
instance as the first argument and returns the first `n` elements according to
this ordering:

```julia
DataStructures.nextreme(Base.Forward, n, a) # Equivalent to nsmallest(n, a)
```


# Improving performance with Float data

One use case for custom orderings is to achieve faster performance with `Float`
elements with the risk of random ordering if any elements are `NaN`.
The provided `DataStructures.FasterForward` and `DataStructures.FasterReverse`
orderings are optimized for this purpose and may achive a 2x performance boost:

```julia
h = BinaryHeap{Float64, DataStructures.FasterForward}() # faster min heap
h = BinaryHeap{Float64, DataStructures.FasterReverse}() # faster max heap

h = MutableBinaryHeap{Float64, DataStructures.FasterForward}() # faster mutable min heap
h = MutableBinaryHeap{Float64, DataStructures.FasterReverse}() # faster mutable max heap

DataStructures.nextreme(DataStructures.FasterReverse(), n, a)  # faster nlargest(n, a)
DataStructures.nextreme(DataStructures.FasterForward(), n, a)  # faster nsmallest(n, a)
```

# Disjoint Sets

Some algorithms, such as finding connected components in undirected
graph and Kruskal's method of finding minimum spanning tree, require a
data structure that can efficiently represent a collection of disjoint
subsets. A widely used data structure for this purpose is the *Disjoint
set forest*.

Usage:

```julia
a = IntDisjointSets(10)  # creates a forest comprised of 10 singletons
union!(a, 3, 5)          # merges the sets that contain 3 and 5 into one and returns the root of the new set
root_union!(a, x, y)     # merges the sets that have root x and y into one and returns the root of the new set
find_root(a, 3)          # finds the root element of the subset that contains 3
in_same_set(a, x, y)     # determines whether x and y are in the same set
elem = push!(a)          # adds a single element in a new set; returns the new element
                         # (this operation is often called MakeSet)
```

One may also use other element types:

```julia
a = DisjointSets{AbstractString}(["a", "b", "c", "d"])
union!(a, "a", "b")
in_same_set(a, "c", "d")
push!(a, "f")
```

Note that the internal implementation of `IntDisjointSets` is based on
vectors, and is very efficient. `DisjointSets{T}` is a wrapper of
`IntDisjointSets`, which uses a dictionary to map input elements to an
internal index. Note for `DisjointSets`, `union!`, `root_union!` and
`find_root` return the index of the root.

```@meta
DocTestSetup = :(using DataStructures)
```

# Queue

The Queue data structure, also known as *First In, First Out* (FIFO) queue, allows
addition and deletion of items in opposite ends of the data structure. Insertion is
performed in the back of the queue while deletion is performed in the front of the
queue. In DataStructures.jl, the `Queue` type is a light-weight wrapper around the
[Deque](./deque.md) type.

Queues are often used as a base for many different data structures, some of its
variations implemented by DataStructures.jl include:

- [Double Ended Queues](./deque.md)
- [Circular Double Ended Queues](./circ_deque.md)
- [Priority Queues](./priority-queue.md)

## Constructors

```@autodocs
Modules = [DataStructures]
Pages = ["src/queue.jl"]
Order = [:type]
```

## Usage

The `Queue` type implements the following methods:

- [`eltype(::Type{Queue{T}}) where {T}`](@ref)
- [`first(q::Queue)`](@ref)
- [`isempty(q::Queue)`](@ref)
- [`length(q::Queue)`](@ref)
- [`last(q::Queue)`](@ref)
- [`push!(q::Queue, x)`](@ref)
- [`popfirst!(q::Queue)`](@ref)

-----------

```@autodocs
Modules = [DataStructures]
Pages = ["src/queue.jl"]
Order = [:function]
```

```@meta
DocTestSetup = nothing
```

```@meta
DocTestSetup = :(using DataStructures)
```

# SwissDict

`SwissDict` provides a standard dictionary, conforming to the AbstractDict protocol, which is inspired from SwissTable developed by Google. This provides improved performance over Dict at extremely high Load Factor.

The interface of `SwissDict` replicates that of `Dict`.

Examples:

```jldoctest
julia> d = SwissDict(1 => 'a', 2 => 'b')
SwissDict{Int64, Char} with 2 entries:
  1 => 'a'
  2 => 'b'

julia> d[3] = 'c';

julia> collect(d)
3-element Vector{Pair{Int64, Char}}:
 1 => 'a'
 2 => 'b'
 3 => 'c'

julia> delete!(d, 2);

julia> d[1]
'a': ASCII/Unicode U+0061 (category Ll: Letter, lowercase)

julia> d
SwissDict{Int64, Char} with 2 entries:
  1 => 'a'
  3 => 'c'

julia> pop!(d)
1 => 'a'
```

```@meta
DocTestSetup = nothing
```

# DefaultDict and DefaultOrderedDict

A DefaultDict allows specification of a default value to return when a
requested key is not in a dictionary.

While the implementation is slightly different, a `DefaultDict` can be
thought to provide a normal `Dict` with a default value. A
`DefaultOrderedDict` does the same for an `OrderedDict`.

Constructors:

```julia
DefaultDict(default, kv)    # create a DefaultDict with a default value or function,
                            # optionally wrapping an existing dictionary
                            # or array of key-value pairs

DefaultDict{KeyType, ValueType}(default)   # create a DefaultDict with Dict type (KeyType,ValueType)

DefaultOrderedDict(default, kv)     # create a DefaultOrderedDict with a default value or function,
                                    # optionally wrapping an existing dictionary
                                    # or array of key-value pairs

DefaultOrderedDict{KeyType, ValueType}(default) # create a DefaultOrderedDict with Dict type (KeyType,ValueType)
```

All constructors also take a `passkey::Bool=false` keyword argument which determines whether to pass along the `key`
argument when calling the default function. It has no effect when the key is just a value.

Examples using `DefaultDict`:

```@setup DataStructures
using DataStructures
```

```@repl DataStructures
dd = DefaultDict(1)               # create an (Any=>Any) DefaultDict with a default value of 1
```

```@repl DataStructures
dd = DefaultDict{AbstractString, Int}(0)  # create a (AbstractString=>Int) DefaultDict with a default value of 0
```

```@repl DataStructures
d = Dict('a'=>1, 'b'=>2)
dd = DefaultDict(0, d)            # provide a default value to an existing dictionary
d['c']  # should raise a KeyError because 'c' key doesn't exist
dd['c']
```

```@repl DataStructures
dd = DefaultOrderedDict(time)     # call time() to provide the default value for an OrderedDict
dd = DefaultDict(Dict)            # Create a dictionary of dictionaries - Dict() is called to provide the default value
dd = DefaultDict(()->myfunc())    # call function myfunc to provide the default value
```

These all create the same default dict

```@repl DataStructures
dd = DefaultDict{AbstractString, Vector{Int}}(() -> Vector{Int}())
```

```@repl DataStructures
dd = DefaultDict{AbstractString, Vector{Int}}(() -> Int[])
```

```@repl DataStructures
dd = DefaultDict{AbstractString, Vector{Int}}(Vector{Int})

push!(dd["A"], 1)

push!(dd["B"], 2)

dd
```

Create a Dictionary of type `AbstractString=>DefaultDict{AbstractString, Int}`, where the default of the inner set of `DefaultDict`s is zero

```@repl DataStructures
dd = DefaultDict{AbstractString, DefaultDict}(() -> DefaultDict{AbstractString,Int}(0))
```

Use `DefaultDict` to cache an expensive function call, i.e., [memoize](https://en.wikipedia.org/wiki/Memoization)

```@repl DataStructures
dd = DefaultDict{AbstractString, Int}(passkey=true) do key
    len = length(key)
    sleep(len)
    return len
end

dd["hi"]  # slow

dd["ho"]  # slow

dd["hi"]  # fast
```

Note that in the second-last example, we need to use a function to create each new `DefaultDict`.
If we forget, we will end up using the same`DefaultDict` for all default values:

```@repl DataStructures
dd = DefaultDict{AbstractString, DefaultDict}(DefaultDict{AbstractString,Int}(0));
dd["a"]
dd["b"]["a"] = 1
dd["a"]
```

To create a `DefaultDict` which recursively calls itself you can write:
```@repl
rdict(args...) = DefaultDict(rdict, Dict{Any,Any}(args...))
dd = rdict()
dd["a"]["b"]["c"]
```

It's also possible to create a recursive `DefaultDict` where the key is restricted:
```@repl
rdict(args...) = DefaultDict{String,Any,typeof(rdict)}(rdict, Dict{String,Any}(args...))
dd = rdict()
dd["a"]["b"]["c"]
```

# Deque

A Deque (short for Double-ended Queue) is an abstract data type that generalizes
a Queue for which elements can be added to or removed from both the front (head)
and the back (tail) in $O(1)$ time complexity.

The type `Deque` implements the Double-ended Queue as a list of fixed-size blocks
using an [unrolled linked list](https://en.wikipedia.org/wiki/Unrolled_linked_list).

!!! note
    Julia's `Vector` type also provides this interface, and thus can
    be used as a deque. However, the `Deque` type in DataStructures.jl is
    implemented as a list of contiguous blocks (default size = 1 kilo-byte). As a
    Deque grows, new blocks are created and linked to existing blocks.
    This approach prevents copying operations that take place when growing a `Vector`.

Benchmark shows that the performance of `Deque` is comparable to
`Vector` on `push!`, but is noticeably faster on `pushfirst!` (by about
30% to 40%).


## Constructors

```@autodocs
Modules = [DataStructures]
Pages = ["src/deque.jl"]
Order = [:type] # only types
```

## Usage

The `Deque` implements the following methods:

- [`==(x::Deque, y::Deque)`](@ref)
- [`empty!(d::Deque{T}) where T`](@ref)
- [`first(d::Deque)`](@ref)
- [`isempty(d::Deque)`](@ref)
- [`last(d::Deque)`](@ref)
- [`length(d::Deque)`](@ref)
- [`pop!(d::Deque{T}) where T`](@ref)
- [`popfirst!(d::Deque{T}) where T`](@ref)
- [`push!(d::Deque{T}, x) where T`](@ref)
- [`pushfirst!(d::Deque{T}, x) where T`](@ref)

-------

```@autodocs
Modules = [DataStructures]
Pages = ["src/deque.jl"]
Order = [:function] # only functions
```

```@meta
DocTestSetup = :(using DataStructures)
```

# AVL Tree

The AVL Tree is a self-balancing binary search tree in which balancing operations take place
based on the difference of height between the left and right subtrees. Such operations may occur
during the insertion and deletion of keys performing recursive _rotate operations_ to ensue
that the difference between the heights of the left and right substrees is restricted to
$[-1, 1]$.

![](./assets/AVL-tree.svg)

Example of AVL Tree with balance factors shown in green.

AVL Trees are often compared with [Red–Black Trees](./red_black_tree.md) because both take $O(\log n)$ time for the basic
operations. However, for lookup-intensive applications, AVL Trees are faster than Red–Black Trees
because they are more strictly balanced. Similar to Red–Black Trees, AVL Trees are height-balanced.

!!! note "Complexity"

    Computational complexity for common operations using an AVL Tree

    | Operation | Average Case | Worst Case |
    |-----------|--------------|------------|
    | Space | $\Theta(n)$ | $O(n)$ |
    | Search | $\Theta(\log n)$ | $O(\log n)$ |
    | Insertion | $\Theta(\log n)$ | $O(\log n)$ |
    | Deletion | $\Theta(\log n)$ | $O(\log n)$ |

# Constructors

```@autodocs
Modules = [DataStructures]
Pages = ["src/avl_tree.jl"]
Order = [:type]
```

# Usage

The `AVLTree` type implements the following methods:

- [`delete!(tree::AVLTree{K}, k::K) where K`](@ref)
- [`in(key, tree::AVLTree)`](@ref)
- [`getindex(tree::AVLTree{K}, ind::Integer) where K`](@ref)
- [`haskey(tree::AVLTree{K}, k::K) where K`](@ref)
- [`push!(tree::AVLTree{K}, k) where K`](@ref)
- [`sorted_rank(tree::AVLTree{K}, key::K) where K`](@ref)

-----

```@autodocs
Modules = [DataStructures]
Pages = ["src/avl_tree.jl"]
Order = [:function]
```

```@meta
DocTestSetup = nothing
```

# Stack and Queue

The `Stack` and `Queue` types are a light-weight wrapper of a deque
type, which respectively provide interfaces for LIFO and FIFO access.

Usage of Stack:

```julia
s = Stack{Int}()                # create a stack
isempty(s)                      # check whether the stack is empty
length(s)                       # get the number of elements
eltype(s)                       # get the type of elements
push!(s, 1)                     # push back a item
first(s)                        # get an item from the top of stack
pop!(s)                         # get and remove a first item
empty!(s)                       # make a stack empty
iterate(s::Stack)               # Get a LIFO iterator of a stack
Iterators.reverse(s::Stack{T})  # Get a FILO iterator of a stack
s1 == s2                        # check whether the two stacks are same
```

Usage of Queue:

```julia
q = Queue{Int}()
enqueue!(q, x)
x = first(q)
x = last(q)
x = dequeue!(q)
```

Both `Stack` and `Queue` implement the Iterator interface; iterating
over `Stack` returns items in FILO order and iterating over `Queue`
returns items in FIFO order. There is also a `reverse_iter` function
implemented for both which returns items in the reverse order for each
type (i.e. FIFO for `Stack` and LIFO for `Queue`).

# OrderedDicts and OrderedSets

`OrderedDicts` are simply dictionaries whose entries have a particular
order. For `OrderedDicts` (and `OrderedSets`), order refers to
_insertion order_, which allows deterministic iteration over the
dictionary or set:

```julia
d = OrderedDict{Char,Int}()
for c in 'a':'e'
    d[c] = c-'a'+1
end
collect(d) # => [('a',1),('b',2),('c',3),('d',4),('e',5)]

s = OrderedSet(π,e,γ,catalan,φ)
collect(s) # => [π = 3.1415926535897...,
           #     e = 2.7182818284590...,
           #     γ = 0.5772156649015...,
           #     catalan = 0.9159655941772...,
           #     φ = 1.6180339887498...]
```

All standard `Dict` functions are available for `OrderedDicts`, and
all `Set` operations are available for `OrderedSets`.

Note that to create an `OrderedSet` of a particular type, you must specify
the type in curly-braces:

```julia
# create an OrderedSet of Strings
strs = OrderedSet{AbstractString}()
```

```@meta
DocTestSetup = :(using DataStructures)
```

# DiBitVector

`DiBitVector` provides a memory-efficient vector of elements that represent four different values from `0` to `3`. This structure is comparable to a `BitVector` in its performance and memory characteristics.

Examples:

```jldoctest
julia> v = DiBitVector(4, 0)
4-element DiBitVector:
 0x00
 0x00
 0x00
 0x00

julia> w = DiBitVector(4, 2)
4-element DiBitVector:
 0x02
 0x02
 0x02
 0x02

julia> v[1] = 2
2

julia> v[2:4] .= 2
3-element view(::DiBitVector, 2:4) with eltype UInt8:
 0x02
 0x02
 0x02

julia> v == w
true

julia> pop!(v)
0x02

julia> length(v)
3
```

```@meta
DocTestSetup = nothing
```

```@meta
DocTestSetup = :(using DataStructures)
```

# Splay Tree

The `SplayTree` type is an implementation of Splay Tree in Julia. It is a self-balancing binary search tree with the additional property that recently accessed elements are quick to access again. Operations such as search, insert and delete can be done in `O(log n)` amortized time, where `n` is the number of nodes in the `SplayTree`.

Examples:

```jldoctest
julia> tree = SplayTree{Int}();

julia> for k in 1:2:20
           push!(tree, k)
       end

julia> haskey(tree, 3)
true

julia> tree[4]
7

julia> for k in 1:2:10
           delete!(tree, k)
       end

julia> haskey(tree, 5)
false
```

```@meta
DocTestSetup = nothing
```

# CircularBuffer

The `CircularBuffer` type implements a circular buffer of fixed
`capacity` where new items are pushed to the back of the list,
overwriting values in a circular fashion.

Usage:

```julia
cb = CircularBuffer{Int}(n)   # allocate an Int buffer with maximum capacity n
isfull(cb)           # test whether the buffer is full
isempty(cb)          # test whether the buffer is empty
empty!(cb)           # reset the buffer
capacity(cb)         # return capacity
length(cb)           # get the number of elements currently in the buffer
size(cb)             # same as length(cb)
push!(cb, 10)        # add an element to the back and overwrite front if full
pop!(cb)             # remove the element at the back
pushfirst!(cb, 10)   # add an element to the front and overwrite back if full
popfirst!(cb)        # remove the element at the front
append!(cb, [1, 2, 3, 4])     # push at most last `capacity` items
convert(Vector{Float64}, cb)  # convert items to type Float64
eltype(cb)           # return type of items
cb[1]                # get the element at the front
cb[end]              # get the element at the back
fill!(cb, data)      # grows the buffer up-to capacity, and fills it entirely, preserving existing elements.
```

# Fenwick Tree

The `FenwickTree` type is data structures which is used for handling increment and decrement to prefix-sums of an array efficiently.

Usage:

```julia
FenwickTree{T}(n) # Constructs a Fenwick Tree of length `n`
FenwickTree{T}(counts)  # Constructs a Fenwick Tree from an array of `counts`
inc!(ft, ind, val)  # Increases the value of the FenwickTree `ft` by `val` from the index `ind` upto the length of `ft`
dec!(ft, ind, val)  # Decreases the value of the FenwickTree `ft` by `val` from the index `ind` upto the length of `ft`
incdec!(ft, left, right, val)  # Increases the value of the FenwickTree `ft` by `val` from the indices from `left` and decreases it from the `right`
prefixsum(ft, ind)  # Return the cumulative sum from index 1 upto `ind` of the FenwickTree `ft`
```

Examples:

```julia
julia> f = FenwickTree{Int}(6)
julia> inc!(f, 2, 5)
julia> prefixsum(f, 1)
 0
julia> prefixsum(f, 3)
 5
```

# CircularDeque

The `CircularDeque` type implements a double-ended queue using a
circular buffer of fixed `capacity`. This data structure supports
constant-time insertion/removal of elements at both ends of a sequence.

Usage:

```julia
a = CircularDeque{Int}(n)   # allocate a deque with maximum capacity n
isempty(a)          # test whether the deque is empty
empty!(a)           # reset the deque
capacity(a)         # return capacity
length(a)           # get the number of elements currently in the deque
push!(a, 10)        # add an element to the back
pop!(a)             # remove an element from the back
pushfirst!(a, 20)   # add an element to the front
popfirst!(a)        # remove an element from the front
first(a)            # get the element at the front
last(a)             # get the element at the back
eltype(a)           # return type of items
```

*Note:* Julia's `Vector` type also provides this interface, and thus can
be used as a deque. However, the `CircularDeque` type in this package is
implemented as a circular buffer, and thus avoids copying elements when
modifications are made to the front of the vector.

Benchmarks show that the performance of `CircularDeque` is several times
faster than `Deque`.

```@meta
DocTestSetup = :(using DataStructures)
```

# Trie

An implementation of the Trie data structure. This is an associative
structure, with iterable keys:

```jldoctest
julia> t = Trie{Char,Int}();


julia> t["Rob"] = 42;


julia> t["Roger"] = 24;


julia> haskey(t, "Rob")
true

julia> get(t, "Rob", nothing)
42

julia> keys(t)
2-element Vector{String}:
 "Roger"
 "Rob"

julia> keys(subtrie(t, "Ro"))
2-element Vector{String}:
 "ger"
 "b"
```

Note that the keys don't need to be `String`s:

```jldoctest
julia> t = Trie{Int,Char}();

julia> t[1:3] = 'a';

julia> t[[2,3,5]] = 'b';

julia> keys(t)
2-element Vector{Vector{Int64}}:
 [2, 3, 5]
 [1, 2, 3]
```

Constructors:

```julia
Trie(keys, values)                  # construct a Trie with the given keys and values
Trie(keys)                          # construct a Trie{K,Nothing} with the given keys and with values = nothing
Trie(kvs::AbstractVector{(K, V)})   # construct a Trie from the given vector of (key, value) pairs
Trie(kvs::AbstractDict{K, V})       # construct a Trie from the given associative structure
```

This package also provides an iterator `partial_path(t::Trie, prefix)` for looping
over all the nodes encountered in searching for the given `prefix`.
This obviates much of the boilerplate code needed in writing many trie
algorithms. For example, to test whether a trie contains any prefix of a
given string `str`, use:

```julia
seen_prefix(t::Trie, str) = any(v -> v.is_key, partial_path(t, str))
```

`find_prefixes` can be used to find all keys which are prefixes of the given string.

```jldoctest
julia> t = Trie(["A", "ABC", "ABCD", "BCE"]);

julia> find_prefixes(t, "ABCDE")
3-element Vector{String}:
 "A"
 "ABC"
 "ABCD"
```

```@meta
DocTestSetup = nothing
```

# Accumulators and Counters

A accumulator, as defined below, is a data structure that maintains an
accumulated number for each key. This is a counter when the accumulated
values reflect the counts:

```julia
struct Accumulator{K, V<:Number}
    map::Dict{K, V}
end
```

## Constructors

There are different ways to construct an accumulator/counter:

```julia
a = Accumulator{K, V}()  # construct an accumulator with key-type K and
                         # accumulated value type V

a = Accumulator(dict)    # construct an accumulator from a dictionary

a = counter(K)           # construct a counter, i.e. an accumulator with
                         # key type K and value type Int

a = counter(dict)        # construct a counter from a dictionary

a = counter(seq)         # construct a counter by counting keys in a sequence

a = counter(gen)         # construct a counter by counting keys in a generator
```

## Usage
Usage of an accumulator/counter:

```julia
# let a and a2 be accumulators/counters

a[x]             # get the current value/count for x,
                 # if x was not added to a, it returns zero.

a[x] = v         # sets the current value/count for `x` to `v`

inc!(a, x)       # increment the value/count for x by 1
inc!(a, x, v)    # increment the value/count for x by v

dec!(a, x)       # decrement the value/count for x by 1
dec!(a, x, v)    # decrement the value/count for x by v

reset!(a, x)     # remove a key x from a, and return its current value

merge!(a, a2)    # add all counts from a2 to a1
merge(a, a2)     # return a new accumulator/counter that combines the
                 # values/counts in both a and a2
                 # `a[v] + a2[v]` over all `v` in the universe
```

`merge` is the multiset sum operation (sometimes written ⊎).

## Use as a multiset

An `Accumulator{T, <:Integer} where T` such as is returned by `counter`,
is a [multiset](https://en.wikipedia.org/wiki/Multiset) or Bag, of objects of type `T`.
If the count type is not an integer but a more general real number, then this is a form of fuzzy multiset.
We support a number of operations supporting the use of `Accumulator`s as multisets.


Note that these operations will throw an error if the accumulator has negative or zero counts for any items.

```julia

setdiff(a1, a2)          # The opposite of `merge` (i.e. multiset sum),
                         # returns a new multiset with the count of items in `a2` removed from `a1`, down to a minimum of zero
                         # `max(a1[v] - a2[v], 0)` over all `v` in the universe


union(a1, a2)            # multiset union (sometimes called maximum, or lowest common multiple)
                         # returns a new multiset with the counts being the higher of those in `a1` or `a2`.
                         # `max(a1[v], a2[v])` over all `v` in the universe

intersect(a1, a2)        # multiset intersection (sometimes called infimum or greatest common divisor)
                         # returns a new multiset with the counts being the lowest of those in `a1` or `a2`.
                         # Note that this means things not occurring in both with be removed (count zero).
                         # `min(a1[v], a2[v])` over all `v` in the universe
```

```@meta
DocTestSetup = :(using DataStructures)
```
# Priority Queue

The `PriorityQueue` type provides a basic priority queue implementation
allowing for arbitrary key and priority types. Multiple identical keys
are not permitted, but the priority of existing keys can be changed
efficiently.

## Constructors

```@autodocs
Modules = [DataStructures]
Pages = ["src/priorityqueue.jl"]
Order = [:type]
```

## Usage

The `PriorityQueue` type implements the following methods:

- [`delete!(pd::PriorityQueue, key)`](@ref)
- [`empty!(pd::PriorityQueue)`](@ref)
- [`first(pd::PriorityQueue)`](@ref)
- [`haskey(pd::PriorityQueue, key)`](@ref)
- [`isempty(pd::PriorityQueue)`](@ref)
- [`length(pd::PriorityQueue)`](@ref)
- [`popfirst!(pd::PriorityQueue)`](@ref)
- [`push!(pd::PriorityQueue)`](@ref)

!!! note
    `PriorityQueue` also behaves similarly to a `Dict` in that keys can be
    inserted and priorities accessed or changed using indexing notation.

    Examples:

    ```jldoctest
    julia> pq = PriorityQueue();

    julia> # Insert keys with associated priorities
           pq["a"] = 10; pq["b"] = 5; pq["c"] = 15; pq
    PriorityQueue{Any, Any, Base.Order.ForwardOrdering} with 3 entries:
      "b" => 5
      "a" => 10
      "c" => 15

    julia> # Change the priority of an existing key
           pq["a"] = 0; pq
    PriorityQueue{Any, Any, Base.Order.ForwardOrdering} with 3 entries:
      "a" => 0
      "b" => 5
      "c" => 15
    ```

    It is also possible to iterate over the priorities and elements of the queue in sorted order.

    ```jldoctest
    julia> pq = PriorityQueue("a" => 2, "b" => 1, "c" => 3)
    PriorityQueue{String, Int64, Base.Order.ForwardOrdering} with 3 entries:
      "b" => 1
      "a" => 2
      "c" => 3

    julia> for priority in values(pq)
               println(priority)
           end
    1
    2
    3

    julia> for element in keys(pq)
               println(element)
           end
    b
    a
    c

    julia> for (element, priority) in pq
               println("$element $priority")
           end
    b 1
    a 2
    c 3
    ```

------

```@autodocs
Modules = [DataStructures]
Pages = ["src/priorityqueue.jl"]
Order = [:function]
```

```@meta
DocTestSetup = nothing
```

```@meta
DocTestSetup = :(using DataStructures)
```

# Stack

The Stack data structure corresponds to a *Last In, First Out* (LIFO) queue in 
which elements are added to and removed from only one of the ends of the queue.
In DataStructures.jl the [`Stack`](./stack.md) type is a light-weight wrapper around
the [`Deque`](./deque.md) type.

!!! note "Notes on the Iterator interface implemented by the Stack"
    The `Stack` type implements the Julia Iterator interface; iterating
    over `Stack` returns items in *First In, Last Out* (FILO) order, i.e. "from top
    to bottom" of the stack. There is also a `Iterators.reverse` function which
    iterates over the items in *First In, First Out* (FIFO) order, or "from bottom
    to top" of the stack.

    ```jldoctest
    julia> s = Stack{Int64}()
    Stack{Int64}(Deque [Int64[]])

    julia> for i in 1:4
               push!(s, i)
           end

    julia> for el in s # top to bottom iteration 
               println(el)
           end
    4
    3
    2
    1

    julia> for el in Iterators.reverse(s) # bottom to top iteration 
               println(el)
           end
    1
    2
    3
    4
    ```

## Constructors

```@autodocs
Modules = [DataStructures]
Pages = ["src/stack.jl"]
Order = [:type]
```

## Usage

The `Stack` type implements the following methods:

- [`==(x::Stack, y::Stack)`](@ref)
- [`eltype(::Type{Stack{T}}) where {T}`](@ref)
- [`empty!(s::Stack)`](@ref)
- [`first(s::Stack)`](@ref)
- [`isempty(s::Stack)`](@ref)
- [`length(s::Stack)`](@ref)
- [`pop!(s::Stack)`](@ref)
- [`push!(s::Stack, x)`](@ref)

----------

```@autodocs
Modules = [DataStructures]
Pages = ["src/stack.jl"]
Order = [:function]
```

```@meta
DocTestSetup = nothing
```

# Mutable Linked List

The `MutableLinkedList` type implements a doubly linked list with mutable nodes.
This data structure supports constant-time insertion/removal of elements
at both ends of the list.

Usage:

```julia
l = MutableLinkedList{T}()        # initialize an empty list of type T
l = MutableLinkedList{T}(elts...) # initialize a list with elements of type T
isempty(l)                        # test whether list is empty
length(l)                         # get the number of elements in list
collect(l)                        # return a vector consisting of list elements
eltype(l)                         # return type of list
first(l)                          # return value of first element of list
last(l)                           # return value of last element of list
l1 == l2                          # test lists for equality
map(f, l)                         # return list with f applied to elements
filter(f, l)                      # return list of elements where f(el) == true
reverse(l)                        # return reversed list
copy(l)                           # return a copy of list
getindex(l, idx)   || l[idx]      # get value at index
getindex(l, range) || l[range]    # get values within range a:b
setindex!(l, data, idx)           # set value at index to data
append!(l1, l2)                   # attach l2 at the end of l1
append!(l, elts...)               # attach elements at end of list
delete!(l, idx)                   # delete element at index
delete!(l, range)                 # delete elements within range a:b
push!(l, data)                    # add element to end of list
pushfirst!(l, data)               # add element to beginning of list
pop!(l)                           # remove element from end of list
popfirst!(l)                      # remove element from beginning of list
```

`MutableLinkedList` implements the Iterator interface, iterating over the list
from first to last.

```@meta
DocTestSetup = :(using DataStructures)
```

# RobinDict

`RobinDict` provides a standard dictionary, conforming to the AbstractDict protocol, which uses the Robin Hood hashing algorithm with backward-shift deletion to provide improved average performance over Dict.

The interface of `RobinDict` replicates that of `Dict`.
This has an ordered version called `OrderedRobinDict`, which replicates the interface of `OrderedDict`.

Examples:

```jldoctest
julia> d = RobinDict{Int, Char}(1 => 'a', 2 => 'b')
RobinDict{Int64, Char} with 2 entries:
  2 => 'b'
  1 => 'a'

julia> d[3] = 'c';

julia> collect(d)
3-element Vector{Pair{Int64, Char}}:
 2 => 'b'
 3 => 'c'
 1 => 'a'

julia> delete!(d, 2);

julia> d[1]
'a': ASCII/Unicode U+0061 (category Ll: Letter, lowercase)

julia> d
RobinDict{Int64, Char} with 2 entries:
  3 => 'c'
  1 => 'a'

julia> pop!(d)
3 => 'c'
```

```@meta
DocTestSetup = nothing
```

# DataStructures.IntSet

`DataStructures.IntSet` is a drop-in replacement for the Base `BitSet`
type. It efficiently stores dense collections of small non-negative
`Int`s as a sorted set. The constructor `IntSet([itr])` constructs a
sorted set of the integers generated by the given iterable object, or an
empty set if no argument is given. If the set will be sparse (for
example holding a few very large integers), use `Set` or `SortedSet`
instead.

A complement IntSet may be constructed with `complement` or
`complement!`. The complement of an empty `IntSet` contains
`typemax(Int)` elements from 0 to `typemax(Int)-1`.

# Sorted Containers

```@meta
CurrentModule = DataStructures
```

Three sorted containers are provided: SortedDict, SortedMultiDict and
SortedSet. _SortedDict_ is similar to the built-in Julia type `Dict`
with the additional feature that the keys are stored in sorted order and
can be efficiently iterated in this order. SortedDict is a subtype of
AbstractDict. It is generally slower than `Dict` because looking up a key
requires an O(log _n_) tree search rather than an expected O(1)
hash-table lookup time of `Dict`. SortedDict is a parameterized type
with three parameters, the key type `K`, the value type `V`, and the
ordering type `O`. SortedSet has only keys; it is an alternative to the
built-in `Set` container and is a subtype of AbstractSet.
Internally, SortedSet is implemented as a
SortedDict in which the value type is `Nothing`. Finally, SortedMultiDict
is similar to SortedDict except that each key can be associated with
multiple values. The key=>value pairs in a SortedMultiDict are stored
according to the sorted order for keys, and key=>value pairs with the
same key are stored in order of insertion.

The containers internally use a 2-3 tree, which is a kind of balanced
tree and is described in data structure textbooks.  Internally, one `Vector` is
used to store key/data pairs (the leaves of the tree) while a second holds the
tree structure.

The containers require two functions to compare keys: a _less-than_ and
_equals_ function. With the default ordering argument, the comparison
functions are `isless(key1,key2)` (true when `key1 < key2`) and
`isequal(key1,key2)` (true when `key1 == key2`) where `key1` and `key2`
are keys. More details are provided below.

## Tokens for Sorted Containers

The sorted containers support an object for indexing called a
_token_ defined as a two-entry tuple and aliased as `SortedDictToken`,
`SortedMultiDictToken`, or `SortedSetToken`.
A token is the address of a single data item in the
container and can be dereferenced in time O(1).

The first entry of a token tuple is the container as a whole, and the
second refers to the particular item. The second part is called a
_semitoken_. The type of the semitoken is `IntSemiToken`.

A restriction for the sorted containers is that `IntSemiToken`
cannot used as the key-type. This is because ambiguity would
result between the two subscripting calls `sc[k]` and `sc[st]` described
below. In the rare scenario that a sorted container whose key-type is
`IntSemiToken` is required, a workaround is to wrap the key inside
another immutable structure.

The notion of token is similar to the concept of iterators used by C++
standard containers. Tokens can be explicitly advanced or regressed
through the data in the sorted order; they are implicitly advanced or
regressed via iteration defined below.

A token may take two special values: the _before-start_ value and the
_past-end_ value. These values act as lower and upper bounds on the
actual data. The before-start token can be advanced, while the past-end
token can be regressed. A dereferencing operation on either leads to an
error.

In the current implementation, semitokens are internally stored as
integers. Users should regard these integers as opaque
since future versions of the package may change the internal indexing
scheme.
In certain situations it may be more costly to operate on tokens than
semitokens because the first entry of a token (i.e., the container)
is not a bits-type.
If code profiling indicates that statements using tokens are allocating memory,
then it may be advisable to rewrite the application code using semitokens
rather than tokens.

## Complexity of Sorted Containers

In the list of functions below, the running time of the various
operations is provided. In these running times, _n_ denotes the
number of items in the container,
and _c_ denotes the time needed to compare two keys.



## Constructors for Sorted Containers

### `SortedDict` constructors

```@docs
SortedDict{K,V,Ord}(o::Ord=Forward) where {K, V, Ord <: Ordering}
SortedDict(o::Ord=Forward) where {Ord <: Ordering}
SortedDict(iter, o::Ord=Forward) where {Ord <: Ordering}
SortedDict(ps::Pair...)
SortedDict{K,V}(::Val{true}, iterable) where {K,V}
```


### `SortedMultiDict` constructors

```@docs
SortedMultiDict{K,V,Ord}(o::Ord=Forward) where {K, V, Ord <: Ordering}
SortedMultiDict(o::Ord=Forward) where {Ord <: Ordering}
SortedMultiDict(ps::Pair...)
SortedMultiDict(iter, o::Ord=Forward) where {Ord <: Ordering}
SortedMultiDict{K,V}(::Val{true}, iterable) where {K,V}
```

### `SortedSet` constructors
```@docs
SortedSet{K,Ord}(o::Ord=Forward) where {K, Ord<:Ordering}
SortedSet(o::Ord=Forward) where {Ord <: Ordering}
SortedSet(o::Ordering, iter)
SortedSet{K}(::Val{true}, iterable) where {K}
```


## Navigating the Containers

```@docs
Base.getindex(sd::SortedDict, k)
Base.getindex(m::SortedDict, st::IntSemiToken)
Base.setindex!(m::SortedDict, newvalue, st::IntSemiToken)
Base.setindex!(sd::SortedDict, newvalue, k)
deref(token::Token)
deref_key(token::Token)
deref_value(token::Token)
Base.firstindex(m::SortedContainer)
Base.lastindex(m::SortedContainer)
token_firstindex(m::SortedContainer)
token_lastindex(m::SortedContainer)
Base.first(sc::SortedContainer)
Base.last(sc::SortedContainer)
pastendsemitoken(sc::SortedContainer)
beforestartsemitoken(sc::SortedContainer)
pastendtoken(sc::SortedContainer)
beforestarttoken(sc::SortedContainer)
advance(token::Token)
regress(token::Token)
+(t::Token, k::Integer)
Base.searchsortedfirst(m::SortedContainer, k)
Base.searchsortedlast(m::SortedContainer, k)
searchsortedafter(m::SortedContainer, k)
searchequalrange(smd::SortedMultiDict, k)
findkey(m::SortedSet, k)
findkey(sd::SortedDict, k)
```

## Inserting & Deleting in Sorted Containers


```@docs
Base.push!(ss::SortedSet, k)
Base.push!(sd::SortedDict, p::Pair)
Base.push!(smd::SortedMultiDict, p::Pair)
push_return_semitoken!(ss::SortedSet, k)
push_return_semitoken!(sd::SortedDict, p::Pair)
push_return_semitoken!(smd::SortedMultiDict, p::Pair)
Base.delete!(token::Token) 
Base.delete!(ss::SortedSet, k)
Base.delete!(sc::SortedDict, k)
Base.pop!(ss::SortedSet, k)
Base.pop!(sd::SortedDict, k)
Base.popfirst!(ss::SortedSet)
poplast!(ss::SortedSet)
```

## Iteration and Token Manipulation

```@docs
compare(m::SortedContainer, s::IntSemiToken, t::IntSemiToken)
status(token::Token) 
Base.iterate(sci::SortedContainerIterable)
Base.in(k,m::SortedSet)
Base.in(p::Pair, sd::SortedDict)
Base.in(p::Pair, smd::SortedMultiDict)
Base.in(x, iter::SortedContainerIterable)
```

## Misc. Functions


    Base.isempty(m::SortedContainer)
    Base.empty!(m::SortedContainer)
    Base.empty(m::SortedContainer)
    Base.length(m::SortedContainer)
    Base.eltype(m::SortedContainer)
    Base.keytype(m::SortedContainer)
    Base.valtype(m::SortedContainer)
    Base.eltype(m::SortedContainerIteration)
    Base.keytype(m::SortedContainerIteration)
    Base.valtype(m::SortedContainerIteration)
    
    
These functions from `Base` are all applicable to sorted containers
with the obvious meaning.  The `eltype`, `keytype`, and `valtype` functions
may be applied either to the object `m` or its type.
Note that `keytype` and `valtype` are
applicable only to SortedDict and SortedMultiDict, or to
pairs iterations over SortedDict or SortedMultiDict.
Time: O(1)


```@docs
ordtype(sc::SortedContainer)
orderobject(sc::SortedContainer)
Base.haskey(sc::SortedContainer, k)
Base.get(sd::SortedDict,k,v)
Base.get!(sd::SortedDict,k,v)
Base.getkey(sd::SortedDict,k,defaultk)
Base.isequal(ss1::SortedSet{K,Ord}, ss2::SortedSet{K,Ord}) where {K, Ord <: Ordering}
Base.isequal(sc1::SortedDict{K,V,Ord}, sc2::SortedDict{K,V,Ord}) where {K, V, Ord <: Ordering}
Base.isequal(smd1::SortedMultiDict{K,V,Ord}, smd2::SortedMultiDict{K,V,Ord}) where {K, V, Ord <: Ordering}
packcopy(sc::SortedSet)
packdeepcopy(sc::SortedSet)
Base.merge(sd::SortedDict{K,V,Ord}, d1::AbstractDict{K,V}...) where {K,V,Ord <: Ordering}
Base.merge!(sd::SortedDict{K,V,Ord}, d1::AbstractDict{K,V}...) where {K,V,Ord <: Ordering}
Base.merge(smd::SortedMultiDict, iter...)
Base.merge!(smd::SortedMultiDict, iter...)
```


## Set operations

The SortedSet container supports the following set operations. Note that
in the case of `intersect`, `symdiff` and `setdiff`, the two SortedSets should
have the same key and ordering object. If they have different key or
ordering types, no error message is produced; instead, the built-in
default versions of these functions (that can be applied to `Any`
iterables and that return arrays) are invoked.

```@docs
Base.union!(ss::SortedSet, iterable...)
Base.union(ss::SortedSet, iterable...)
Base.intersect(ss::SortedSet, others...)
Base.symdiff(ss1::SortedSet, iterable)
Base.setdiff(ss1::SortedSet{K,Ord}, ss2::SortedSet{K,Ord}) where {K, Ord<:Ordering}
Base.setdiff!(m1::SortedSet, iterable)
Base.issubset(iterable, ss::SortedSet)
```

## Ordering of keys

As mentioned earlier, the default ordering of keys uses `isless` and
`isequal` functions. If the default ordering is used, it is a
requirement of the container that `isequal(a,b)` is true if and only if
`!isless(a,b)` and `!isless(b,a)` are both true. This relationship
between `isequal` and `isless` holds for common built-in types, but it
may not hold for all types, especially user-defined types. If it does
not hold for a certain type, then a custom ordering argument must be
defined as discussed in the next few paragraphs.

The name for the default ordering (i.e., using `isless` and `isequal`)
is `Forward`. Note: this is the name of the ordering object; its type is
`ForwardOrdering.` Another possible ordering object is `Reverse`, which
reverses the usual sorted order. This name must be imported
`import Base.Reverse` if it is used.

As an example of a custom ordering, suppose the keys are of type
`String`, and the user wishes to order the keys ignoring case: _APPLE_,
_berry_ and _Cherry_ would appear in that order, and _APPLE_ and _aPPlE_
would be indistinguishable in this ordering.

The simplest approach is to define an ordering object of the form
`Lt(my_isless)`, where `Lt` is a built-in type (see `ordering.jl`) and
`my_isless` is the user's comparison function. In the above example, the
ordering object would be:

```julia
Lt((x,y) -> isless(lowercase(x),lowercase(y)))
```

The ordering object is indicated in the above list of constructors in
the `o` position (see above for constructor syntax).

This approach may suffer from a performance hit because higher performance
may be possible if an equality method is also available as well as a
less-than method.
A more complicated but higher-performance method to implement
a custom ordering is as follows. First, the user creates a singleton
type that is a subtype of `Ordering` as follows:

```julia
struct CaseInsensitive <: Ordering
end
```

Next, the user defines a method named `lt` for less-than in this
ordering:

```julia
lt(::CaseInsensitive, a, b) = isless(lowercase(a), lowercase(b))
```

The first argument to `lt` is an object of the `CaseInsensitive` type
(there is only one such object since it is a singleton type). The
container also needs an equal-to function; the default is:

```julia
eq(o::Ordering, a, b) = !lt(o, a, b) && !lt(o, b, a)
```


The user can also customize this
function with a more efficient implementation. In the above example, an
appropriate customization would be:

```julia
eq(::CaseInsensitive, a, b) = isequal(lowercase(a), lowercase(b))
```

Note: the user-defined `eq` and `lt` functions must be compatible in the sense
that `!lt(o, a, b) && !lt(o, b, a)` if and only if 
`eq(o, a, b)`.


Finally, the user specifies the unique element of `CaseInsensitive`,
namely the object `CaseInsensitive()`, as the ordering object to the
`SortedDict`, `SortedMultiDict` or `SortedSet` constructor.

For the above code to work, the module must make the following
declarations, typically near the beginning:

```julia
import Base.Ordering
import Base.lt
import DataStructures.eq
```

## Cautionary note on mutable keys

As with ordinary
Dicts, keys for the sorted containers can be either mutable or
immutable. In the case of mutable keys, it is important that the keys
not be mutated once they are in the container else the indexing
structure will be corrupted. (The same restriction applies to Dict.) For
example, the
following sequence of statements leaves `sd` in a corrupted state:

```julia
sd = SortedDict{Vector{Int},Int}()
k = [1,2,3]
sd[k] = 19
sd[[6,4]] = 12
k[1] = 7
```

## Performance of Sorted Containers

The sorted containers are currently not optimized for cache performance.

```@meta
DocTestSetup = :(using DataStructures)
```

# Red Black Tree

The `RBTree` type is an implementation of Red Black Tree in Julia. It is a self-balancing binary search tree with an extra bit of information, the color, in each of its node. Operations such as search, insert and delete can be done in `O(log n)` complexity, where `n` is the number of nodes in the `RBTree`.

Examples:

```jldoctest
julia> tree = RBTree{Int}();

julia> for k in 1:2:20
           push!(tree, k)
       end

julia> haskey(tree, 3)
true

julia> tree[4]
7

julia> for k in 1:2:10
           delete!(tree, k)
       end

julia> haskey(tree, 5)
false
```

```@meta
DocTestSetup = nothing
```

# Linked List

A list of sequentially linked nodes. This allows efficient insertion of
nodes to the front of the list:

```julia
julia> l1 = nil()
nil()

julia> l2 = cons(1, l1)
list(1)

julia> l3 = list(2, 3)
list(2, 3)

julia> l4 = cat(l1, l2, l3)
list(1, 2, 3)

julia> l5 = map((x) -> x*2, l4)
list(2, 4, 6)

julia> for i in l5; print(i); end
246
```

# DataStructures.SparseIntSet

Implementation of a __Sparse Integer Set__, for background see [Sparse Sets](https://www.computist.xyz/2018/06/sparse-sets.html).
Only positive non-zero `Int`s are allowed inside the set.
The idea is to have one **packed** `Vector` storing all the `Int`s contained in the set as to allow for fast iteration, and a sparse, paged **reverse** `Vector` with the position of a particular `Int` inside the **packed** `Vector`. This allows for very fast iteration, insertion and deletion of indices.
Most behavior is similar to a normal `IntSet`, however `collect`, `first` and `last` are with respected to the **packed** vector, in which the ordering is not guaranteed.
The **reverse** `Vector` is paged, meaning that it is a `Vector{Vector{Int}}` where each of the `Vector{Int}`s has the length of one memory page of `Int`s. Every time an index that was not yet in the range of the already present pages, a new one will be created and added to the **reverse**, allowing for dynamical growth.
Popping the last `Int` of a particular page will automatically clean up the memory of that page.

# DataStructures.jl

This package implements a variety of data structures, including

-   Deque (implemented with an [unrolled linked list](https://en.wikipedia.org/wiki/Unrolled_linked_list))
-   CircularBuffer
-   CircularDeque (based on a circular buffer)
-   Stack
-   Queue
-   Priority Queue
-   Fenwick Tree
-   Accumulators and Counters (i.e. Multisets / Bags)
-   Disjoint Sets
-   Binary Heap
-   Mutable Binary Heap
-   Ordered Dicts and Sets
-   RobinDict and OrderedRobinDict (implemented with [Robin Hood Hashing](https://cs.uwaterloo.ca/research/tr/1986/CS-86-14.pdf))
-   SwissDict (inspired from [SwissTables](https://abseil.io/blog/20180927-swisstables))
-   Dictionaries with Defaults
-   Trie
-   Linked List and Mutable Linked List
-   Sorted Dict, Sorted Multi-Dict and Sorted Set
-   DataStructures.IntSet
-   SparseIntSet
-   DiBitVector
-   Red Black Tree
-   AVL Tree
-   Splay Tree

## Contents

```@contents
Pages = [
    "index.md",
    "deque.md",
    "circ_buffer.md",
    "circ_deque.md",
    "stack_and_queue.md",
    "priority-queue.md",
    "fenwick.md",
    "accumulators.md",
    "disjoint_sets.md",
    "heaps.md",
    "ordered_containers.md",
    "default_dict.md",
    "robin_dict.md",
    "trie.md",
    "linked_list.md",
    "mutable_linked_list.md",
    "intset.md",
    "sorted_containers.md",
    "sparse_int_set.md",
    "dibit_vector.md",
    "red_black_tree.md",
    "avl_tree.md",
    "splay_tree.md",
]
```
